/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 32 "parser.y"

/** @endcond */

// local
#include "pjl_config.h"                 /* must go first */
#include "c_ast.h"
#include "c_ast_check.h"
#include "c_ast_util.h"
#include "c_keyword.h"
#include "c_lang.h"
#include "c_operator.h"
#include "c_sglob.h"
#include "c_sname.h"
#include "c_type.h"
#include "c_typedef.h"
#include "cdecl.h"
#include "cdecl_keyword.h"
#include "color.h"
#include "decl_flags.h"
#include "dump.h"
#include "did_you_mean.h"
#include "english.h"
#include "gibberish.h"
#include "help.h"
#include "lexer.h"
#include "literals.h"
#include "options.h"
#include "p_macro.h"
#include "p_token.h"
#include "print.h"
#include "set_options.h"
#include "show.h"
#include "slist.h"
#include "types.h"
#include "util.h"

/// @cond DOXYGEN_IGNORE

// standard
#include <assert.h>
#include <stdarg.h>
#include <stdbool.h>
#include <stdio.h>
#include <stdlib.h>

// Silence these warnings for Bison-generated code.
#ifdef __GNUC__
# pragma GCC diagnostic push
# pragma GCC diagnostic ignored "-Wconversion"
# pragma GCC diagnostic ignored "-Wredundant-decls"
# pragma GCC diagnostic ignored "-Wunreachable-code"
#endif /* __GNUC__ */

// Developer aid for tracing when Bison %destructors are called.
#if 0
#define DTRACE                    EPRINTF( "%d: destructor\n", __LINE__ )
#else
#define DTRACE                    NO_OP
#endif

#define IF_CDECL_DEBUG(...) \
  BLOCK( if ( opt_cdecl_debug != CDECL_DEBUG_NO ) { __VA_ARGS__ } )

/// @endcond

///////////////////////////////////////////////////////////////////////////////

/**
 * @defgroup parser-group Parser
 * Helper macros, data structures, variables, functions, and the grammar for
 * C/C++ declarations.
 * @{
 */

/**
 * Calls #elaborate_error_dym() with #DYM_NONE.
 *
 * @param ... Arguments passed to fl_elaborate_error().
 *
 * @note This must be used _only_ after an `error` token, e.g.:
 * ```
 *  | Y_define error
 *    {
 *      elaborate_error( "name expected" );
 *    }
 * ```
 * @note A newline _is_ printed.
 *
 * @sa elaborate_error_dym()
 * @sa keyword_expected()
 * @sa punct_expected()
 */
#define elaborate_error(...) \
  elaborate_error_dym( DYM_NONE, __VA_ARGS__ )

/**
 * Calls fl_elaborate_error() followed by #PARSE_ABORT().
 *
 * @param DYM_KINDS The bitwise-or of \ref dym_kind_t things possibly meant.
 * @param ... Arguments passed to fl_elaborate_error().
 *
 * @note This must be used _only_ after an `error` token, e.g.:
 * ```
 *  | error
 *    {
 *      elaborate_error_dym( DYM_COMMANDS, "unexpected token" );
 *    }
 * ```
 * @note A newline _is_ printed.
 *
 * @sa elaborate_error()
 * @sa keyword_expected()
 * @sa punct_expected()
 */
#define elaborate_error_dym(DYM_KINDS,...) BLOCK( \
  fl_elaborate_error( __FILE__, __LINE__, (DYM_KINDS), __VA_ARGS__ ); PARSE_ABORT(); )

/**
 * Prints that a particular language feature is not supported by **cdecl** and
 * will be ignored.
 *
 * @param LOC The location of what's being ignored.
 * @param ... The `printf()` arguments, the first of which _must_ be a string
 * literal of what is being ignored.
 *
 * @sa #UNSUPPORTED()
 */
#define IGNORING(LOC,...) \
  IGNORING_IMPL( (LOC), __VA_ARGS__, CDECL )

/// @cond DOXYGEN_IGNORE
#define IGNORING_IMPL(LOC,WHAT,...) \
  print_warning( (LOC), WHAT " not supported by %s (ignoring)%s", __VA_ARGS__, "\n" )
/// @endcond

/**
 * Checks whether the type currently being declared (`enum`, `struct`,
 * `typedef`, or `union`) is nested within some other type (`struct` or
 * `union`) and whether the current language is C: if not, prints an error
 * message.
 *
 * @remarks In debug mode, also includes the file & line where the function was
 * called from in the error message.
 *
 * @param TYPE_LOC The location of the type declaration.
 * @return Returns `true` only if the type currently being declared is either
 * not nested or the current language is C++.
 *
 * @sa fl_is_nested_type_ok()
 */
#define is_nested_type_ok(TYPE_LOC) \
  fl_is_nested_type_ok( __FILE__, __LINE__, (TYPE_LOC) )

/**
 * Checks whether \ref opt_lang is among the bitwise-or of languages specified
 * by \a LANG_MACRO, i.e., \a LANG_MACRO is supported by \ref opt_lang.
 *
 * @param LANG_MACRO A `LANG_*` macro without the `LANG_` prefix.
 * @return Returns `true` only if either **cdecl** is \ref cdecl_initialized is
 * `false` or \ref opt_lang is among the bitwise-or of languages specified by
 * \a LANG_MACRO.
 *
 * @sa #OPT_LANG_IS()
 */
#define IS_SUPPORTED(LANG_MACRO) \
  ( !cdecl_initialized || OPT_LANG_IS( LANG_MACRO ) )

/**
 * Calls fl_keyword_expected() followed by #PARSE_ABORT().
 *
 * @param KEYWORD A keyword literal.
 *
 * @note This must be used _only_ after an `error` token, e.g.:
 * ```
 *  : Y_virtual
 *  | error
 *    {
 *      keyword_expected( L_virtual );
 *    }
 * ```
 *
 * @sa elaborate_error()
 * @sa elaborate_error_dym()
 * @sa punct_expected()
 */
#define keyword_expected(KEYWORD) BLOCK ( \
  fl_keyword_expected( __FILE__, __LINE__, (KEYWORD) ); PARSE_ABORT(); )

/**
 * Aborts the current parse after an error message has been printed.
 *
 * @sa #PARSE_ASSERT()
 */
#define PARSE_ABORT() \
  BLOCK( parse_cleanup( /*fatal_error=*/true ); YYABORT; )

/**
 * Evaluates \a EXPR: if `false`, calls #PARSE_ABORT().
 *
 * @param EXPR The expression to evalulate.
 */
#define PARSE_ASSERT(EXPR)        BLOCK( if ( !(EXPR) ) PARSE_ABORT(); )

/**
 * Calls fl_punct_expected() followed by #PARSE_ABORT().
 *
 * @param PUNCT The punctuation character that was expected.
 *
 * @note This must be used _only_ after an `error` token, e.g.:
 * ```
 *  : ','
 *  | error
 *    {
 *      punct_expected( ',' );
 *    }
 * ```
 *
 * @sa elaborate_error()
 * @sa elaborate_error_dym()
 * @sa keyword_expected()
 */
#define punct_expected(PUNCT) BLOCK( \
  fl_punct_expected( __FILE__, __LINE__, (PUNCT) ); PARSE_ABORT(); )

/**
 * Prints that a particular language feature is not supported by **cdecl** and
 * it an error.
 *
 * @param LOC The location of what's not supported.
 * @param ... The `printf()` arguments, the first of which _must_ be a string
 * literal of what is unsupported.
 *
 * @sa #IGNORING()
 */
#define UNSUPPORTED(LOC,...) \
  UNSUPPORTED_IMPL( (LOC), __VA_ARGS__, CDECL )

/// @cond DOXYGEN_IGNORE
#define UNSUPPORTED_IMPL(LOC,WHAT,...) \
  print_error( (LOC), WHAT " not supported by %s%s", __VA_ARGS__, "\n" )
/// @endcond

/** @} */

///////////////////////////////////////////////////////////////////////////////

/**
 * @defgroup parser-dump-group Debugging Macros
 * Macros that are used to dump a trace during parsing when \ref
 * opt_cdecl_debug is set.
 * @ingroup parser-group
 * @{
 */

/**
 * Dumps \a ALIGN.
 *
 * @param KEY The key name to print.
 * @param ALIGN The \ref c_alignas to dump.
 */
#define DUMP_ALIGN(KEY,ALIGN) IF_CDECL_DEBUG( \
  DUMP_KEY( KEY ": " ); c_alignas_dump( &(ALIGN), stdout ); )

/**
 * Dumps an AST.
 *
 * @param KEY The key name to print.
 * @param AST The AST to dump.
 *
 * @sa #DUMP_AST_LIST()
 * @sa #DUMP_AST_PAIR()
 */
#define DUMP_AST(KEY,AST) IF_CDECL_DEBUG( \
  DUMP_KEY( KEY ": " ); c_ast_dump( (AST), stdout ); )

/**
 * Dumps an s_list of AST.
 *
 * @param KEY The key name to print.
 * @param AST_LIST The \ref slist of AST to dump.
 *
 * @sa #DUMP_AST()
 * @sa #DUMP_AST_PAIR()
 */
#define DUMP_AST_LIST(KEY,AST_LIST) IF_CDECL_DEBUG( \
  DUMP_KEY( KEY ": " ); c_ast_list_dump( &(AST_LIST), stdout ); )

/**
 * Dump a \ref c_ast_pair.
 *
 * @param KEY The key name to print.
 * @param ASTP The \ref c_ast_pair to dump.
 *
 * @sa #DUMP_AST()
 */
#define DUMP_AST_PAIR(KEY,ASTP) IF_CDECL_DEBUG( \
  DUMP_KEY( KEY ": " ); c_ast_pair_dump( &(ASTP), stdout ); )

/**
 * Dumps a `bool`.
 *
 * @param KEY The key name to print.
 * @param BOOL The `bool` to dump.
 *
 * @sa #DUMP_KEY()
 */
#define DUMP_BOOL(KEY,BOOL)  IF_CDECL_DEBUG( \
  DUMP_KEY( KEY ": " ); bool_dump( (BOOL), stdout ); )

/**
 * Ends a dump block.
 *
 * @sa #DUMP_START()
 */
#define DUMP_END()                IF_CDECL_DEBUG( PUTS( "\n}\n\n" ); )

/**
 * Possibly dumps a comma and a newline followed by the `printf()` arguments
 * --- used for printing a key followed by a value.
 *
 * @param ... The `printf()` arguments.
 */
#define DUMP_KEY(...) IF_CDECL_DEBUG(     \
  fput_sep( ",\n", &dump_comma, stdout ); \
  PRINTF( "  " __VA_ARGS__ ); )

/**
 * Dumps an integer.
 *
 * @param KEY The key name to print.
 * @param NUM The integer to dump.
 *
 * @sa #DUMP_KEY()
 * @sa #DUMP_STR()
 */
#define DUMP_INT(KEY,NUM) \
  DUMP_KEY( KEY ": %d", STATIC_CAST( int, (NUM) ) )

/**
 * Dumps a \ref p_macro.
 *
 * @param KEY The key name to print.
 * @param MACRO The \ref p_macro to dump.
 */
#define DUMP_MACRO(KEY,MACRO) IF_CDECL_DEBUG( \
  DUMP_KEY( KEY ": " ); p_macro_dump( (MACRO), stdout ); )

/**
 * Dumps a list of macro arguments.
 *
 * @param KEY The key name to print.
 * @param ARG_LIST The list of arguments to dump.
 */
#define DUMP_MACRO_ARG_LIST(KEY,ARG_LIST) IF_CDECL_DEBUG( \
  if ( (ARG_LIST) != NULL ) {                             \
    DUMP_KEY( KEY ": " );                                 \
    p_arg_list_dump( (ARG_LIST), 1, stdout );             \
  } )

/**
 * Dumps a list of \ref p_param.
 *
 * @param KEY The key name to print.
 * @param PARAM_LIST The list of \ref p_param to dump.
 */
#define DUMP_MACRO_PARAM_LIST(KEY,PARAM_LIST) IF_CDECL_DEBUG( \
  if ( (PARAM_LIST) != NULL ) {                               \
    DUMP_KEY( KEY ": " );                                     \
    p_param_list_dump( (PARAM_LIST), 1, stdout );             \
  } )

/**
 * Dumps a list of \ref p_token.
 *
 * @param KEY The key name to print.
 * @param TOKEN_LIST The list of \ref p_token to dump.
 */
#define DUMP_MACRO_TOKEN_LIST(KEY,TOKEN_LIST) IF_CDECL_DEBUG( \
  if ( (TOKEN_LIST) != NULL ) {                               \
    DUMP_KEY( KEY ": " );                                     \
    p_token_list_dump( (TOKEN_LIST), 1, stdout );             \
  } )

/**
 * Dumps a parser grammar production.
 *
 * @remarks For grammar productions, it should be the first `DUMP_*()` after
 * #DUMP_START(). If a production has a result, it should be dumped as the
 * final thing before the #DUMP_END() with the KEY of `$$_` followed by a
 * suffix denoting the type, e.g., `ast`.  For example:
 * ```
 *  DUMP_START();
 *  DUMP_PROD( "rule",
 *             "subrule_1 name subrule_2" );
 *  DUMP_AST( "subrule_1", $1 );
 *  DUMP_STR( "name", $2 );
 *  DUMP_AST( "subrule_2", $3 );
 *  // ...
 *  DUMP_AST( "$$_ast", $$ );
 *  DUMP_END();
 * ```
 *
 * @param NAME The grammar production name.
 * @param RULE The grammar production rule.
 */
#define DUMP_PROD(NAME,RULE) IF_CDECL_DEBUG( \
  PUTS( "  rule: {\n    lhs: \"" NAME "\",\n    rhs: \"" RULE "\"\n  },\n" ); )

/**
 * Dumps a scoped name.
 *
 * @param KEY The key name to print.
 * @param SNAME The scoped name to dump.
 *
 * @sa #DUMP_KEY()
 * @sa #DUMP_SNAME_LIST()
 * @sa #DUMP_STR()
 */
#define DUMP_SNAME(KEY,SNAME) IF_CDECL_DEBUG( \
  DUMP_KEY( KEY ": " ); c_sname_dump( &(SNAME), stdout ); )

/**
 * Dumps a list of scoped names.
 *
 * @param KEY The key name to print.
 * @param LIST The list of scoped names to dump.
 *
 * @sa #DUMP_KEY()
 * @sa #DUMP_SNAME()
 */
#define DUMP_SNAME_LIST(KEY,LIST) IF_CDECL_DEBUG( \
  DUMP_KEY( KEY ": " ); c_sname_list_dump( &(LIST), stdout ); )

/**
 * Starts a dump block.
 *
 * @note The dump block _must_ end with #DUMP_END().
 *
 * @sa #DUMP_PROD
 * @sa #DUMP_END
 */
#define DUMP_START()                \
  bool dump_comma = false;          \
  IF_CDECL_DEBUG( PUTS( "{\n" ); )

/**
 * Dumps a C string.
 *
 * @param KEY The key name to print.
 * @param STR The C string to dump.
 *
 * @sa #DUMP_INT()
 * @sa #DUMP_SNAME()
 * @sa #DUMP_STR_LIST()
 */
#define DUMP_STR(KEY,STR) IF_CDECL_DEBUG( \
  DUMP_KEY( KEY ": " ); fputs_quoted( (STR), '"', stdout ); )

/**
 * Dumps a list of C strings.
 *
 * @param KEY The key name to print.
 * @param STR_LIST The list of C strings to dump.
 *
 * @sa #DUMP_STR()
 */
#define DUMP_STR_LIST(KEY,STR_LIST) IF_CDECL_DEBUG( \
  DUMP_KEY( KEY ": " ); str_list_dump( (STR_LIST), stdout ); )

/**
 * Dumps a \ref c_tid_t.
 *
 * @param KEY The key name to print.
 * @param TID The \ref c_tid_t to dump.
 *
 * @sa #DUMP_TYPE()
 */
#define DUMP_TID(KEY,TID) IF_CDECL_DEBUG( \
  DUMP_KEY( KEY ": " ); c_tid_dump( (TID), stdout ); )

/**
 * Dumps a \ref c_type.
 *
 * @param KEY The key name to print.
 * @param TYPE The \ref c_type to dump.
 *
 * @sa #DUMP_TID()
 */
#define DUMP_TYPE(KEY,TYPE) IF_CDECL_DEBUG( \
  DUMP_KEY( KEY ": " ); c_type_dump( &(TYPE), stdout ); )

/** @} */

///////////////////////////////////////////////////////////////////////////////

/**
 * @addtogroup parser-group
 * @{
 */

/**
 * Inherited attributes.
 *
 * @remarks These are grouped into a `struct` (rather than having them as
 * separate global variables) so that they can all be reset (mostly) via a
 * single assignment from `{0}`.
 *
 * @sa ia_cleanup()
 */
struct in_attr {
  c_alignas_t     align;            ///< Alignment, if any.
  unsigned        ast_depth;        ///< Parentheses nesting depth.
  bool            is_typename;      ///< C++ only: is `typename` specified?
  c_sname_t       scope_sname;      ///< C++ only: current scope name, if any.

  /**
   * Type AST stack.
   *
   * @sa ia_type_ast_peek()
   * @sa ia_type_ast_pop()
   * @sa ia_type_ast_push()
   */
  c_ast_list_t    type_ast_stack;

  /**
   * Declaration type specifier AST.
   *
   * @remarks A C/C++ declaration is of the form:
   *
   *      type-specifier declarator+
   *
   * where one or more declarators all have the same base type, e.g.:
   *
   *      int i, *p, a[2], f(double);
   *
   * This is a pointer to the base type AST (above, `int`) that is duplicated
   * for each declarator.  It's set by the first call to ia_type_ast_push().
   *
   * @sa ia_type_spec_ast()
   */
  c_ast_t const  *type_spec_ast;

  /**
   * Red-black node for temporary `typedef`.
   *
   * @remarks This is used only in the `pc99_func_or_constructor_declaration_c`
   * grammar production. It's needed because a temporary `typedef` needs to be
   * created in a mid-rule action then removed in the end-rule action and
   * there's no way to pass local variables between Bison actions, so it's
   * passed via an inherited attribute.
   */
  rb_node_t      *typedef_rb;
};
typedef struct in_attr in_attr_t;

// local functions
PJL_PRINTF_LIKE_FUNC(4)
static void fl_elaborate_error( char const*, int, dym_kind_t, char const*,
                                ... );

// local variables
static c_ast_list_t   gc_ast_list;      ///< c_ast nodes freed after parse.
static in_attr_t      in_attr;          ///< Inherited attributes.
static c_ast_list_t   typedef_ast_list; ///< List of ASTs for `typedef`s.

////////// inline functions ///////////////////////////////////////////////////

/**
 * Duplicates \a ast and adds it to \ref gc_ast_list.
 *
 * @param ast The AST to duplicate.
 * @return Returns the duplicated AST.
 *
 * @sa c_ast_new_gc()
 */
static inline c_ast_t* c_ast_dup_gc( c_ast_t const *ast ) {
  return c_ast_dup( ast, &gc_ast_list );
}

/**
 * Garbage-collects the AST nodes on \a ast_list but does _not_ free \a
 * ast_list itself.
 *
 * @param ast_list The AST list to free the nodes of.
 *
 * @sa c_ast_list_cleanup()
 * @sa c_ast_dup_gc()
 * @sa c_ast_new_gc()
 * @sa c_ast_pair_new_gc()
 */
static inline void c_ast_list_cleanup_gc( c_ast_list_t *ast_list ) {
  slist_cleanup( ast_list, POINTER_CAST( slist_free_fn_t, &c_ast_free ) );
}

/**
 * Creates a new AST and adds it to \ref gc_ast_list.
 *
 * @param kind The kind of AST to create.
 * @param loc A pointer to the token location data.
 * @return Returns a pointer to a new AST.
 *
 * @sa c_ast_dup_gc()
 * @sa c_ast_pair_new_gc()
 */
NODISCARD
static inline c_ast_t* c_ast_new_gc( c_ast_kind_t kind, c_loc_t const *loc ) {
  return c_ast_new( kind, in_attr.ast_depth, loc, &gc_ast_list );
}

/**
 * Set our mode to deciphering gibberish into English.
 */
static inline void gibberish_to_english( void ) {
  cdecl_mode = CDECL_GIBBERISH_TO_ENGLISH;
  lexer_find &= ~LEXER_FIND_CDECL_KEYWORDS;
}

/**
 * Peeks at the type AST at the top of the
 * \ref in_attr.type_ast_stack "type AST inherited attribute stack".
 *
 * @return Returns said AST.
 *
 * @sa ia_type_ast_pop()
 * @sa ia_type_ast_push()
 */
NODISCARD
static inline c_ast_t* ia_type_ast_peek( void ) {
  return slist_front( &in_attr.type_ast_stack );
}

/**
 * Pops a type AST from the
 * \ref in_attr.type_ast_stack "type AST inherited attribute stack".
 *
 * @return Returns said AST.
 *
 * @sa ia_type_ast_peek()
 * @sa ia_type_ast_push()
 */
PJL_DISCARD
static inline c_ast_t* ia_type_ast_pop( void ) {
  return slist_pop_front( &in_attr.type_ast_stack );
}

/**
 * Pushes a type AST onto the
 * \ref in_attr.type_ast_stack "type AST inherited attribute  stack".
 *
 * @remarks Additionally, if \a ast is #K_BUILTIN and \ref
 * in_attr::type_spec_ast "type_spec_ast" is NULL, sets \ref
 * in_attr::type_spec_ast "type_spec_ast" to \a ast.
 *
 * @param ast The AST to push.
 *
 * @sa ia_type_ast_peek()
 * @sa ia_type_ast_pop()
 */
static inline void ia_type_ast_push( c_ast_t *ast ) {
  slist_push_front( &in_attr.type_ast_stack, ast );
  if ( in_attr.type_spec_ast == NULL && ast->kind == K_BUILTIN )
    in_attr.type_spec_ast = ast;
}

/**
 * Given an AST for a type that is the "of type", return type, or "to type" of
 * a declaration, returns a duplicate of \a type_ast if necessary.
 *
 * @param type_ast The AST of a type.
 * @return If \a type_ast `==` \ref in_attr::type_spec_ast "type_spec_ast",
 * returns a duplicate of \a type_ast; otherwise returns \a type_ast.
 *
 * @sa \ref in_attr::type_spec_ast
 */
NODISCARD
static inline c_ast_t* ia_type_spec_ast( c_ast_t *type_ast ) {
  // Yes, == is correct here: we mean the same AST node.
  return type_ast == in_attr.type_spec_ast ?
    c_ast_dup_gc( type_ast ) : type_ast;
}

////////// local functions ////////////////////////////////////////////////////

/**
 * Prints a warning that the attribute \a keyword syntax is not supported (and
 * ignored).
 *
 * @param keyword The attribute syntax keyword, e.g., `__attribute__` or
 * `__declspec`.
 * @param keyword_loc The source location of \a keyword.
 */
static void attr_syntax_not_supported( char const *keyword,
                                       c_loc_t const *keyword_loc ) {
  assert( keyword != NULL );
  assert( keyword_loc != NULL );

  print_warning( keyword_loc,
    "\"%s\" not supported by " CDECL " (ignoring)", keyword
  );
  if ( OPT_LANG_IS( ATTRIBUTES ) )
    print_hint( "%s...%s", other_token_c( "[[" ), other_token_c( "]]" ) );
  else
    EPUTC( '\n' );
}

/**
 * A predicate function for slist_free_if() that checks whether \a ast is one
 * that can be garbage collected: if so, c_ast_free()s it.
 *
 * @param ast_node The \ref slist_node pointing to the AST to check.
 * @param user_data Contains the AST of the type being declared.
 * @return Returns `true` only if \a ast should be removed from the list.
 */
NODISCARD
static bool c_ast_free_if_garbage( slist_node_t *ast_node,
                                   user_data_t user_data ) {
  assert( ast_node != NULL );
  c_ast_t *const ast = ast_node->data;
  assert( ast != NULL );
  c_ast_t const *const type_ast = user_data.pc;
  assert( type_ast != NULL );

  if ( ast == type_ast || !c_ast_is_orphan( ast ) ) {
    assert( ast->kind != K_PLACEHOLDER );
    return false;
  }

  // We also need to ensure the AST isn't in the type_ast_stack.
  FOREACH_SLIST_NODE( type_node, &in_attr.type_ast_stack ) {
    c_ast_t const *const stack_type_ast = type_node->data;
    if ( ast == stack_type_ast )
      return false;
  } // for

  c_ast_free( ast );
  return true;
}

/**
 * Checks whether `typename` is OK since the type's name is a qualified name.
 *
 * @param ast The AST to check.
 * @return Returns `true` only upon success.
 */
NODISCARD
bool c_ast_is_typename_ok( c_ast_t const *ast ) {
  c_ast_t const *const raw_ast = c_ast_untypedef( ast );
  if ( c_sname_count( &raw_ast->sname ) < 2 ) {
    print_error( &ast->loc, "qualified name expected after \"typename\"\n" );
    return false;
  }
  return true;
}

/**
 * If \a bit_width is &gt; 0 and \a ast is an integral type, sets \a ast's \ref
 * c_bit_field_ast::bit_width "bit_width" to \a bit_width.
 *
 * @remarks This check has to be done now in the parser rather than later in
 * the AST since we need to use the \ref c_ast::bit_field `union` member now.
 *
 * @param ast The AST whose \ref c_bit_field_ast::bit_width "bit_width" to
 * possibly set.
 * @param bit_width The bit-field width.
 * @return Return's `true` only if \a ast if an integral type.
 */
NODISCARD
static bool c_ast_set_bit_field_width( c_ast_t *ast, unsigned bit_width ) {
  assert( ast != NULL );

  if ( bit_width > 0 ) {
    if ( !c_ast_is_integral( ast ) ) {
      print_error( &ast->loc, "invalid bit-field type " );
      print_ast_type_aka( ast, stderr );
      EPRINTF( "; must be an integral %stype\n",
        OPT_LANG_IS( enum_BITFIELDS ) ? "or enumeration " : ""
      );
      return false;
    }
    ast->bit_field.bit_width = bit_width;
  }

  return true;
}

/**
 * Defines a type by adding it to the global set.
 *
 * @param type_ast The AST of the type to define.
 * @param decl_flags The declaration flags to use; must only be one of
 * #C_ENG_DECL, #C_GIB_TYPEDEF, or #C_GIB_USING.
 * @return Returns `true` either if the type was defined or it's equivalent to
 * an existing type; `false` if a different type already exists having the same
 * name.
 */
NODISCARD
static bool define_type( c_ast_t const *type_ast, unsigned decl_flags ) {
  assert( type_ast != NULL );
  assert( is_1_bit_only_in_set( decl_flags, C_TYPE_DECL_ANY ) );

  c_ast_t const *const leaf_ast = c_ast_leaf( type_ast );
  if ( c_ast_is_tid_any( leaf_ast, TB_auto ) ) {
    print_error( &leaf_ast->loc,
      "\"%s\" illegal in type definition\n",
      c_type_name_error( &leaf_ast->type )
    );
    return false;
  }

  rb_node_t const *const typedef_rb = c_typedef_add( type_ast, decl_flags );
  c_typedef_t const *const tdef = typedef_rb->data;

  if ( tdef->ast == type_ast ) {
    //
    // Type was added: we have to move the AST from the gc_ast_list so it won't
    // be garbage collected at the end of the parse to a separate
    // typedef_ast_list that's freed only at program termination.
    //
    // But first, garbage collect all orphaned AST nodes.  (For a non-type-
    // defining parse, this step isn't necessary since all nodes are freed at
    // the end of the parse anyway.)
    //
    slist_free_if(
      &gc_ast_list,
      &c_ast_free_if_garbage,
      (user_data_t){ .pc = type_ast }
    );
    slist_push_list_back( &typedef_ast_list, &gc_ast_list );
  }
  else {
    //
    // Type was NOT added because a previously declared type having the same
    // name was returned: check if the types are equal.
    //
    // In C, multiple typedef declarations having the same name are allowed
    // only if the types are equivalent:
    //
    //      typedef int T;
    //      typedef int T;                // OK
    //      typedef double T;             // error: types aren't equivalent
    //
    if ( !c_ast_equal( type_ast, tdef->ast ) ) {
      print_error( &type_ast->loc, "type " );
      print_ast_type_aka( type_ast, stderr );
      EPUTS( " redefinition incompatible with original type \"" );
      print_type_ast( tdef, stderr );
      EPUTS( "\"\n" );
      return false;
    }
  }

  return true;
}

/**
 * Checks whether the type currently being declared (`enum`, `struct`,
 * `typedef`, or `union`) is nested within some other type (`struct` or
 * `union`) and whether the current language is C: if not, prints an error
 * message.
 *
 * @note It is unnecessary to check either when a `class` is being declared or
 * when a type is being declared within a `namespace` since those are not legal
 * in C anyway.
 *
 * @note This function isn't normally called directly; use the
 * #is_nested_type_ok() macro instead.
 *
 * @param file The name of the file where this function was called from.
 * @param line The line number within \a file where this function was called
 * from.
 * @param type_loc The location of the type declaration.
 * @return Returns `true` only if the type currently being declared is either
 * not nested or the current language is C++.
 */
NODISCARD
static bool fl_is_nested_type_ok( char const *file, int line,
                                  c_loc_t const *type_loc ) {
  assert( type_loc != NULL );
  if ( !c_sname_empty( &in_attr.scope_sname ) &&
       !OPT_LANG_IS( NESTED_TYPES ) ) {
    fl_print_error( file, line, type_loc,
      "nested types not supported%s\n",
      C_LANG_WHICH( NESTED_TYPES )
    );
    return false;
  }
  return true;
}

/**
 * A special case of fl_elaborate_error() that prevents oddly worded error
 * messages where a C/C++ keyword is expected, but that keyword isn't a keyword
 * either until a later version of the language or in a different language;
 * hence, the lexer will return the keyword as the `Y_NAME` token instead of
 * the keyword token.
 *
 * For example, if fl_elaborate_error() were used for the following \b cdecl
 * command when the current language is C, you'd get the following:
 * ```
 * declare f as virtual function returning void
 *              ^
 * 14: syntax error: "virtual": "virtual" expected; not a keyword until C++98
 * ```
 * because it's really this:
 * ```
 * ... "virtual" [the name]": "virtual" [the token] expected ...
 * ```
 * and that looks odd.
 *
 * @note This function isn't normally called directly; use the
 * #keyword_expected() macro instead.
 *
 * @param file The name of the file where this function was called from.
 * @param line The line number within \a file where this function was called
 * from.
 * @param keyword A keyword literal.
 *
 * @sa fl_elaborate_error()
 * @sa fl_punct_expected()
 * @sa yyerror()
 */
static void fl_keyword_expected( char const *file, int line,
                                 char const *keyword ) {
  assert( keyword != NULL );

  dym_kind_t dym_kinds = DYM_NONE;

  char const *const error_token = lexer_printable_token();
  if ( error_token != NULL ) {
    if ( strcmp( error_token, keyword ) == 0 ) {
      //
      // The error token is the expected keyword which means the lexer returned
      // it as a name and not the token which likely means it's not a C/C++
      // keyword until a later version of the current language.
      //
      c_keyword_t const *const ck =
        c_keyword_find( keyword, LANG_ANY, C_KW_CTX_DEFAULT );
      if ( ck != NULL ) {
        char const *const which_lang = c_lang_which( ck->lang_ids );
        if ( which_lang[0] != '\0' ) {
          EPUTS( ": " );
          print_debug_file_line( file, line );
          EPRINTF( "\"%s\" not supported%s\n", keyword, which_lang );
          return;
        }
      }
    }

    dym_kinds = cdecl_mode == CDECL_ENGLISH_TO_GIBBERISH ?
      DYM_CDECL_KEYWORDS : DYM_C_KEYWORDS;
  }

  fl_elaborate_error( file, line, dym_kinds, "\"%s\" expected", keyword );
}

/**
 * A special case of fl_elaborate_error() that prevents oddly worded error
 * messages when a punctuation character is expected by not doing keyword look-
 * ups of the error token.

 * For example, if fl_elaborate_error() were used for the following \b cdecl
 * command, you'd get the following:
 * ```
 * explain void f(int g const)
 *                      ^
 * 29: syntax error: "const": ',' expected ("const" is a keyword)
 * ```
 * and that looks odd since, if a punctuation character was expected, it seems
 * silly to point out that the encountered token is a keyword.
 *
 * @note This function isn't normally called directly; use the
 * #punct_expected() macro instead.
 *
 * @param file The name of the file where this function was called from.
 * @param line The line number within \a file where this function was called
 * from.
 * @param punct The punctuation character that was expected.
 *
 * @sa fl_elaborate_error()
 * @sa fl_keyword_expected()
 * @sa yyerror()
 */
static void fl_punct_expected( char const *file, int line, char punct ) {
  EPUTS( ": " );
  print_debug_file_line( file, line );

  char const *const error_token = lexer_printable_token();
  if ( error_token != NULL )
    EPRINTF( "\"%s\": ", error_token );

  print_debug_file_line( file, line );
  EPRINTF( "'%c' expected\n", punct );
}

/**
 * Cleans-up all resources used by \ref in_attr "inherited attributes".
 */
static void ia_cleanup( void ) {
  c_sname_cleanup( &in_attr.scope_sname );
  // Do _not_ pass &c_ast_free for the 2nd argument! All AST nodes were already
  // free'd from the gc_ast_list in parse_cleanup(). Just free the slist nodes.
  slist_cleanup( &in_attr.type_ast_stack, /*free_fn=*/NULL );
  in_attr = (in_attr_t){ 0 };
}

/**
 * Joins \a type_ast and \a decl_ast into a single AST.
 *
 * @param type_ast The type AST.
 * @param decl_ast The declaration AST.
 * @return Returns the joined AST on success or NULL on error.
 */
NODISCARD
c_ast_t* join_type_decl( c_ast_t *type_ast, c_ast_t *decl_ast ) {
  assert( type_ast != NULL );
  assert( decl_ast != NULL );

  if ( in_attr.is_typename && !c_ast_is_typename_ok( type_ast ) )
    return NULL;

  c_type_t type = c_ast_take_type_any( type_ast, &T_TS_typedef );

  if ( c_tid_is_any( type.stids, TS_typedef ) && decl_ast->kind == K_TYPEDEF ) {
    //
    // This is for a case like:
    //
    //      explain typedef int int32_t;
    //
    // that is: explaining an existing typedef.  In order to do that, we have
    // to un-typedef it so we explain the type that it's a typedef for.
    //
    c_ast_t const *const raw_decl_ast = c_ast_untypedef( decl_ast );

    //
    // However, we also have to check whether the typedef being explained is
    // not equivalent to the existing typedef.  This is for a case like:
    //
    //      explain typedef char int32_t;
    //
    if ( !c_ast_equal( type_ast, raw_decl_ast ) ) {
      print_error( &decl_ast->loc, "type " );
      print_ast_type_aka( type_ast, stderr );
      EPUTS( " redefinition incompatible with original type " );
      print_ast_type_aka( decl_ast, stderr );
      EPUTC( '\n' );
      return NULL;
    }

    //
    // Because the raw_decl_ast for the existing type is about to be combined
    // with type_ast, duplicate raw_decl_ast first.
    //
    decl_ast = c_ast_dup_gc( raw_decl_ast );
  }

  c_ast_t *const ast = c_ast_patch_placeholder( type_ast, decl_ast );
  c_type_t const tdef_type = c_ast_take_type_any( ast, &T_TS_typedef );
  c_type_or_eq( &type, &tdef_type );
  c_type_or_eq( &ast->type, &type );

  if ( in_attr.align.kind != C_ALIGNAS_NONE ) {
    ast->align = in_attr.align;
    if ( c_tid_is_any( type.stids, TS_typedef ) ) {
      //
      // We check for illegal aligned typedef here rather than in c_ast_check.c
      // because the "typedef-ness" needed to be removed previously before the
      // eventual call to c_ast_check().
      //
      print_error( &ast->align.loc, "typedef can not be aligned\n" );
      return NULL;
    }
  }

  if ( ast->kind == K_UDEF_CONV &&
       c_sname_local_type( &ast->sname )->btids == TB_SCOPE ) {
    //
    // User-defined conversions don't have names, but they can still have a
    // scope.  Since only classes can have them, if the scope is still
    // TB_SCOPE, change it to TB_class.
    //
    c_sname_set_local_type( &ast->sname, &C_TYPE_LIT_B( TB_class ) );
  }

  return ast;
}

/**
 * Cleans up individial parse data after each parse.
 *
 * @param fatal_error Must be `true` only if a fatal semantic error has
 * occurred and `YYABORT` is about to be called to bail out of parsing by
 * returning from yyparse().
 */
static void parse_cleanup( bool fatal_error ) {
  cdecl_mode = CDECL_ENGLISH_TO_GIBBERISH;

  //
  // We need to reset the lexer differently depending on whether we completed a
  // parse with a fatal error.  If so, do a "hard" reset that also resets the
  // EOF flag of the lexer.
  //
  lexer_reset( /*hard_reset=*/fatal_error );

  c_ast_list_cleanup_gc( &gc_ast_list );
  ia_cleanup();
}

/**
 * Creates a new \ref p_token_list_t containing a single #P_PLACEMARKER token.
 *
 * @return Returns said list.
 */
NODISCARD
static p_token_list_t* p_token_list_new_placemarker( void ) {
  p_token_list_t *const rv_tokens = MALLOC( p_token_list_t, 1 );
  slist_init( rv_tokens );
  slist_push_back( rv_tokens, p_token_new( P_PLACEMARKER, /*literal=*/NULL ) );
  return rv_tokens;
}

/**
 * Called by Bison to print a parsing error message to standard error.
 *
 * @remarks A custom error printing function via `%%define parse.error custom`
 * and
 * [`yyreport_syntax_error()`](https://www.gnu.org/software/bison/manual/html_node/Syntax-Error-Reporting-Function.html)
 * is not done because printing a (perhaps long) list of all the possible
 * expected tokens isn't helpful.
 * @par
 * It's also more flexible to be able to call one of #elaborate_error(),
 * #keyword_expected(), or #punct_expected() at the point of the error rather
 * than having a single function try to figure out the best type of error
 * message to print.
 *
 * @note A newline is _not_ printed since the error message will be appended to
 * by fl_elaborate_error().  For example, the parts of an error message are
 * printed by the functions shown:
 *
 *      42: syntax error: "int": "into" expected
 *      |--||----------||----------------------|
 *      |   |           |
 *      |   yyerror()   fl_elaborate_error()
 *      |
 *      print_loc()
 *
 * @param msg The error message to print.  Bison invariably passes `syntax
 * error`.
 *
 * @sa fl_elaborate_error()
 * @sa fl_keyword_expected()
 * @sa fl_punct_expected()
 * @sa print_loc()
 */
static void yyerror( char const *msg ) {
  assert( msg != NULL );

  c_loc_t const loc = lexer_loc();
  print_loc( &loc );

  color_start( stderr, sgr_error );
  EPUTS( msg );                         // no newline
  color_end( stderr, sgr_error );

  //
  // A syntax error has occurred, but syntax errors aren't fatal since Bison
  // tries to recover.  We'll clean-up the current parse, but YYABORT won't be
  // called so we won't bail out of parsing by returning from yyparse(); hence,
  // parsing will continue.
  //
  parse_cleanup( /*fatal_error=*/false );
}

/** @} */

///////////////////////////////////////////////////////////////////////////////

/// @cond DOXYGEN_IGNORE


#line 1251 "parser.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include  "parser.h" 
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_Y_cast = 3,                     /* Y_cast  */
  YYSYMBOL_Y_const_ENG = 4,                /* Y_const_ENG  */
  YYSYMBOL_Y_declare = 5,                  /* Y_declare  */
  YYSYMBOL_Y_define = 6,                   /* Y_define  */
  YYSYMBOL_Y_dynamic = 7,                  /* Y_dynamic  */
  YYSYMBOL_Y_explain = 8,                  /* Y_explain  */
  YYSYMBOL_Y_no = 9,                       /* Y_no  */
  YYSYMBOL_Y_quit = 10,                    /* Y_quit  */
  YYSYMBOL_Y_reinterpret = 11,             /* Y_reinterpret  */
  YYSYMBOL_Y_set = 12,                     /* Y_set  */
  YYSYMBOL_Y_show = 13,                    /* Y_show  */
  YYSYMBOL_Y_aligned = 14,                 /* Y_aligned  */
  YYSYMBOL_Y_all = 15,                     /* Y_all  */
  YYSYMBOL_Y_array = 16,                   /* Y_array  */
  YYSYMBOL_Y_as = 17,                      /* Y_as  */
  YYSYMBOL_Y_bit = 18,                     /* Y_bit  */
  YYSYMBOL_Y_bit_precise = 19,             /* Y_bit_precise  */
  YYSYMBOL_Y_bits = 20,                    /* Y_bits  */
  YYSYMBOL_Y_by = 21,                      /* Y_by  */
  YYSYMBOL_Y_bytes = 22,                   /* Y_bytes  */
  YYSYMBOL_Y_capturing = 23,               /* Y_capturing  */
  YYSYMBOL_Y_commands = 24,                /* Y_commands  */
  YYSYMBOL_Y_constructor = 25,             /* Y_constructor  */
  YYSYMBOL_Y_conversion = 26,              /* Y_conversion  */
  YYSYMBOL_Y_copy = 27,                    /* Y_copy  */
  YYSYMBOL_Y_defined = 28,                 /* Y_defined  */
  YYSYMBOL_Y_destructor = 29,              /* Y_destructor  */
  YYSYMBOL_Y_english = 30,                 /* Y_english  */
  YYSYMBOL_Y_evaluation = 31,              /* Y_evaluation  */
  YYSYMBOL_Y_expand = 32,                  /* Y_expand  */
  YYSYMBOL_Y_expression = 33,              /* Y_expression  */
  YYSYMBOL_Y_floating = 34,                /* Y_floating  */
  YYSYMBOL_Y_function = 35,                /* Y_function  */
  YYSYMBOL_Y_initialization = 36,          /* Y_initialization  */
  YYSYMBOL_Y_into = 37,                    /* Y_into  */
  YYSYMBOL_Y_lambda = 38,                  /* Y_lambda  */
  YYSYMBOL_Y_length = 39,                  /* Y_length  */
  YYSYMBOL_Y_linkage = 40,                 /* Y_linkage  */
  YYSYMBOL_Y_literal = 41,                 /* Y_literal  */
  YYSYMBOL_Y_macros = 42,                  /* Y_macros  */
  YYSYMBOL_Y_member = 43,                  /* Y_member  */
  YYSYMBOL_Y_non_empty = 44,               /* Y_non_empty  */
  YYSYMBOL_Y_non_member = 45,              /* Y_non_member  */
  YYSYMBOL_Y_of = 46,                      /* Y_of  */
  YYSYMBOL_Y_options = 47,                 /* Y_options  */
  YYSYMBOL_Y_point = 48,                   /* Y_point  */
  YYSYMBOL_Y_pointer = 49,                 /* Y_pointer  */
  YYSYMBOL_Y_precise = 50,                 /* Y_precise  */
  YYSYMBOL_Y_precision = 51,               /* Y_precision  */
  YYSYMBOL_Y_predefined = 52,              /* Y_predefined  */
  YYSYMBOL_Y_pure = 53,                    /* Y_pure  */
  YYSYMBOL_Y_reference = 54,               /* Y_reference  */
  YYSYMBOL_Y_returning = 55,               /* Y_returning  */
  YYSYMBOL_Y_rvalue = 56,                  /* Y_rvalue  */
  YYSYMBOL_Y_scope = 57,                   /* Y_scope  */
  YYSYMBOL_Y_to = 58,                      /* Y_to  */
  YYSYMBOL_Y_user = 59,                    /* Y_user  */
  YYSYMBOL_Y_user_defined = 60,            /* Y_user_defined  */
  YYSYMBOL_Y_variable = 61,                /* Y_variable  */
  YYSYMBOL_Y_wide = 62,                    /* Y_wide  */
  YYSYMBOL_Y_width = 63,                   /* Y_width  */
  YYSYMBOL_Y_PREC_LESS_THAN_upc_layout_qualifier = 64, /* Y_PREC_LESS_THAN_upc_layout_qualifier  */
  YYSYMBOL_Y_COLON_COLON = 65,             /* Y_COLON_COLON  */
  YYSYMBOL_66_ = 66,                       /* "::"  */
  YYSYMBOL_Y_COLON_COLON_STAR = 67,        /* Y_COLON_COLON_STAR  */
  YYSYMBOL_Y_PLUS_PLUS = 68,               /* "++"  */
  YYSYMBOL_Y_MINUS_MINUS = 69,             /* "--"  */
  YYSYMBOL_70_ = 70,                       /* '('  */
  YYSYMBOL_71_ = 71,                       /* ')'  */
  YYSYMBOL_72_ = 72,                       /* '['  */
  YYSYMBOL_73_ = 73,                       /* ']'  */
  YYSYMBOL_74_ = 74,                       /* '.'  */
  YYSYMBOL_Y_MINUS_GREATER = 75,           /* Y_MINUS_GREATER  */
  YYSYMBOL_76_ = 76,                       /* "->"  */
  YYSYMBOL_77_ = 77,                       /* '&'  */
  YYSYMBOL_78_ = 78,                       /* '*'  */
  YYSYMBOL_79_ = 79,                       /* '!'  */
  YYSYMBOL_Y_sizeof = 80,                  /* Y_sizeof  */
  YYSYMBOL_81_ = 81,                       /* '~'  */
  YYSYMBOL_Y_DOT_STAR = 82,                /* Y_DOT_STAR  */
  YYSYMBOL_83_ = 83,                       /* ".*"  */
  YYSYMBOL_Y_MINUS_GREATER_STAR = 84,      /* Y_MINUS_GREATER_STAR  */
  YYSYMBOL_85_ = 85,                       /* "->*"  */
  YYSYMBOL_86_ = 86,                       /* '/'  */
  YYSYMBOL_87_ = 87,                       /* '%'  */
  YYSYMBOL_88_ = 88,                       /* '-'  */
  YYSYMBOL_89_ = 89,                       /* '+'  */
  YYSYMBOL_Y_LESS_LESS = 90,               /* Y_LESS_LESS  */
  YYSYMBOL_91_ = 91,                       /* "<<"  */
  YYSYMBOL_Y_GREATER_GREATER = 92,         /* Y_GREATER_GREATER  */
  YYSYMBOL_93_ = 93,                       /* ">>"  */
  YYSYMBOL_Y_LESS_EQUAL_GREATER = 94,      /* Y_LESS_EQUAL_GREATER  */
  YYSYMBOL_95_ = 95,                       /* "<=>"  */
  YYSYMBOL_96_ = 96,                       /* '<'  */
  YYSYMBOL_97_ = 97,                       /* '>'  */
  YYSYMBOL_Y_LESS_EQUAL = 98,              /* Y_LESS_EQUAL  */
  YYSYMBOL_99_ = 99,                       /* "<="  */
  YYSYMBOL_Y_GREATER_EQUAL = 100,          /* Y_GREATER_EQUAL  */
  YYSYMBOL_101_ = 101,                     /* ">="  */
  YYSYMBOL_Y_EQUAL_EQUAL = 102,            /* Y_EQUAL_EQUAL  */
  YYSYMBOL_103_ = 103,                     /* "=="  */
  YYSYMBOL_Y_EXCLAM_EQUAL = 104,           /* Y_EXCLAM_EQUAL  */
  YYSYMBOL_Y_bit_and = 105,                /* Y_bit_and  */
  YYSYMBOL_106_ = 106,                     /* '^'  */
  YYSYMBOL_107_ = 107,                     /* '|'  */
  YYSYMBOL_Y_AMPER_AMPER = 108,            /* Y_AMPER_AMPER  */
  YYSYMBOL_Y_PIPE_PIPE = 109,              /* Y_PIPE_PIPE  */
  YYSYMBOL_Y_QMARK_COLON = 110,            /* Y_QMARK_COLON  */
  YYSYMBOL_111_ = 111,                     /* "?:"  */
  YYSYMBOL_112_ = 112,                     /* '='  */
  YYSYMBOL_Y_PERCENT_EQUAL = 113,          /* Y_PERCENT_EQUAL  */
  YYSYMBOL_114_ = 114,                     /* "%="  */
  YYSYMBOL_Y_AMPER_EQUAL = 115,            /* Y_AMPER_EQUAL  */
  YYSYMBOL_Y_STAR_EQUAL = 116,             /* Y_STAR_EQUAL  */
  YYSYMBOL_117_ = 117,                     /* "*="  */
  YYSYMBOL_Y_PLUS_EQUAL = 118,             /* Y_PLUS_EQUAL  */
  YYSYMBOL_119_ = 119,                     /* "+="  */
  YYSYMBOL_Y_MINUS_EQUAL = 120,            /* Y_MINUS_EQUAL  */
  YYSYMBOL_121_ = 121,                     /* "-="  */
  YYSYMBOL_Y_SLASH_EQUAL = 122,            /* Y_SLASH_EQUAL  */
  YYSYMBOL_123_ = 123,                     /* "/="  */
  YYSYMBOL_Y_LESS_LESS_EQUAL = 124,        /* Y_LESS_LESS_EQUAL  */
  YYSYMBOL_125_ = 125,                     /* "<<="  */
  YYSYMBOL_Y_GREATER_GREATER_EQUAL = 126,  /* Y_GREATER_GREATER_EQUAL  */
  YYSYMBOL_127_ = 127,                     /* ">>="  */
  YYSYMBOL_Y_CARET_EQUAL = 128,            /* Y_CARET_EQUAL  */
  YYSYMBOL_Y_PIPE_EQUAL = 129,             /* Y_PIPE_EQUAL  */
  YYSYMBOL_130_ = 130,                     /* ','  */
  YYSYMBOL_Y_auto_STORAGE = 131,           /* Y_auto_STORAGE  */
  YYSYMBOL_Y_break = 132,                  /* Y_break  */
  YYSYMBOL_Y_case = 133,                   /* Y_case  */
  YYSYMBOL_Y_char = 134,                   /* Y_char  */
  YYSYMBOL_Y_continue = 135,               /* Y_continue  */
  YYSYMBOL_Y_default = 136,                /* Y_default  */
  YYSYMBOL_Y_do = 137,                     /* Y_do  */
  YYSYMBOL_Y_double = 138,                 /* Y_double  */
  YYSYMBOL_Y_else = 139,                   /* Y_else  */
  YYSYMBOL_Y_extern = 140,                 /* Y_extern  */
  YYSYMBOL_Y_float = 141,                  /* Y_float  */
  YYSYMBOL_Y_for = 142,                    /* Y_for  */
  YYSYMBOL_Y_goto = 143,                   /* Y_goto  */
  YYSYMBOL_Y_if = 144,                     /* Y_if  */
  YYSYMBOL_Y_int = 145,                    /* Y_int  */
  YYSYMBOL_Y_long = 146,                   /* Y_long  */
  YYSYMBOL_Y_register = 147,               /* Y_register  */
  YYSYMBOL_Y_return = 148,                 /* Y_return  */
  YYSYMBOL_Y_short = 149,                  /* Y_short  */
  YYSYMBOL_Y_static = 150,                 /* Y_static  */
  YYSYMBOL_Y_struct = 151,                 /* Y_struct  */
  YYSYMBOL_Y_switch = 152,                 /* Y_switch  */
  YYSYMBOL_Y_typedef = 153,                /* Y_typedef  */
  YYSYMBOL_Y_union = 154,                  /* Y_union  */
  YYSYMBOL_Y_unsigned = 155,               /* Y_unsigned  */
  YYSYMBOL_Y_while = 156,                  /* Y_while  */
  YYSYMBOL_157_ = 157,                     /* '#'  */
  YYSYMBOL_Y_P_CONCAT = 158,               /* "##"  */
  YYSYMBOL_Y_P_MACRO_NAME = 159,           /* Y_P_MACRO_NAME  */
  YYSYMBOL_Y_P_SPACE = 160,                /* Y_P_SPACE  */
  YYSYMBOL_Y_P_define = 161,               /* Y_P_define  */
  YYSYMBOL_Y_P_elif = 162,                 /* Y_P_elif  */
  YYSYMBOL_Y_P_else = 163,                 /* Y_P_else  */
  YYSYMBOL_Y_P_error = 164,                /* Y_P_error  */
  YYSYMBOL_Y_P_if = 165,                   /* Y_P_if  */
  YYSYMBOL_Y_P_ifdef = 166,                /* Y_P_ifdef  */
  YYSYMBOL_Y_P_ifndef = 167,               /* Y_P_ifndef  */
  YYSYMBOL_Y_P_line = 168,                 /* Y_P_line  */
  YYSYMBOL_Y_P_undef = 169,                /* Y_P_undef  */
  YYSYMBOL_Y_P___VA_ARGS__ = 170,          /* Y_P___VA_ARGS__  */
  YYSYMBOL_Y_P___VA_OPT__ = 171,           /* Y_P___VA_OPT__  */
  YYSYMBOL_Y_P_pragma = 172,               /* Y_P_pragma  */
  YYSYMBOL_Y_P_elifdef = 173,              /* Y_P_elifdef  */
  YYSYMBOL_Y_P_elifndef = 174,             /* Y_P_elifndef  */
  YYSYMBOL_Y_P_embed = 175,                /* Y_P_embed  */
  YYSYMBOL_Y_P_warning = 176,              /* Y_P_warning  */
  YYSYMBOL_Y_asm = 177,                    /* Y_asm  */
  YYSYMBOL_Y_const = 178,                  /* Y_const  */
  YYSYMBOL_Y_DOT_DOT_DOT = 179,            /* "..."  */
  YYSYMBOL_Y_enum = 180,                   /* Y_enum  */
  YYSYMBOL_Y_signed = 181,                 /* Y_signed  */
  YYSYMBOL_Y_void = 182,                   /* Y_void  */
  YYSYMBOL_Y_volatile = 183,               /* Y_volatile  */
  YYSYMBOL_Y_wchar_t = 184,                /* Y_wchar_t  */
  YYSYMBOL_Y__Bool = 185,                  /* Y__Bool  */
  YYSYMBOL_Y__Complex = 186,               /* Y__Complex  */
  YYSYMBOL_Y__Imaginary = 187,             /* Y__Imaginary  */
  YYSYMBOL_Y_inline = 188,                 /* Y_inline  */
  YYSYMBOL_Y_restrict = 189,               /* Y_restrict  */
  YYSYMBOL_Y__Alignas = 190,               /* Y__Alignas  */
  YYSYMBOL_Y__Alignof = 191,               /* Y__Alignof  */
  YYSYMBOL_Y__Atomic_QUAL = 192,           /* Y__Atomic_QUAL  */
  YYSYMBOL_Y__Atomic_SPEC = 193,           /* Y__Atomic_SPEC  */
  YYSYMBOL_Y__Generic = 194,               /* Y__Generic  */
  YYSYMBOL_Y__Noreturn = 195,              /* Y__Noreturn  */
  YYSYMBOL_Y__Static_assert = 196,         /* Y__Static_assert  */
  YYSYMBOL_Y__Thread_local = 197,          /* Y__Thread_local  */
  YYSYMBOL_Y_thread = 198,                 /* Y_thread  */
  YYSYMBOL_Y_local = 199,                  /* Y_local  */
  YYSYMBOL_Y_bool = 200,                   /* Y_bool  */
  YYSYMBOL_Y_catch = 201,                  /* Y_catch  */
  YYSYMBOL_Y_class = 202,                  /* Y_class  */
  YYSYMBOL_Y_const_cast = 203,             /* Y_const_cast  */
  YYSYMBOL_Y_CONSTRUCTOR_SNAME = 204,      /* Y_CONSTRUCTOR_SNAME  */
  YYSYMBOL_Y_delete = 205,                 /* Y_delete  */
  YYSYMBOL_Y_DESTRUCTOR_SNAME = 206,       /* Y_DESTRUCTOR_SNAME  */
  YYSYMBOL_Y_dynamic_cast = 207,           /* Y_dynamic_cast  */
  YYSYMBOL_Y_explicit = 208,               /* Y_explicit  */
  YYSYMBOL_Y_false = 209,                  /* Y_false  */
  YYSYMBOL_Y_friend = 210,                 /* Y_friend  */
  YYSYMBOL_Y_mutable = 211,                /* Y_mutable  */
  YYSYMBOL_Y_namespace = 212,              /* Y_namespace  */
  YYSYMBOL_Y_new = 213,                    /* Y_new  */
  YYSYMBOL_Y_operator = 214,               /* Y_operator  */
  YYSYMBOL_Y_OPERATOR_SNAME = 215,         /* Y_OPERATOR_SNAME  */
  YYSYMBOL_Y_private = 216,                /* Y_private  */
  YYSYMBOL_Y_protected = 217,              /* Y_protected  */
  YYSYMBOL_Y_public = 218,                 /* Y_public  */
  YYSYMBOL_Y_reinterpret_cast = 219,       /* Y_reinterpret_cast  */
  YYSYMBOL_Y_static_cast = 220,            /* Y_static_cast  */
  YYSYMBOL_Y_template = 221,               /* Y_template  */
  YYSYMBOL_Y_this = 222,                   /* Y_this  */
  YYSYMBOL_Y_throw = 223,                  /* Y_throw  */
  YYSYMBOL_Y_true = 224,                   /* Y_true  */
  YYSYMBOL_Y_try = 225,                    /* Y_try  */
  YYSYMBOL_Y_typeid = 226,                 /* Y_typeid  */
  YYSYMBOL_Y_typename = 227,               /* Y_typename  */
  YYSYMBOL_Y_using = 228,                  /* Y_using  */
  YYSYMBOL_Y_virtual = 229,                /* Y_virtual  */
  YYSYMBOL_Y_char16_t = 230,               /* Y_char16_t  */
  YYSYMBOL_Y_char32_t = 231,               /* Y_char32_t  */
  YYSYMBOL_Y__BitInt = 232,                /* Y__BitInt  */
  YYSYMBOL_Y_reproducible = 233,           /* Y_reproducible  */
  YYSYMBOL_Y_typeof = 234,                 /* Y_typeof  */
  YYSYMBOL_Y_typeof_unqual = 235,          /* Y_typeof_unqual  */
  YYSYMBOL_Y_unsequenced = 236,            /* Y_unsequenced  */
  YYSYMBOL_Y_ATTR_BEGIN = 237,             /* Y_ATTR_BEGIN  */
  YYSYMBOL_Y_alignas = 238,                /* Y_alignas  */
  YYSYMBOL_Y_alignof = 239,                /* Y_alignof  */
  YYSYMBOL_Y_auto_TYPE = 240,              /* Y_auto_TYPE  */
  YYSYMBOL_Y_carries = 241,                /* Y_carries  */
  YYSYMBOL_Y_dependency = 242,             /* Y_dependency  */
  YYSYMBOL_Y_carries_dependency = 243,     /* Y_carries_dependency  */
  YYSYMBOL_Y_constexpr = 244,              /* Y_constexpr  */
  YYSYMBOL_Y_decltype = 245,               /* Y_decltype  */
  YYSYMBOL_Y_except = 246,                 /* Y_except  */
  YYSYMBOL_Y_final = 247,                  /* Y_final  */
  YYSYMBOL_Y_noexcept = 248,               /* Y_noexcept  */
  YYSYMBOL_Y_nullptr = 249,                /* Y_nullptr  */
  YYSYMBOL_Y_override = 250,               /* Y_override  */
  YYSYMBOL_Y_static_assert = 251,          /* Y_static_assert  */
  YYSYMBOL_Y_thread_local = 252,           /* Y_thread_local  */
  YYSYMBOL_Y_deprecated = 253,             /* Y_deprecated  */
  YYSYMBOL_Y_discard = 254,                /* Y_discard  */
  YYSYMBOL_Y_maybe_unused = 255,           /* Y_maybe_unused  */
  YYSYMBOL_Y_maybe = 256,                  /* Y_maybe  */
  YYSYMBOL_Y_unused = 257,                 /* Y_unused  */
  YYSYMBOL_Y_nodiscard = 258,              /* Y_nodiscard  */
  YYSYMBOL_Y_noreturn = 259,               /* Y_noreturn  */
  YYSYMBOL_Y_char8_t = 260,                /* Y_char8_t  */
  YYSYMBOL_Y_concept = 261,                /* Y_concept  */
  YYSYMBOL_Y_consteval = 262,              /* Y_consteval  */
  YYSYMBOL_Y_constinit = 263,              /* Y_constinit  */
  YYSYMBOL_Y_co_await = 264,               /* Y_co_await  */
  YYSYMBOL_Y_co_return = 265,              /* Y_co_return  */
  YYSYMBOL_Y_co_yield = 266,               /* Y_co_yield  */
  YYSYMBOL_Y_export = 267,                 /* Y_export  */
  YYSYMBOL_Y_no_unique_address = 268,      /* Y_no_unique_address  */
  YYSYMBOL_Y_requires = 269,               /* Y_requires  */
  YYSYMBOL_Y_unique = 270,                 /* Y_unique  */
  YYSYMBOL_Y_address = 271,                /* Y_address  */
  YYSYMBOL_Y_EMC__Accum = 272,             /* Y_EMC__Accum  */
  YYSYMBOL_Y_EMC__Fract = 273,             /* Y_EMC__Fract  */
  YYSYMBOL_Y_EMC__Sat = 274,               /* Y_EMC__Sat  */
  YYSYMBOL_Y_UPC_relaxed = 275,            /* Y_UPC_relaxed  */
  YYSYMBOL_Y_UPC_shared = 276,             /* Y_UPC_shared  */
  YYSYMBOL_Y_UPC_strict = 277,             /* Y_UPC_strict  */
  YYSYMBOL_Y_GNU___attribute__ = 278,      /* Y_GNU___attribute__  */
  YYSYMBOL_Y_GNU___restrict = 279,         /* Y_GNU___restrict  */
  YYSYMBOL_Y_Apple___block = 280,          /* Y_Apple___block  */
  YYSYMBOL_Y_Apple_block = 281,            /* Y_Apple_block  */
  YYSYMBOL_Y_MSC___cdecl = 282,            /* Y_MSC___cdecl  */
  YYSYMBOL_Y_MSC___clrcall = 283,          /* Y_MSC___clrcall  */
  YYSYMBOL_Y_MSC___declspec = 284,         /* Y_MSC___declspec  */
  YYSYMBOL_Y_MSC___fastcall = 285,         /* Y_MSC___fastcall  */
  YYSYMBOL_Y_MSC___stdcall = 286,          /* Y_MSC___stdcall  */
  YYSYMBOL_Y_MSC___thiscall = 287,         /* Y_MSC___thiscall  */
  YYSYMBOL_Y_MSC___vectorcall = 288,       /* Y_MSC___vectorcall  */
  YYSYMBOL_289_ = 289,                     /* ':'  */
  YYSYMBOL_290_ = 290,                     /* ';'  */
  YYSYMBOL_291_ = 291,                     /* '{'  */
  YYSYMBOL_292_ = 292,                     /* '}'  */
  YYSYMBOL_Y_CHAR_LIT = 293,               /* Y_CHAR_LIT  */
  YYSYMBOL_Y_END = 294,                    /* Y_END  */
  YYSYMBOL_Y_ERROR = 295,                  /* Y_ERROR  */
  YYSYMBOL_Y_FLOAT_LIT = 296,              /* Y_FLOAT_LIT  */
  YYSYMBOL_Y_GLOB = 297,                   /* Y_GLOB  */
  YYSYMBOL_Y_INT_LIT = 298,                /* Y_INT_LIT  */
  YYSYMBOL_Y_NAME = 299,                   /* Y_NAME  */
  YYSYMBOL_Y_SET_OPTION = 300,             /* Y_SET_OPTION  */
  YYSYMBOL_Y_STR_LIT = 301,                /* Y_STR_LIT  */
  YYSYMBOL_Y_TYPEDEF_NAME = 302,           /* Y_TYPEDEF_NAME  */
  YYSYMBOL_Y_TYPEDEF_SNAME = 303,          /* Y_TYPEDEF_SNAME  */
  YYSYMBOL_Y_LEXER_ERROR = 304,            /* Y_LEXER_ERROR  */
  YYSYMBOL_305_ = 305,                     /* '$'  */
  YYSYMBOL_306_ = 306,                     /* '@'  */
  YYSYMBOL_307_ = 307,                     /* '`'  */
  YYSYMBOL_308_ = 308,                     /* '?'  */
  YYSYMBOL_YYACCEPT = 309,                 /* $accept  */
  YYSYMBOL_command_list = 310,             /* command_list  */
  YYSYMBOL_command = 311,                  /* command  */
  YYSYMBOL_cast_command = 312,             /* cast_command  */
  YYSYMBOL_new_style_cast_english = 313,   /* new_style_cast_english  */
  YYSYMBOL_declare_command = 314,          /* declare_command  */
  YYSYMBOL_315_1 = 315,                    /* $@1  */
  YYSYMBOL_alignas_or_width_decl_english_ast = 316, /* alignas_or_width_decl_english_ast  */
  YYSYMBOL_alignas_specifier_english = 317, /* alignas_specifier_english  */
  YYSYMBOL_aligned_english = 318,          /* aligned_english  */
  YYSYMBOL_capturing_paren_capture_decl_list_english_opt = 319, /* capturing_paren_capture_decl_list_english_opt  */
  YYSYMBOL_paren_capture_decl_list_english = 320, /* paren_capture_decl_list_english  */
  YYSYMBOL_capture_decl_list_english_opt = 321, /* capture_decl_list_english_opt  */
  YYSYMBOL_capture_decl_list_english = 322, /* capture_decl_list_english  */
  YYSYMBOL_capture_decl_english_ast = 323, /* capture_decl_english_ast  */
  YYSYMBOL_capture_default_opt = 324,      /* capture_default_opt  */
  YYSYMBOL_width_specifier_english_uint = 325, /* width_specifier_english_uint  */
  YYSYMBOL_storage_class_subset_english_type_opt = 326, /* storage_class_subset_english_type_opt  */
  YYSYMBOL_storage_class_subset_english_type = 327, /* storage_class_subset_english_type  */
  YYSYMBOL_storage_class_subset_english_stid = 328, /* storage_class_subset_english_stid  */
  YYSYMBOL_define_command = 329,           /* define_command  */
  YYSYMBOL_expand_command = 330,           /* expand_command  */
  YYSYMBOL_expand_command2 = 331,          /* expand_command2  */
  YYSYMBOL_p_extra_token_except_lparen = 332, /* p_extra_token_except_lparen  */
  YYSYMBOL_p_extra_tokens_opt = 333,       /* p_extra_tokens_opt  */
  YYSYMBOL_p_extra_tokens = 334,           /* p_extra_tokens  */
  YYSYMBOL_p_extra_token = 335,            /* p_extra_token  */
  YYSYMBOL_p_arg_list_opt = 336,           /* p_arg_list_opt  */
  YYSYMBOL_p_comma_arg_list = 337,         /* p_comma_arg_list  */
  YYSYMBOL_p_arg_list = 338,               /* p_arg_list  */
  YYSYMBOL_p_arg_tokens = 339,             /* p_arg_tokens  */
  YYSYMBOL_p_arg_token_as_list = 340,      /* p_arg_token_as_list  */
  YYSYMBOL_p_arg_token = 341,              /* p_arg_token  */
  YYSYMBOL_p_num_lit = 342,                /* p_num_lit  */
  YYSYMBOL_p_other = 343,                  /* p_other  */
  YYSYMBOL_p_punctuator = 344,             /* p_punctuator  */
  YYSYMBOL_p_arg_tokens_with_comma_opt = 345, /* p_arg_tokens_with_comma_opt  */
  YYSYMBOL_p_arg_tokens_with_comma = 346,  /* p_arg_tokens_with_comma  */
  YYSYMBOL_p_arg_token_with_comma_as_list = 347, /* p_arg_token_with_comma_as_list  */
  YYSYMBOL_p_arg_token_with_comma = 348,   /* p_arg_token_with_comma  */
  YYSYMBOL_explain_command = 349,          /* explain_command  */
  YYSYMBOL_350_2 = 350,                    /* $@2  */
  YYSYMBOL_explain = 351,                  /* explain  */
  YYSYMBOL_help_command = 352,             /* help_command  */
  YYSYMBOL_353_3 = 353,                    /* $@3  */
  YYSYMBOL_help_what_opt = 354,            /* help_what_opt  */
  YYSYMBOL_preprocessor_command = 355,     /* preprocessor_command  */
  YYSYMBOL_p_define = 356,                 /* p_define  */
  YYSYMBOL_p_paren_param_list_opt = 357,   /* p_paren_param_list_opt  */
  YYSYMBOL_p_param_list_opt = 358,         /* p_param_list_opt  */
  YYSYMBOL_p_param_list = 359,             /* p_param_list  */
  YYSYMBOL_p_param = 360,                  /* p_param  */
  YYSYMBOL_p_replace_list_opt = 361,       /* p_replace_list_opt  */
  YYSYMBOL_p_replace_list = 362,           /* p_replace_list  */
  YYSYMBOL_p_replace_token = 363,          /* p_replace_token  */
  YYSYMBOL_p_undef = 364,                  /* p_undef  */
  YYSYMBOL_quit_command = 365,             /* quit_command  */
  YYSYMBOL_scoped_command = 366,           /* scoped_command  */
  YYSYMBOL_set_command = 367,              /* set_command  */
  YYSYMBOL_set_option_list = 368,          /* set_option_list  */
  YYSYMBOL_set_option = 369,               /* set_option  */
  YYSYMBOL_set_option_value_opt = 370,     /* set_option_value_opt  */
  YYSYMBOL_show_command = 371,             /* show_command  */
  YYSYMBOL_show_format = 372,              /* show_format  */
  YYSYMBOL_show_format_exp = 373,          /* show_format_exp  */
  YYSYMBOL_show_format_opt = 374,          /* show_format_opt  */
  YYSYMBOL_show_types_opt = 375,           /* show_types_opt  */
  YYSYMBOL_predefined_or_user_types_opt = 376, /* predefined_or_user_types_opt  */
  YYSYMBOL_template_command = 377,         /* template_command  */
  YYSYMBOL_typedef_command = 378,          /* typedef_command  */
  YYSYMBOL_using_command = 379,            /* using_command  */
  YYSYMBOL_c_style_cast_expr_c = 380,      /* c_style_cast_expr_c  */
  YYSYMBOL_381_4 = 381,                    /* $@4  */
  YYSYMBOL_new_style_cast_expr_c = 382,    /* new_style_cast_expr_c  */
  YYSYMBOL_383_5 = 383,                    /* $@5  */
  YYSYMBOL_new_style_cast_c = 384,         /* new_style_cast_c  */
  YYSYMBOL_aligned_declaration_c = 385,    /* aligned_declaration_c  */
  YYSYMBOL_386_6 = 386,                    /* $@6  */
  YYSYMBOL_387_7 = 387,                    /* $@7  */
  YYSYMBOL_alignas_specifier_c = 388,      /* alignas_specifier_c  */
  YYSYMBOL_389_8 = 389,                    /* $@8  */
  YYSYMBOL_alignas = 390,                  /* alignas  */
  YYSYMBOL_asm_declaration_c = 391,        /* asm_declaration_c  */
  YYSYMBOL_scoped_declaration_c = 392,     /* scoped_declaration_c  */
  YYSYMBOL_class_struct_union_declaration_c = 393, /* class_struct_union_declaration_c  */
  YYSYMBOL_394_9 = 394,                    /* $@9  */
  YYSYMBOL_395_10 = 395,                   /* $@10  */
  YYSYMBOL_enum_declaration_c = 396,       /* enum_declaration_c  */
  YYSYMBOL_397_11 = 397,                   /* $@11  */
  YYSYMBOL_namespace_declaration_c = 398,  /* namespace_declaration_c  */
  YYSYMBOL_399_12 = 399,                   /* $@12  */
  YYSYMBOL_400_13 = 400,                   /* $@13  */
  YYSYMBOL_namespace_sname_c_exp = 401,    /* namespace_sname_c_exp  */
  YYSYMBOL_namespace_sname_c = 402,        /* namespace_sname_c  */
  YYSYMBOL_namespace_typedef_sname_c = 403, /* namespace_typedef_sname_c  */
  YYSYMBOL_brace_in_scope_declaration_c_exp = 404, /* brace_in_scope_declaration_c_exp  */
  YYSYMBOL_brace_in_scope_declaration_c_opt = 405, /* brace_in_scope_declaration_c_opt  */
  YYSYMBOL_brace_in_scope_declaration_c = 406, /* brace_in_scope_declaration_c  */
  YYSYMBOL_in_scope_declaration_c_exp = 407, /* in_scope_declaration_c_exp  */
  YYSYMBOL_lambda_declaration_c = 408,     /* lambda_declaration_c  */
  YYSYMBOL_capture_decl_list_c_opt = 409,  /* capture_decl_list_c_opt  */
  YYSYMBOL_capture_decl_list_c = 410,      /* capture_decl_list_c  */
  YYSYMBOL_capture_decl_c_ast = 411,       /* capture_decl_c_ast  */
  YYSYMBOL_lambda_param_c_ast_list_opt = 412, /* lambda_param_c_ast_list_opt  */
  YYSYMBOL_lambda_return_type_c_ast_opt = 413, /* lambda_return_type_c_ast_opt  */
  YYSYMBOL_414_14 = 414,                   /* $@14  */
  YYSYMBOL_template_declaration_c = 415,   /* template_declaration_c  */
  YYSYMBOL_typed_declaration_c = 416,      /* typed_declaration_c  */
  YYSYMBOL_417_15 = 417,                   /* $@15  */
  YYSYMBOL_typedef_declaration_c = 418,    /* typedef_declaration_c  */
  YYSYMBOL_419_16 = 419,                   /* $@16  */
  YYSYMBOL_420_17 = 420,                   /* $@17  */
  YYSYMBOL_typedef_decl_list_c = 421,      /* typedef_decl_list_c  */
  YYSYMBOL_typedef_decl_c = 422,           /* typedef_decl_c  */
  YYSYMBOL_typedef_decl_c_exp = 423,       /* typedef_decl_c_exp  */
  YYSYMBOL_user_defined_conversion_declaration_c = 424, /* user_defined_conversion_declaration_c  */
  YYSYMBOL_using_declaration_c = 425,      /* using_declaration_c  */
  YYSYMBOL_using_decl_c_ast = 426,         /* using_decl_c_ast  */
  YYSYMBOL_427_18 = 427,                   /* $@18  */
  YYSYMBOL_428_19 = 428,                   /* $@19  */
  YYSYMBOL_decl_list_c_opt = 429,          /* decl_list_c_opt  */
  YYSYMBOL_decl_list_c = 430,              /* decl_list_c  */
  YYSYMBOL_decl_c = 431,                   /* decl_c  */
  YYSYMBOL_decl_c_exp = 432,               /* decl_c_exp  */
  YYSYMBOL_decl_c_astp = 433,              /* decl_c_astp  */
  YYSYMBOL_msc_calling_convention_c_astp = 434, /* msc_calling_convention_c_astp  */
  YYSYMBOL_decl2_c_astp = 435,             /* decl2_c_astp  */
  YYSYMBOL_array_decl_c_astp = 436,        /* array_decl_c_astp  */
  YYSYMBOL_array_size_c_ast = 437,         /* array_size_c_ast  */
  YYSYMBOL_block_decl_c_astp = 438,        /* block_decl_c_astp  */
  YYSYMBOL_439_20 = 439,                   /* $@20  */
  YYSYMBOL_destructor_declaration_c = 440, /* destructor_declaration_c  */
  YYSYMBOL_file_scope_constructor_declaration_c = 441, /* file_scope_constructor_declaration_c  */
  YYSYMBOL_file_scope_destructor_declaration_c = 442, /* file_scope_destructor_declaration_c  */
  YYSYMBOL_func_decl_c_astp = 443,         /* func_decl_c_astp  */
  YYSYMBOL_pc99_func_or_constructor_declaration_c = 444, /* pc99_func_or_constructor_declaration_c  */
  YYSYMBOL_445_21 = 445,                   /* $@21  */
  YYSYMBOL_rparen_func_qualifier_list_c_stid_opt = 446, /* rparen_func_qualifier_list_c_stid_opt  */
  YYSYMBOL_447_22 = 447,                   /* $@22  */
  YYSYMBOL_func_qualifier_list_c_stid_opt = 448, /* func_qualifier_list_c_stid_opt  */
  YYSYMBOL_func_qualifier_c_stid = 449,    /* func_qualifier_c_stid  */
  YYSYMBOL_func_ref_qualifier_c_stid_opt = 450, /* func_ref_qualifier_c_stid_opt  */
  YYSYMBOL_noexcept_c_stid_opt = 451,      /* noexcept_c_stid_opt  */
  YYSYMBOL_noexcept_bool_stid_exp = 452,   /* noexcept_bool_stid_exp  */
  YYSYMBOL_trailing_return_type_c_ast_opt = 453, /* trailing_return_type_c_ast_opt  */
  YYSYMBOL_454_23 = 454,                   /* $@23  */
  YYSYMBOL_func_equals_c_stid_opt = 455,   /* func_equals_c_stid_opt  */
  YYSYMBOL_param_c_ast_list_exp = 456,     /* param_c_ast_list_exp  */
  YYSYMBOL_param_c_ast_list_opt = 457,     /* param_c_ast_list_opt  */
  YYSYMBOL_param_c_ast_list = 458,         /* param_c_ast_list  */
  YYSYMBOL_param_c_ast = 459,              /* param_c_ast  */
  YYSYMBOL_460_24 = 460,                   /* $@24  */
  YYSYMBOL_param_c_ast_exp = 461,          /* param_c_ast_exp  */
  YYSYMBOL_nested_decl_c_astp = 462,       /* nested_decl_c_astp  */
  YYSYMBOL_463_25 = 463,                   /* $@25  */
  YYSYMBOL_oper_decl_c_astp = 464,         /* oper_decl_c_astp  */
  YYSYMBOL_pointer_decl_c_astp = 465,      /* pointer_decl_c_astp  */
  YYSYMBOL_466_26 = 466,                   /* $@26  */
  YYSYMBOL_pointer_type_c_ast = 467,       /* pointer_type_c_ast  */
  YYSYMBOL_pc99_pointer_decl_list_c = 468, /* pc99_pointer_decl_list_c  */
  YYSYMBOL_pc99_pointer_decl_c = 469,      /* pc99_pointer_decl_c  */
  YYSYMBOL_470_27 = 470,                   /* $@27  */
  YYSYMBOL_pc99_pointer_type_c_ast = 471,  /* pc99_pointer_type_c_ast  */
  YYSYMBOL_pointer_to_member_decl_c_astp = 472, /* pointer_to_member_decl_c_astp  */
  YYSYMBOL_473_28 = 473,                   /* $@28  */
  YYSYMBOL_pointer_to_member_type_c_ast = 474, /* pointer_to_member_type_c_ast  */
  YYSYMBOL_reference_decl_c_astp = 475,    /* reference_decl_c_astp  */
  YYSYMBOL_476_29 = 476,                   /* $@29  */
  YYSYMBOL_reference_type_c_ast = 477,     /* reference_type_c_ast  */
  YYSYMBOL_typedef_type_decl_c_ast = 478,  /* typedef_type_decl_c_ast  */
  YYSYMBOL_user_defined_conversion_decl_c_astp = 479, /* user_defined_conversion_decl_c_astp  */
  YYSYMBOL_480_30 = 480,                   /* $@30  */
  YYSYMBOL_user_defined_literal_decl_c_astp = 481, /* user_defined_literal_decl_c_astp  */
  YYSYMBOL_cast_c_astp_opt = 482,          /* cast_c_astp_opt  */
  YYSYMBOL_cast_c_astp = 483,              /* cast_c_astp  */
  YYSYMBOL_cast2_c_astp = 484,             /* cast2_c_astp  */
  YYSYMBOL_array_cast_c_astp = 485,        /* array_cast_c_astp  */
  YYSYMBOL_block_cast_c_astp = 486,        /* block_cast_c_astp  */
  YYSYMBOL_487_31 = 487,                   /* $@31  */
  YYSYMBOL_func_cast_c_astp = 488,         /* func_cast_c_astp  */
  YYSYMBOL_nested_cast_c_astp = 489,       /* nested_cast_c_astp  */
  YYSYMBOL_490_32 = 490,                   /* $@32  */
  YYSYMBOL_pointer_cast_c_astp = 491,      /* pointer_cast_c_astp  */
  YYSYMBOL_492_33 = 492,                   /* $@33  */
  YYSYMBOL_pointer_to_member_cast_c_astp = 493, /* pointer_to_member_cast_c_astp  */
  YYSYMBOL_494_34 = 494,                   /* $@34  */
  YYSYMBOL_reference_cast_c_astp = 495,    /* reference_cast_c_astp  */
  YYSYMBOL_496_35 = 496,                   /* $@35  */
  YYSYMBOL_udc_decl_c_ast_opt = 497,       /* udc_decl_c_ast_opt  */
  YYSYMBOL_udc_decl_c_ast = 498,           /* udc_decl_c_ast  */
  YYSYMBOL_pointer_udc_decl_c_ast = 499,   /* pointer_udc_decl_c_ast  */
  YYSYMBOL_500_36 = 500,                   /* $@36  */
  YYSYMBOL_pointer_to_member_udc_decl_c_ast = 501, /* pointer_to_member_udc_decl_c_ast  */
  YYSYMBOL_502_37 = 502,                   /* $@37  */
  YYSYMBOL_reference_udc_decl_c_ast = 503, /* reference_udc_decl_c_ast  */
  YYSYMBOL_504_38 = 504,                   /* $@38  */
  YYSYMBOL_type_c_ast = 505,               /* type_c_ast  */
  YYSYMBOL_type_modifier_list_c_type_opt = 506, /* type_modifier_list_c_type_opt  */
  YYSYMBOL_type_modifier_list_c_type = 507, /* type_modifier_list_c_type  */
  YYSYMBOL_type_modifier_c_type = 508,     /* type_modifier_c_type  */
  YYSYMBOL_type_modifier_base_type = 509,  /* type_modifier_base_type  */
  YYSYMBOL_east_modified_type_c_ast = 510, /* east_modified_type_c_ast  */
  YYSYMBOL_atomic_builtin_typedef_type_c_ast = 511, /* atomic_builtin_typedef_type_c_ast  */
  YYSYMBOL_atomic_specifier_type_c_ast = 512, /* atomic_specifier_type_c_ast  */
  YYSYMBOL_513_39 = 513,                   /* $@39  */
  YYSYMBOL_builtin_type_c_ast = 514,       /* builtin_type_c_ast  */
  YYSYMBOL_builtin_no_BitInt_c_btid = 515, /* builtin_no_BitInt_c_btid  */
  YYSYMBOL_typeof_type_c_ast = 516,        /* typeof_type_c_ast  */
  YYSYMBOL_517_40 = 517,                   /* $@40  */
  YYSYMBOL_typeof = 518,                   /* typeof  */
  YYSYMBOL_enum_class_struct_union_c_ast = 519, /* enum_class_struct_union_c_ast  */
  YYSYMBOL_class_struct_union_c_ast = 520, /* class_struct_union_c_ast  */
  YYSYMBOL_enum_c_ast = 521,               /* enum_c_ast  */
  YYSYMBOL_enum_btids = 522,               /* enum_btids  */
  YYSYMBOL_enum_fixed_type_c_ast_opt = 523, /* enum_fixed_type_c_ast_opt  */
  YYSYMBOL_enum_fixed_type_c_ast = 524,    /* enum_fixed_type_c_ast  */
  YYSYMBOL_enum_fixed_type_modifier_list_btid_opt = 525, /* enum_fixed_type_modifier_list_btid_opt  */
  YYSYMBOL_enum_fixed_type_modifier_list_btid = 526, /* enum_fixed_type_modifier_list_btid  */
  YYSYMBOL_enum_fixed_type_modifier_btid = 527, /* enum_fixed_type_modifier_btid  */
  YYSYMBOL_enum_unmodified_fixed_type_c_ast = 528, /* enum_unmodified_fixed_type_c_ast  */
  YYSYMBOL_class_struct_btid_opt = 529,    /* class_struct_btid_opt  */
  YYSYMBOL_class_struct_btid = 530,        /* class_struct_btid  */
  YYSYMBOL_class_struct_union_btid = 531,  /* class_struct_union_btid  */
  YYSYMBOL_type_qualifier_list_c_stid_opt = 532, /* type_qualifier_list_c_stid_opt  */
  YYSYMBOL_type_qualifier_list_c_stid = 533, /* type_qualifier_list_c_stid  */
  YYSYMBOL_type_qualifier_c_stid = 534,    /* type_qualifier_c_stid  */
  YYSYMBOL_cv_qualifier_stid = 535,        /* cv_qualifier_stid  */
  YYSYMBOL_cv_qualifier_list_stid_opt = 536, /* cv_qualifier_list_stid_opt  */
  YYSYMBOL_restrict_qualifier_c_stid = 537, /* restrict_qualifier_c_stid  */
  YYSYMBOL_upc_layout_qualifier_c = 538,   /* upc_layout_qualifier_c  */
  YYSYMBOL_storage_class_c_type = 539,     /* storage_class_c_type  */
  YYSYMBOL__Noreturn_atid = 540,           /* _Noreturn_atid  */
  YYSYMBOL_attribute_specifier_list_c_atid_opt = 541, /* attribute_specifier_list_c_atid_opt  */
  YYSYMBOL_attribute_specifier_list_c_atid = 542, /* attribute_specifier_list_c_atid  */
  YYSYMBOL_543_41 = 543,                   /* $@41  */
  YYSYMBOL_using_opt = 544,                /* using_opt  */
  YYSYMBOL_attribute_list_c_atid_opt = 545, /* attribute_list_c_atid_opt  */
  YYSYMBOL_attribute_list_c_atid = 546,    /* attribute_list_c_atid  */
  YYSYMBOL_attribute_c_atid_exp = 547,     /* attribute_c_atid_exp  */
  YYSYMBOL_attribute_str_arg_c_opt = 548,  /* attribute_str_arg_c_opt  */
  YYSYMBOL_gnu_or_msc_attribute_specifier_list_c_opt = 549, /* gnu_or_msc_attribute_specifier_list_c_opt  */
  YYSYMBOL_gnu_or_msc_attribute_specifier_list_c = 550, /* gnu_or_msc_attribute_specifier_list_c  */
  YYSYMBOL_gnu_attribute_specifier_list_c_opt = 551, /* gnu_attribute_specifier_list_c_opt  */
  YYSYMBOL_gnu_attribute_specifier_list_c = 552, /* gnu_attribute_specifier_list_c  */
  YYSYMBOL_gnu_attribute_specifier_c = 553, /* gnu_attribute_specifier_c  */
  YYSYMBOL_554_42 = 554,                   /* $@42  */
  YYSYMBOL_gnu_attribute_list_c_opt = 555, /* gnu_attribute_list_c_opt  */
  YYSYMBOL_gnu_attribuet_list_c = 556,     /* gnu_attribuet_list_c  */
  YYSYMBOL_gnu_attribute_c_exp = 557,      /* gnu_attribute_c_exp  */
  YYSYMBOL_gnu_attribute_decl_arg_list_c_opt = 558, /* gnu_attribute_decl_arg_list_c_opt  */
  YYSYMBOL_gnu_attribute_arg_list_c_opt = 559, /* gnu_attribute_arg_list_c_opt  */
  YYSYMBOL_gnu_attribute_arg_list_c = 560, /* gnu_attribute_arg_list_c  */
  YYSYMBOL_gnu_attribute_arg_c = 561,      /* gnu_attribute_arg_c  */
  YYSYMBOL_msc_attribute_specifier_list_c = 562, /* msc_attribute_specifier_list_c  */
  YYSYMBOL_msc_attribute_specifier_c = 563, /* msc_attribute_specifier_c  */
  YYSYMBOL_564_43 = 564,                   /* $@43  */
  YYSYMBOL_msc_attribute_list_c_opt = 565, /* msc_attribute_list_c_opt  */
  YYSYMBOL_msc_attribuet_list_c = 566,     /* msc_attribuet_list_c  */
  YYSYMBOL_decl_english_ast = 567,         /* decl_english_ast  */
  YYSYMBOL_array_decl_english_ast = 568,   /* array_decl_english_ast  */
  YYSYMBOL_array_size_decl_ast = 569,      /* array_size_decl_ast  */
  YYSYMBOL_length_opt = 570,               /* length_opt  */
  YYSYMBOL_block_decl_english_ast = 571,   /* block_decl_english_ast  */
  YYSYMBOL_constructor_decl_english_ast = 572, /* constructor_decl_english_ast  */
  YYSYMBOL_destructor_decl_english_ast = 573, /* destructor_decl_english_ast  */
  YYSYMBOL_parens_opt = 574,               /* parens_opt  */
  YYSYMBOL_func_decl_english_ast = 575,    /* func_decl_english_ast  */
  YYSYMBOL_func_qualifier_english_type_opt = 576, /* func_qualifier_english_type_opt  */
  YYSYMBOL_msc_calling_convention_atid = 577, /* msc_calling_convention_atid  */
  YYSYMBOL_paren_param_decl_list_english_opt = 578, /* paren_param_decl_list_english_opt  */
  YYSYMBOL_paren_param_decl_list_english = 579, /* paren_param_decl_list_english  */
  YYSYMBOL_param_decl_list_english_opt = 580, /* param_decl_list_english_opt  */
  YYSYMBOL_param_decl_list_english = 581,  /* param_decl_list_english  */
  YYSYMBOL_decl_english_ast_exp = 582,     /* decl_english_ast_exp  */
  YYSYMBOL_ref_qualifier_english_stid_opt = 583, /* ref_qualifier_english_stid_opt  */
  YYSYMBOL_returning_english_ast_opt = 584, /* returning_english_ast_opt  */
  YYSYMBOL_returning_english_ast = 585,    /* returning_english_ast  */
  YYSYMBOL_qualified_decl_english_ast = 586, /* qualified_decl_english_ast  */
  YYSYMBOL_type_qualifier_list_english_type_opt = 587, /* type_qualifier_list_english_type_opt  */
  YYSYMBOL_type_qualifier_list_english_type = 588, /* type_qualifier_list_english_type  */
  YYSYMBOL_type_qualifier_english_type = 589, /* type_qualifier_english_type  */
  YYSYMBOL_attribute_english_atid = 590,   /* attribute_english_atid  */
  YYSYMBOL_storage_class_english_stid = 591, /* storage_class_english_stid  */
  YYSYMBOL_eval_expr_init_stid = 592,      /* eval_expr_init_stid  */
  YYSYMBOL_linkage_stid = 593,             /* linkage_stid  */
  YYSYMBOL_linkage_opt = 594,              /* linkage_opt  */
  YYSYMBOL_type_qualifier_english_stid = 595, /* type_qualifier_english_stid  */
  YYSYMBOL_upc_layout_qualifier_english = 596, /* upc_layout_qualifier_english  */
  YYSYMBOL_qualifiable_decl_english_ast = 597, /* qualifiable_decl_english_ast  */
  YYSYMBOL_pointer_decl_english_ast = 598, /* pointer_decl_english_ast  */
  YYSYMBOL_reference_decl_english_ast = 599, /* reference_decl_english_ast  */
  YYSYMBOL_reference_english_ast = 600,    /* reference_english_ast  */
  YYSYMBOL_user_defined_literal_decl_english_ast = 601, /* user_defined_literal_decl_english_ast  */
  YYSYMBOL_var_decl_english_ast = 602,     /* var_decl_english_ast  */
  YYSYMBOL_type_english_ast = 603,         /* type_english_ast  */
  YYSYMBOL_type_modifier_list_english_type_opt = 604, /* type_modifier_list_english_type_opt  */
  YYSYMBOL_type_modifier_list_english_type = 605, /* type_modifier_list_english_type  */
  YYSYMBOL_type_modifier_english_type = 606, /* type_modifier_english_type  */
  YYSYMBOL_unmodified_type_english_ast = 607, /* unmodified_type_english_ast  */
  YYSYMBOL_builtin_type_english_ast = 608, /* builtin_type_english_ast  */
  YYSYMBOL_builtin_no_BitInt_english_btid = 609, /* builtin_no_BitInt_english_btid  */
  YYSYMBOL_BitInt_english_int = 610,       /* BitInt_english_int  */
  YYSYMBOL_BitInt_english = 611,           /* BitInt_english  */
  YYSYMBOL_precise_opt = 612,              /* precise_opt  */
  YYSYMBOL_class_struct_union_english_ast = 613, /* class_struct_union_english_ast  */
  YYSYMBOL_enum_english_ast = 614,         /* enum_english_ast  */
  YYSYMBOL_of_type_enum_fixed_type_english_ast_opt = 615, /* of_type_enum_fixed_type_english_ast_opt  */
  YYSYMBOL_enum_fixed_type_english_ast = 616, /* enum_fixed_type_english_ast  */
  YYSYMBOL_enum_fixed_type_modifier_list_english_btid_opt = 617, /* enum_fixed_type_modifier_list_english_btid_opt  */
  YYSYMBOL_enum_fixed_type_modifier_list_english_btid = 618, /* enum_fixed_type_modifier_list_english_btid  */
  YYSYMBOL_enum_unmodified_fixed_type_english_ast = 619, /* enum_unmodified_fixed_type_english_ast  */
  YYSYMBOL_any_name = 620,                 /* any_name  */
  YYSYMBOL_any_name_exp = 621,             /* any_name_exp  */
  YYSYMBOL_any_sname_c = 622,              /* any_sname_c  */
  YYSYMBOL_any_sname_c_exp = 623,          /* any_sname_c_exp  */
  YYSYMBOL_any_sname_c_opt = 624,          /* any_sname_c_opt  */
  YYSYMBOL_any_typedef = 625,              /* any_typedef  */
  YYSYMBOL_name_ast = 626,                 /* name_ast  */
  YYSYMBOL_name_exp = 627,                 /* name_exp  */
  YYSYMBOL_name_cat = 628,                 /* name_cat  */
  YYSYMBOL_name_opt = 629,                 /* name_opt  */
  YYSYMBOL_oper_sname_c_opt = 630,         /* oper_sname_c_opt  */
  YYSYMBOL_typedef_type_c_ast = 631,       /* typedef_type_c_ast  */
  YYSYMBOL_sub_scope_sname_c_opt = 632,    /* sub_scope_sname_c_opt  */
  YYSYMBOL_sname_c = 633,                  /* sname_c  */
  YYSYMBOL_sname_c_ast = 634,              /* sname_c_ast  */
  YYSYMBOL_bit_field_c_uint_opt = 635,     /* bit_field_c_uint_opt  */
  YYSYMBOL_sname_c_exp = 636,              /* sname_c_exp  */
  YYSYMBOL_sname_c_opt = 637,              /* sname_c_opt  */
  YYSYMBOL_sname_english = 638,            /* sname_english  */
  YYSYMBOL_sname_english_ast = 639,        /* sname_english_ast  */
  YYSYMBOL_sname_english_exp = 640,        /* sname_english_exp  */
  YYSYMBOL_sname_english_opt = 641,        /* sname_english_opt  */
  YYSYMBOL_sname_list_english = 642,       /* sname_list_english  */
  YYSYMBOL_typedef_sname_c = 643,          /* typedef_sname_c  */
  YYSYMBOL_address_exp = 644,              /* address_exp  */
  YYSYMBOL_array_exp = 645,                /* array_exp  */
  YYSYMBOL_as_exp = 646,                   /* as_exp  */
  YYSYMBOL_as_into_to_exp = 647,           /* as_into_to_exp  */
  YYSYMBOL_as_or_to_opt = 648,             /* as_or_to_opt  */
  YYSYMBOL_bits_opt = 649,                 /* bits_opt  */
  YYSYMBOL_bytes_opt = 650,                /* bytes_opt  */
  YYSYMBOL_cast_exp = 651,                 /* cast_exp  */
  YYSYMBOL_char_exp = 652,                 /* char_exp  */
  YYSYMBOL_class_struct_union_btid_exp = 653, /* class_struct_union_btid_exp  */
  YYSYMBOL_colon_exp = 654,                /* colon_exp  */
  YYSYMBOL_comma_exp = 655,                /* comma_exp  */
  YYSYMBOL_conversion_exp = 656,           /* conversion_exp  */
  YYSYMBOL_c_operator = 657,               /* c_operator  */
  YYSYMBOL_default_exp = 658,              /* default_exp  */
  YYSYMBOL_defined_exp = 659,              /* defined_exp  */
  YYSYMBOL_dependency_exp = 660,           /* dependency_exp  */
  YYSYMBOL_destructor_sname = 661,         /* destructor_sname  */
  YYSYMBOL_empty_str_lit_exp = 662,        /* empty_str_lit_exp  */
  YYSYMBOL_equals_exp = 663,               /* equals_exp  */
  YYSYMBOL_extern_linkage_c_stid = 664,    /* extern_linkage_c_stid  */
  YYSYMBOL_extern_linkage_c_stid_opt = 665, /* extern_linkage_c_stid_opt  */
  YYSYMBOL_glob = 666,                     /* glob  */
  YYSYMBOL_glob_opt = 667,                 /* glob_opt  */
  YYSYMBOL_gt_exp = 668,                   /* gt_exp  */
  YYSYMBOL_inline_stid_opt = 669,          /* inline_stid_opt  */
  YYSYMBOL_int_exp = 670,                  /* int_exp  */
  YYSYMBOL_literal_exp = 671,              /* literal_exp  */
  YYSYMBOL_local_exp = 672,                /* local_exp  */
  YYSYMBOL_lparen_exp = 673,               /* lparen_exp  */
  YYSYMBOL_lt_exp = 674,                   /* lt_exp  */
  YYSYMBOL_member_or_non_member_opt = 675, /* member_or_non_member_opt  */
  YYSYMBOL_namespace_btid_exp = 676,       /* namespace_btid_exp  */
  YYSYMBOL_namespace_type = 677,           /* namespace_type  */
  YYSYMBOL_of_exp = 678,                   /* of_exp  */
  YYSYMBOL_of_scope_english = 679,         /* of_scope_english  */
  YYSYMBOL_of_scope_list_english = 680,    /* of_scope_list_english  */
  YYSYMBOL_of_scope_list_english_opt = 681, /* of_scope_list_english_opt  */
  YYSYMBOL_operator_exp = 682,             /* operator_exp  */
  YYSYMBOL_operator_opt = 683,             /* operator_opt  */
  YYSYMBOL_point_exp = 684,                /* point_exp  */
  YYSYMBOL_precision_opt = 685,            /* precision_opt  */
  YYSYMBOL_rbrace_exp = 686,               /* rbrace_exp  */
  YYSYMBOL_rbracket_exp = 687,             /* rbracket_exp  */
  YYSYMBOL_reference_exp = 688,            /* reference_exp  */
  YYSYMBOL_returning = 689,                /* returning  */
  YYSYMBOL_returning_exp = 690,            /* returning_exp  */
  YYSYMBOL_rparen_exp = 691,               /* rparen_exp  */
  YYSYMBOL_scope_english_type = 692,       /* scope_english_type  */
  YYSYMBOL_scope_english_type_exp = 693,   /* scope_english_type_exp  */
  YYSYMBOL_semi_exp = 694,                 /* semi_exp  */
  YYSYMBOL_semi_opt = 695,                 /* semi_opt  */
  YYSYMBOL_semi_or_end = 696,              /* semi_or_end  */
  YYSYMBOL_static_stid_opt = 697,          /* static_stid_opt  */
  YYSYMBOL_str_lit = 698,                  /* str_lit  */
  YYSYMBOL_str_lit_exp = 699,              /* str_lit_exp  */
  YYSYMBOL_this_exp = 700,                 /* this_exp  */
  YYSYMBOL_this_stid_opt = 701,            /* this_stid_opt  */
  YYSYMBOL_to_exp = 702,                   /* to_exp  */
  YYSYMBOL_type_opt = 703,                 /* type_opt  */
  YYSYMBOL_typename_flag_opt = 704,        /* typename_flag_opt  */
  YYSYMBOL_uint_lit = 705,                 /* uint_lit  */
  YYSYMBOL_uint_lit_exp = 706,             /* uint_lit_exp  */
  YYSYMBOL_uint_lit_opt = 707,             /* uint_lit_opt  */
  YYSYMBOL_unused_exp = 708,               /* unused_exp  */
  YYSYMBOL_user_defined = 709,             /* user_defined  */
  YYSYMBOL_virtual_stid_exp = 710,         /* virtual_stid_exp  */
  YYSYMBOL_virtual_stid_opt = 711          /* virtual_stid_opt  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
             && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE) \
             + YYSIZEOF (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  2
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   6349

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  309
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  403
/* YYNRULES -- Number of rules.  */
#define YYNRULES  1083
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  1425

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   535


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    79,     2,   157,   305,    87,    77,     2,
      70,    71,    78,    89,   130,    88,    74,    86,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   289,   290,
      96,   112,    97,   308,   306,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    72,     2,    73,   106,     2,   307,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   291,   107,   292,    81,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    75,    76,    80,    82,    83,
      84,    85,    90,    91,    92,    93,    94,    95,    98,    99,
     100,   101,   102,   103,   104,   105,   108,   109,   110,   111,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   129,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   140,   141,   142,   143,
     144,   145,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,  1875,  1875,  1876,  1885,  1886,  1887,  1888,  1889,  1890,
    1891,  1892,  1893,  1894,  1895,  1896,  1897,  1898,  1899,  1900,
    1919,  1942,  1967,  1968,  1969,  1970,  1971,  1980,  2059,  2058,
    2123,  2159,  2192,  2202,  2204,  2220,  2251,  2257,  2263,  2272,
    2273,  2274,  2278,  2279,  2283,  2290,  2294,  2298,  2306,  2307,
    2311,  2327,  2343,  2348,  2353,  2359,  2363,  2364,  2365,  2369,
    2383,  2384,  2403,  2404,  2425,  2429,  2430,  2431,  2432,  2433,
    2434,  2435,  2436,  2437,  2438,  2439,  2440,  2441,  2442,  2443,
    2444,  2450,  2501,  2523,  2530,  2545,  2557,  2565,  2566,  2573,
    2574,  2578,  2583,  2592,  2593,  2601,  2606,  2618,  2638,  2658,
    2680,  2687,  2695,  2700,  2719,  2731,  2740,  2745,  2749,  2755,
    2764,  2768,  2772,  2776,  2780,  2784,  2788,  2795,  2796,  2800,
    2801,  2802,  2806,  2807,  2808,  2809,  2812,  2813,  2815,  2816,
    2817,  2818,  2819,  2820,  2821,  2822,  2823,  2824,  2825,  2826,
    2827,  2828,  2829,  2830,  2831,  2832,  2833,  2834,  2835,  2836,
    2837,  2838,  2839,  2840,  2841,  2842,  2843,  2844,  2845,  2846,
    2847,  2848,  2849,  2850,  2851,  2852,  2853,  2854,  2855,  2856,
    2861,  2865,  2879,  2885,  2889,  2895,  2904,  2905,  2917,  2922,
    2927,  2932,  2937,  2942,  2947,  2952,  2957,  2962,  2972,  2981,
    2991,  2991,  3006,  3011,  3035,  3042,  3049,  3067,  3066,  3085,
    3086,  3087,  3088,  3093,  3105,  3106,  3108,  3110,  3115,  3120,
    3125,  3130,  3135,  3140,  3145,  3150,  3155,  3160,  3165,  3170,
    3177,  3219,  3220,  3224,  3234,  3238,  3252,  3268,  3273,  3278,
    3289,  3290,  3294,  3300,  3309,  3320,  3324,  3328,  3332,  3336,
    3340,  3347,  3356,  3362,  3368,  3372,  3376,  3377,  3381,  3391,
    3392,  3393,  3403,  3414,  3425,  3431,  3437,  3449,  3454,  3463,
    3472,  3473,  3474,  3488,  3489,  3499,  3500,  3504,  3505,  3509,
    3510,  3515,  3518,  3519,  3525,  3531,  3537,  3548,  3547,  3585,
    3596,  3595,  3628,  3629,  3630,  3631,  3641,  3642,  3641,  3647,
    3661,  3661,  3680,  3687,  3688,  3694,  3705,  3706,  3707,  3715,
    3720,  3714,  3770,  3769,  3812,  3816,  3811,  3880,  3881,  3882,
    3895,  3910,  3926,  3943,  3963,  3978,  3995,  4014,  4018,  4019,
    4026,  4027,  4031,  4032,  4036,  4037,  4038,  4039,  4048,  4081,
    4082,  4086,  4103,  4119,  4124,  4130,  4135,  4140,  4145,  4153,
    4154,  4158,  4159,  4159,  4180,  4190,  4190,  4200,  4206,  4199,
    4221,  4222,  4227,  4292,  4293,  4302,  4319,  4330,  4351,  4329,
    4416,  4465,  4473,  4478,  4487,  4516,  4517,  4524,  4525,  4526,
    4527,  4528,  4537,  4538,  4542,  4543,  4544,  4545,  4546,  4547,
    4551,  4555,  4556,  4563,  4599,  4604,  4610,  4616,  4622,  4630,
    4638,  4644,  4653,  4662,  4673,  4672,  4726,  4761,  4799,  4841,
    4979,  4978,  5089,  5088,  5107,  5108,  5125,  5126,  5127,  5135,
    5139,  5140,  5141,  5145,  5146,  5147,  5151,  5155,  5172,  5173,
    5174,  5181,  5183,  5183,  5236,  5243,  5244,  5245,  5246,  5254,
    5266,  5267,  5275,  5276,  5280,  5294,  5313,  5312,  5348,  5353,
    5366,  5367,  5377,  5376,  5402,  5459,  5459,  5480,  5501,  5506,
    5514,  5514,  5535,  5576,  5576,  5597,  5637,  5637,  5657,  5675,
    5698,  5797,  5796,  5843,  5889,  5890,  5894,  5895,  5896,  5897,
    5901,  5902,  5903,  5904,  5906,  5916,  5955,  5954,  6005,  6081,
    6080,  6124,  6124,  6147,  6147,  6171,  6171,  6201,  6202,  6206,
    6207,  6208,  6209,  6213,  6213,  6232,  6232,  6251,  6251,  6279,
    6315,  6331,  6335,  6336,  6340,  6355,  6359,  6383,  6384,  6385,
    6392,  6393,  6394,  6395,  6396,  6397,  6398,  6404,  6408,  6426,
    6445,  6446,  6447,  6448,  6455,  6454,  6503,  6515,  6531,  6532,
    6533,  6534,  6535,  6536,  6537,  6538,  6539,  6540,  6541,  6542,
    6543,  6544,  6549,  6548,  6591,  6600,  6601,  6607,  6608,  6612,
    6632,  6644,  6666,  6680,  6684,  6685,  6686,  6702,  6721,  6748,
    6768,  6769,  6773,  6790,  6794,  6795,  6796,  6797,  6801,  6802,
    6803,  6809,  6810,  6814,  6815,  6819,  6820,  6826,  6827,  6831,
    6847,  6852,  6859,  6860,  6861,  6862,  6863,  6864,  6865,  6869,
    6870,  6874,  6875,  6892,  6906,  6910,  6911,  6912,  6913,  6922,
    6923,  6924,  6925,  6926,  6927,  6928,  6929,  6930,  6931,  6932,
    6933,  6934,  6935,  6964,  6966,  6967,  6968,  6969,  6970,  6974,
    6975,  6981,  6982,  6987,  6986,  7012,  7019,  7020,  7028,  7029,
    7033,  7048,  7052,  7053,  7054,  7055,  7056,  7057,  7058,  7059,
    7060,  7090,  7097,  7098,  7106,  7107,  7111,  7112,  7116,  7117,
    7121,  7122,  7127,  7126,  7142,  7143,  7147,  7148,  7152,  7156,
    7163,  7164,  7168,  7169,  7173,  7174,  7178,  7179,  7180,  7181,
    7182,  7183,  7190,  7191,  7196,  7195,  7208,  7209,  7220,  7221,
    7229,  7230,  7231,  7237,  7253,  7278,  7282,  7288,  7294,  7302,
    7303,  7310,  7333,  7352,  7365,  7366,  7373,  7401,  7405,  7412,
    7413,  7414,  7415,  7416,  7417,  7423,  7424,  7428,  7443,  7444,
    7448,  7464,  7482,  7483,  7492,  7493,  7494,  7501,  7513,  7517,
    7529,  7538,  7559,  7560,  7564,  7581,  7585,  7586,  7587,  7591,
    7592,  7593,  7594,  7595,  7596,  7597,  7598,  7599,  7600,  7601,
    7602,  7603,  7604,  7608,  7609,  7610,  7614,  7615,  7616,  7617,
    7618,  7619,  7620,  7621,  7622,  7626,  7627,  7628,  7629,  7630,
    7631,  7632,  7633,  7635,  7636,  7637,  7638,  7639,  7640,  7641,
    7642,  7643,  7647,  7648,  7649,  7660,  7680,  7681,  7685,  7686,
    7687,  7688,  7689,  7690,  7691,  7695,  7696,  7700,  7701,  7702,
    7703,  7704,  7705,  7706,  7707,  7717,  7740,  7761,  7774,  7792,
    7797,  7806,  7848,  7873,  7878,  7896,  7919,  7940,  7941,  7945,
    7962,  7966,  7970,  7971,  7972,  7973,  7977,  7990,  8006,  8007,
    8008,  8009,  8010,  8022,  8023,  8024,  8025,  8026,  8027,  8028,
    8029,  8030,  8031,  8032,  8036,  8040,  8044,  8048,  8055,  8056,
    8057,  8061,  8062,  8066,  8084,  8106,  8107,  8114,  8133,  8149,
    8150,  8154,  8171,  8175,  8176,  8184,  8185,  8193,  8194,  8202,
    8203,  8207,  8208,  8216,  8217,  8221,  8222,  8226,  8241,  8242,
    8250,  8255,  8259,  8260,  8264,  8266,  8275,  8337,  8338,  8345,
    8371,  8394,  8409,  8430,  8431,  8445,  8446,  8454,  8455,  8459,
    8479,  8509,  8510,  8518,  8519,  8523,  8540,  8557,  8577,  8600,
    8608,  8609,  8616,  8617,  8624,  8644,  8651,  8652,  8653,  8654,
    8661,  8662,  8663,  8667,  8668,  8669,  8673,  8674,  8678,  8679,
    8686,  8687,  8694,  8695,  8702,  8703,  8710,  8711,  8718,  8719,
    8726,  8727,  8728,  8729,  8730,  8731,  8732,  8733,  8734,  8735,
    8736,  8737,  8738,  8739,  8740,  8741,  8742,  8743,  8744,  8745,
    8746,  8747,  8748,  8749,  8750,  8751,  8752,  8753,  8754,  8755,
    8756,  8757,  8758,  8759,  8760,  8761,  8762,  8763,  8764,  8765,
    8766,  8767,  8768,  8769,  8770,  8771,  8772,  8773,  8777,  8778,
    8785,  8786,  8793,  8794,  8801,  8802,  8810,  8825,  8826,  8833,
    8834,  8842,  8843,  8847,  8862,  8863,  8867,  8868,  8875,  8876,
    8880,  8881,  8888,  8889,  8896,  8897,  8904,  8905,  8912,  8913,
    8920,  8921,  8922,  8926,  8927,  8934,  8935,  8939,  8940,  8947,
    8970,  8981,  8985,  8986,  8990,  8991,  8998,  8999,  9003,  9004,
    9010,  9011,  9015,  9016,  9023,  9024,  9031,  9032,  9039,  9040,
    9044,  9045,  9052,  9053,  9060,  9061,  9062,  9066,  9067,  9076,
    9077,  9084,  9085,  9089,  9090,  9094,  9095,  9099,  9100,  9108,
    9109,  9117,  9118,  9125,  9126,  9130,  9131,  9138,  9139,  9143,
    9144,  9148,  9164,  9165,  9172,  9173,  9177,  9178,  9185,  9186,
    9190,  9191,  9198,  9199
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "Y_cast",
  "Y_const_ENG", "Y_declare", "Y_define", "Y_dynamic", "Y_explain", "Y_no",
  "Y_quit", "Y_reinterpret", "Y_set", "Y_show", "Y_aligned", "Y_all",
  "Y_array", "Y_as", "Y_bit", "Y_bit_precise", "Y_bits", "Y_by", "Y_bytes",
  "Y_capturing", "Y_commands", "Y_constructor", "Y_conversion", "Y_copy",
  "Y_defined", "Y_destructor", "Y_english", "Y_evaluation", "Y_expand",
  "Y_expression", "Y_floating", "Y_function", "Y_initialization", "Y_into",
  "Y_lambda", "Y_length", "Y_linkage", "Y_literal", "Y_macros", "Y_member",
  "Y_non_empty", "Y_non_member", "Y_of", "Y_options", "Y_point",
  "Y_pointer", "Y_precise", "Y_precision", "Y_predefined", "Y_pure",
  "Y_reference", "Y_returning", "Y_rvalue", "Y_scope", "Y_to", "Y_user",
  "Y_user_defined", "Y_variable", "Y_wide", "Y_width",
  "Y_PREC_LESS_THAN_upc_layout_qualifier", "Y_COLON_COLON", "\"::\"",
  "Y_COLON_COLON_STAR", "\"++\"", "\"--\"", "'('", "')'", "'['", "']'",
  "'.'", "Y_MINUS_GREATER", "\"->\"", "'&'", "'*'", "'!'", "Y_sizeof",
  "'~'", "Y_DOT_STAR", "\".*\"", "Y_MINUS_GREATER_STAR", "\"->*\"", "'/'",
  "'%'", "'-'", "'+'", "Y_LESS_LESS", "\"<<\"", "Y_GREATER_GREATER",
  "\">>\"", "Y_LESS_EQUAL_GREATER", "\"<=>\"", "'<'", "'>'",
  "Y_LESS_EQUAL", "\"<=\"", "Y_GREATER_EQUAL", "\">=\"", "Y_EQUAL_EQUAL",
  "\"==\"", "Y_EXCLAM_EQUAL", "Y_bit_and", "'^'", "'|'", "Y_AMPER_AMPER",
  "Y_PIPE_PIPE", "Y_QMARK_COLON", "\"?:\"", "'='", "Y_PERCENT_EQUAL",
  "\"%=\"", "Y_AMPER_EQUAL", "Y_STAR_EQUAL", "\"*=\"", "Y_PLUS_EQUAL",
  "\"+=\"", "Y_MINUS_EQUAL", "\"-=\"", "Y_SLASH_EQUAL", "\"/=\"",
  "Y_LESS_LESS_EQUAL", "\"<<=\"", "Y_GREATER_GREATER_EQUAL", "\">>=\"",
  "Y_CARET_EQUAL", "Y_PIPE_EQUAL", "','", "Y_auto_STORAGE", "Y_break",
  "Y_case", "Y_char", "Y_continue", "Y_default", "Y_do", "Y_double",
  "Y_else", "Y_extern", "Y_float", "Y_for", "Y_goto", "Y_if", "Y_int",
  "Y_long", "Y_register", "Y_return", "Y_short", "Y_static", "Y_struct",
  "Y_switch", "Y_typedef", "Y_union", "Y_unsigned", "Y_while", "'#'",
  "\"##\"", "Y_P_MACRO_NAME", "Y_P_SPACE", "Y_P_define", "Y_P_elif",
  "Y_P_else", "Y_P_error", "Y_P_if", "Y_P_ifdef", "Y_P_ifndef", "Y_P_line",
  "Y_P_undef", "Y_P___VA_ARGS__", "Y_P___VA_OPT__", "Y_P_pragma",
  "Y_P_elifdef", "Y_P_elifndef", "Y_P_embed", "Y_P_warning", "Y_asm",
  "Y_const", "\"...\"", "Y_enum", "Y_signed", "Y_void", "Y_volatile",
  "Y_wchar_t", "Y__Bool", "Y__Complex", "Y__Imaginary", "Y_inline",
  "Y_restrict", "Y__Alignas", "Y__Alignof", "Y__Atomic_QUAL",
  "Y__Atomic_SPEC", "Y__Generic", "Y__Noreturn", "Y__Static_assert",
  "Y__Thread_local", "Y_thread", "Y_local", "Y_bool", "Y_catch", "Y_class",
  "Y_const_cast", "Y_CONSTRUCTOR_SNAME", "Y_delete", "Y_DESTRUCTOR_SNAME",
  "Y_dynamic_cast", "Y_explicit", "Y_false", "Y_friend", "Y_mutable",
  "Y_namespace", "Y_new", "Y_operator", "Y_OPERATOR_SNAME", "Y_private",
  "Y_protected", "Y_public", "Y_reinterpret_cast", "Y_static_cast",
  "Y_template", "Y_this", "Y_throw", "Y_true", "Y_try", "Y_typeid",
  "Y_typename", "Y_using", "Y_virtual", "Y_char16_t", "Y_char32_t",
  "Y__BitInt", "Y_reproducible", "Y_typeof", "Y_typeof_unqual",
  "Y_unsequenced", "Y_ATTR_BEGIN", "Y_alignas", "Y_alignof", "Y_auto_TYPE",
  "Y_carries", "Y_dependency", "Y_carries_dependency", "Y_constexpr",
  "Y_decltype", "Y_except", "Y_final", "Y_noexcept", "Y_nullptr",
  "Y_override", "Y_static_assert", "Y_thread_local", "Y_deprecated",
  "Y_discard", "Y_maybe_unused", "Y_maybe", "Y_unused", "Y_nodiscard",
  "Y_noreturn", "Y_char8_t", "Y_concept", "Y_consteval", "Y_constinit",
  "Y_co_await", "Y_co_return", "Y_co_yield", "Y_export",
  "Y_no_unique_address", "Y_requires", "Y_unique", "Y_address",
  "Y_EMC__Accum", "Y_EMC__Fract", "Y_EMC__Sat", "Y_UPC_relaxed",
  "Y_UPC_shared", "Y_UPC_strict", "Y_GNU___attribute__",
  "Y_GNU___restrict", "Y_Apple___block", "Y_Apple_block", "Y_MSC___cdecl",
  "Y_MSC___clrcall", "Y_MSC___declspec", "Y_MSC___fastcall",
  "Y_MSC___stdcall", "Y_MSC___thiscall", "Y_MSC___vectorcall", "':'",
  "';'", "'{'", "'}'", "Y_CHAR_LIT", "Y_END", "Y_ERROR", "Y_FLOAT_LIT",
  "Y_GLOB", "Y_INT_LIT", "Y_NAME", "Y_SET_OPTION", "Y_STR_LIT",
  "Y_TYPEDEF_NAME", "Y_TYPEDEF_SNAME", "Y_LEXER_ERROR", "'$'", "'@'",
  "'`'", "'?'", "$accept", "command_list", "command", "cast_command",
  "new_style_cast_english", "declare_command", "$@1",
  "alignas_or_width_decl_english_ast", "alignas_specifier_english",
  "aligned_english", "capturing_paren_capture_decl_list_english_opt",
  "paren_capture_decl_list_english", "capture_decl_list_english_opt",
  "capture_decl_list_english", "capture_decl_english_ast",
  "capture_default_opt", "width_specifier_english_uint",
  "storage_class_subset_english_type_opt",
  "storage_class_subset_english_type", "storage_class_subset_english_stid",
  "define_command", "expand_command", "expand_command2",
  "p_extra_token_except_lparen", "p_extra_tokens_opt", "p_extra_tokens",
  "p_extra_token", "p_arg_list_opt", "p_comma_arg_list", "p_arg_list",
  "p_arg_tokens", "p_arg_token_as_list", "p_arg_token", "p_num_lit",
  "p_other", "p_punctuator", "p_arg_tokens_with_comma_opt",
  "p_arg_tokens_with_comma", "p_arg_token_with_comma_as_list",
  "p_arg_token_with_comma", "explain_command", "$@2", "explain",
  "help_command", "$@3", "help_what_opt", "preprocessor_command",
  "p_define", "p_paren_param_list_opt", "p_param_list_opt", "p_param_list",
  "p_param", "p_replace_list_opt", "p_replace_list", "p_replace_token",
  "p_undef", "quit_command", "scoped_command", "set_command",
  "set_option_list", "set_option", "set_option_value_opt", "show_command",
  "show_format", "show_format_exp", "show_format_opt", "show_types_opt",
  "predefined_or_user_types_opt", "template_command", "typedef_command",
  "using_command", "c_style_cast_expr_c", "$@4", "new_style_cast_expr_c",
  "$@5", "new_style_cast_c", "aligned_declaration_c", "$@6", "$@7",
  "alignas_specifier_c", "$@8", "alignas", "asm_declaration_c",
  "scoped_declaration_c", "class_struct_union_declaration_c", "$@9",
  "$@10", "enum_declaration_c", "$@11", "namespace_declaration_c", "$@12",
  "$@13", "namespace_sname_c_exp", "namespace_sname_c",
  "namespace_typedef_sname_c", "brace_in_scope_declaration_c_exp",
  "brace_in_scope_declaration_c_opt", "brace_in_scope_declaration_c",
  "in_scope_declaration_c_exp", "lambda_declaration_c",
  "capture_decl_list_c_opt", "capture_decl_list_c", "capture_decl_c_ast",
  "lambda_param_c_ast_list_opt", "lambda_return_type_c_ast_opt", "$@14",
  "template_declaration_c", "typed_declaration_c", "$@15",
  "typedef_declaration_c", "$@16", "$@17", "typedef_decl_list_c",
  "typedef_decl_c", "typedef_decl_c_exp",
  "user_defined_conversion_declaration_c", "using_declaration_c",
  "using_decl_c_ast", "$@18", "$@19", "decl_list_c_opt", "decl_list_c",
  "decl_c", "decl_c_exp", "decl_c_astp", "msc_calling_convention_c_astp",
  "decl2_c_astp", "array_decl_c_astp", "array_size_c_ast",
  "block_decl_c_astp", "$@20", "destructor_declaration_c",
  "file_scope_constructor_declaration_c",
  "file_scope_destructor_declaration_c", "func_decl_c_astp",
  "pc99_func_or_constructor_declaration_c", "$@21",
  "rparen_func_qualifier_list_c_stid_opt", "$@22",
  "func_qualifier_list_c_stid_opt", "func_qualifier_c_stid",
  "func_ref_qualifier_c_stid_opt", "noexcept_c_stid_opt",
  "noexcept_bool_stid_exp", "trailing_return_type_c_ast_opt", "$@23",
  "func_equals_c_stid_opt", "param_c_ast_list_exp", "param_c_ast_list_opt",
  "param_c_ast_list", "param_c_ast", "$@24", "param_c_ast_exp",
  "nested_decl_c_astp", "$@25", "oper_decl_c_astp", "pointer_decl_c_astp",
  "$@26", "pointer_type_c_ast", "pc99_pointer_decl_list_c",
  "pc99_pointer_decl_c", "$@27", "pc99_pointer_type_c_ast",
  "pointer_to_member_decl_c_astp", "$@28", "pointer_to_member_type_c_ast",
  "reference_decl_c_astp", "$@29", "reference_type_c_ast",
  "typedef_type_decl_c_ast", "user_defined_conversion_decl_c_astp", "$@30",
  "user_defined_literal_decl_c_astp", "cast_c_astp_opt", "cast_c_astp",
  "cast2_c_astp", "array_cast_c_astp", "block_cast_c_astp", "$@31",
  "func_cast_c_astp", "nested_cast_c_astp", "$@32", "pointer_cast_c_astp",
  "$@33", "pointer_to_member_cast_c_astp", "$@34", "reference_cast_c_astp",
  "$@35", "udc_decl_c_ast_opt", "udc_decl_c_ast", "pointer_udc_decl_c_ast",
  "$@36", "pointer_to_member_udc_decl_c_ast", "$@37",
  "reference_udc_decl_c_ast", "$@38", "type_c_ast",
  "type_modifier_list_c_type_opt", "type_modifier_list_c_type",
  "type_modifier_c_type", "type_modifier_base_type",
  "east_modified_type_c_ast", "atomic_builtin_typedef_type_c_ast",
  "atomic_specifier_type_c_ast", "$@39", "builtin_type_c_ast",
  "builtin_no_BitInt_c_btid", "typeof_type_c_ast", "$@40", "typeof",
  "enum_class_struct_union_c_ast", "class_struct_union_c_ast",
  "enum_c_ast", "enum_btids", "enum_fixed_type_c_ast_opt",
  "enum_fixed_type_c_ast", "enum_fixed_type_modifier_list_btid_opt",
  "enum_fixed_type_modifier_list_btid", "enum_fixed_type_modifier_btid",
  "enum_unmodified_fixed_type_c_ast", "class_struct_btid_opt",
  "class_struct_btid", "class_struct_union_btid",
  "type_qualifier_list_c_stid_opt", "type_qualifier_list_c_stid",
  "type_qualifier_c_stid", "cv_qualifier_stid",
  "cv_qualifier_list_stid_opt", "restrict_qualifier_c_stid",
  "upc_layout_qualifier_c", "storage_class_c_type", "_Noreturn_atid",
  "attribute_specifier_list_c_atid_opt", "attribute_specifier_list_c_atid",
  "$@41", "using_opt", "attribute_list_c_atid_opt",
  "attribute_list_c_atid", "attribute_c_atid_exp",
  "attribute_str_arg_c_opt", "gnu_or_msc_attribute_specifier_list_c_opt",
  "gnu_or_msc_attribute_specifier_list_c",
  "gnu_attribute_specifier_list_c_opt", "gnu_attribute_specifier_list_c",
  "gnu_attribute_specifier_c", "$@42", "gnu_attribute_list_c_opt",
  "gnu_attribuet_list_c", "gnu_attribute_c_exp",
  "gnu_attribute_decl_arg_list_c_opt", "gnu_attribute_arg_list_c_opt",
  "gnu_attribute_arg_list_c", "gnu_attribute_arg_c",
  "msc_attribute_specifier_list_c", "msc_attribute_specifier_c", "$@43",
  "msc_attribute_list_c_opt", "msc_attribuet_list_c", "decl_english_ast",
  "array_decl_english_ast", "array_size_decl_ast", "length_opt",
  "block_decl_english_ast", "constructor_decl_english_ast",
  "destructor_decl_english_ast", "parens_opt", "func_decl_english_ast",
  "func_qualifier_english_type_opt", "msc_calling_convention_atid",
  "paren_param_decl_list_english_opt", "paren_param_decl_list_english",
  "param_decl_list_english_opt", "param_decl_list_english",
  "decl_english_ast_exp", "ref_qualifier_english_stid_opt",
  "returning_english_ast_opt", "returning_english_ast",
  "qualified_decl_english_ast", "type_qualifier_list_english_type_opt",
  "type_qualifier_list_english_type", "type_qualifier_english_type",
  "attribute_english_atid", "storage_class_english_stid",
  "eval_expr_init_stid", "linkage_stid", "linkage_opt",
  "type_qualifier_english_stid", "upc_layout_qualifier_english",
  "qualifiable_decl_english_ast", "pointer_decl_english_ast",
  "reference_decl_english_ast", "reference_english_ast",
  "user_defined_literal_decl_english_ast", "var_decl_english_ast",
  "type_english_ast", "type_modifier_list_english_type_opt",
  "type_modifier_list_english_type", "type_modifier_english_type",
  "unmodified_type_english_ast", "builtin_type_english_ast",
  "builtin_no_BitInt_english_btid", "BitInt_english_int", "BitInt_english",
  "precise_opt", "class_struct_union_english_ast", "enum_english_ast",
  "of_type_enum_fixed_type_english_ast_opt", "enum_fixed_type_english_ast",
  "enum_fixed_type_modifier_list_english_btid_opt",
  "enum_fixed_type_modifier_list_english_btid",
  "enum_unmodified_fixed_type_english_ast", "any_name", "any_name_exp",
  "any_sname_c", "any_sname_c_exp", "any_sname_c_opt", "any_typedef",
  "name_ast", "name_exp", "name_cat", "name_opt", "oper_sname_c_opt",
  "typedef_type_c_ast", "sub_scope_sname_c_opt", "sname_c", "sname_c_ast",
  "bit_field_c_uint_opt", "sname_c_exp", "sname_c_opt", "sname_english",
  "sname_english_ast", "sname_english_exp", "sname_english_opt",
  "sname_list_english", "typedef_sname_c", "address_exp", "array_exp",
  "as_exp", "as_into_to_exp", "as_or_to_opt", "bits_opt", "bytes_opt",
  "cast_exp", "char_exp", "class_struct_union_btid_exp", "colon_exp",
  "comma_exp", "conversion_exp", "c_operator", "default_exp",
  "defined_exp", "dependency_exp", "destructor_sname", "empty_str_lit_exp",
  "equals_exp", "extern_linkage_c_stid", "extern_linkage_c_stid_opt",
  "glob", "glob_opt", "gt_exp", "inline_stid_opt", "int_exp",
  "literal_exp", "local_exp", "lparen_exp", "lt_exp",
  "member_or_non_member_opt", "namespace_btid_exp", "namespace_type",
  "of_exp", "of_scope_english", "of_scope_list_english",
  "of_scope_list_english_opt", "operator_exp", "operator_opt", "point_exp",
  "precision_opt", "rbrace_exp", "rbracket_exp", "reference_exp",
  "returning", "returning_exp", "rparen_exp", "scope_english_type",
  "scope_english_type_exp", "semi_exp", "semi_opt", "semi_or_end",
  "static_stid_opt", "str_lit", "str_lit_exp", "this_exp", "this_stid_opt",
  "to_exp", "type_opt", "typename_flag_opt", "uint_lit", "uint_lit_exp",
  "uint_lit_opt", "unused_exp", "user_defined", "virtual_stid_exp",
  "virtual_stid_opt", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-1209)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-1084)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int16 yypact[] =
{
   -1209,  1090, -1209, -1209,   337,  3066,   110,   665, -1209, -1209,
     665,  -131,  1719,    87,   665, -1209,    36, -1209,  1326,   665,
     310,   205, -1209, -1209, -1209, -1209, -1209, -1209, -1209, -1209,
   -1209, -1209, -1209, -1209,   -95,   110,   -95,   -95,   -95,   -95,
    1660,   -95,   -12,   -95, -1209,   -95,   -95,   -95,   -95,   -95,
   -1209, -1209, -1209, -1209, -1209, -1209, -1209, -1209, -1209, -1209,
   -1209, -1209, -1209, -1209, -1209, -1209, -1209,   438, -1209,   423,
   -1209,   135,   476, -1209, -1209, -1209, -1209,   132,   131, -1209,
   -1209, -1209, -1209, -1209, -1209, -1209, -1209, -1209, -1209, -1209,
   -1209, -1209, -1209, -1209, -1209, -1209, -1209, -1209, -1209, -1209,
   -1209, -1209, -1209, -1209, -1209, -1209, -1209, -1209, -1209, -1209,
   -1209, -1209, -1209, -1209, -1209, -1209, -1209,   475,   478, -1209,
    4582, -1209,   139, -1209, -1209, -1209,   479, -1209, -1209, -1209,
   -1209,   452,  -131, -1209, -1209,   226, -1209, -1209, -1209, -1209,
      31,   446, -1209,  5069, -1209, -1209, -1209, -1209,    90, -1209,
   -1209, -1209, -1209, -1209, -1209, -1209,    90, -1209, -1209, -1209,
   -1209, -1209, -1209, -1209, -1209, -1209, -1209, -1209, -1209, -1209,
      60,    74, -1209,   135, -1209, -1209, -1209, -1209, -1209,  5690,
     382,   708, -1209, -1209, -1209,   -74, -1209, -1209, -1209, -1209,
   -1209, -1209, -1209, -1209,   178, -1209, -1209, -1209, -1209, -1209,
   -1209, -1209, -1209,   -69, -1209, -1209, -1209,   178, -1209, -1209,
   -1209, -1209, -1209, -1209,   513, -1209,   557, -1209, -1209,   178,
   -1209, -1209,   512, -1209, -1209, -1209, -1209, -1209, -1209, -1209,
   -1209, -1209, -1209, -1209, -1209, -1209, -1209, -1209,   554, -1209,
   -1209, -1209, -1209, -1209,   582, -1209, -1209,   116, -1209, -1209,
     178, -1209, -1209, -1209, -1209, -1209, -1209, -1209, -1209, -1209,
   -1209,   527, -1209, -1209, -1209,  5849, -1209, -1209, -1209,  6065,
   -1209, -1209, -1209, -1209,   178, -1209, -1209, -1209,   383,   383,
   -1209, -1209, -1209, -1209, -1209, -1209, -1209,   387, -1209,   389,
   -1209,   611,   469, -1209,   423,   465,   468,   -24,   633, -1209,
   -1209, -1209, -1209, -1209, -1209, -1209, -1209,   133,   133,   154,
     470, -1209,   438, -1209,   360, -1209, -1209, -1209, -1209,  4239,
     337, -1209, -1209, -1209, -1209, -1209, -1209,   131,   131,   601,
     467,   102,    73, -1209, -1209, -1209, -1209, -1209, -1209, -1209,
   -1209, -1209, -1209,    84, -1209, -1209, -1209, -1209, -1209, -1209,
   -1209,    85, -1209, -1209, -1209, -1209, -1209, -1209, -1209, -1209,
     511, -1209, -1209, -1209,   110,  4239,   438,  4239,    41, -1209,
   -1209, -1209, -1209, -1209, -1209, -1209, -1209,   545,    79, -1209,
   -1209, -1209, -1209, -1209, -1209, -1209, -1209,  1318, -1209, -1209,
   -1209, -1209, -1209, -1209, -1209, -1209, -1209, -1209, -1209, -1209,
   -1209, -1209, -1209, -1209, -1209, -1209, -1209, -1209, -1209, -1209,
   -1209, -1209, -1209, -1209, -1209, -1209, -1209, -1209, -1209, -1209,
   -1209, -1209, -1209, -1209, -1209, -1209, -1209, -1209, -1209, -1209,
   -1209, -1209, -1209, -1209, -1209, -1209, -1209, -1209, -1209, -1209,
   -1209, -1209, -1209, -1209, -1209,  5206, -1209, -1209, -1209, -1209,
   -1209,  5849, -1209, -1209,   653, -1209, -1209, -1209, -1209, -1209,
     383, -1209,    92, -1209, -1209,   425,  4239, -1209, -1209,   132,
   -1209, -1209,   428,   188, -1209, -1209, -1209,   663,   117, -1209,
   -1209,   758,   190,   758, -1209, -1209,   448, -1209, -1209, -1209,
      52,  5849, -1209,  5849,   109, -1209,    89, -1209,   178,   178,
   -1209, -1209, -1209,  5849,    36,  3681,  2035,  2035,  1751, -1209,
   -1209, -1209,  6065,  3840,   304,   112, -1209,   112, -1209, -1209,
     337, -1209,  5849, -1209,   178, -1209, -1209,   178,    60, -1209,
   -1209,   456, -1209, -1209, -1209, -1209,   675,   683, -1209, -1209,
   -1209, -1209, -1209, -1209,   133, -1209, -1209, -1209,   601,   471,
   -1209,    73,   463, -1209, -1209, -1209,   -74, -1209, -1209, -1209,
   -1209, -1209, -1209,    99, -1209, -1209, -1209, -1209, -1209, -1209,
   -1209, -1209, -1209, -1209, -1209, -1209, -1209, -1209, -1209, -1209,
      27, -1209, -1209,   577, -1209, -1209, -1209, -1209,  4730,  4481,
   -1209, -1209, -1209, -1209, -1209, -1209,   142, -1209,   156, -1209,
   -1209, -1209, -1209, -1209, -1209, -1209, -1209, -1209, -1209, -1209,
      77,   200,   552,   682, -1209, -1209, -1209, -1209, -1209, -1209,
   -1209, -1209, -1209, -1209,   159, -1209, -1209,   147,   479, -1209,
   -1209, -1209,    79, -1209, -1209, -1209, -1209, -1209,  5314, -1209,
     685,  5451,   639,  5559, -1209, -1209, -1209, -1209, -1209,  5206,
   -1209, -1209,    82,  4954,   122, -1209, -1209, -1209, -1209, -1209,
     483, -1209, -1209, -1209, -1209,   713, -1209, -1209,   382,   190,
   -1209, -1209, -1209, -1209, -1209, -1209,   132, -1209, -1209, -1209,
   -1209, -1209,   132,   560,   719, -1209,   131,   131,   178,    70,
      21, -1209, -1209,   729, -1209,   132,   696,   708,   708,   708,
   -1209, -1209, -1209, -1209, -1209, -1209,   673, -1209, -1209,   618,
   -1209, -1209, -1209, -1209, -1209, -1209, -1209, -1209, -1209, -1209,
   -1209, -1209, -1209, -1209,   488,   737,   634,   591,   520,   119,
     387, -1209, -1209,   673, -1209, -1209,   519,   456,   522, -1209,
     523, -1209, -1209,    21,   744,   178,  1022, -1209,   536,    48,
     461,   534, -1209, -1209, -1209, -1209, -1209, -1209, -1209,   776,
   -1209, -1209, -1209, -1209, -1209, -1209, -1209,   124,   682,   748,
     445,   535,   138,   781,   682, -1209, -1209, -1209, -1209, -1209,
   -1209,   701, -1209, -1209, -1209, -1209, -1209,   445, -1209,  4379,
    1917, -1209, -1209,  4239, -1209, -1209,   178, -1209, -1209, -1209,
   -1209,   552,   552, -1209,    93,   449,   756,   123, -1209, -1209,
    4092,   128, -1209, -1209, -1209,   620,   559,   109, -1209, -1209,
   -1209,  1942, -1209,  4481, -1209,  5314,   764,  5314, -1209, -1209,
    5206, -1209,   639,  5451, -1209, -1209,  2035, -1209, -1209, -1209,
     767,   137, -1209, -1209, -1209, -1209, -1209, -1209, -1209, -1209,
   -1209,  4954, -1209, -1209, -1209,  5849,   733, -1209, -1209, -1209,
     530, -1209,   770, -1209, -1209, -1209, -1209, -1209, -1209, -1209,
   -1209,    21, -1209, -1209, -1209, -1209,   483, -1209,    90,   392,
   -1209, -1209, -1209,    78, -1209,   771, -1209,   782,    80, -1209,
   -1209, -1209,   783,   143, -1209, -1209,  5849,   483,  5849, -1209,
     483, -1209, -1209,  2035, -1209, -1209, -1209,   845,    21,  1185,
     387,  2035,  2035,  2035, -1209,   618,   689, -1209,    11,   774,
    1449,   109, -1209, -1209, -1209,   387,   483, -1209, -1209, -1209,
     187,   744, -1209,   319,   744, -1209, -1209, -1209, -1209, -1209,
   -1209, -1209, -1209,  5998, -1209,   529, -1209,   670, -1209, -1209,
   -1209, -1209, -1209,    90, -1209, -1209,    90, -1209, -1209, -1209,
   -1209, -1209, -1209,   163, -1209, -1209,   132, -1209, -1209, -1209,
    2230, -1209, -1209,   588, -1209,   223,   128, -1209, -1209,   820,
    4239,   806,   111,   453,   107,   561,   809, -1209, -1209, -1209,
   -1209, -1209, -1209, -1209, -1209, -1209, -1209, -1209, -1209, -1209,
     133,   133, -1209, -1209, -1209, -1209,   100, -1209, -1209, -1209,
   -1209, -1209,  4092,   786,   788,   115, -1209, -1209,    90, -1209,
   -1209,   552, -1209,   792,   144, -1209, -1209, -1209, -1209,  2518,
   -1209,   438, -1209, -1209, -1209,   752, -1209, -1209,   844,   742,
     797, -1209, -1209, -1209,  5451,  5559,   740, -1209, -1209, -1209,
      59, -1209, -1209, -1209,   483,   483,   483,   483, -1209,   575,
      21,   810,  4692,   530,    76, -1209, -1209, -1209, -1209,   817,
   -1209,   817, -1209, -1209,   816,   125, -1209,   423,   821,   145,
   -1209,    -7, -1209, -1209, -1209,   319,  3361, -1209,   186, -1209,
     530,   708,   132, -1209, -1209, -1209,   744,   823,   708,   131,
     815,  3961, -1209,   131, -1209, -1209, -1209, -1209, -1209,   178,
      90, -1209, -1209,   530, -1209, -1209, -1209,   178, -1209, -1209,
   -1209, -1209, -1209,   319, -1209,   178,   824,   387,   319, -1209,
     529, -1209,   529, -1209, -1209, -1209,   617,    61,    61, -1209,
   -1209, -1209, -1209,  4239, -1209, -1209,   163, -1209, -1209, -1209,
     602, -1209,   682, -1209, -1209,   111, -1209, -1209, -1209, -1209,
   -1209, -1209, -1209, -1209, -1209, -1209, -1209, -1209, -1209,   862,
   -1209, -1209,   109,   109,   752,   838, -1209, -1209, -1209, -1209,
   -1209, -1209, -1209, -1209,  2806, -1209, -1209,   120, -1209, -1209,
   -1209, -1209, -1209, -1209,   138,   701, -1209,  1073, -1209,   483,
     708,   530,   839,   839,   839,   423, -1209,   744, -1209,  5849,
   -1209, -1209, -1209, -1209, -1209,    52, -1209, -1209,   131,   354,
     132,    96,    -7, -1209, -1209, -1209, -1209, -1209,   842,   149,
   -1209,   804, -1209, -1209, -1209,   483, -1209, -1209,   178, -1209,
    2035, -1209,   451, -1209,   -80, -1209,   131, -1209, -1209,   312,
   -1209,   304,    21,   178, -1209,   187,   187,   187,   744,   387,
     702,  3201,   243, -1209,   387, -1209, -1209,    57, -1209, -1209,
   -1209, -1209, -1209,   441, -1209,   163,   128, -1209,   765, -1209,
     752,   132, -1209,   128, -1209, -1209, -1209, -1209, -1209,  4239,
   -1209,    94, -1209, -1209, -1209,   839,   483, -1209,   319, -1209,
     132, -1209, -1209, -1209, -1209,   157, -1209,    -7,   118, -1209,
     839,    97,   132, -1209, -1209,   319,   131,   131, -1209,   131,
     131,   744,  3521, -1209, -1209, -1209,   319, -1209, -1209, -1209,
   -1209, -1209, -1209,   501, -1209, -1209, -1209, -1209,   132,   804,
   -1209, -1209, -1209, -1209, -1209,   110,  4239, -1209, -1209,   529,
   -1209, -1209, -1209, -1209, -1209, -1209,   682,   530,   162,   483,
   -1209,   503, -1209, -1209, -1209, -1209, -1209, -1209, -1209,   423,
     132,   178,   162, -1209, -1209, -1209, -1209,   451, -1209,   846,
     525,   804, -1209, -1209, -1209,  4239, -1209, -1209, -1209,  3948,
    4084,   128,   178,  5849, -1209,   387,   839, -1209,    21,   804,
     319,   319, -1209, -1209,   438, -1209, -1209, -1209, -1209, -1209,
      21, -1209,   848, -1209,   162,   162,   849,   483,   387,   804,
   -1209, -1209, -1209, -1209, -1209
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_int16 yydefact[] =
{
       2,     0,     1,    19,   893,     0,     0,     0,   196,   242,
       0,   244,     0,     0,     0,   574,  1069,   576,     0,     0,
     571,     0,   573,   282,   283,  1015,   284,   285,   344,   357,
    1053,  1054,   197,     3,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    12,     0,     0,     0,     0,     0,
      26,   243,   296,   297,   298,   274,   275,   276,   356,   302,
     575,   299,   304,    18,   881,   865,   866,  1022,   899,   859,
     894,     0,   860,    32,   958,   946,   950,     0,     0,   954,
     952,   939,   943,   935,   977,   955,   953,   956,   937,   949,
     945,   960,   967,   963,   959,   966,   962,   969,   965,   936,
     972,   974,   940,   975,   970,   964,   938,   941,   944,   947,
     951,   957,   961,   968,   973,   976,   948,   933,   931,   930,
     591,   896,     0,    28,   892,   891,     0,   919,   918,    23,
      24,   249,   245,   247,   259,   271,   269,   270,   256,   258,
     994,   265,    83,    84,    25,  1070,   347,   219,     0,   207,
     210,   212,   213,   214,   215,   216,     0,   217,   208,   209,
     211,   218,   205,   206,    22,   553,   572,  1014,  1013,  1016,
       0,     0,     4,     0,     5,     6,     7,     8,   195,     0,
     329,   577,   599,   532,   539,   606,   538,   537,   512,   517,
     513,   614,   615,   515,     0,   589,   514,   528,   590,   536,
     530,   510,   511,   610,   593,   293,   582,     0,   619,   616,
     531,   604,   609,   611,     0,   190,   618,   534,   535,     0,
     545,   546,     0,   294,   529,   602,   608,   613,   617,   620,
     533,   601,   603,   605,   540,   541,   516,   585,   586,   588,
     652,   594,   600,   674,   881,   178,   179,     0,   181,   286,
       0,   182,   186,   189,   180,   192,   184,   183,   185,   187,
     188,   449,   450,   355,   345,   499,   505,   506,   501,   502,
     520,   521,   526,   523,     0,   591,   547,   548,   621,   621,
     507,   583,   584,   508,   612,   509,   625,   646,   651,   647,
     673,   877,     0,   522,   194,   607,     0,     0,     0,     9,
      10,    11,    13,    14,    15,    16,    17,     0,     0,     0,
       0,  1021,  1023,   889,     0,   909,   906,   907,   908,   722,
       0,  1043,  1042,   942,  1035,  1034,   971,     0,     0,     0,
       0,    42,     0,    77,    72,   737,    68,    71,    73,    78,
      79,   741,   742,     0,   730,    66,    70,    75,    76,   731,
     733,     0,   735,   738,    65,    67,    69,   740,    61,    63,
       0,    62,   905,   904,     0,   722,  1022,   722,     0,   248,
     246,   272,   273,   268,   257,   993,   995,   265,     0,   260,
     261,   262,   266,   252,   147,   167,   162,     0,    88,   137,
     138,   129,   160,   125,   126,   122,   143,   149,   161,   130,
     124,   128,   127,   157,   153,   156,   133,   135,   155,   152,
     150,   151,   139,   141,   144,   165,   134,   163,   145,   169,
     166,   159,   168,   158,   154,   146,   164,   177,   123,   113,
     148,   131,   132,   140,   142,   110,   117,   118,   111,   114,
     119,   120,   121,   136,    82,    89,   176,   112,   115,   116,
      87,     0,   869,   868,   221,   241,   858,   855,   856,   857,
     621,   203,     0,   871,   198,   200,   722,   610,   618,     0,
     277,   607,   333,     0,   335,   337,   336,     0,     0,   332,
     452,   578,   644,     0,  1057,  1058,   989,   775,  1007,  1006,
       0,     0,   875,     0,     0,   623,     0,   587,     0,     0,
     400,  1009,  1008,     0,  1069,     0,   874,   874,   360,   504,
     500,   518,   503,     0,   519,     0,   622,     0,   650,   672,
       0,   876,     0,   193,     0,   984,   985,     0,     0,   862,
     861,   554,   300,   309,   313,   305,   307,   308,   317,  1048,
    1046,  1044,  1045,  1047,     0,  1020,   879,   880,     0,     0,
     761,     0,     0,  1078,   743,   749,   753,   763,   769,   804,
     757,   778,   766,     0,   750,   751,   756,   758,   764,   768,
     770,   747,   755,   760,   762,   767,   746,   748,   752,   781,
     782,   784,   744,  1022,   779,   780,    20,   680,   807,   723,
     725,   726,   727,   728,   681,   682,     0,   803,     0,   898,
     897,   934,   932,   772,   773,   774,    64,   736,    74,   734,
       0,     0,    48,   705,  1081,  1080,    80,   983,   982,   729,
    1077,  1076,   732,   592,     0,   895,    27,    33,     0,    81,
     251,   250,     0,   254,   264,   263,   253,   101,   170,   103,
       0,    97,    96,   105,   107,   108,    94,    93,    85,    90,
      92,   348,     0,   230,     0,   202,   201,   870,    21,   279,
     464,   334,  1062,  1061,   338,   339,   927,   926,     0,   644,
     581,   645,   580,   990,  1060,  1059,     0,   524,   191,  1073,
    1071,  1072,     0,   626,     0,   595,     0,     0,     0,     0,
    1063,   280,   287,     0,   290,     0,   442,   577,   577,   577,
     699,   700,   701,   702,   703,   704,   448,   363,   364,   367,
     374,   375,   376,   377,   378,   368,   445,   369,   453,   370,
     456,   380,   381,   382,   874,     0,   877,     0,   883,   883,
     648,   451,   346,   361,   544,   542,   861,   554,     0,   549,
       0,   878,   461,  1063,     0,     0,     0,   303,   320,     0,
       0,     0,  1019,   745,   759,   771,   981,   980,  1079,   776,
    1005,  1004,   765,   786,   783,   785,   890,   685,   705,   694,
       0,   715,     0,   689,   705,   811,   787,   788,   789,   790,
     791,  1010,   698,   697,   721,   792,   793,     0,   794,     0,
     808,   810,   724,   722,  1003,  1002,     0,   901,   900,   739,
      47,    48,    48,    43,    56,    56,     0,     0,    51,    55,
     722,   717,   706,   929,   928,  1026,   910,     0,    40,    41,
      34,     0,    35,   722,   255,   170,     0,   171,   173,   174,
      89,   102,    98,   100,   106,    91,   874,   229,   228,   227,
       0,     0,   226,   235,   236,   237,   238,   239,   240,   234,
     220,   231,   233,   988,   987,     0,   479,   481,   483,   485,
       0,   465,   466,   470,   471,   472,   473,   467,   468,   469,
     474,  1063,    60,   331,   579,   295,   464,   527,     0,     0,
     598,   597,   596,     0,   659,   660,   679,     0,     0,   439,
    1064,   867,     0,     0,   435,   438,     0,   464,     0,   292,
     464,   289,   394,   874,   458,   447,   459,     0,  1063,     0,
     648,   874,   874,   874,   371,     0,   372,   373,   883,     0,
       0,     0,   460,   882,   379,   649,   464,   551,   552,   550,
     487,     0,   402,   413,     0,   556,   564,   565,   567,   566,
     568,   570,   555,   557,   563,   560,   569,     0,   301,   321,
     319,   306,   318,     0,   310,   311,     0,   315,   314,   777,
     754,   688,   687,     0,   686,   692,     0,   693,  1066,  1065,
       0,  1037,  1036,   716,   690,     0,   717,  1011,  1012,     0,
     722,   841,     0,     0,     0,  1074,  1030,   829,   828,   818,
     826,   820,   821,   824,   825,   838,   819,   823,   832,   833,
       0,     0,   805,   812,   816,   817,     0,   813,   814,   815,
     809,   802,   722,     0,     0,     0,    58,    52,     0,    53,
      44,     0,   711,     0,     0,  1038,  1039,    30,   718,     0,
    1027,  1022,   911,   912,    39,   913,    38,    37,   916,   714,
       0,   109,   172,    86,    99,   104,   349,   351,   352,   222,
       0,   232,   358,   476,   464,   464,   464,   464,   475,   887,
    1063,     0,   341,     0,     0,   641,   638,   639,   632,   642,
     634,   642,   636,   637,     0,     0,   631,   640,     0,     0,
     657,   662,   658,   675,   678,   413,     0,   436,     0,   288,
       0,   577,     0,   366,   365,   362,     0,  1035,   577,     0,
       0,     0,   384,     0,   383,   446,   454,   457,   591,     0,
       0,   986,   884,     0,   493,   495,   497,     0,   488,   489,
     490,   491,   492,   413,   404,     0,   414,   648,   413,   562,
     560,   559,   561,   327,   322,   324,  1051,     0,     0,   312,
     316,  1018,  1017,   722,   695,   797,     0,   795,   903,   902,
     872,   691,   705,   798,   842,     0,  1001,  1000,   839,  1029,
    1028,   830,   921,   920,   827,  1075,   822,  1031,   831,   845,
     843,   837,     0,     0,   913,     0,    46,    45,   979,   978,
      57,    54,    50,   707,     0,   720,   719,     0,   914,   915,
      59,   917,    36,   715,     0,  1010,   175,     0,   225,   464,
     577,     0,   482,   484,   486,   888,   278,     0,   340,     0,
     328,   525,   925,   924,   627,     0,   633,   635,     0,     0,
       0,     0,     0,   667,   668,   666,   669,   671,     0,     0,
     665,   425,   441,   440,   434,   464,   997,   996,     0,   291,
     874,   443,   410,   393,     0,   386,     0,  1056,   387,     0,
     385,   455,  1063,     0,   543,   487,   487,   487,     0,   648,
     403,     0,     0,   398,   648,   558,  1052,     0,  1050,  1049,
     325,   326,   683,     0,   873,     0,   717,   840,  1067,   844,
     913,     0,   834,   717,   713,   712,   710,  1041,  1040,   722,
     716,     0,   354,   353,   350,   359,   464,   480,   413,   342,
       0,   624,   630,   653,   656,     0,   661,     0,     0,   401,
     437,     0,     0,   411,   412,   413,     0,     0,   390,     0,
       0,     0,     0,   494,   496,   498,   413,   397,   407,   408,
     409,   405,   406,     0,   416,   420,   418,   419,     0,   425,
    1033,  1032,   323,   923,   922,     0,   722,   696,  1068,   849,
     836,   835,   801,    31,  1025,  1024,   705,     0,   421,   464,
     643,   927,   670,   664,   429,   426,   427,   428,   886,   885,
       0,     0,   421,   392,   391,   389,   388,   410,   431,     0,
       0,   425,   417,   415,   396,   722,   684,   852,   846,     0,
     850,   717,     0,     0,   478,   424,   343,   281,  1063,   425,
     413,   413,   462,   796,  1022,   853,   847,   854,   851,    29,
    1063,   422,     0,   399,   421,   421,     0,   464,   648,   425,
     463,   477,   423,   395,   444
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -1209, -1209, -1209, -1209, -1209, -1209, -1209, -1209, -1209, -1209,
   -1209, -1209,   -96, -1209,   -97,   127, -1209,    56, -1209, -1209,
   -1209, -1209, -1209,   787,   103, -1209,   290, -1209,  -539,   299,
    -611,  -608,  -265, -1209, -1209, -1209,   121, -1209,   129,  -348,
   -1209, -1209, -1209, -1209, -1209, -1209, -1209, -1209, -1209, -1209,
   -1209,  -107, -1209, -1209,   106, -1209, -1209, -1209, -1209, -1209,
     812, -1209, -1209,  -282,   328,   584, -1209, -1209, -1209, -1209,
   -1209, -1209, -1209, -1209, -1209,   923, -1209, -1209, -1209, -1209,
   -1209, -1209, -1209,    17, -1209, -1209, -1209, -1209, -1209, -1209,
   -1209, -1209, -1209, -1209, -1209, -1209, -1209,   218, -1209, -1209,
   -1209, -1209,  -150, -1209, -1209, -1209,   928,  -459, -1209,    22,
   -1209, -1209, -1209,  -227, -1209, -1209,    24,   676, -1209, -1209,
   -1209,   466,    68, -1209,  -482, -1209,   253, -1209,  -610, -1209,
   -1209, -1209, -1209, -1209,   255, -1209, -1209,  -883, -1209, -1209,
   -1209,  -397,  -981, -1209,  -728, -1209, -1208, -1209,  -703, -1141,
     -93, -1209, -1209, -1209, -1209, -1209,   266, -1209,  -330,   819,
   -1209, -1209, -1209, -1209, -1209,  -378, -1209, -1209,   -81, -1209,
     951, -1209, -1209,  -655, -1209, -1209, -1209, -1209, -1209, -1209,
   -1209, -1209, -1209, -1209, -1209, -1209, -1209, -1209,  -525, -1209,
   -1209, -1209, -1209, -1209, -1209, -1209,  -170, -1209,   725,  -181,
    -362,   730, -1209, -1209, -1209,  -644, -1209,  -496, -1209, -1209,
   -1209, -1209, -1209,    12,   262, -1209,  -130,   258,  -915,    58,
   -1209,   985,     4,  -643,    98,  -143,  -278,  -260,  -300, -1209,
   -1209, -1209,  -164,  -172, -1209, -1209, -1209, -1209,  -213,   -62,
     341,  -160,  -867,  -661,  -277, -1209, -1209, -1209,  -831, -1209,
   -1209,  -208,  -289, -1209,   738, -1209, -1209, -1209,  -301, -1209,
   -1209, -1209, -1209, -1209, -1209, -1209, -1209, -1209,   450,  -748,
   -1209,    29, -1209, -1209,    -3,  -947, -1209, -1209,   219, -1209,
     454,  -108, -1209,   496,   491, -1209, -1209, -1209, -1209, -1209,
   -1209, -1209, -1209, -1209, -1209, -1209, -1209,   259, -1209,  -341,
   -1209, -1209, -1209, -1209, -1209, -1209, -1209, -1209, -1209, -1209,
   -1209, -1209,   524,     2,  -292,   533,    -8, -1209,  -145, -1209,
   -1209,  1011,  -462, -1209,    -4,  -136,   325, -1209, -1209,   714,
    -335,   -32, -1209, -1209, -1209, -1209, -1209,  -104,   883, -1209,
   -1047, -1209,   459, -1209, -1209, -1209,  -461, -1209,   146, -1209,
   -1209, -1209, -1209, -1209, -1209,  1023, -1209, -1209, -1209, -1209,
   -1209,   -91, -1209, -1209,  -180, -1209,  -133, -1209,   755,  -998,
     757, -1209,   -53, -1209, -1209, -1209, -1209, -1209,  -304,  -127,
    -117, -1209,  -436, -1209, -1209,   -67, -1209,   983, -1209,  -138,
    -848, -1209, -1209,   285, -1209,   571,  -437,  -767, -1209, -1209,
     716,   526, -1209
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
       0,     1,    33,    34,    35,    36,   366,   626,   820,   821,
     613,   803,   806,   807,   808,  1017,   822,   120,   358,   359,
      37,    38,   444,   647,   648,   649,   650,   640,   641,   642,
     643,   644,   446,   447,   448,   449,   826,   827,   828,   450,
      39,   493,    40,    41,   171,   464,    42,   162,   653,   840,
     841,   842,   850,   851,   852,   163,    43,    44,    45,   132,
     133,   369,    46,   382,   636,   383,   140,   373,    47,    48,
      49,   245,   660,   246,   897,    50,   248,   504,   898,   249,
     900,   250,   251,    51,    52,   308,   748,    53,   307,    54,
     309,   749,   535,   536,   537,   951,   948,   949,  1136,   252,
     477,   478,   809,   872,  1210,  1359,    55,   254,   508,    56,
     451,   836,  1046,  1047,  1294,   255,    57,    58,   170,  1199,
     732,   706,   707,  1095,   708,   914,   709,   710,  1058,   711,
    1091,   256,   257,   258,   712,   259,   690,   933,  1124,  1260,
    1331,  1315,  1127,  1338,  1394,  1417,  1309,  1379,   892,   893,
     894,  1235,  1234,   713,   903,   714,   715,   911,   857,   260,
     261,   507,   262,   717,   912,   858,   719,   913,   859,   721,
     722,   930,   723,   860,   861,   862,   863,   864,  1200,   865,
     866,  1054,   867,  1055,   868,  1056,   869,  1057,  1117,  1118,
    1119,  1255,  1120,  1256,  1121,  1257,   264,   511,   265,   266,
     267,   268,   269,   270,   876,   271,   272,   273,   926,   274,
     275,   276,   277,   278,   747,   942,  1131,  1132,   944,   945,
     165,    60,   279,   480,   481,   280,   281,   360,   282,   497,
     283,   284,   515,   285,   683,   879,  1074,  1075,  1076,  1216,
     670,   286,   924,   287,   288,   498,  1078,  1079,   886,  1082,
    1228,  1229,  1230,   289,   290,   499,   887,   888,  1022,   776,
     963,   975,   777,   778,   779,   967,   780,   781,   724,   811,
     812,  1023,  1024,  1286,   783,  1027,  1028,   587,   588,   589,
     590,   591,   592,   606,   486,   960,   593,   764,   784,   785,
     786,   787,   594,   595,   788,   789,   790,   791,  1002,  1003,
    1004,  1005,  1006,  1155,  1007,  1008,  1279,  1388,  1389,  1390,
    1406,   459,   460,   725,   531,   738,    68,   895,   454,   465,
    1275,   727,   293,   521,   729,   870,   923,  1370,  1206,   125,
     597,   126,    71,   122,    72,   799,  1150,   365,   319,  1034,
    1190,  1192,   129,  1164,  1345,  1214,  1086,   815,   123,  1180,
     758,   619,   527,  1110,   855,   471,   296,   376,   377,  1238,
     297,  1158,   796,   762,   490,   503,   979,   169,    62,  1143,
     311,   312,   766,  1356,  1031,  1161,  1168,  1342,   326,   973,
    1029,  1289,   323,   543,   544,  1270,  1267,    63,  1249,   675,
     676,   664,   896,   970,  1349,   146,   681,   682,  1166,   622,
     598,   616,   298
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      69,    69,    69,   173,   141,    61,    67,    67,    67,   470,
     518,   455,   361,    59,   313,   514,   532,   668,   586,   585,
     965,   483,   367,   601,   602,   731,   976,   491,  1129,  1151,
     479,    69,   291,   659,   678,   834,   294,    67,   482,   494,
     931,   584,   630,  1104,   728,   728,   728,   487,  1123,   950,
    1035,  1128,  1080,   674,   904,   905,   906,  1084,  1340,   687,
     837,   456,  1268,  1222,   627,   585,   629,   585,   695,   925,
     505,   884,  1111,   374,   614,   461,   314,  1212,   797,   884,
     634,   884,   623,   837,   509,   617,   620,   584,   142,   584,
     684,   452,  -432,   655,   513,  1354,   635,   884,  1368,   910,
     760,  1171,   940,   833,  1231,   763,   516,   516,  1162,   379,
     679,   124,  1156,   529,  1015,   517,  1178,   501,   666,  1364,
    1333,  1287,   645,   853,   666,   611,   666,  1282,   718,   718,
     718,  1384,   324,   321,   529,  -999,   315,  -999,   666,   971,
     362,  -676,  1259,   765,   666,   666,   666,  1264,  1273,  -654,
     666,  -677,   316,  -223,  1112,   533,   363,   794,  1361,   793,
     813,   816,   685,  1172,  1141,   658,   585,   686,  1061,   131,
    1173,   291,   317,  1402,   612,  1025,   716,   716,   716,   488,
     524,  1380,   525,  1025,   314,   814,  -859,  1236,   584,   662,
    -330,  1413,   972,   318,   -49,    30,   -49,   795,  -629,    31,
     889,   800,   961,   322,   325,  1096,   167,   314,  -224,  1142,
     817,  1424,   502,  1242,  -433,  -709,  -655,  1129,   680,  1316,
    -663,  1063,  1045,   737,  1148,   739,   775,   484,   322,  1016,
     485,   462,   380,  1350,   854,  -999,   623,  1393,   838,  1149,
     875,  1163,  1088,   890,  1335,  1090,   877,   667,   489,   925,
     941,  1179,   752,   667,  1365,   667,  1157,   291,   909,   901,
    1263,   838,   728,   145,   697,   698,  1100,   667,  1026,   364,
     801,  1113,   802,   667,   667,   667,  1026,  1346,   371,   667,
     526,   651,   300,  1237,   946,   372,  1223,   667,   516,   585,
     829,  1224,  1225,  1044,  1226,   699,   654,  1227,   761,   940,
     921,   538,   615,    69,    69,   910,   547,   381,  1355,   530,
     530,   584,   599,   628,   541,   596,   600,  1358,   688,   689,
     891,   677,   671,  1366,  1298,   680,   618,  1009,   375,  1347,
     964,   509,   625,   691,  1372,   694,  1352,   818,   669,   947,
     672,   631,   621,   735,   743,  1381,  1021,   744,   798,  1341,
     635,  1269,   742,   484,  1048,  1065,   485,  1207,   839,   457,
      69,   596,   458,   596,  -199,  1213,    67,  1300,  -199,   885,
     730,   730,   730,   463,   728,  1326,   645,   885,   645,   885,
    1050,   839,   881,   882,  1038,   819,   143,   680,   849,   453,
    1304,   656,  1327,  1065,   716,   885,    64,  1339,   680,  1201,
    1202,  1203,  1204,  -863,  1276,  1280,  1281,   680,   921,    64,
     663,    64,    65,    66,    65,    66,   680,   168,   487,  1414,
    1415,  1092,   680,   962,  1059,   720,   720,   720,   775,  1105,
    1106,  1107,    64,  1045,  1387,    65,    66,   834,  1377,  1089,
     240,   728,  1343,   291,  1409,   728,   968,   941,  1240,   728,
     728,   728,  1336,   534,  1159,  1244,    65,    66,   718,   472,
     473,    15,   596,   378,   756,  -628,   925,  1337,   240,   130,
    1015,   539,  1103,   144,   243,  1408,   379,   829,   164,   829,
     362,   946,   195,   291,   310,   291,    64,   198,   314,    65,
      66,   757,  1011,   585,   474,   291,   363,   291,   726,   726,
     726,  1160,   666,   969, -1043,   291,   716,  1018,   883,   671,
     585,    69,    22,    69,   291,   584,    69,   736,   873,   736,
    1037,   585,   741,   585,   823,   718,   666,   540,  1313,   718,
    1144,   321,   584,   718,   718,   718,  -799,   483,   483,   483,
      69,   320,  1125,   584,  1295,   584,   530,   327,  1165,  1321,
     328,  1423,  1115,   856,   482,   482,   482,  1296,   696,  1314,
     697,   698,   632,  1184,   368,   934,   698,  1126,   645,  1174,
     552,   553,  1382,   716, -1043,   379,  1032,   716,   492,   804,
    1310,   716,   716,   716,   495,  1016,   849,  1066,   730,  -800,
    1067,   699,    15,  -799,  -881,    17,  -430,  1068,   925,   380,
    1114,   322,   909,   925,   475,  1102,   805,  1069,  1391,  1070,
     680,  1319,  1071,  1072,  1219,   607,  1012,  1033,  1221,   607,
     222,    15,  1073,   310,    17,  1066,   496,  1211,  1067,   472,
     473,   667,   603, -1043,   604,  1068,    64,   605, -1083,    65,
      66,  1357,  -881,    22,  1399,  1069,  -800,  1070,   518,   953,
    1071,  1072,   500,    64,  1239,   667,  1241,   506,    21,   546,
    1073,   240,    65,    66,   474,   240,   127,   243,   128,  1147,
     585,  1133,    22,   243,   381,   936,   520,  1254,   937,  1153,
     585,   476,    25,   522,   938,  1052,  1419,  1420,   908,   195,
     909,    64,   584,  -992,   198,  1412,    29,  1395,   380,   520,
     730,  -899,   584,   214,  1396,  1013,  1014,  1416,  1169,  1170,
     939,  1395,   585,   608,   528,  1048,   291,   754,    70,   121,
     918,   609,   956,   652,   657,   609,  1087,   661,  1186,   585,
    1323,  1324,  1325,  1064,   584,   728,   665,   610,   291,   673,
     750,   610,   955,   957,   977,   746,   978,   958,   751,   483,
     742,   584,   810,  1395,  1395,   720,   830,   925,  1312,  -376,
     954,  -376,  1422,    65,    66,  1297,   482,   730,  1307,   639,
    1188,   730,  1189,   381,   475,   730,   730,   730,   728,   645,
     645,   291,    64,   871,  1303,    65,    66,    64,   878,   596,
      65,    66,   880,  1001,  1122,  1245,  1193,  1248,  1194,  1250,
     899,  1000,   902,   907,   919,   920,   596,  1317,  1139,   921,
    -864,  1140,  1320,   928,   929,   932,   959,   596,   966,   718,
     974,    15,   720,    16,    17,  1334,   720,   947,   726,  1020,
     720,   720,   720,    64,  1030,  1041,    65,    66,  1049,  1053,
    1060,  1081,  1272,   585,  1307,  1351,  1093,   291,  1251,  1116,
      20,   476,  1108,  1083,  1085,  1152,  1154,  1176,    21,   680,
    1167,  1177,   718,  1183,  1360,   584,  1191,   716,  1196,  1362,
    1197,  1367,    22,  1181,    64,  1077,  1371,  1115,  1115,  1115,
     195,  1208,    25,  1285,   585,   198,   195,  1215,   291,  1218,
     291,   198,  1220,  1246,  1262,   726,  1243,   204,    29,   726,
     206,  1274,  1383,   726,   726,   726,   584,  1266,  1278,  1283,
     716,   909,   291,  1306,  1301,   696,  1308,  1401,  1348,  1418,
    1421,  1392,   697,   698,  1182,  1114,  1114,  1114,  1062,  1252,
     445,   483,  1019,  1043,  1397,   291,   195,  1258,   483,   835,
     832,   198,  1318,  1198,   370,  1261,  1040,   204,   482,  1328,
     206,    61,  1329,   699,   361,   482,  1042,  1051,   669,    59,
     824,   633,  1134,   247,  1135,  1253,   596,   952,   253,  1137,
    1293,  1138,   523,   623,   733,  1094,   596,   915,  1187,   916,
    1400,  1330,  1332,   237,   238,   239,   240,   241,  1353,   585,
     917,   263,   243,  1233,   512,   510,    69,    69,   469,   927,
    1265,  1130,   530,   530,   943,   166,  1302,  1101,   596,  1217,
     874,   584,  1373,  1374,  1305,  1375,  1376,   172,  1363,   174,
     175,   176,   177,   935,   299,   596,   301,   519,   302,   303,
     304,   305,   306,   237,   238,   239,  1195,   241,   782,  1299,
     483,  1175,  1039,   792,   753,  1386,   585,   759,  1405,  1010,
     740,   292,   745,   922,  1407,  1205,   466,   482,  1311,  -874,
     214,   730,  1291,   295,  1277,   542,  1109,  1290,   584,   545,
    1288,  1271,   980,  1322,  1292,   692,   624,   755,     0,     0,
       0,     0,     0,     0,  1403,   585,     0,     0,     0,     0,
       2,     3,     0,     4,     0,     5,     6,     7,     8,     0,
       9,    10,    11,    12,   730,     0,     0,   584,     0,     0,
       0,     0,     0,     0,     0,     0,   720,     0,   518,  1122,
    1122,  1122,    13,     0,     0,     0,     0,   700,   701,     0,
     702,   703,   704,   705,     0,     0,     0,     0,     0,   596,
       0,     0,     0,   696,    64,     0,     0,    65,    66,     0,
     697,   698,     0,     0,     0,     0,   183,     0,     0,   720,
     184,     0,     0,   186,     0,     0,     0,   187,   936,     0,
       0,   937,     0,     0,  1116,  1116,  1116,   938,     0,     0,
     596,   699,     0,     0,     0,     0,  1097,     0,     0,   726,
       0,  1398,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   291,     0,   939,   197,     0,   199,   200,     0,     0,
       0,     0,  1410,     0,     0,  1077,     0,     0,     0,     0,
       0,     0,   210,  1411,     0,     0,     0,     0,     0,     0,
       0,     0,   726,     0,     0,     0,     0,     0,     0,     0,
      14,    15,     0,    16,    17,     0,     0,    18,     0,     0,
       0,     0,   217,   218,   219,     0,   220,   221,   325,     0,
       0,     0,   224,  -577,     0,     0,     0,     0,    19,     0,
      20,     0,     0,     0,     0,     0,     0,  1344,    21,     0,
       0,     0,   230,     0,     0,   596,     0,  -874,   214,     0,
       0,     0,    22,    23,   234,   235,     0,    24,     0,     0,
       0,     0,    25,     0,     0,     0,     0,  1369,     0,    26,
      27,    28,     0,  1385,     0,     0,     0,     0,    29,   637,
       0,     0,     0,     0,    65,    66,     0,   147,     0,     0,
       0,     0,     0,     0,     0,  1098,     0,     0,     0,     0,
       0,    69,   596,     0,     0,     0,     0,    67,     0,     0,
       0,     0,     0,     0,     0,   700,   701,     0,   702,   703,
     704,   705,     0,   195,     0,     0,     0,     0,   198,     0,
       0,     0,    64,     0,   204,    65,    66,   206,     0,     0,
      30,   596,     0,   384,    31,   291,   385,   386,   638,   -95,
     389,   390,   391,   392,     0,   393,   394,   395,    32,   396,
     397,     0,   398,     0,   399,   400,   401,   402,   403,     0,
     404,     0,   405,     0,   406,   407,   408,     0,   409,     0,
     410,     0,   411,     0,   412,   413,   414,   415,     0,     0,
     416,   417,     0,   418,   419,     0,   420,     0,   421,     0,
     422,     0,   423,     0,   424,     0,   425,   426,   639,     0,
     674,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     237,   238,   239,   240,   241,     0,     0,     0,     0,   243,
       0,     0,     0,     0,     0,   428,     0,     0,   429,     0,
       0,     0,     0,   680,  1099,     0,     0,   148,   149,   150,
     151,   152,   153,   154,   155,   156,     0,   430,   157,   158,
     159,   160,   161,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    74,     0,     0,    75,    76,    77,
       0,    78,     0,    79,    80,     0,    81,    82,    83,     0,
      84,    85,     0,    86,     0,    87,    88,    89,    90,    91,
       0,    92,     0,    93,     0,    94,    95,    96,     0,    97,
       0,    98,     0,    99,     0,   100,   101,   102,   103,   104,
       0,   105,   106,     0,   107,   108,     0,   109,     0,   110,
       0,   111,     0,   112,     0,   113,     0,   114,   115,   116,
     182,     0,     0,   183,     0,     0,     0,   184,     0,   185,
     186,     0,     0,     0,   187,   188,   189,     0,   190,   191,
      15,     0,   192,    17,   193,     0,     0,   431,   432,   433,
     434,   435,     0,     0,   436,     0,   437,   438,     0,   439,
    -204,     0,     0,   440,   441,   442,   443,   195,     0,    20,
     196,   197,   198,   199,   200,   201,   202,   467,   204,     0,
       0,   206,   207,     0,   208,     0,   209,     0,     0,   210,
       0,    22,     0,     0,   117,     0,     0,   211,     0,   212,
     213,   178,   118,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   468,   217,
     218,   219,     0,   220,   221,     0,   222,     0,     0,   224,
       0,     0,     0,   225,     0,     0,   226,     0,     0,   227,
       0,   228,     0,     0,     0,     0,     0,     0,   229,   230,
       0,   231,   232,   119,     0,     0,   233,     0,     0,     0,
     134,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     179,     0,   180,   243,   135,     0,  -267,     0,   181,     0,
       0, -1082,     0,     0,     0,     0,     0,     0,     0,  -267,
     484,    65,    66,   485,     0,     0,     0,     0,     0,     0,
       0,  -267,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   136,     0,     0,     0,     0,     0,     0,   137,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   182,     0,     0,   183,     0,     0,     0,   184,     0,
     185,   186,     0,     0,     0,   187,   188,   189,     0,   190,
     191,    15,     0,   192,    17,   193,     0,     0,     0,     0,
       0,   696,     0,     0,     0,     0,     0,     0,   697,   698,
       0,     0,     0,     0,     0,     0,     0,   194,   195,     0,
      20,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,     0,   206,   207,     0,   208,     0,   209,     0,   699,
     210,     0,    22,    23,  -998,     0,  -998,    24,   211,     0,
     212,   213,  -267,     0,  -874,   214,     0,     0,   138,    26,
      27,    28,     0,     0,     0,     0,     0,   215,  -991,   216,
     217,   218,   219,     0,   220,   221,     0,   222,   223,     0,
     224,     0,     0,     0,   225,     0,     0,   226,     0,     0,
     227,     0,   228,     0,     0,     0,     0,     0,  -806,   229,
     230,     0,   231,   232,     0,     0,     0,   233,     0,     0,
       0,  -806,   234,   235,   236,   237,   238,   239,   240,   241,
     242,     0,     0,  1036,   243,     0,   548,  -267,     0,     0,
       0,   549,     0,     0,     0,     0,     0,     0,  -722,   244,
    -722,  -722,    65,    66,  -998,  -874,   214,  -722,     0,     0,
       0,  -722,     0,     0,     0,     0,  -722,  -722,     0,     0,
    -806,     0,     0,     0,     0,  -722,   550,  -722,  -806,     0,
       0,  -722,     0,     0,     0,   551,  -722,     0,  -722,     0,
       0,   552,   553,  -722,  -722,     0,     0,     0,     0,  -267,
       0,     0,     0,  -267,     0,     0,  -267,     0,   139,     0,
       0,    65,    66,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   700,   701,     0,   702,   703,   704,   705,
       0,     0,     0,     0,     0,     0,     0,  -806,     0,     0,
      64,     0,     0,    65,    66,     0,     0,     0,     0,     0,
       0,     0,     0,   188,   189,     0,   190,     0,     0,     0,
       0,     0,   193,   554,     0,     0,  -722,     0,   555,     0,
    -722,     0,   556,  -722,     0,     0,     0,  -722,  -722,  -722,
       0,  -722,   557,  -722,     0,   558,  -722,  -722,   196,     0,
       0,     0,     0,   201,   202,   696,     0,  -806,     0,     0,
       0,     0,   697,   698,     0,     0,     0,     0,     0,     0,
     195,   559,  -722,  -722,  -722,   198,  -722,  -722,  -722,  -722,
     560,   204,     0,     0,   561,     0,     0,   335,     0,   562,
     563,     0,  -722,   699,  -722,     0,     0,   564,     0,     0,
     565,     0,   566,   567,     0,  -806,     0,     0,     0,     0,
       0,     0,     0,     0,   568,   569,     0,     0,     0,     0,
       0,   570,  -722,  -722,  -722,   341,     0,     0,   342,     0,
       0,     0,  -722,   343,     0,   344,   571,     0,     0,   572,
     573,   236,   574,     0,   575,   349,     0,   350,   351,     0,
     352,   353,  -722,     0,   576,   577,     0,  -806,     0,   578,
     357,  -806,     0,     0,  -722,  -722,  -722,   579,   580,   581,
       0,   241,   582,  -722,  -722,  -722,     0,  -722,  -722,  -722,
    -722,  1145,     0,     0,   548,     0,     0,     0,     0,   549,
     680,   583,     0,     0,  -722,  -722,  -722,     0,  -722,  -722,
     214,     0,     0,     0,     0,  -722,     0,     0,     0,  -722,
       0,     0,     0,     0,  -722,  -722,     0,     0,     0,     0,
       0,     0,     0,  1146,   550,  -722,     0,     0,     0,  -722,
       0,     0,     0,   551,  -722,     0,  -722,     0,     0,   552,
     553,  -722,  -722,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   700,   701,     0,
     702,   703,   704,   705,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    64,     0,     0,    65,    66,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   554,     0,     0,  -722,     0,   555,     0,  -722,     0,
     556,  -722,     0,     0,     0,  -722,  -722,  -722,     0,  -722,
     557,  -722,     0,   558,  -722,  -722,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   195,   559,
    -722,  -722,  -722,   198,  -722,  -722,  -722,  -722,   560,   204,
       0,     0,   561,     0,     0,   335,     0,   562,   563,     0,
    -722,     0,  -722,     0,     0,   564,     0,     0,   565,     0,
     566,   567,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   568,   569,     0,     0,     0,     0,     0,   570,
    -722,  -722,  -722,   341,     0,     0,   342,     0,     0,     0,
    -722,   343,     0,   344,   571,     0,     0,   572,   573,     0,
     574,     0,   575,   349,     0,   350,   351,     0,   352,   353,
    -722,     0,   576,   577,     0,     0,     0,   578,   357,     0,
       0,     0,  -722,  -722,  -722,   579,   580,   581,     0,   241,
     582,  -722,  -722,  -722,     0,  -722,  -722,  -722,  -722,  1185,
       0,     0,   548,     0,     0,     0,     0,   549,     0,   583,
       0,     0,  -722,  -722,  -722,     0,  -722,  -722,     0,     0,
       0,     0,     0,  -722,     0,     0,     0,  -722,     0,     0,
       0,     0,  -722,  -722,     0,     0,     0,     0,     0,     0,
       0,  -722,   550,  -722,     0,     0,     0,  -722,     0,     0,
       0,   551,  -722,     0,  -722,     0,     0,   552,   553,  -722,
    -722,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   554,
       0,     0,  -722,     0,   555,     0,  -722,     0,   556,  -722,
       0,     0,     0,  -722,  -722,  -722,     0,  -722,   557,  -722,
       0,   558,  -722,  -722,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   195,   559,  -722,  -722,
    -722,   198,  -722,  -722,  -722,  -722,   560,   204,     0,     0,
     561,     0,     0,   335,     0,   562,   563,     0,  -722,     0,
    -722,     0,     0,   564,     0,     0,   565,     0,   566,   567,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     568,   569,     0,     0,     0,     0,     0,   570,  -722,  -722,
    -722,   341,     0,     0,   342,     0,     0,     0,  -722,   343,
       0,   344,   571,     0,     0,   572,   573,     0,   574,     0,
     575,   349,     0,   350,   351,     0,   352,   353,  -722,     0,
     576,   577,     0,     0,     0,   578,   357,     0,     0,     0,
    -722,  -722,  -722,   579,   580,   581,     0,   241,   582,  -722,
    -722,  -722,     0,  -722,  -722,  -722,  -722,  1284,     0,     0,
     548,     0,     0,     0,     0,   549,     0,   583,     0,     0,
    -722,  -722,  -722,     0,  -722,  -722,     0,     0,     0,     0,
       0,  -722,     0,     0,     0,  -722,     0,     0,     0,     0,
    -722,  -722,     0,     0,     0,     0,     0,     0,     0,  -722,
     550,  -722,     0,     0,     0,  -722,     0,     0,     0,   551,
    -722,     0,  -722,     0,     0,   552,   553,  -722,  -722,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   554,     0,     0,
    -722,     0,   555,     0,  -722,     0,   556,  -722,     0,     0,
       0,  -722,  -722,  -722,     0,  -722,   557,  -722,     0,   558,
    -722,  -722,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   195,   559,  -722,  -722,  -722,   198,
    -722,  -722,  -722,  -722,   560,   204,     0,     0,   561,     0,
       0,   335,     0,   562,   563,     0,  -722,     0,  -722,     0,
       0,   564,     0,     0,   565,     0,   566,   567,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   568,   569,
       0,     0,     0,     0,     0,   570,  -722,  -722,  -722,   341,
       0,     0,   342,     0,     0,     0,  -722,   343,     0,   344,
     571,     0,     0,   572,   573,     0,   574,     0,   575,   349,
       0,   350,   351,     0,   352,   353,  -722,    73,   576,   577,
     -60,     0,     0,   578,   357,   -60,     0,     0,  -722,  -722,
    -722,   579,   580,   581,     0,   241,   582,  -722,  -722,  -722,
       0,  -722,  -722,  -722,  -722,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   -60,   583,     0,     0,  -722,  -722,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   -60,
       0,     0,     0,     0,     0,   -60,   -60,     0,     0,     0,
       0,    74,     0,     0,    75,    76,    77,     0,    78,     0,
      79,    80,     0,    81,    82,    83,     0,    84,    85,     0,
      86,     0,    87,    88,    89,    90,    91,     0,    92,     0,
      93,     0,    94,    95,    96,     0,    97,     0,    98,     0,
      99,     0,   100,   101,   102,   103,   104,     0,   105,   106,
       0,   107,   108,     0,   109,     0,   110,     0,   111,     0,
     112,     0,   113,     0,   114,   115,   116,     0,     0,     0,
       0,     0,   321,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   -60,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   -60,     0,     0,     0,     0,   -60,
       0,     0,     0,     0,   -60,     0,     0,     0,     0,     0,
       0,   -60,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   117,   322,     0,   -60,     0,   -60,   -60,     0,   118,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   -60,
       0,     0,     0,     0,     0,   -60,     0,     0,     0,   -60,
       0,     0,   -60,     0,     0,     0,     0,   -60,     0,   -60,
     -60,     0,     0,   -60,   -60,     0,   -60,     0,     0,   -60,
       0,   -60,   -60,     0,   -60,   -60,     0,     0,   -60,   -60,
     119,     0, -1063,   -60,   -60, -1063,     0,     0,     0, -1063,
       0, -1063, -1063,     0,     0,     0, -1063, -1063, -1063,     0,
   -1063, -1063, -1063,     0, -1063, -1063, -1063,     0,     0,     0,
       0,     0,  1232,     0,     0,    64,     0,     0,    65,    66,
       0,     0,     0,     0,     0,     0,     0,     0,     0, -1063,
     889, -1063, -1063, -1063, -1063, -1063, -1063, -1063, -1063, -1063,
   -1063,     0,     0, -1063, -1063,     0, -1063,     0, -1063,     0,
       0, -1063,     0, -1063,     0,     0,     0,     0,     0, -1063,
       0, -1063, -1063,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   890,     0,     0,     0,     0,     0,     0,
   -1063, -1063, -1063, -1063,     0, -1063, -1063,     0, -1063,     0,
       0, -1063,     0,     0,     0, -1063,     0,     0, -1063,     0,
       0, -1063,     0, -1063,     0,     0,     0,     0,     0,     0,
   -1063, -1063,     0, -1063, -1063,     0,     0,     0, -1063,     0,
       0,     0,     0, -1063, -1063, -1063, -1063, -1063, -1063, -1063,
   -1063, -1063,     0,     0,     0, -1063,     0,     0,     0,     0,
       0,     0, -1063,     0,     0, -1063,     0,     0,     0, -1063,
     891, -1063, -1063, -1063, -1063,     0, -1063, -1063, -1063,     0,
   -1063, -1063, -1063,     0, -1063, -1063, -1063,     0,     0,     0,
       0,     0,  1378,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0, -1063,
     889, -1063, -1063, -1063, -1063, -1063, -1063, -1063, -1063, -1063,
   -1063,     0,     0, -1063, -1063,     0, -1063,     0, -1063,     0,
       0, -1063,     0, -1063,     0,     0,     0,     0,     0, -1063,
       0, -1063, -1063,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   890,     0,     0,     0,     0,     0,     0,
   -1063, -1063, -1063, -1063,     0, -1063, -1063,     0, -1063,     0,
       0, -1063,     0,     0,     0, -1063,     0,     0, -1063,     0,
       0, -1063,     0, -1063,     0,     0,     0,     0,     0,     0,
   -1063, -1063,     0, -1063, -1063,     0,     0,     0, -1063,     0,
       0,     0,     0, -1063, -1063, -1063, -1063, -1063, -1063, -1063,
   -1063, -1063,     0,     0,     0, -1063,     0,     0,     0,     0,
       0,     0, -1063,     0,     0, -1063,     0,     0,     0, -1063,
     891, -1063, -1063, -1063, -1063,     0, -1063, -1063, -1063,     0,
   -1063, -1063, -1063,     0, -1063, -1063, -1063,     0,     0,     0,
       0,     0,   693,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0, -1063,
     889, -1063, -1063, -1063, -1063, -1063, -1063, -1063, -1063, -1063,
   -1063,     0,     0, -1063, -1063,     0, -1063,     0, -1063,     0,
       0, -1063,     0, -1063,     0,     0,     0,     0,     0, -1063,
       0, -1063, -1063,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   890,     0,     0,     0,     0,     0,     0,
   -1063, -1063, -1063, -1063,     0, -1063, -1063,     0, -1063,     0,
       0, -1063,     0,     0,     0, -1063,     0,     0, -1063,     0,
       0, -1063,     0, -1063,     0,     0,     0,     0,     0,     0,
   -1063, -1063,     0, -1063, -1063,     0,     0,     0, -1063,     0,
       0,     0,     0, -1063, -1063, -1063, -1063, -1063, -1063, -1063,
   -1063, -1063,     0,     0,     0, -1063,     0,     0,     0,     0,
       0,     0,   182,     0,     0,   183,     0,     0,     0,   184,
     891,   185,   186, -1063, -1063,     0,   187,   188,   189,     0,
     190,   191,    15,     0,   192,    17,   193,     0,     0,     0,
       0,   734,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   195,
       0,    20,   196,   197,   198,   199,   200,   201,   202,   467,
     204,     0,     0,   206,   207,     0,   208,     0,   209,     0,
       0,   210,     0,    22,     0,     0,     0,     0,     0,   211,
       0,   212,   213,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     468,   217,   218,   219,     0,   220,   221,     0,   222,     0,
       0,   224,     0,     0,     0,   225,     0,     0,   226,     0,
       0,   227,     0,   228,     0,     0,     0,     0,     0,     0,
     229,   230,     0,   231,   232,     0,     0,     0,   233,     0,
       0,     0,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   324,     0,     0,   243,   981,   982,     0,     0,
       0,   182,     0,     0,   183,     0,     0,     0,   184,   680,
     185,   186,   983,    65,    66,   187,   188,   189,     0,   190,
     191,    15,     0,   192,    17,   193,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     984,     0,     0,     0,     0,     0,     0,     0,   195,     0,
      20,   196,   197,   198,   199,   200,   201,   202,   467,   204,
       0,     0,   206,   207,   325,   208,     0,   209,     0,  -578,
     210,     0,    22,     0,     0,     0,     0,     0,   211,     0,
     212,   213,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   468,
     217,   218,   219,     0,   220,   221,     0,   222,     0,     0,
     224,     0,   985,     0,   225,  -848,   986,   226,     0,   987,
     227,     0,   228,   988,     0,     0,   548,     0,  -848,   229,
     230,   549,   231,   232,     0,     0,     0,   233,     0,     0,
       0,  1247,   234,   235,   236,   237,   238,   239,   240,   241,
     242,     0,     0,     0,   243,     0,     0,     0,     0,     0,
     989,     0,   990,   991,     0,     0,   550,     0,     0,   195,
       0,     0,    65,    66,   198,   551,     0,  -848,   992,     0,
     204,   552,   553,   206,     0,  -848,     0,     0,     0,     0,
       0,     0,     0,  -708,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   993,   994,
     995,     0,     0,     0,     0,     0,     0,     0,   996,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   997,     0,
       0,     0,     0,     0,  -848,     0,     0,     0,     0,     0,
     998,   999,     0,   554,     0,     0,     0,     0,   555,     0,
     936,     0,   556,   937,     0,     0,   237,   238,   239,   938,
     241,     0,   557,   548,     0,   558,     0,  1404,   549,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0, -1055,
   -1055,     0,     0,     0,     0,   939,     0,     0,     0,     0,
     195,   559,     0,     0,  -848,   198,     0,     0,     0,     0,
     560,   204,     0,   550,   561,     0,     0,   335,     0,   562,
     563,     0,   551,     0,     0,     0,     0,   564,   552,   553,
     565,     0,   566,   567,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   568,   569,     0,     0,     0,     0,
       0,   570,  -848,     0,     0,   341,     0,     0,   342,     0,
       0,     0,     0,   343,     0,   344,   571,     0,     0,   572,
     573,     0,   574,     0,   575,   349,     0,   350,   351,     0,
     352,   353,     0,     0,   576,   577,     0,     0,     0,   578,
     357,     0,     0,     0,     0,     0,     0,   579,   580,   581,
     554,   241,   582,     0,  -848,   555,     0,     0,  -848,   556,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   557,
       0,   583,   558,     0,     0,     0,     0,   981,   982,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   983,     0,     0,     0,   195,   559,     0,
       0,     0,   198,     0,     0,     0,     0,   560,   204,     0,
       0,   561,     0,     0,   335,     0,   562,   563,     0,     0,
       0,   984,     0,     0,   564,     0,     0,   565,     0,   566,
     567,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   568,   569,     0,     0,     0,     0,     0,   570,     0,
       0,     0,   341,     0,     0,   342,     0,     0,     0,     0,
     343,     0,   344,   571,     0,   548,   572,   573,     0,   574,
     549,   575,   349,     0,   350,   351,     0,   352,   353,     0,
       0,   576,   577,     0,     0,     0,   578,   357,     0,     0,
       0,     0,     0,   985,   579,   580,   581,   986,   241,   582,
     987,     0,     0,     0,   988,   550,     0,     0,     0,     0,
      15,     0,     0,    17,   551,     0,     0,     0,   583,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    20,
       0,   989,     0,   990,   991,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   992,
       0,    22,     0,     0,     0,     0,   329,     0,     0,     0,
       0,   330,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   993,
     994,   995,   554,     0,     0,     0,     0,   555,     0,   996,
     331,   556,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   557,     0,     0,   558,   332,     0,     0,     0,   997,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   998,   999,     0,     0,     0,     0,     0,     0,   195,
       0,     0,     0,     0,   198,     0,     0,     0,     0,   560,
     204,     0,     0,   561,     0,     0,   335,     0,   562,   563,
       0,    65,    66,     0,     0,     0,   564,     0,     0,   565,
       0,   566,   567,     0,     0,     0,   329,     0,     0,     0,
       0,   330,     0,   568,   569,     0,     0,     0,     0,     0,
     570,     0,     0,     0,   341,     0,     0,   342,     0,     0,
       0,     0,   343,     0,   344,   571,     0,     0,   572,   573,
       0,   574,   333,   575,   349,     0,   350,   351,     0,   352,
     353,     0,     0,   576,   577,   332,   767,     0,   578,   357,
       0,     0,     0,     0,     0,   768,   579,   580,   581,   769,
     241,   582,     0,     0,     0,  -714,     0,  1209,     0,     0,
     334,     0,     0,  -714,     0,  -714,     0,   335,     0,   770,
       0,     0,     0,     0,   771,     0,   772,     0,     0,     0,
     336,   773,   337,   338,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   339,     0,     0,     0,     0,
       0,   340,     0,     0,     0,   341,     0,     0,   342,     0,
       0,     0,     0,   343,     0,   344,   345,     0,     0,   346,
     347,     0,   348,     0,     0,   349,     0,   350,   351,     0,
     352,   353,   333,     0,   354,   355,     0,     0,     0,   356,
     357,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   188,   189,     0,   190,
     334,     0,     0,     0,     0,   193,     0,   335,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     336,     0,   337,   338,     0,     0,     0,     0,     0,     0,
       0,   196,     0,     0,     0,   339,   201,   202,     0,     0,
       0,   340,     0,     0,     0,   341,     0,     0,   342,     0,
       0,     0,     0,   343,     0,   344,   345,     0,     0,   346,
     347,     0,   348,     0,     0,   349,     0,   350,   351,     0,
     352,   353,     0,     0,   354,   355,     0,     0,     0,   356,
     357,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   236,     0,     0,     0,     0,     0,
       0,   774,   700,   701,     0,   702,   703,   704,   705,   384,
       0,     0,   385,   386,   843,   844,   389,   390,   391,   392,
       0,   393,   394,   395,     0,   396,   397,     0,   398,     0,
     399,   400,   401,   402,   403,     0,   404,     0,   405,     0,
     406,   407,   408,     0,   409,     0,   410,     0,   411,     0,
     412,   413,   414,   415,     0,     0,   416,   417,     0,   418,
     419,     0,   420,     0,   421,     0,   422,     0,   423,     0,
     424,     0,   425,   426,   845,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   428,   846,     0,   429,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   847,   848,     0,     0,     0,     0,
       0,     0,     0,   430,   384,     0,     0,   385,   386,   387,
     388,   389,   390,   391,   392,     0,   393,   394,   395,     0,
     396,   397,     0,   398,     0,   399,   400,   401,   402,   403,
       0,   404,     0,   405,     0,   406,   407,   408,     0,   409,
       0,   410,     0,   411,     0,   412,   413,   414,   415,     0,
       0,   416,   417,     0,   418,   419,     0,   420,     0,   421,
       0,   422,     0,   423,     0,   424,     0,   425,   426,   427,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   428,     0,     0,   429,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   431,   432,   433,   434,   435,   430,     0,
     436,     0,   437,   438,     0,   439,     0,     0,     0,   440,
     441,   442,   443,     0,     0,     0,     0,     0,     0,     0,
       0,   384,     0,     0,   385,   386,   646,   388,   389,   390,
     391,   392,     0,   393,   394,   395,     0,   396,   397,     0,
     398,     0,   399,   400,   401,   402,   403,     0,   404,     0,
     405,     0,   406,   407,   408,     0,   409,     0,   410,     0,
     411,     0,   412,   413,   414,   415,     0,     0,   416,   417,
       0,   418,   419,     0,   420,     0,   421,     0,   422,     0,
     423,     0,   424,     0,   425,   426,   427,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   431,   432,
     433,   434,   435,   428,     0,   436,   429,   437,   438,     0,
     439,     0,     0,     0,   440,   441,   442,   443,     0,   384,
       0,     0,   385,   386,   825,   430,   389,   390,   391,   392,
       0,   393,   394,   395,     0,   396,   397,     0,   398,     0,
     399,   400,   401,   402,   403,     0,   404,     0,   405,     0,
     406,   407,   408,     0,   409,     0,   410,     0,   411,     0,
     412,   413,   414,   415,     0,     0,   416,   417,     0,   418,
     419,     0,   420,     0,   421,     0,   422,     0,   423,     0,
     424,     0,   425,   426,   427,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   428,     0,     0,   429,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   430,     0,   431,   432,   433,   434,   435,
       0,     0,   436,     0,   437,   438,     0,   439,     0,     0,
       0,   440,   441,   442,   443,     0,   384,     0,     0,   385,
     386,   638,     0,   389,   390,   391,   392,     0,   393,   394,
     395,     0,   396,   397,     0,   398,     0,   399,   400,   401,
     402,   403,     0,   404,     0,   405,     0,   406,   407,   408,
       0,   409,     0,   410,     0,   411,     0,   412,   413,   414,
     415,     0,     0,   416,   417,     0,   418,   419,     0,   420,
       0,   421,     0,   422,     0,   423,     0,   424,     0,   425,
     426,   831,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   431,   432,   433,   434,   435,   428,     0,
     436,   429,   437,   438,     0,   439,     0,     0,     0,   440,
     441,   442,   443,     0,   384,     0,     0,   385,   386,   638,
     430,   389,   390,   391,   392,     0,   393,   394,   395,     0,
     396,   397,     0,   398,     0,   399,   400,   401,   402,   403,
       0,   404,     0,   405,     0,   406,   407,   408,     0,   409,
       0,   410,     0,   411,     0,   412,   413,   414,   415,     0,
       0,   416,   417,     0,   418,   419,     0,   420,     0,   421,
       0,   422,     0,   423,     0,   424,     0,   425,   426,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   428,     0,     0,   429,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   430,     0,
     431,   432,   433,   434,   435,     0,     0,   436,     0,   437,
     438,     0,   439,     0,     0,     0,   440,   441,   442,   443,
       0,     0,     0,     0,     0,     0,     0,     0,   181,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   182,     0,     0,   183,     0,     0,     0,   184,     0,
     185,   186,     0,     0,     0,   187,   188,   189,     0,   190,
     191,    15,     0,   192,    17,   193,     0,     0,   431,   432,
     433,   434,   435,     0,     0,   436,     0,   437,   438,     0,
     439,     0,     0,     0,   440,   441,   442,   443,   195,     0,
      20,   196,   197,   198,   199,   200,   201,   202,   467,   204,
       0,     0,   206,   207,     0,   208,     0,   209,     0,     0,
     210,     0,    22,     0,     0,     0,     0,     0,   211,     0,
     212,   213,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   468,
     217,   218,   219,     0,   220,   221,     0,   222,     0,     0,
     224,     0,     0,     0,   225,     0,     0,   226,     0,     0,
     227,     0,   228,     0,     0,     0,     0,     0,     0,   229,
     230,     0,   231,   232,     0,     0,     0,   233,     0,     0,
       0,     0,   234,   235,   236,   237,   238,   239,   240,   241,
     242,     0,     0,     0,   243,     0,     0,     0,     0,     0,
     182,     0,     0,   183,     0,     0,     0,   184,     0,   185,
     186,     0,    65,    66,   187,   188,   189,     0,   190,   191,
      15,     0,   192,    17,   193,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   195,     0,    20,
     196,   197,   198,   199,   200,   201,   202,   467,   204,     0,
       0,   206,   207,     0,   208,     0,   209,     0,     0,   210,
       0,    22,     0,     0,     0,     0,     0,   211,     0,   212,
     213,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   468,   217,
     218,   219,     0,   220,   221,     0,   222,     0,     0,   224,
       0,     0,     0,   225,     0,     0,   226,     0,     0,   227,
       0,   228,     0,     0,     0,     0,     0,     0,   229,   230,
       0,   231,   232,     0,     0,     0,   233,     0,     0,     0,
       0,   234,   235,   236,   237,   238,   239,   240,   241,   242,
       0,     0,   183,   243,     0,     0,   184,     0,     0,   186,
       0,     0,     0,   187,   936,     0,     0,   937,     0,     0,
       0,    65,    66,   938,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   939,
     197,     0,   199,   200,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   182,     0,   210,     0,
       0,     0,     0,     0,     0,   185,     0,     0,     0,     0,
       0,   188,   189,     0,   190,   191,     0,     0,   192,     0,
     193,     0,     0,     0,     0,     0,     0,     0,   217,   218,
     219,     0,   220,   221,     0,     0,     0,     0,   224,     0,
       0,     0,     0,   195,     0,     0,   196,     0,   198,     0,
       0,   201,   202,   467,   204,     0,     0,   206,   230,     0,
     208,     0,   209,     0,     0,     0,     0,     0,     0,     0,
     234,   235,     0,   211,     0,   212,   213,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   468,     0,     0,     0,     0,     0,
      65,    66,   222,     0,     0,     0,     0,     0,     0,   225,
       0,     0,   226,     0,     0,   227,     0,   228,     0,     0,
       0,     0,     0,     0,   229,     0,     0,   231,   232,     0,
       0,     0,   233,     0,     0,     0,     0,     0,     0,   236,
     237,   238,   239,   240,   241,   242,     0,     0,     0,   243
};

static const yytype_int16 yycheck[] =
{
       4,     5,     6,    35,    12,     1,     4,     5,     6,   179,
     287,   156,   120,     1,    67,   275,   308,   478,   319,   319,
     768,   181,   126,   327,   328,   507,   774,   207,   943,   976,
     180,    35,    40,   469,   493,   643,    40,    35,   181,   219,
     743,   319,     1,   910,   506,   507,   508,   185,   931,     1,
     817,   934,   883,     1,   697,   698,   699,   888,     1,   496,
       1,     1,     1,    70,   365,   365,   367,   367,   505,   730,
     250,     1,   920,    42,     1,     1,    65,     1,     1,     1,
       1,     1,   360,     1,   265,     1,     1,   365,     1,   367,
       1,     1,    71,     1,   274,     1,   378,     1,     1,   709,
       1,     1,   746,   642,  1085,    78,   278,   279,     1,    30,
       1,     1,     1,     1,    21,   279,     1,     1,     1,     1,
    1261,     1,   387,     1,     1,    23,     1,  1174,   506,   507,
     508,  1339,     1,     1,     1,   204,     1,   206,     1,     1,
       1,    71,  1123,   580,     1,     1,     1,  1128,  1146,    71,
       1,    71,    17,    71,   921,     1,    17,     1,     1,    17,
       1,    14,    73,    63,     1,   466,   466,    78,   871,   300,
      70,   179,    37,  1381,    72,    55,   506,   507,   508,     1,
     204,  1322,   206,    55,    65,    26,    67,     1,   466,     1,
      73,  1399,    54,    58,    71,   290,    73,    41,    73,   294,
     179,     1,    78,    71,    73,   908,     1,    65,    71,    46,
      63,  1419,    96,  1096,    71,    71,    71,  1132,   298,   299,
      71,   876,   833,   515,     1,   517,   588,   301,    71,   136,
     304,   157,   153,  1280,   112,   304,   514,    75,   179,    16,
     676,   134,   897,   222,     1,   900,   682,   130,    70,   910,
     746,   136,   544,   130,   136,   130,   145,   265,    72,   695,
    1127,   179,   724,   227,    77,    78,   909,   130,   148,   130,
      70,   926,    72,   130,   130,   130,   148,  1275,    52,   130,
     304,   451,   294,    97,   746,    59,   293,   130,   460,   589,
     638,   298,   299,   832,   301,   108,   460,   304,   199,   943,
     289,   309,   229,   307,   308,   915,   314,   228,   214,   307,
     308,   589,   320,   366,   310,   319,   320,  1298,   498,   499,
     299,   491,   482,   205,  1207,   298,   242,   789,   297,  1276,
     767,   512,   364,   503,  1315,   505,  1283,   190,   481,   291,
     483,   300,   257,   513,   524,  1326,   807,   527,   271,   292,
     632,   290,   522,   301,   836,     1,   304,  1060,   299,   299,
     364,   365,   302,   367,   290,   289,   364,  1215,   294,   299,
     506,   507,   508,   299,   836,  1258,   641,   299,   643,   299,
     841,   299,   686,   687,   821,   238,   299,   298,   653,   299,
    1221,   299,  1259,     1,   724,   299,   299,  1264,   298,  1054,
    1055,  1056,  1057,   291,  1152,  1172,  1173,   298,   289,   299,
     222,   299,   302,   303,   302,   303,   298,   212,   556,  1400,
    1401,   903,   298,   299,   860,   506,   507,   508,   790,   911,
     912,   913,   299,  1044,  1349,   302,   303,  1045,  1321,   898,
     278,   903,     1,   451,  1391,   907,     1,   943,  1091,   911,
     912,   913,   209,   299,     1,  1098,   302,   303,   836,    77,
      78,   151,   466,    17,     1,    73,  1127,   224,   278,    10,
      21,     1,   909,    14,   284,  1390,    30,   825,    19,   827,
       1,   943,   178,   491,    46,   493,   299,   183,    65,   302,
     303,    28,   793,   793,   112,   503,    17,   505,   506,   507,
     508,    48,     1,    58,     1,   513,   836,    58,   688,   669,
     810,   515,   202,   517,   522,   793,   520,   515,   668,   517,
     821,   821,   520,   823,   628,   903,     1,    57,    77,   907,
     966,     1,   810,   911,   912,   913,     1,   697,   698,   699,
     544,    65,   223,   821,  1199,   823,   544,    72,   985,  1252,
      72,  1418,   930,    70,   697,   698,   699,  1200,    70,   108,
      77,    78,    17,  1024,   112,   745,    78,   248,   833,  1006,
      59,    60,    71,   903,    71,    30,    17,   907,    65,    27,
    1235,   911,   912,   913,    72,   136,   851,   233,   724,     1,
     236,   108,   151,    58,    17,   154,    71,   243,  1259,   153,
     930,    71,    72,  1264,   222,   909,    54,   253,  1356,   255,
     298,   299,   258,   259,  1075,   148,   796,    58,  1079,   148,
     237,   151,   268,    46,   154,   233,    72,  1063,   236,    77,
      78,   130,    31,   130,    33,   243,   299,    36,    81,   302,
     303,  1296,    65,   202,  1372,   253,    58,   255,   925,   188,
     258,   259,    70,   299,  1090,   130,  1092,   130,   188,   299,
     268,   278,   302,   303,   112,   278,     1,   284,     3,   970,
     970,     1,   202,   284,   228,   146,    65,  1113,   149,   980,
     980,   299,   212,   214,   155,   855,  1414,  1415,    70,   178,
      72,   299,   970,   228,   183,  1398,   228,  1358,   153,    65,
     836,    67,   980,   215,  1359,   801,   802,  1410,  1000,  1001,
     181,  1372,  1012,   246,    81,  1197,   724,   246,     4,     5,
     724,   254,   188,    70,   299,   254,   896,   299,  1029,  1029,
    1255,  1256,  1257,   878,  1012,  1197,    73,   270,   746,   291,
      65,   270,   750,   751,    43,   289,    45,   751,    65,   909,
     920,  1029,    70,  1414,  1415,   836,    71,  1418,  1240,    70,
     299,    72,  1417,   302,   303,  1201,   909,   903,  1229,   130,
      18,   907,    20,   228,   222,   911,   912,   913,  1240,  1044,
    1045,   789,   299,    70,  1220,   302,   303,   299,   228,   793,
     302,   303,    73,   789,   930,  1099,    54,  1101,    56,  1103,
      71,   789,   106,   130,    67,   214,   810,  1244,   953,   289,
     291,   956,  1249,   291,   291,    71,    40,   821,    70,  1197,
      39,   151,   903,   153,   154,  1261,   907,   291,   836,    73,
     911,   912,   913,   299,   214,    71,   302,   303,    71,   106,
      70,    70,  1143,  1143,  1305,  1281,     1,   855,  1108,   930,
     180,   299,    78,    71,    71,    35,    50,    71,   188,   298,
      51,    73,  1240,    71,  1300,  1143,    22,  1197,    71,  1305,
     130,  1308,   202,  1018,   299,   879,  1312,  1255,  1256,  1257,
     178,    71,   212,  1184,  1184,   183,   178,    70,   896,    73,
     898,   183,    71,    78,    70,   903,    73,   189,   228,   907,
     192,   299,  1338,   911,   912,   913,  1184,   290,    46,    71,
    1240,    72,   920,    71,  1218,    70,   112,    71,   153,    71,
      71,  1357,    77,    78,  1021,  1255,  1256,  1257,   872,  1109,
     143,  1091,   805,   830,  1370,   943,   178,  1117,  1098,   649,
     641,   183,  1246,  1050,   132,  1125,   825,   189,  1091,   247,
     192,   947,   250,   108,  1062,  1098,   827,   851,  1101,   947,
     632,   377,   292,    40,   947,  1110,   970,   749,    40,   947,
    1197,   947,   296,  1251,   508,   907,   980,   724,  1031,   724,
    1377,   279,  1260,   275,   276,   277,   278,   279,  1289,  1289,
     724,    40,   284,  1086,   269,   265,  1000,  1001,   179,   737,
    1130,   943,  1000,  1001,   746,    20,  1219,   909,  1012,  1071,
     669,  1289,  1316,  1317,  1222,  1319,  1320,    34,  1307,    36,
      37,    38,    39,     1,    41,  1029,    43,   289,    45,    46,
      47,    48,    49,   275,   276,   277,  1039,   279,   588,  1209,
    1200,  1012,   823,   589,   548,  1346,  1346,   556,  1389,   790,
     517,    40,   528,   728,  1389,  1059,   173,  1200,  1238,   214,
     215,  1197,  1195,    40,  1155,   310,   920,  1194,  1346,   312,
    1187,  1138,   787,  1253,     1,   504,   360,   551,    -1,    -1,
      -1,    -1,    -1,    -1,  1385,  1385,    -1,    -1,    -1,    -1,
       0,     1,    -1,     3,    -1,     5,     6,     7,     8,    -1,
      10,    11,    12,    13,  1240,    -1,    -1,  1385,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1197,    -1,  1395,  1255,
    1256,  1257,    32,    -1,    -1,    -1,    -1,   282,   283,    -1,
     285,   286,   287,   288,    -1,    -1,    -1,    -1,    -1,  1143,
      -1,    -1,    -1,    70,   299,    -1,    -1,   302,   303,    -1,
      77,    78,    -1,    -1,    -1,    -1,   134,    -1,    -1,  1240,
     138,    -1,    -1,   141,    -1,    -1,    -1,   145,   146,    -1,
      -1,   149,    -1,    -1,  1255,  1256,  1257,   155,    -1,    -1,
    1184,   108,    -1,    -1,    -1,    -1,     1,    -1,    -1,  1197,
      -1,  1371,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1209,    -1,   181,   182,    -1,   184,   185,    -1,    -1,
      -1,    -1,  1392,    -1,    -1,  1219,    -1,    -1,    -1,    -1,
      -1,    -1,   200,  1393,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1240,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     150,   151,    -1,   153,   154,    -1,    -1,   157,    -1,    -1,
      -1,    -1,   230,   231,   232,    -1,   234,   235,    73,    -1,
      -1,    -1,   240,    78,    -1,    -1,    -1,    -1,   178,    -1,
     180,    -1,    -1,    -1,    -1,    -1,    -1,  1273,   188,    -1,
      -1,    -1,   260,    -1,    -1,  1289,    -1,   214,   215,    -1,
      -1,    -1,   202,   203,   272,   273,    -1,   207,    -1,    -1,
      -1,    -1,   212,    -1,    -1,    -1,    -1,  1311,    -1,   219,
     220,   221,    -1,  1345,    -1,    -1,    -1,    -1,   228,     1,
      -1,    -1,    -1,    -1,   302,   303,    -1,     1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   150,    -1,    -1,    -1,    -1,
      -1,  1345,  1346,    -1,    -1,    -1,    -1,  1345,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   282,   283,    -1,   285,   286,
     287,   288,    -1,   178,    -1,    -1,    -1,    -1,   183,    -1,
      -1,    -1,   299,    -1,   189,   302,   303,   192,    -1,    -1,
     290,  1385,    -1,    65,   294,  1393,    68,    69,    70,    71,
      72,    73,    74,    75,    -1,    77,    78,    79,   308,    81,
      82,    -1,    84,    -1,    86,    87,    88,    89,    90,    -1,
      92,    -1,    94,    -1,    96,    97,    98,    -1,   100,    -1,
     102,    -1,   104,    -1,   106,   107,   108,   109,    -1,    -1,
     112,   113,    -1,   115,   116,    -1,   118,    -1,   120,    -1,
     122,    -1,   124,    -1,   126,    -1,   128,   129,   130,    -1,
       1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     275,   276,   277,   278,   279,    -1,    -1,    -1,    -1,   284,
      -1,    -1,    -1,    -1,    -1,   157,    -1,    -1,   160,    -1,
      -1,    -1,    -1,   298,   299,    -1,    -1,   161,   162,   163,
     164,   165,   166,   167,   168,   169,    -1,   179,   172,   173,
     174,   175,   176,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    65,    -1,    -1,    68,    69,    70,
      -1,    72,    -1,    74,    75,    -1,    77,    78,    79,    -1,
      81,    82,    -1,    84,    -1,    86,    87,    88,    89,    90,
      -1,    92,    -1,    94,    -1,    96,    97,    98,    -1,   100,
      -1,   102,    -1,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,    -1,   115,   116,    -1,   118,    -1,   120,
      -1,   122,    -1,   124,    -1,   126,    -1,   128,   129,   130,
     131,    -1,    -1,   134,    -1,    -1,    -1,   138,    -1,   140,
     141,    -1,    -1,    -1,   145,   146,   147,    -1,   149,   150,
     151,    -1,   153,   154,   155,    -1,    -1,   289,   290,   291,
     292,   293,    -1,    -1,   296,    -1,   298,   299,    -1,   301,
     294,    -1,    -1,   305,   306,   307,   308,   178,    -1,   180,
     181,   182,   183,   184,   185,   186,   187,   188,   189,    -1,
      -1,   192,   193,    -1,   195,    -1,   197,    -1,    -1,   200,
      -1,   202,    -1,    -1,   205,    -1,    -1,   208,    -1,   210,
     211,     1,   213,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   229,   230,
     231,   232,    -1,   234,   235,    -1,   237,    -1,    -1,   240,
      -1,    -1,    -1,   244,    -1,    -1,   247,    -1,    -1,   250,
      -1,   252,    -1,    -1,    -1,    -1,    -1,    -1,   259,   260,
      -1,   262,   263,   264,    -1,    -1,   267,    -1,    -1,    -1,
       1,   272,   273,   274,   275,   276,   277,   278,   279,   280,
      70,    -1,    72,   284,    15,    -1,    17,    -1,    78,    -1,
      -1,    81,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    30,
     301,   302,   303,   304,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    42,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    52,    -1,    -1,    -1,    -1,    -1,    -1,    59,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   131,    -1,    -1,   134,    -1,    -1,    -1,   138,    -1,
     140,   141,    -1,    -1,    -1,   145,   146,   147,    -1,   149,
     150,   151,    -1,   153,   154,   155,    -1,    -1,    -1,    -1,
      -1,    70,    -1,    -1,    -1,    -1,    -1,    -1,    77,    78,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   177,   178,    -1,
     180,   181,   182,   183,   184,   185,   186,   187,   188,   189,
     190,    -1,   192,   193,    -1,   195,    -1,   197,    -1,   108,
     200,    -1,   202,   203,   204,    -1,   206,   207,   208,    -1,
     210,   211,   153,    -1,   214,   215,    -1,    -1,   159,   219,
     220,   221,    -1,    -1,    -1,    -1,    -1,   227,   228,   229,
     230,   231,   232,    -1,   234,   235,    -1,   237,   238,    -1,
     240,    -1,    -1,    -1,   244,    -1,    -1,   247,    -1,    -1,
     250,    -1,   252,    -1,    -1,    -1,    -1,    -1,     1,   259,
     260,    -1,   262,   263,    -1,    -1,    -1,   267,    -1,    -1,
      -1,    14,   272,   273,   274,   275,   276,   277,   278,   279,
     280,    -1,    -1,     1,   284,    -1,     4,   228,    -1,    -1,
      -1,     9,    -1,    -1,    -1,    -1,    -1,    -1,    16,   299,
      18,    19,   302,   303,   304,   214,   215,    25,    -1,    -1,
      -1,    29,    -1,    -1,    -1,    -1,    34,    35,    -1,    -1,
      63,    -1,    -1,    -1,    -1,    43,    44,    45,    71,    -1,
      -1,    49,    -1,    -1,    -1,    53,    54,    -1,    56,    -1,
      -1,    59,    60,    61,    62,    -1,    -1,    -1,    -1,   290,
      -1,    -1,    -1,   294,    -1,    -1,   297,    -1,   299,    -1,
      -1,   302,   303,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   282,   283,    -1,   285,   286,   287,   288,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   130,    -1,    -1,
     299,    -1,    -1,   302,   303,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   146,   147,    -1,   149,    -1,    -1,    -1,
      -1,    -1,   155,   131,    -1,    -1,   134,    -1,   136,    -1,
     138,    -1,   140,   141,    -1,    -1,    -1,   145,   146,   147,
      -1,   149,   150,   151,    -1,   153,   154,   155,   181,    -1,
      -1,    -1,    -1,   186,   187,    70,    -1,   190,    -1,    -1,
      -1,    -1,    77,    78,    -1,    -1,    -1,    -1,    -1,    -1,
     178,   179,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,    -1,    -1,   192,    -1,    -1,   195,    -1,   197,
     198,    -1,   200,   108,   202,    -1,    -1,   205,    -1,    -1,
     208,    -1,   210,   211,    -1,   238,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   222,   223,    -1,    -1,    -1,    -1,
      -1,   229,   230,   231,   232,   233,    -1,    -1,   236,    -1,
      -1,    -1,   240,   241,    -1,   243,   244,    -1,    -1,   247,
     248,   274,   250,    -1,   252,   253,    -1,   255,   256,    -1,
     258,   259,   260,    -1,   262,   263,    -1,   290,    -1,   267,
     268,   294,    -1,    -1,   272,   273,   274,   275,   276,   277,
      -1,   279,   280,   281,   282,   283,    -1,   285,   286,   287,
     288,     1,    -1,    -1,     4,    -1,    -1,    -1,    -1,     9,
     298,   299,    -1,    -1,   302,   303,    16,    -1,    18,    19,
     215,    -1,    -1,    -1,    -1,    25,    -1,    -1,    -1,    29,
      -1,    -1,    -1,    -1,    34,    35,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    43,    44,    45,    -1,    -1,    -1,    49,
      -1,    -1,    -1,    53,    54,    -1,    56,    -1,    -1,    59,
      60,    61,    62,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   282,   283,    -1,
     285,   286,   287,   288,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   299,    -1,    -1,   302,   303,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   131,    -1,    -1,   134,    -1,   136,    -1,   138,    -1,
     140,   141,    -1,    -1,    -1,   145,   146,   147,    -1,   149,
     150,   151,    -1,   153,   154,   155,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   178,   179,
     180,   181,   182,   183,   184,   185,   186,   187,   188,   189,
      -1,    -1,   192,    -1,    -1,   195,    -1,   197,   198,    -1,
     200,    -1,   202,    -1,    -1,   205,    -1,    -1,   208,    -1,
     210,   211,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   222,   223,    -1,    -1,    -1,    -1,    -1,   229,
     230,   231,   232,   233,    -1,    -1,   236,    -1,    -1,    -1,
     240,   241,    -1,   243,   244,    -1,    -1,   247,   248,    -1,
     250,    -1,   252,   253,    -1,   255,   256,    -1,   258,   259,
     260,    -1,   262,   263,    -1,    -1,    -1,   267,   268,    -1,
      -1,    -1,   272,   273,   274,   275,   276,   277,    -1,   279,
     280,   281,   282,   283,    -1,   285,   286,   287,   288,     1,
      -1,    -1,     4,    -1,    -1,    -1,    -1,     9,    -1,   299,
      -1,    -1,   302,   303,    16,    -1,    18,    19,    -1,    -1,
      -1,    -1,    -1,    25,    -1,    -1,    -1,    29,    -1,    -1,
      -1,    -1,    34,    35,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    43,    44,    45,    -1,    -1,    -1,    49,    -1,    -1,
      -1,    53,    54,    -1,    56,    -1,    -1,    59,    60,    61,
      62,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   131,
      -1,    -1,   134,    -1,   136,    -1,   138,    -1,   140,   141,
      -1,    -1,    -1,   145,   146,   147,    -1,   149,   150,   151,
      -1,   153,   154,   155,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   178,   179,   180,   181,
     182,   183,   184,   185,   186,   187,   188,   189,    -1,    -1,
     192,    -1,    -1,   195,    -1,   197,   198,    -1,   200,    -1,
     202,    -1,    -1,   205,    -1,    -1,   208,    -1,   210,   211,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     222,   223,    -1,    -1,    -1,    -1,    -1,   229,   230,   231,
     232,   233,    -1,    -1,   236,    -1,    -1,    -1,   240,   241,
      -1,   243,   244,    -1,    -1,   247,   248,    -1,   250,    -1,
     252,   253,    -1,   255,   256,    -1,   258,   259,   260,    -1,
     262,   263,    -1,    -1,    -1,   267,   268,    -1,    -1,    -1,
     272,   273,   274,   275,   276,   277,    -1,   279,   280,   281,
     282,   283,    -1,   285,   286,   287,   288,     1,    -1,    -1,
       4,    -1,    -1,    -1,    -1,     9,    -1,   299,    -1,    -1,
     302,   303,    16,    -1,    18,    19,    -1,    -1,    -1,    -1,
      -1,    25,    -1,    -1,    -1,    29,    -1,    -1,    -1,    -1,
      34,    35,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    43,
      44,    45,    -1,    -1,    -1,    49,    -1,    -1,    -1,    53,
      54,    -1,    56,    -1,    -1,    59,    60,    61,    62,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   131,    -1,    -1,
     134,    -1,   136,    -1,   138,    -1,   140,   141,    -1,    -1,
      -1,   145,   146,   147,    -1,   149,   150,   151,    -1,   153,
     154,   155,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   178,   179,   180,   181,   182,   183,
     184,   185,   186,   187,   188,   189,    -1,    -1,   192,    -1,
      -1,   195,    -1,   197,   198,    -1,   200,    -1,   202,    -1,
      -1,   205,    -1,    -1,   208,    -1,   210,   211,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   222,   223,
      -1,    -1,    -1,    -1,    -1,   229,   230,   231,   232,   233,
      -1,    -1,   236,    -1,    -1,    -1,   240,   241,    -1,   243,
     244,    -1,    -1,   247,   248,    -1,   250,    -1,   252,   253,
      -1,   255,   256,    -1,   258,   259,   260,     1,   262,   263,
       4,    -1,    -1,   267,   268,     9,    -1,    -1,   272,   273,
     274,   275,   276,   277,    -1,   279,   280,   281,   282,   283,
      -1,   285,   286,   287,   288,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    38,   299,    -1,    -1,   302,   303,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    53,
      -1,    -1,    -1,    -1,    -1,    59,    60,    -1,    -1,    -1,
      -1,    65,    -1,    -1,    68,    69,    70,    -1,    72,    -1,
      74,    75,    -1,    77,    78,    79,    -1,    81,    82,    -1,
      84,    -1,    86,    87,    88,    89,    90,    -1,    92,    -1,
      94,    -1,    96,    97,    98,    -1,   100,    -1,   102,    -1,
     104,    -1,   106,   107,   108,   109,   110,    -1,   112,   113,
      -1,   115,   116,    -1,   118,    -1,   120,    -1,   122,    -1,
     124,    -1,   126,    -1,   128,   129,   130,    -1,    -1,    -1,
      -1,    -1,     1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   150,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   178,    -1,    -1,    -1,    -1,   183,
      -1,    -1,    -1,    -1,   188,    -1,    -1,    -1,    -1,    -1,
      -1,   195,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   205,    71,    -1,   208,    -1,   210,   211,    -1,   213,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   223,
      -1,    -1,    -1,    -1,    -1,   229,    -1,    -1,    -1,   233,
      -1,    -1,   236,    -1,    -1,    -1,    -1,   241,    -1,   243,
     244,    -1,    -1,   247,   248,    -1,   250,    -1,    -1,   253,
      -1,   255,   256,    -1,   258,   259,    -1,    -1,   262,   263,
     264,    -1,   131,   267,   268,   134,    -1,    -1,    -1,   138,
      -1,   140,   141,    -1,    -1,    -1,   145,   146,   147,    -1,
     149,   150,   151,    -1,   153,   154,   155,    -1,    -1,    -1,
      -1,    -1,     1,    -1,    -1,   299,    -1,    -1,   302,   303,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   178,
     179,   180,   181,   182,   183,   184,   185,   186,   187,   188,
     189,    -1,    -1,   192,   193,    -1,   195,    -1,   197,    -1,
      -1,   200,    -1,   202,    -1,    -1,    -1,    -1,    -1,   208,
      -1,   210,   211,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   222,    -1,    -1,    -1,    -1,    -1,    -1,
     229,   230,   231,   232,    -1,   234,   235,    -1,   237,    -1,
      -1,   240,    -1,    -1,    -1,   244,    -1,    -1,   247,    -1,
      -1,   250,    -1,   252,    -1,    -1,    -1,    -1,    -1,    -1,
     259,   260,    -1,   262,   263,    -1,    -1,    -1,   267,    -1,
      -1,    -1,    -1,   272,   273,   274,   275,   276,   277,   278,
     279,   280,    -1,    -1,    -1,   284,    -1,    -1,    -1,    -1,
      -1,    -1,   131,    -1,    -1,   134,    -1,    -1,    -1,   138,
     299,   140,   141,   302,   303,    -1,   145,   146,   147,    -1,
     149,   150,   151,    -1,   153,   154,   155,    -1,    -1,    -1,
      -1,    -1,     1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   178,
     179,   180,   181,   182,   183,   184,   185,   186,   187,   188,
     189,    -1,    -1,   192,   193,    -1,   195,    -1,   197,    -1,
      -1,   200,    -1,   202,    -1,    -1,    -1,    -1,    -1,   208,
      -1,   210,   211,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   222,    -1,    -1,    -1,    -1,    -1,    -1,
     229,   230,   231,   232,    -1,   234,   235,    -1,   237,    -1,
      -1,   240,    -1,    -1,    -1,   244,    -1,    -1,   247,    -1,
      -1,   250,    -1,   252,    -1,    -1,    -1,    -1,    -1,    -1,
     259,   260,    -1,   262,   263,    -1,    -1,    -1,   267,    -1,
      -1,    -1,    -1,   272,   273,   274,   275,   276,   277,   278,
     279,   280,    -1,    -1,    -1,   284,    -1,    -1,    -1,    -1,
      -1,    -1,   131,    -1,    -1,   134,    -1,    -1,    -1,   138,
     299,   140,   141,   302,   303,    -1,   145,   146,   147,    -1,
     149,   150,   151,    -1,   153,   154,   155,    -1,    -1,    -1,
      -1,    -1,     1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   178,
     179,   180,   181,   182,   183,   184,   185,   186,   187,   188,
     189,    -1,    -1,   192,   193,    -1,   195,    -1,   197,    -1,
      -1,   200,    -1,   202,    -1,    -1,    -1,    -1,    -1,   208,
      -1,   210,   211,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   222,    -1,    -1,    -1,    -1,    -1,    -1,
     229,   230,   231,   232,    -1,   234,   235,    -1,   237,    -1,
      -1,   240,    -1,    -1,    -1,   244,    -1,    -1,   247,    -1,
      -1,   250,    -1,   252,    -1,    -1,    -1,    -1,    -1,    -1,
     259,   260,    -1,   262,   263,    -1,    -1,    -1,   267,    -1,
      -1,    -1,    -1,   272,   273,   274,   275,   276,   277,   278,
     279,   280,    -1,    -1,    -1,   284,    -1,    -1,    -1,    -1,
      -1,    -1,   131,    -1,    -1,   134,    -1,    -1,    -1,   138,
     299,   140,   141,   302,   303,    -1,   145,   146,   147,    -1,
     149,   150,   151,    -1,   153,   154,   155,    -1,    -1,    -1,
      -1,     1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   178,
      -1,   180,   181,   182,   183,   184,   185,   186,   187,   188,
     189,    -1,    -1,   192,   193,    -1,   195,    -1,   197,    -1,
      -1,   200,    -1,   202,    -1,    -1,    -1,    -1,    -1,   208,
      -1,   210,   211,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     229,   230,   231,   232,    -1,   234,   235,    -1,   237,    -1,
      -1,   240,    -1,    -1,    -1,   244,    -1,    -1,   247,    -1,
      -1,   250,    -1,   252,    -1,    -1,    -1,    -1,    -1,    -1,
     259,   260,    -1,   262,   263,    -1,    -1,    -1,   267,    -1,
      -1,    -1,    -1,   272,   273,   274,   275,   276,   277,   278,
     279,   280,     1,    -1,    -1,   284,    18,    19,    -1,    -1,
      -1,   131,    -1,    -1,   134,    -1,    -1,    -1,   138,   298,
     140,   141,    34,   302,   303,   145,   146,   147,    -1,   149,
     150,   151,    -1,   153,   154,   155,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      62,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   178,    -1,
     180,   181,   182,   183,   184,   185,   186,   187,   188,   189,
      -1,    -1,   192,   193,    73,   195,    -1,   197,    -1,    78,
     200,    -1,   202,    -1,    -1,    -1,    -1,    -1,   208,    -1,
     210,   211,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   229,
     230,   231,   232,    -1,   234,   235,    -1,   237,    -1,    -1,
     240,    -1,   134,    -1,   244,     1,   138,   247,    -1,   141,
     250,    -1,   252,   145,    -1,    -1,     4,    -1,    14,   259,
     260,     9,   262,   263,    -1,    -1,    -1,   267,    -1,    -1,
      -1,   150,   272,   273,   274,   275,   276,   277,   278,   279,
     280,    -1,    -1,    -1,   284,    -1,    -1,    -1,    -1,    -1,
     182,    -1,   184,   185,    -1,    -1,    44,    -1,    -1,   178,
      -1,    -1,   302,   303,   183,    53,    -1,    63,   200,    -1,
     189,    59,    60,   192,    -1,    71,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    71,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   230,   231,
     232,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   240,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   260,    -1,
      -1,    -1,    -1,    -1,   130,    -1,    -1,    -1,    -1,    -1,
     272,   273,    -1,   131,    -1,    -1,    -1,    -1,   136,    -1,
     146,    -1,   140,   149,    -1,    -1,   275,   276,   277,   155,
     279,    -1,   150,     4,    -1,   153,    -1,   299,     9,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   298,
     299,    -1,    -1,    -1,    -1,   181,    -1,    -1,    -1,    -1,
     178,   179,    -1,    -1,   190,   183,    -1,    -1,    -1,    -1,
     188,   189,    -1,    44,   192,    -1,    -1,   195,    -1,   197,
     198,    -1,    53,    -1,    -1,    -1,    -1,   205,    59,    60,
     208,    -1,   210,   211,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   222,   223,    -1,    -1,    -1,    -1,
      -1,   229,   238,    -1,    -1,   233,    -1,    -1,   236,    -1,
      -1,    -1,    -1,   241,    -1,   243,   244,    -1,    -1,   247,
     248,    -1,   250,    -1,   252,   253,    -1,   255,   256,    -1,
     258,   259,    -1,    -1,   262,   263,    -1,    -1,    -1,   267,
     268,    -1,    -1,    -1,    -1,    -1,    -1,   275,   276,   277,
     131,   279,   280,    -1,   290,   136,    -1,    -1,   294,   140,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   150,
      -1,   299,   153,    -1,    -1,    -1,    -1,    18,    19,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    34,    -1,    -1,    -1,   178,   179,    -1,
      -1,    -1,   183,    -1,    -1,    -1,    -1,   188,   189,    -1,
      -1,   192,    -1,    -1,   195,    -1,   197,   198,    -1,    -1,
      -1,    62,    -1,    -1,   205,    -1,    -1,   208,    -1,   210,
     211,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   222,   223,    -1,    -1,    -1,    -1,    -1,   229,    -1,
      -1,    -1,   233,    -1,    -1,   236,    -1,    -1,    -1,    -1,
     241,    -1,   243,   244,    -1,     4,   247,   248,    -1,   250,
       9,   252,   253,    -1,   255,   256,    -1,   258,   259,    -1,
      -1,   262,   263,    -1,    -1,    -1,   267,   268,    -1,    -1,
      -1,    -1,    -1,   134,   275,   276,   277,   138,   279,   280,
     141,    -1,    -1,    -1,   145,    44,    -1,    -1,    -1,    -1,
     151,    -1,    -1,   154,    53,    -1,    -1,    -1,   299,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   180,
      -1,   182,    -1,   184,   185,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   200,
      -1,   202,    -1,    -1,    -1,    -1,     4,    -1,    -1,    -1,
      -1,     9,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   230,
     231,   232,   131,    -1,    -1,    -1,    -1,   136,    -1,   240,
      38,   140,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   150,    -1,    -1,   153,    53,    -1,    -1,    -1,   260,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   272,   273,    -1,    -1,    -1,    -1,    -1,    -1,   178,
      -1,    -1,    -1,    -1,   183,    -1,    -1,    -1,    -1,   188,
     189,    -1,    -1,   192,    -1,    -1,   195,    -1,   197,   198,
      -1,   302,   303,    -1,    -1,    -1,   205,    -1,    -1,   208,
      -1,   210,   211,    -1,    -1,    -1,     4,    -1,    -1,    -1,
      -1,     9,    -1,   222,   223,    -1,    -1,    -1,    -1,    -1,
     229,    -1,    -1,    -1,   233,    -1,    -1,   236,    -1,    -1,
      -1,    -1,   241,    -1,   243,   244,    -1,    -1,   247,   248,
      -1,   250,   150,   252,   253,    -1,   255,   256,    -1,   258,
     259,    -1,    -1,   262,   263,    53,    16,    -1,   267,   268,
      -1,    -1,    -1,    -1,    -1,    25,   275,   276,   277,    29,
     279,   280,    -1,    -1,    -1,    35,    -1,    75,    -1,    -1,
     188,    -1,    -1,    43,    -1,    45,    -1,   195,    -1,    49,
      -1,    -1,    -1,    -1,    54,    -1,    56,    -1,    -1,    -1,
     208,    61,   210,   211,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   223,    -1,    -1,    -1,    -1,
      -1,   229,    -1,    -1,    -1,   233,    -1,    -1,   236,    -1,
      -1,    -1,    -1,   241,    -1,   243,   244,    -1,    -1,   247,
     248,    -1,   250,    -1,    -1,   253,    -1,   255,   256,    -1,
     258,   259,   150,    -1,   262,   263,    -1,    -1,    -1,   267,
     268,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   146,   147,    -1,   149,
     188,    -1,    -1,    -1,    -1,   155,    -1,   195,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     208,    -1,   210,   211,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   181,    -1,    -1,    -1,   223,   186,   187,    -1,    -1,
      -1,   229,    -1,    -1,    -1,   233,    -1,    -1,   236,    -1,
      -1,    -1,    -1,   241,    -1,   243,   244,    -1,    -1,   247,
     248,    -1,   250,    -1,    -1,   253,    -1,   255,   256,    -1,
     258,   259,    -1,    -1,   262,   263,    -1,    -1,    -1,   267,
     268,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   274,    -1,    -1,    -1,    -1,    -1,
      -1,   281,   282,   283,    -1,   285,   286,   287,   288,    65,
      -1,    -1,    68,    69,    70,    71,    72,    73,    74,    75,
      -1,    77,    78,    79,    -1,    81,    82,    -1,    84,    -1,
      86,    87,    88,    89,    90,    -1,    92,    -1,    94,    -1,
      96,    97,    98,    -1,   100,    -1,   102,    -1,   104,    -1,
     106,   107,   108,   109,    -1,    -1,   112,   113,    -1,   115,
     116,    -1,   118,    -1,   120,    -1,   122,    -1,   124,    -1,
     126,    -1,   128,   129,   130,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   157,   158,    -1,   160,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   170,   171,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   179,    65,    -1,    -1,    68,    69,    70,
      71,    72,    73,    74,    75,    -1,    77,    78,    79,    -1,
      81,    82,    -1,    84,    -1,    86,    87,    88,    89,    90,
      -1,    92,    -1,    94,    -1,    96,    97,    98,    -1,   100,
      -1,   102,    -1,   104,    -1,   106,   107,   108,   109,    -1,
      -1,   112,   113,    -1,   115,   116,    -1,   118,    -1,   120,
      -1,   122,    -1,   124,    -1,   126,    -1,   128,   129,   130,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   157,    -1,    -1,   160,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   289,   290,   291,   292,   293,   179,    -1,
     296,    -1,   298,   299,    -1,   301,    -1,    -1,    -1,   305,
     306,   307,   308,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    -1,    68,    69,    70,    71,    72,    73,
      74,    75,    -1,    77,    78,    79,    -1,    81,    82,    -1,
      84,    -1,    86,    87,    88,    89,    90,    -1,    92,    -1,
      94,    -1,    96,    97,    98,    -1,   100,    -1,   102,    -1,
     104,    -1,   106,   107,   108,   109,    -1,    -1,   112,   113,
      -1,   115,   116,    -1,   118,    -1,   120,    -1,   122,    -1,
     124,    -1,   126,    -1,   128,   129,   130,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   289,   290,
     291,   292,   293,   157,    -1,   296,   160,   298,   299,    -1,
     301,    -1,    -1,    -1,   305,   306,   307,   308,    -1,    65,
      -1,    -1,    68,    69,    70,   179,    72,    73,    74,    75,
      -1,    77,    78,    79,    -1,    81,    82,    -1,    84,    -1,
      86,    87,    88,    89,    90,    -1,    92,    -1,    94,    -1,
      96,    97,    98,    -1,   100,    -1,   102,    -1,   104,    -1,
     106,   107,   108,   109,    -1,    -1,   112,   113,    -1,   115,
     116,    -1,   118,    -1,   120,    -1,   122,    -1,   124,    -1,
     126,    -1,   128,   129,   130,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   157,    -1,    -1,   160,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   179,    -1,   289,   290,   291,   292,   293,
      -1,    -1,   296,    -1,   298,   299,    -1,   301,    -1,    -1,
      -1,   305,   306,   307,   308,    -1,    65,    -1,    -1,    68,
      69,    70,    -1,    72,    73,    74,    75,    -1,    77,    78,
      79,    -1,    81,    82,    -1,    84,    -1,    86,    87,    88,
      89,    90,    -1,    92,    -1,    94,    -1,    96,    97,    98,
      -1,   100,    -1,   102,    -1,   104,    -1,   106,   107,   108,
     109,    -1,    -1,   112,   113,    -1,   115,   116,    -1,   118,
      -1,   120,    -1,   122,    -1,   124,    -1,   126,    -1,   128,
     129,   130,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   289,   290,   291,   292,   293,   157,    -1,
     296,   160,   298,   299,    -1,   301,    -1,    -1,    -1,   305,
     306,   307,   308,    -1,    65,    -1,    -1,    68,    69,    70,
     179,    72,    73,    74,    75,    -1,    77,    78,    79,    -1,
      81,    82,    -1,    84,    -1,    86,    87,    88,    89,    90,
      -1,    92,    -1,    94,    -1,    96,    97,    98,    -1,   100,
      -1,   102,    -1,   104,    -1,   106,   107,   108,   109,    -1,
      -1,   112,   113,    -1,   115,   116,    -1,   118,    -1,   120,
      -1,   122,    -1,   124,    -1,   126,    -1,   128,   129,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   157,    -1,    -1,   160,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   179,    -1,
     289,   290,   291,   292,   293,    -1,    -1,   296,    -1,   298,
     299,    -1,   301,    -1,    -1,    -1,   305,   306,   307,   308,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   131,    -1,    -1,   134,    -1,    -1,    -1,   138,    -1,
     140,   141,    -1,    -1,    -1,   145,   146,   147,    -1,   149,
     150,   151,    -1,   153,   154,   155,    -1,    -1,   289,   290,
     291,   292,   293,    -1,    -1,   296,    -1,   298,   299,    -1,
     301,    -1,    -1,    -1,   305,   306,   307,   308,   178,    -1,
     180,   181,   182,   183,   184,   185,   186,   187,   188,   189,
      -1,    -1,   192,   193,    -1,   195,    -1,   197,    -1,    -1,
     200,    -1,   202,    -1,    -1,    -1,    -1,    -1,   208,    -1,
     210,   211,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   229,
     230,   231,   232,    -1,   234,   235,    -1,   237,    -1,    -1,
     240,    -1,    -1,    -1,   244,    -1,    -1,   247,    -1,    -1,
     250,    -1,   252,    -1,    -1,    -1,    -1,    -1,    -1,   259,
     260,    -1,   262,   263,    -1,    -1,    -1,   267,    -1,    -1,
      -1,    -1,   272,   273,   274,   275,   276,   277,   278,   279,
     280,    -1,    -1,    -1,   284,    -1,    -1,    -1,    -1,    -1,
     131,    -1,    -1,   134,    -1,    -1,    -1,   138,    -1,   140,
     141,    -1,   302,   303,   145,   146,   147,    -1,   149,   150,
     151,    -1,   153,   154,   155,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   178,    -1,   180,
     181,   182,   183,   184,   185,   186,   187,   188,   189,    -1,
      -1,   192,   193,    -1,   195,    -1,   197,    -1,    -1,   200,
      -1,   202,    -1,    -1,    -1,    -1,    -1,   208,    -1,   210,
     211,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   229,   230,
     231,   232,    -1,   234,   235,    -1,   237,    -1,    -1,   240,
      -1,    -1,    -1,   244,    -1,    -1,   247,    -1,    -1,   250,
      -1,   252,    -1,    -1,    -1,    -1,    -1,    -1,   259,   260,
      -1,   262,   263,    -1,    -1,    -1,   267,    -1,    -1,    -1,
      -1,   272,   273,   274,   275,   276,   277,   278,   279,   280,
      -1,    -1,   134,   284,    -1,    -1,   138,    -1,    -1,   141,
      -1,    -1,    -1,   145,   146,    -1,    -1,   149,    -1,    -1,
      -1,   302,   303,   155,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   181,
     182,    -1,   184,   185,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   131,    -1,   200,    -1,
      -1,    -1,    -1,    -1,    -1,   140,    -1,    -1,    -1,    -1,
      -1,   146,   147,    -1,   149,   150,    -1,    -1,   153,    -1,
     155,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   230,   231,
     232,    -1,   234,   235,    -1,    -1,    -1,    -1,   240,    -1,
      -1,    -1,    -1,   178,    -1,    -1,   181,    -1,   183,    -1,
      -1,   186,   187,   188,   189,    -1,    -1,   192,   260,    -1,
     195,    -1,   197,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     272,   273,    -1,   208,    -1,   210,   211,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   229,    -1,    -1,    -1,    -1,    -1,
     302,   303,   237,    -1,    -1,    -1,    -1,    -1,    -1,   244,
      -1,    -1,   247,    -1,    -1,   250,    -1,   252,    -1,    -1,
      -1,    -1,    -1,    -1,   259,    -1,    -1,   262,   263,    -1,
      -1,    -1,   267,    -1,    -1,    -1,    -1,    -1,    -1,   274,
     275,   276,   277,   278,   279,   280,    -1,    -1,    -1,   284
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_int16 yystos[] =
{
       0,   310,     0,     1,     3,     5,     6,     7,     8,    10,
      11,    12,    13,    32,   150,   151,   153,   154,   157,   178,
     180,   188,   202,   203,   207,   212,   219,   220,   221,   228,
     290,   294,   308,   311,   312,   313,   314,   329,   330,   349,
     351,   352,   355,   365,   366,   367,   371,   377,   378,   379,
     384,   392,   393,   396,   398,   415,   418,   425,   426,   522,
     530,   531,   677,   696,   299,   302,   303,   622,   625,   633,
     638,   641,   643,     1,    65,    68,    69,    70,    72,    74,
      75,    77,    78,    79,    81,    82,    84,    86,    87,    88,
      89,    90,    92,    94,    96,    97,    98,   100,   102,   104,
     106,   107,   108,   109,   110,   112,   113,   115,   116,   118,
     120,   122,   124,   126,   128,   129,   130,   205,   213,   264,
     326,   638,   642,   657,     1,   638,   640,     1,     3,   651,
     651,   300,   368,   369,     1,    15,    52,    59,   159,   299,
     375,   625,     1,   299,   651,   227,   704,     1,   161,   162,
     163,   164,   165,   166,   167,   168,   169,   172,   173,   174,
     175,   176,   356,   364,   651,   529,   530,     1,   212,   676,
     427,   353,   696,   640,   696,   696,   696,   696,     1,    70,
      72,    78,   131,   134,   138,   140,   141,   145,   146,   147,
     149,   150,   153,   155,   177,   178,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   192,   193,   195,   197,
     200,   208,   210,   211,   215,   227,   229,   230,   231,   232,
     234,   235,   237,   238,   240,   244,   247,   250,   252,   259,
     260,   262,   263,   267,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   284,   299,   380,   382,   384,   385,   388,
     390,   391,   408,   415,   416,   424,   440,   441,   442,   444,
     468,   469,   471,   479,   505,   507,   508,   509,   510,   511,
     512,   514,   515,   516,   518,   519,   520,   521,   522,   531,
     534,   535,   537,   539,   540,   542,   550,   552,   553,   562,
     563,   625,   630,   631,   633,   664,   665,   669,   711,   696,
     294,   696,   696,   696,   696,   696,   696,   397,   394,   399,
      46,   679,   680,   681,    65,     1,    17,    37,    58,   647,
      65,     1,    71,   691,     1,    73,   687,    72,    72,     4,
       9,    38,    53,   150,   188,   195,   208,   210,   211,   223,
     229,   233,   236,   241,   243,   244,   247,   248,   250,   253,
     255,   256,   258,   259,   262,   263,   267,   268,   327,   328,
     536,   590,     1,    17,   130,   646,   315,   646,   112,   370,
     369,    52,    59,   376,    42,   297,   666,   667,    17,    30,
     153,   228,   372,   374,    65,    68,    69,    70,    71,    72,
      73,    74,    75,    77,    78,    79,    81,    82,    84,    86,
      87,    88,    89,    90,    92,    94,    96,    97,    98,   100,
     102,   104,   106,   107,   108,   109,   112,   113,   115,   116,
     118,   120,   122,   124,   126,   128,   129,   130,   157,   160,
     179,   289,   290,   291,   292,   293,   296,   298,   299,   301,
     305,   306,   307,   308,   331,   332,   341,   342,   343,   344,
     348,   419,     1,   299,   627,   627,     1,   299,   302,   620,
     621,     1,   157,   299,   354,   628,   647,   188,   229,   468,
     505,   664,    77,    78,   112,   222,   299,   409,   410,   411,
     532,   533,   534,   550,   301,   304,   593,   698,     1,    70,
     673,   673,    65,   350,   673,    72,    72,   538,   554,   564,
      70,     1,    96,   674,   386,   673,   130,   470,   417,   508,
     510,   506,   507,   673,   536,   541,   542,   541,   553,   563,
      65,   632,   214,   426,   204,   206,   304,   661,    81,     1,
     622,   623,   623,     1,   299,   401,   402,   403,   625,     1,
      57,   531,   677,   692,   693,   679,   299,   625,     4,     9,
      44,    53,    59,    60,   131,   136,   140,   150,   153,   179,
     188,   192,   197,   198,   205,   208,   210,   211,   222,   223,
     229,   244,   247,   248,   250,   252,   262,   263,   267,   275,
     276,   277,   280,   299,   535,   537,   567,   586,   587,   588,
     589,   590,   591,   595,   601,   602,   633,   639,   709,   625,
     633,   687,   687,    31,    33,    36,   592,   148,   246,   254,
     270,    23,    72,   319,     1,   229,   710,     1,   242,   660,
       1,   257,   708,   535,   709,   640,   316,   567,   681,   567,
       1,   300,    17,   374,     1,   372,   373,     1,    70,   130,
     336,   337,   338,   339,   340,   341,    70,   332,   333,   334,
     335,   505,    70,   357,   541,     1,   299,   299,   567,   691,
     381,   299,     1,   222,   700,    73,     1,   130,   655,   534,
     549,   550,   534,   291,     1,   698,   699,   505,   416,     1,
     298,   705,   706,   543,     1,    73,    78,   705,   673,   673,
     445,   505,   704,     1,   505,   705,    70,    77,    78,   108,
     282,   283,   285,   286,   287,   288,   430,   431,   433,   435,
     436,   438,   443,   462,   464,   465,   467,   472,   474,   475,
     477,   478,   479,   481,   577,   622,   625,   630,   631,   633,
     634,   433,   429,   430,     1,   505,   622,   623,   624,   623,
     624,   622,   505,   673,   673,   621,   289,   523,   395,   400,
      65,    65,   623,   592,   246,   710,     1,    28,   659,   593,
       1,   199,   672,    78,   596,   705,   681,    16,    25,    29,
      49,    54,    56,    61,   281,   509,   568,   571,   572,   573,
     575,   576,   577,   583,   597,   598,   599,   600,   603,   604,
     605,   606,   589,    17,     1,    41,   671,     1,   271,   644,
       1,    70,    72,   320,    27,    54,   321,   322,   323,   411,
      70,   578,   579,     1,    26,   656,    14,    63,   190,   238,
     317,   318,   325,   646,   373,    70,   345,   346,   347,   348,
      71,   130,   338,   337,   340,   335,   420,     1,   179,   299,
     358,   359,   360,    70,    71,   130,   158,   170,   171,   341,
     361,   362,   363,     1,   112,   663,    70,   467,   474,   477,
     482,   483,   484,   485,   486,   488,   489,   491,   493,   495,
     634,    70,   412,   411,   549,   691,   513,   691,   228,   544,
      73,   687,   687,   673,     1,   299,   557,   565,   566,   179,
     222,   299,   457,   458,   459,   626,   701,   383,   387,    71,
     389,   691,   106,   463,   532,   532,   532,   130,    70,    72,
     437,   466,   473,   476,   434,   435,   443,   465,   633,    67,
     214,   289,   635,   635,   551,   552,   517,   523,   291,   291,
     480,   457,    71,   446,   673,     1,   146,   149,   155,   181,
     514,   516,   524,   526,   527,   528,   631,   291,   405,   406,
       1,   404,   406,   188,   299,   625,   188,   625,   633,    40,
     594,    78,   299,   569,   705,   578,    70,   574,     1,    58,
     702,     1,    54,   688,    39,   570,   578,    43,    45,   675,
     702,    18,    19,    34,    62,   134,   138,   141,   145,   182,
     184,   185,   200,   230,   231,   232,   240,   260,   272,   273,
     522,   531,   607,   608,   609,   610,   611,   613,   614,   631,
     606,   567,   673,   321,   321,    21,   136,   324,    58,   324,
      73,   655,   567,   580,   581,    55,   148,   584,   585,   689,
     214,   683,    17,    58,   648,   706,     1,   567,   705,   587,
     345,    71,   347,   333,   337,   339,   421,   422,   433,    71,
     655,   363,   505,   106,   490,   492,   494,   496,   437,   691,
      70,   457,   326,   482,   627,     1,   233,   236,   243,   253,
     255,   258,   259,   268,   545,   546,   547,   633,   555,   556,
     557,    70,   558,    71,   557,    71,   655,   505,   482,   416,
     482,   439,   433,     1,   431,   432,   457,     1,   150,   299,
     532,   533,   687,   705,   551,   433,   433,   433,    78,   657,
     662,   699,   706,   482,   467,   474,   477,   497,   498,   499,
     501,   503,   634,   446,   447,   223,   248,   451,   446,   527,
     528,   525,   526,     1,   292,   392,   407,   418,   425,   627,
     627,     1,    46,   678,   691,     1,    43,   567,     1,    16,
     645,   584,    35,   567,    50,   612,     1,   145,   670,     1,
      48,   684,     1,   134,   652,   705,   707,    51,   685,   623,
     623,     1,    63,    70,   705,   580,    71,    73,     1,   136,
     658,   627,   323,    71,   655,     1,   567,   681,    18,    20,
     649,    22,   650,    54,    56,   583,    71,   130,   360,   428,
     487,   482,   482,   482,   482,   633,   637,   457,    71,    75,
     413,   691,     1,   289,   654,    70,   548,   548,    73,   655,
      71,   655,    70,   293,   298,   299,   301,   304,   559,   560,
     561,   451,     1,   459,   461,   460,     1,    97,   668,   691,
     532,   691,   446,    73,   532,   687,    78,   150,   687,   697,
     687,   536,   673,   627,   691,   500,   502,   504,   673,   451,
     448,   673,    70,   551,   451,   525,   290,   695,     1,   290,
     694,   694,   567,   678,   299,   629,   578,   670,    46,   615,
     706,   706,   649,    71,     1,   567,   582,     1,   689,   690,
     688,   675,     1,   422,   423,   482,   532,   691,   446,   505,
     699,   687,   547,   691,   557,   560,    71,   655,   112,   455,
     482,   673,   433,    77,   108,   450,   299,   705,   687,   299,
     705,   457,   673,   497,   497,   497,   446,   551,   247,   250,
     279,   449,   535,   458,   691,     1,   209,   224,   452,   551,
       1,   292,   686,     1,   531,   653,   678,   584,   153,   703,
     649,   691,   584,   567,     1,   214,   682,   482,   451,   414,
     691,     1,   691,   561,     1,   136,   205,   705,     1,   633,
     636,   691,   451,   687,   687,   687,   687,   446,     1,   456,
     458,   451,    71,   691,   455,   640,   567,   527,   616,   617,
     618,   578,   691,    75,   453,   552,   482,   691,   673,   453,
     450,    71,   455,   567,   299,   608,   619,   639,   527,   584,
     673,   505,   457,   455,   451,   451,   457,   454,    71,   453,
     453,    71,   482,   551,   455
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_int16 yyr1[] =
{
       0,   309,   310,   310,   311,   311,   311,   311,   311,   311,
     311,   311,   311,   311,   311,   311,   311,   311,   311,   311,
     312,   312,   313,   313,   313,   313,   313,   314,   315,   314,
     314,   314,   314,   316,   316,   316,   317,   317,   317,   318,
     318,   318,   319,   319,   319,   320,   320,   320,   321,   321,
     322,   322,   323,   323,   323,   323,   324,   324,   324,   325,
     326,   326,   327,   327,   328,   328,   328,   328,   328,   328,
     328,   328,   328,   328,   328,   328,   328,   328,   328,   328,
     328,   329,   330,   330,   331,   331,   331,   332,   332,   333,
     333,   334,   334,   335,   335,   336,   336,   336,   336,   336,
     336,   336,   337,   337,   338,   338,   339,   339,   340,   340,
     341,   341,   341,   341,   341,   341,   341,   342,   342,   343,
     343,   343,   344,   344,   344,   344,   344,   344,   344,   344,
     344,   344,   344,   344,   344,   344,   344,   344,   344,   344,
     344,   344,   344,   344,   344,   344,   344,   344,   344,   344,
     344,   344,   344,   344,   344,   344,   344,   344,   344,   344,
     344,   344,   344,   344,   344,   344,   344,   344,   344,   344,
     345,   345,   346,   346,   347,   347,   348,   348,   349,   349,
     349,   349,   349,   349,   349,   349,   349,   349,   349,   349,
     350,   349,   349,   349,   349,   349,   351,   353,   352,   354,
     354,   354,   354,   354,   355,   355,   355,   355,   355,   355,
     355,   355,   355,   355,   355,   355,   355,   355,   355,   355,
     356,   357,   357,   358,   358,   359,   359,   360,   360,   360,
     361,   361,   362,   362,   363,   363,   363,   363,   363,   363,
     363,   364,   365,   366,   367,   367,   368,   368,   369,   370,
     370,   370,   371,   371,   371,   371,   371,   371,   371,   371,
     372,   372,   372,   373,   373,   374,   374,   375,   375,   375,
     375,   376,   376,   376,   377,   378,   379,   381,   380,   380,
     383,   382,   384,   384,   384,   384,   386,   387,   385,   388,
     389,   388,   388,   390,   390,   391,   392,   392,   392,   394,
     395,   393,   397,   396,   399,   400,   398,   401,   401,   401,
     402,   402,   402,   402,   403,   403,   403,   403,   404,   404,
     405,   405,   406,   406,   407,   407,   407,   407,   408,   409,
     409,   410,   410,   411,   411,   411,   411,   411,   411,   412,
     412,   413,   414,   413,   415,   417,   416,   419,   420,   418,
     421,   421,   422,   423,   423,   424,   425,   427,   428,   426,
     429,   429,   430,   430,   431,   432,   432,   433,   433,   433,
     433,   433,   434,   434,   435,   435,   435,   435,   435,   435,
     435,   435,   435,   436,   437,   437,   437,   437,   437,   437,
     437,   437,   437,   437,   439,   438,   440,   441,   442,   443,
     445,   444,   447,   446,   448,   448,   449,   449,   449,   449,
     450,   450,   450,   451,   451,   451,   451,   451,   452,   452,
     452,   453,   454,   453,   453,   455,   455,   455,   455,   455,
     456,   456,   457,   457,   458,   458,   460,   459,   459,   459,
     461,   461,   463,   462,   464,   466,   465,   467,   468,   468,
     470,   469,   471,   473,   472,   474,   476,   475,   477,   477,
     478,   480,   479,   481,   482,   482,   483,   483,   483,   483,
     484,   484,   484,   484,   484,   485,   487,   486,   488,   490,
     489,   492,   491,   494,   493,   496,   495,   497,   497,   498,
     498,   498,   498,   500,   499,   502,   501,   504,   503,   505,
     505,   505,   506,   506,   507,   507,   508,   508,   508,   508,
     509,   509,   509,   509,   509,   509,   509,   509,   510,   510,
     511,   511,   511,   511,   513,   512,   514,   514,   515,   515,
     515,   515,   515,   515,   515,   515,   515,   515,   515,   515,
     515,   515,   517,   516,   516,   518,   518,   519,   519,   520,
     520,   521,   521,   522,   523,   523,   523,   524,   524,   524,
     525,   525,   526,   526,   527,   527,   527,   527,   528,   528,
     528,   529,   529,   530,   530,   531,   531,   532,   532,   533,
     533,   533,   534,   534,   534,   534,   534,   534,   534,   535,
     535,   536,   536,   537,   537,   538,   538,   538,   538,   539,
     539,   539,   539,   539,   539,   539,   539,   539,   539,   539,
     539,   539,   539,   539,   539,   539,   539,   539,   539,   540,
     540,   541,   541,   543,   542,   542,   544,   544,   545,   545,
     546,   546,   547,   547,   547,   547,   547,   547,   547,   547,
     547,   547,   548,   548,   549,   549,   550,   550,   551,   551,
     552,   552,   554,   553,   555,   555,   556,   556,   557,   557,
     558,   558,   559,   559,   560,   560,   561,   561,   561,   561,
     561,   561,   562,   562,   564,   563,   565,   565,   566,   566,
     567,   567,   567,   568,   568,   569,   569,   569,   569,   570,
     570,   571,   572,   573,   574,   574,   575,   576,   576,   577,
     577,   577,   577,   577,   577,   578,   578,   579,   580,   580,
     581,   581,   582,   582,   583,   583,   583,   584,   584,   585,
     585,   586,   587,   587,   588,   588,   589,   589,   589,   590,
     590,   590,   590,   590,   590,   590,   590,   590,   590,   590,
     590,   590,   590,   591,   591,   591,   591,   591,   591,   591,
     591,   591,   591,   591,   591,   591,   591,   591,   591,   591,
     591,   591,   591,   591,   591,   591,   591,   591,   591,   591,
     591,   591,   592,   592,   592,   593,   594,   594,   595,   595,
     595,   595,   595,   595,   595,   596,   596,   597,   597,   597,
     597,   597,   597,   597,   597,   598,   598,   598,   599,   600,
     600,   601,   602,   602,   602,   603,   603,   604,   604,   605,
     605,   606,   607,   607,   607,   607,   608,   608,   609,   609,
     609,   609,   609,   609,   609,   609,   609,   609,   609,   609,
     609,   609,   609,   609,   610,   610,   610,   610,   611,   611,
     611,   612,   612,   613,   614,   615,   615,   616,   616,   617,
     617,   618,   618,   619,   619,   620,   620,   621,   621,   622,
     622,   623,   623,   624,   624,   625,   625,   626,   627,   627,
     628,   628,   629,   629,   630,   630,   631,   632,   632,   633,
     633,   633,   634,   635,   635,   636,   636,   637,   637,   638,
     639,   640,   640,   641,   641,   642,   642,   643,   643,   643,
     644,   644,   645,   645,   646,   646,   647,   647,   647,   647,
     648,   648,   648,   649,   649,   649,   650,   650,   651,   651,
     652,   652,   653,   653,   654,   654,   655,   655,   656,   656,
     657,   657,   657,   657,   657,   657,   657,   657,   657,   657,
     657,   657,   657,   657,   657,   657,   657,   657,   657,   657,
     657,   657,   657,   657,   657,   657,   657,   657,   657,   657,
     657,   657,   657,   657,   657,   657,   657,   657,   657,   657,
     657,   657,   657,   657,   657,   657,   657,   657,   658,   658,
     659,   659,   660,   660,   661,   661,   662,   663,   663,   664,
     664,   665,   665,   666,   667,   667,   668,   668,   669,   669,
     670,   670,   671,   671,   672,   672,   673,   673,   674,   674,
     675,   675,   675,   676,   676,   677,   677,   678,   678,   679,
     680,   680,   681,   681,   682,   682,   683,   683,   684,   684,
     685,   685,   686,   686,   687,   687,   688,   688,   689,   689,
     690,   690,   691,   691,   692,   692,   692,   693,   693,   694,
     694,   695,   695,   696,   696,   697,   697,   698,   698,   699,
     699,   700,   700,   701,   701,   702,   702,   703,   703,   704,
     704,   705,   706,   706,   707,   707,   708,   708,   709,   709,
     710,   710,   711,   711
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     0,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     1,     2,     2,     2,     2,     2,     1,     1,
       4,     4,     2,     2,     2,     2,     1,     4,     0,    11,
       6,     9,     2,     1,     2,     2,     3,     2,     2,     2,
       1,     1,     0,     2,     3,     3,     3,     1,     0,     1,
       3,     1,     2,     2,     3,     1,     0,     2,     1,     3,
       0,     2,     1,     1,     2,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     2,     1,     1,     1,     1,     1,
       2,     4,     3,     2,     0,     2,     4,     1,     1,     0,
       1,     2,     1,     1,     1,     0,     1,     1,     2,     3,
       2,     1,     2,     1,     3,     1,     2,     1,     1,     3,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       0,     1,     2,     1,     1,     3,     1,     1,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       0,     4,     2,     3,     2,     2,     1,     0,     3,     0,
       1,     2,     2,     1,     1,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       4,     0,     3,     0,     1,     3,     1,     1,     1,     1,
       0,     1,     2,     1,     1,     1,     1,     1,     1,     1,
       1,     2,     1,     1,     1,     2,     2,     1,     2,     0,
       2,     2,     3,     4,     4,     5,     2,     3,     2,     2,
       1,     1,     1,     1,     1,     0,     1,     0,     2,     1,
       1,     0,     1,     1,     1,     1,     1,     0,     6,     3,
       0,     9,     1,     1,     1,     1,     0,     0,     5,     4,
       0,     6,     4,     1,     1,     4,     1,     1,     1,     0,
       0,     5,     0,     4,     0,     0,     5,     1,     1,     1,
       3,     3,     4,     1,     3,     3,     4,     1,     1,     1,
       0,     1,     2,     4,     1,     2,     2,     1,     6,     0,
       1,     3,     1,     1,     2,     1,     1,     1,     2,     0,
       3,     0,     0,     4,     1,     0,     3,     0,     0,     6,
       3,     1,     1,     1,     1,     1,     1,     0,     0,     8,
       0,     1,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     2,     1,     1,     1,     1,     1,     1,     1,     2,
       1,     1,     1,     3,     2,     3,     3,     3,     5,     5,
       4,     5,     5,     3,     0,    10,     8,     7,     6,     8,
       0,     7,     0,     3,     0,     2,     1,     1,     1,     1,
       0,     1,     1,     0,     1,     4,     3,     4,     1,     1,
       1,     0,     0,     4,     1,     0,     2,     2,     2,     2,
       1,     1,     0,     1,     3,     1,     0,     4,     1,     1,
       1,     1,     0,     4,    10,     0,     3,     2,     3,     1,
       0,     3,     2,     0,     3,     4,     0,     3,     2,     2,
       2,     0,     9,     9,     0,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     2,     0,     9,     6,     0,
       4,     0,     3,     0,     3,     0,     3,     0,     1,     1,
       1,     1,     1,     0,     3,     0,     3,     0,     3,     1,
       2,     1,     0,     1,     2,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     2,     2,
       1,     1,     1,     1,     0,     6,     1,     4,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     0,     6,     3,     1,     1,     1,     1,     3,
       4,     4,     4,     2,     0,     2,     2,     1,     3,     2,
       0,     1,     2,     1,     1,     1,     1,     1,     1,     1,
       1,     0,     1,     1,     1,     1,     1,     0,     1,     3,
       2,     2,     1,     1,     1,     1,     1,     2,     1,     1,
       1,     0,     2,     1,     1,     2,     3,     3,     3,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     0,     1,     0,     7,     1,     0,     3,     0,     1,
       3,     1,     1,     2,     1,     2,     1,     1,     1,     1,
       1,     1,     0,     3,     0,     1,     1,     1,     0,     1,
       2,     1,     0,     7,     0,     1,     3,     1,     2,     1,
       0,     3,     0,     1,     3,     1,     1,     1,     1,     1,
       3,     1,     2,     1,     0,     5,     0,     1,     2,     1,
       1,     1,     1,     4,     6,     0,     1,     1,     1,     0,
       1,     3,     2,     2,     0,     2,     5,     1,     1,     1,
       1,     1,     1,     1,     1,     0,     1,     3,     0,     1,
       3,     1,     1,     1,     0,     1,     2,     0,     1,     2,
       2,     2,     0,     1,     2,     1,     1,     1,     1,     2,
       1,     1,     2,     1,     2,     1,     2,     1,     1,     3,
       1,     1,     1,     1,     1,     2,     1,     1,     1,     1,
       1,     1,     1,     1,     3,     1,     1,     1,     1,     2,
       1,     1,     1,     1,     1,     2,     1,     1,     1,     1,
       1,     2,     1,     1,     1,     1,     0,     1,     1,     1,
       1,     1,     1,     2,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     3,     7,     3,     3,     1,
       2,     6,     3,     1,     1,     2,     1,     0,     1,     2,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     2,     1,     1,     1,     1,     2,     1,     1,
       2,     2,     1,     1,     3,     4,     4,     2,     1,     2,
       3,     0,     1,     2,     3,     0,     3,     2,     1,     0,
       1,     2,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     0,     1,     1,     1,     1,     1,     1,
       2,     1,     0,     1,     0,     2,     2,     0,     2,     3,
       3,     1,     2,     0,     2,     1,     1,     0,     1,     2,
       2,     1,     1,     0,     1,     3,     1,     3,     3,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       0,     1,     1,     0,     1,     1,     0,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     3,     1,     3,     1,     1,     1,     1,     1,
       1,     1,     2,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     2,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     2,
       3,     0,     1,     1,     0,     1,     1,     1,     0,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       0,     1,     1,     1,     1,     1,     2,     1,     1,     3,
       2,     1,     0,     1,     1,     1,     0,     1,     1,     1,
       0,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     0,     1,     1,     1,     0,     1,     1,     1,     1,
       1,     1,     1,     0,     1,     1,     1,     0,     1,     0,
       1,     1,     1,     1,     0,     1,     1,     1,     1,     2,
       1,     1,     0,     1
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF

/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (0)
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)


/* YYLOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

# ifndef YYLOCATION_PRINT

#  if defined YY_LOCATION_PRINT

   /* Temporary convenience wrapper in case some people defined the
      undocumented and private YY_LOCATION_PRINT macros.  */
#   define YYLOCATION_PRINT(File, Loc)  YY_LOCATION_PRINT(File, *(Loc))

#  elif defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL

/* Print *YYLOCP on YYO.  Private, do not rely on its existence. */

YY_ATTRIBUTE_UNUSED
static int
yy_location_print_ (FILE *yyo, YYLTYPE const * const yylocp)
{
  int res = 0;
  int end_col = 0 != yylocp->last_column ? yylocp->last_column - 1 : 0;
  if (0 <= yylocp->first_line)
    {
      res += YYFPRINTF (yyo, "%d", yylocp->first_line);
      if (0 <= yylocp->first_column)
        res += YYFPRINTF (yyo, ".%d", yylocp->first_column);
    }
  if (0 <= yylocp->last_line)
    {
      if (yylocp->first_line < yylocp->last_line)
        {
          res += YYFPRINTF (yyo, "-%d", yylocp->last_line);
          if (0 <= end_col)
            res += YYFPRINTF (yyo, ".%d", end_col);
        }
      else if (0 <= end_col && yylocp->first_column < end_col)
        res += YYFPRINTF (yyo, "-%d", end_col);
    }
  return res;
}

#   define YYLOCATION_PRINT  yy_location_print_

    /* Temporary convenience wrapper in case some people defined the
       undocumented and private YY_LOCATION_PRINT macros.  */
#   define YY_LOCATION_PRINT(File, Loc)  YYLOCATION_PRINT(File, &(Loc))

#  else

#   define YYLOCATION_PRINT(File, Loc) ((void) 0)
    /* Temporary convenience wrapper in case some people defined the
       undocumented and private YY_LOCATION_PRINT macros.  */
#   define YY_LOCATION_PRINT  YYLOCATION_PRINT

#  endif
# endif /* !defined YYLOCATION_PRINT */


# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value, Location); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  YY_USE (yylocationp);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  YYLOCATION_PRINT (yyo, yylocationp);
  YYFPRINTF (yyo, ": ");
  yy_symbol_value_print (yyo, yykind, yyvaluep, yylocationp);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp, YYLTYPE *yylsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)],
                       &(yylsp[(yyi + 1) - (yynrhs)]));
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, yylsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep, YYLTYPE *yylocationp)
{
  YY_USE (yyvaluep);
  YY_USE (yylocationp);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  switch (yykind)
    {
    case YYSYMBOL_Y_CONSTRUCTOR_SNAME: /* Y_CONSTRUCTOR_SNAME  */
#line 1867 "parser.y"
            { DTRACE; c_sname_cleanup( &((*yyvaluep).sname) );                 }
#line 5090 "parser.c"
        break;

    case YYSYMBOL_Y_DESTRUCTOR_SNAME: /* Y_DESTRUCTOR_SNAME  */
#line 1867 "parser.y"
            { DTRACE; c_sname_cleanup( &((*yyvaluep).sname) );                 }
#line 5096 "parser.c"
        break;

    case YYSYMBOL_Y_OPERATOR_SNAME: /* Y_OPERATOR_SNAME  */
#line 1867 "parser.y"
            { DTRACE; c_sname_cleanup( &((*yyvaluep).sname) );                 }
#line 5102 "parser.c"
        break;

    case YYSYMBOL_Y_CHAR_LIT: /* Y_CHAR_LIT  */
#line 1869 "parser.y"
            { DTRACE; FREE( ((*yyvaluep).str_val) );                             }
#line 5108 "parser.c"
        break;

    case YYSYMBOL_Y_GLOB: /* Y_GLOB  */
#line 1861 "parser.y"
            { DTRACE; FREE( ((*yyvaluep).name) );                             }
#line 5114 "parser.c"
        break;

    case YYSYMBOL_Y_NAME: /* Y_NAME  */
#line 1861 "parser.y"
            { DTRACE; FREE( ((*yyvaluep).name) );                             }
#line 5120 "parser.c"
        break;

    case YYSYMBOL_Y_SET_OPTION: /* Y_SET_OPTION  */
#line 1861 "parser.y"
            { DTRACE; FREE( ((*yyvaluep).name) );                             }
#line 5126 "parser.c"
        break;

    case YYSYMBOL_Y_STR_LIT: /* Y_STR_LIT  */
#line 1869 "parser.y"
            { DTRACE; FREE( ((*yyvaluep).str_val) );                             }
#line 5132 "parser.c"
        break;

    case YYSYMBOL_capturing_paren_capture_decl_list_english_opt: /* capturing_paren_capture_decl_list_english_opt  */
#line 1860 "parser.y"
            { DTRACE; c_ast_list_cleanup( &((*yyvaluep).ast_list) );              }
#line 5138 "parser.c"
        break;

    case YYSYMBOL_paren_capture_decl_list_english: /* paren_capture_decl_list_english  */
#line 1860 "parser.y"
            { DTRACE; c_ast_list_cleanup( &((*yyvaluep).ast_list) );              }
#line 5144 "parser.c"
        break;

    case YYSYMBOL_capture_decl_list_english_opt: /* capture_decl_list_english_opt  */
#line 1860 "parser.y"
            { DTRACE; c_ast_list_cleanup( &((*yyvaluep).ast_list) );              }
#line 5150 "parser.c"
        break;

    case YYSYMBOL_capture_decl_list_english: /* capture_decl_list_english  */
#line 1860 "parser.y"
            { DTRACE; c_ast_list_cleanup( &((*yyvaluep).ast_list) );              }
#line 5156 "parser.c"
        break;

    case YYSYMBOL_p_extra_token_except_lparen: /* p_extra_token_except_lparen  */
#line 1865 "parser.y"
            { DTRACE; p_token_free( ((*yyvaluep).p_token) );                     }
#line 5162 "parser.c"
        break;

    case YYSYMBOL_p_extra_tokens_opt: /* p_extra_tokens_opt  */
#line 1866 "parser.y"
            { DTRACE; p_token_list_cleanup( ((*yyvaluep).p_token_list) ); FREE( ((*yyvaluep).p_token_list) ); }
#line 5168 "parser.c"
        break;

    case YYSYMBOL_p_extra_tokens: /* p_extra_tokens  */
#line 1866 "parser.y"
            { DTRACE; p_token_list_cleanup( ((*yyvaluep).p_token_list) ); FREE( ((*yyvaluep).p_token_list) ); }
#line 5174 "parser.c"
        break;

    case YYSYMBOL_p_extra_token: /* p_extra_token  */
#line 1865 "parser.y"
            { DTRACE; p_token_free( ((*yyvaluep).p_token) );                     }
#line 5180 "parser.c"
        break;

    case YYSYMBOL_p_arg_list_opt: /* p_arg_list_opt  */
#line 1862 "parser.y"
            { DTRACE; p_arg_list_cleanup( ((*yyvaluep).p_arg_list) );   FREE( ((*yyvaluep).p_arg_list) ); }
#line 5186 "parser.c"
        break;

    case YYSYMBOL_p_comma_arg_list: /* p_comma_arg_list  */
#line 1862 "parser.y"
            { DTRACE; p_arg_list_cleanup( ((*yyvaluep).p_arg_list) );   FREE( ((*yyvaluep).p_arg_list) ); }
#line 5192 "parser.c"
        break;

    case YYSYMBOL_p_arg_list: /* p_arg_list  */
#line 1862 "parser.y"
            { DTRACE; p_arg_list_cleanup( ((*yyvaluep).p_arg_list) );   FREE( ((*yyvaluep).p_arg_list) ); }
#line 5198 "parser.c"
        break;

    case YYSYMBOL_p_arg_tokens: /* p_arg_tokens  */
#line 1866 "parser.y"
            { DTRACE; p_token_list_cleanup( ((*yyvaluep).p_token_list) ); FREE( ((*yyvaluep).p_token_list) ); }
#line 5204 "parser.c"
        break;

    case YYSYMBOL_p_arg_token_as_list: /* p_arg_token_as_list  */
#line 1866 "parser.y"
            { DTRACE; p_token_list_cleanup( ((*yyvaluep).p_token_list) ); FREE( ((*yyvaluep).p_token_list) ); }
#line 5210 "parser.c"
        break;

    case YYSYMBOL_p_arg_token: /* p_arg_token  */
#line 1865 "parser.y"
            { DTRACE; p_token_free( ((*yyvaluep).p_token) );                     }
#line 5216 "parser.c"
        break;

    case YYSYMBOL_p_arg_tokens_with_comma_opt: /* p_arg_tokens_with_comma_opt  */
#line 1866 "parser.y"
            { DTRACE; p_token_list_cleanup( ((*yyvaluep).p_token_list) ); FREE( ((*yyvaluep).p_token_list) ); }
#line 5222 "parser.c"
        break;

    case YYSYMBOL_p_arg_tokens_with_comma: /* p_arg_tokens_with_comma  */
#line 1866 "parser.y"
            { DTRACE; p_token_list_cleanup( ((*yyvaluep).p_token_list) ); FREE( ((*yyvaluep).p_token_list) ); }
#line 5228 "parser.c"
        break;

    case YYSYMBOL_p_arg_token_with_comma_as_list: /* p_arg_token_with_comma_as_list  */
#line 1866 "parser.y"
            { DTRACE; p_token_list_cleanup( ((*yyvaluep).p_token_list) ); FREE( ((*yyvaluep).p_token_list) ); }
#line 5234 "parser.c"
        break;

    case YYSYMBOL_p_arg_token_with_comma: /* p_arg_token_with_comma  */
#line 1865 "parser.y"
            { DTRACE; p_token_free( ((*yyvaluep).p_token) );                     }
#line 5240 "parser.c"
        break;

    case YYSYMBOL_help_what_opt: /* help_what_opt  */
#line 1861 "parser.y"
            { DTRACE; FREE( ((*yyvaluep).name) );                             }
#line 5246 "parser.c"
        break;

    case YYSYMBOL_p_paren_param_list_opt: /* p_paren_param_list_opt  */
#line 1864 "parser.y"
            { DTRACE; p_param_list_cleanup( ((*yyvaluep).p_param_list) ); FREE( ((*yyvaluep).p_param_list) ); }
#line 5252 "parser.c"
        break;

    case YYSYMBOL_p_param_list_opt: /* p_param_list_opt  */
#line 1864 "parser.y"
            { DTRACE; p_param_list_cleanup( ((*yyvaluep).p_param_list) ); FREE( ((*yyvaluep).p_param_list) ); }
#line 5258 "parser.c"
        break;

    case YYSYMBOL_p_param_list: /* p_param_list  */
#line 1864 "parser.y"
            { DTRACE; p_param_list_cleanup( ((*yyvaluep).p_param_list) ); FREE( ((*yyvaluep).p_param_list) ); }
#line 5264 "parser.c"
        break;

    case YYSYMBOL_p_param: /* p_param  */
#line 1863 "parser.y"
            { DTRACE; p_param_free( ((*yyvaluep).p_param) );                     }
#line 5270 "parser.c"
        break;

    case YYSYMBOL_p_replace_list_opt: /* p_replace_list_opt  */
#line 1866 "parser.y"
            { DTRACE; p_token_list_cleanup( ((*yyvaluep).p_token_list) ); FREE( ((*yyvaluep).p_token_list) ); }
#line 5276 "parser.c"
        break;

    case YYSYMBOL_p_replace_list: /* p_replace_list  */
#line 1866 "parser.y"
            { DTRACE; p_token_list_cleanup( ((*yyvaluep).p_token_list) ); FREE( ((*yyvaluep).p_token_list) ); }
#line 5282 "parser.c"
        break;

    case YYSYMBOL_p_replace_token: /* p_replace_token  */
#line 1865 "parser.y"
            { DTRACE; p_token_free( ((*yyvaluep).p_token) );                     }
#line 5288 "parser.c"
        break;

    case YYSYMBOL_set_option_value_opt: /* set_option_value_opt  */
#line 1869 "parser.y"
            { DTRACE; FREE( ((*yyvaluep).str_val) );                             }
#line 5294 "parser.c"
        break;

    case YYSYMBOL_namespace_sname_c_exp: /* namespace_sname_c_exp  */
#line 1867 "parser.y"
            { DTRACE; c_sname_cleanup( &((*yyvaluep).sname) );                 }
#line 5300 "parser.c"
        break;

    case YYSYMBOL_namespace_sname_c: /* namespace_sname_c  */
#line 1867 "parser.y"
            { DTRACE; c_sname_cleanup( &((*yyvaluep).sname) );                 }
#line 5306 "parser.c"
        break;

    case YYSYMBOL_namespace_typedef_sname_c: /* namespace_typedef_sname_c  */
#line 1867 "parser.y"
            { DTRACE; c_sname_cleanup( &((*yyvaluep).sname) );                 }
#line 5312 "parser.c"
        break;

    case YYSYMBOL_capture_decl_list_c_opt: /* capture_decl_list_c_opt  */
#line 1860 "parser.y"
            { DTRACE; c_ast_list_cleanup( &((*yyvaluep).ast_list) );              }
#line 5318 "parser.c"
        break;

    case YYSYMBOL_capture_decl_list_c: /* capture_decl_list_c  */
#line 1860 "parser.y"
            { DTRACE; c_ast_list_cleanup( &((*yyvaluep).ast_list) );              }
#line 5324 "parser.c"
        break;

    case YYSYMBOL_lambda_param_c_ast_list_opt: /* lambda_param_c_ast_list_opt  */
#line 1860 "parser.y"
            { DTRACE; c_ast_list_cleanup( &((*yyvaluep).ast_list) );              }
#line 5330 "parser.c"
        break;

    case YYSYMBOL_decl_list_c: /* decl_list_c  */
#line 1860 "parser.y"
            { DTRACE; c_ast_list_cleanup( &((*yyvaluep).ast_list) );              }
#line 5336 "parser.c"
        break;

    case YYSYMBOL_param_c_ast_list_exp: /* param_c_ast_list_exp  */
#line 1860 "parser.y"
            { DTRACE; c_ast_list_cleanup( &((*yyvaluep).ast_list) );              }
#line 5342 "parser.c"
        break;

    case YYSYMBOL_param_c_ast_list_opt: /* param_c_ast_list_opt  */
#line 1860 "parser.y"
            { DTRACE; c_ast_list_cleanup( &((*yyvaluep).ast_list) );              }
#line 5348 "parser.c"
        break;

    case YYSYMBOL_param_c_ast_list: /* param_c_ast_list  */
#line 1860 "parser.y"
            { DTRACE; c_ast_list_cleanup( &((*yyvaluep).ast_list) );              }
#line 5354 "parser.c"
        break;

    case YYSYMBOL_pc99_pointer_decl_list_c: /* pc99_pointer_decl_list_c  */
#line 1860 "parser.y"
            { DTRACE; c_ast_list_cleanup( &((*yyvaluep).ast_list) );              }
#line 5360 "parser.c"
        break;

    case YYSYMBOL_paren_param_decl_list_english_opt: /* paren_param_decl_list_english_opt  */
#line 1860 "parser.y"
            { DTRACE; c_ast_list_cleanup( &((*yyvaluep).ast_list) );              }
#line 5366 "parser.c"
        break;

    case YYSYMBOL_paren_param_decl_list_english: /* paren_param_decl_list_english  */
#line 1860 "parser.y"
            { DTRACE; c_ast_list_cleanup( &((*yyvaluep).ast_list) );              }
#line 5372 "parser.c"
        break;

    case YYSYMBOL_param_decl_list_english_opt: /* param_decl_list_english_opt  */
#line 1860 "parser.y"
            { DTRACE; c_ast_list_cleanup( &((*yyvaluep).ast_list) );              }
#line 5378 "parser.c"
        break;

    case YYSYMBOL_param_decl_list_english: /* param_decl_list_english  */
#line 1860 "parser.y"
            { DTRACE; c_ast_list_cleanup( &((*yyvaluep).ast_list) );              }
#line 5384 "parser.c"
        break;

    case YYSYMBOL_any_name: /* any_name  */
#line 1861 "parser.y"
            { DTRACE; FREE( ((*yyvaluep).name) );                             }
#line 5390 "parser.c"
        break;

    case YYSYMBOL_any_name_exp: /* any_name_exp  */
#line 1861 "parser.y"
            { DTRACE; FREE( ((*yyvaluep).name) );                             }
#line 5396 "parser.c"
        break;

    case YYSYMBOL_any_sname_c: /* any_sname_c  */
#line 1867 "parser.y"
            { DTRACE; c_sname_cleanup( &((*yyvaluep).sname) );                 }
#line 5402 "parser.c"
        break;

    case YYSYMBOL_any_sname_c_exp: /* any_sname_c_exp  */
#line 1867 "parser.y"
            { DTRACE; c_sname_cleanup( &((*yyvaluep).sname) );                 }
#line 5408 "parser.c"
        break;

    case YYSYMBOL_any_sname_c_opt: /* any_sname_c_opt  */
#line 1867 "parser.y"
            { DTRACE; c_sname_cleanup( &((*yyvaluep).sname) );                 }
#line 5414 "parser.c"
        break;

    case YYSYMBOL_name_exp: /* name_exp  */
#line 1861 "parser.y"
            { DTRACE; FREE( ((*yyvaluep).name) );                             }
#line 5420 "parser.c"
        break;

    case YYSYMBOL_name_cat: /* name_cat  */
#line 1861 "parser.y"
            { DTRACE; FREE( ((*yyvaluep).name) );                             }
#line 5426 "parser.c"
        break;

    case YYSYMBOL_name_opt: /* name_opt  */
#line 1861 "parser.y"
            { DTRACE; FREE( ((*yyvaluep).name) );                             }
#line 5432 "parser.c"
        break;

    case YYSYMBOL_oper_sname_c_opt: /* oper_sname_c_opt  */
#line 1867 "parser.y"
            { DTRACE; c_sname_cleanup( &((*yyvaluep).sname) );                 }
#line 5438 "parser.c"
        break;

    case YYSYMBOL_sub_scope_sname_c_opt: /* sub_scope_sname_c_opt  */
#line 1867 "parser.y"
            { DTRACE; c_sname_cleanup( &((*yyvaluep).sname) );                 }
#line 5444 "parser.c"
        break;

    case YYSYMBOL_sname_c: /* sname_c  */
#line 1867 "parser.y"
            { DTRACE; c_sname_cleanup( &((*yyvaluep).sname) );                 }
#line 5450 "parser.c"
        break;

    case YYSYMBOL_sname_c_exp: /* sname_c_exp  */
#line 1867 "parser.y"
            { DTRACE; c_sname_cleanup( &((*yyvaluep).sname) );                 }
#line 5456 "parser.c"
        break;

    case YYSYMBOL_sname_c_opt: /* sname_c_opt  */
#line 1867 "parser.y"
            { DTRACE; c_sname_cleanup( &((*yyvaluep).sname) );                 }
#line 5462 "parser.c"
        break;

    case YYSYMBOL_sname_english: /* sname_english  */
#line 1867 "parser.y"
            { DTRACE; c_sname_cleanup( &((*yyvaluep).sname) );                 }
#line 5468 "parser.c"
        break;

    case YYSYMBOL_sname_english_exp: /* sname_english_exp  */
#line 1867 "parser.y"
            { DTRACE; c_sname_cleanup( &((*yyvaluep).sname) );                 }
#line 5474 "parser.c"
        break;

    case YYSYMBOL_sname_english_opt: /* sname_english_opt  */
#line 1867 "parser.y"
            { DTRACE; c_sname_cleanup( &((*yyvaluep).sname) );                 }
#line 5480 "parser.c"
        break;

    case YYSYMBOL_sname_list_english: /* sname_list_english  */
#line 1868 "parser.y"
            { DTRACE; c_sname_list_cleanup( &((*yyvaluep).sname_list) );            }
#line 5486 "parser.c"
        break;

    case YYSYMBOL_typedef_sname_c: /* typedef_sname_c  */
#line 1867 "parser.y"
            { DTRACE; c_sname_cleanup( &((*yyvaluep).sname) );                 }
#line 5492 "parser.c"
        break;

    case YYSYMBOL_destructor_sname: /* destructor_sname  */
#line 1867 "parser.y"
            { DTRACE; c_sname_cleanup( &((*yyvaluep).sname) );                 }
#line 5498 "parser.c"
        break;

    case YYSYMBOL_glob: /* glob  */
#line 1861 "parser.y"
            { DTRACE; FREE( ((*yyvaluep).name) );                             }
#line 5504 "parser.c"
        break;

    case YYSYMBOL_glob_opt: /* glob_opt  */
#line 1861 "parser.y"
            { DTRACE; FREE( ((*yyvaluep).name) );                             }
#line 5510 "parser.c"
        break;

    case YYSYMBOL_of_scope_english: /* of_scope_english  */
#line 1867 "parser.y"
            { DTRACE; c_sname_cleanup( &((*yyvaluep).sname) );                 }
#line 5516 "parser.c"
        break;

    case YYSYMBOL_of_scope_list_english: /* of_scope_list_english  */
#line 1867 "parser.y"
            { DTRACE; c_sname_cleanup( &((*yyvaluep).sname) );                 }
#line 5522 "parser.c"
        break;

    case YYSYMBOL_of_scope_list_english_opt: /* of_scope_list_english_opt  */
#line 1867 "parser.y"
            { DTRACE; c_sname_cleanup( &((*yyvaluep).sname) );                 }
#line 5528 "parser.c"
        break;

    case YYSYMBOL_str_lit: /* str_lit  */
#line 1869 "parser.y"
            { DTRACE; FREE( ((*yyvaluep).str_val) );                             }
#line 5534 "parser.c"
        break;

    case YYSYMBOL_str_lit_exp: /* str_lit_exp  */
#line 1869 "parser.y"
            { DTRACE; FREE( ((*yyvaluep).str_val) );                             }
#line 5540 "parser.c"
        break;

      default:
        break;
    }
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Location data for the lookahead symbol.  */
YYLTYPE yylloc
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  = { 1, 1, 1, 1 }
# endif
;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

    /* The location stack: array, bottom, top.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls = yylsa;
    YYLTYPE *yylsp = yyls;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

  /* The locations where the error started and ended.  */
  YYLTYPE yyerror_range[3];



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  yylsp[0] = yylloc;
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;
        YYLTYPE *yyls1 = yyls;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yyls1, yysize * YYSIZEOF (*yylsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
        yyls = yyls1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
        YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      yyerror_range[1] = yylloc;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END
  *++yylsp = yylloc;

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location. */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  yyerror_range[1] = yyloc;
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 3: /* command_list: command_list command  */
#line 1877 "parser.y"
    { //
      // We get here only after a successful parse.
      //
      parse_cleanup( /*fatal_error=*/false );
    }
#line 5839 "parser.c"
    break;

  case 19: /* command: error  */
#line 1901 "parser.y"
    {
      if ( lexer_printable_token() != NULL )
        elaborate_error_dym( DYM_COMMANDS, "unexpected token" );
      else
        elaborate_error( "unexpected end of command" );
    }
#line 5850 "parser.c"
    break;

  case 20: /* cast_command: Y_cast sname_english_opt as_into_to_exp decl_english_ast  */
#line 1920 "parser.y"
    {
      DUMP_START();
      DUMP_PROD( "cast_command",
                 "CAST sname_english_opt {AS|[IN]TO} decl_english_ast" );
      DUMP_SNAME( "sname_english_opt", (yyvsp[-2].sname) );
      DUMP_AST( "decl_english_ast", (yyvsp[0].ast) );

      c_ast_t *const cast_ast = c_ast_new_gc( K_CAST, &(yyloc) );
      cast_ast->sname = c_sname_move( &(yyvsp[-2].sname) );
      cast_ast->cast.kind = C_CAST_C;
      cast_ast->cast.to_ast = (yyvsp[0].ast);

      DUMP_AST( "$$_ast", cast_ast );
      DUMP_END();

      PARSE_ASSERT( c_ast_check( cast_ast ) );
      c_ast_gibberish( cast_ast, C_GIB_PRINT_CAST, stdout );
    }
#line 5873 "parser.c"
    break;

  case 21: /* cast_command: new_style_cast_english sname_english_exp as_into_to_exp decl_english_ast  */
#line 1944 "parser.y"
    {
      DUMP_START();
      DUMP_PROD( "cast_command",
                 "new_style_cast_english sname_english_exp {AS|[IN]TO} "
                 "decl_english_ast" );
      DUMP_STR( "new_style_cast_english", c_cast_gibberish( (yyvsp[-3].cast_kind) ) );
      DUMP_SNAME( "sname_english_exp", (yyvsp[-2].sname) );
      DUMP_AST( "decl_english_ast", (yyvsp[0].ast) );

      c_ast_t *const cast_ast = c_ast_new_gc( K_CAST, &(yyloc) );
      cast_ast->sname = c_sname_move( &(yyvsp[-2].sname) );
      cast_ast->cast.kind = (yyvsp[-3].cast_kind);
      cast_ast->cast.to_ast = (yyvsp[0].ast);

      DUMP_AST( "$$_ast", cast_ast );
      DUMP_END();

      PARSE_ASSERT( c_ast_check( cast_ast ) );
      c_ast_gibberish( cast_ast, C_GIB_PRINT_CAST, stdout );
    }
#line 5898 "parser.c"
    break;

  case 22: /* new_style_cast_english: Y_const cast_exp  */
#line 1967 "parser.y"
                                  { (yyval.cast_kind) = C_CAST_CONST;        }
#line 5904 "parser.c"
    break;

  case 23: /* new_style_cast_english: Y_dynamic cast_exp  */
#line 1968 "parser.y"
                                  { (yyval.cast_kind) = C_CAST_DYNAMIC;      }
#line 5910 "parser.c"
    break;

  case 24: /* new_style_cast_english: Y_reinterpret cast_exp  */
#line 1969 "parser.y"
                                  { (yyval.cast_kind) = C_CAST_REINTERPRET;  }
#line 5916 "parser.c"
    break;

  case 25: /* new_style_cast_english: Y_static cast_exp  */
#line 1970 "parser.y"
                                  { (yyval.cast_kind) = C_CAST_STATIC;       }
#line 5922 "parser.c"
    break;

  case 27: /* declare_command: Y_declare sname_list_english as_exp alignas_or_width_decl_english_ast  */
#line 1982 "parser.y"
    {
      if ( (yyvsp[0].ast)->kind == K_NAME ) {
        //
        // This checks for a case like:
        //
        //      declare x as y
        //
        // i.e., declaring a variable name as another name (unknown type).
        // This can get this far due to the nature of the C/C++ grammar.
        //
        // This check has to be done now in the parser rather than later in the
        // AST because the name of the AST node needs to be set to the variable
        // name, but the AST node is itself a name and overwriting it would
        // lose information.
        //
        assert( !c_sname_empty( &(yyvsp[0].ast)->sname ) );
        print_error_unknown_name( &(yylsp[0]), &(yyvsp[0].ast)->sname );
        c_sname_list_cleanup( &(yyvsp[-2].sname_list) );
        PARSE_ABORT();
      }

      DUMP_START();
      DUMP_PROD( "declare_command",
                 "DECLARE sname_list_english AS "
                 "alignas_or_width_decl_english_ast" );
      DUMP_SNAME_LIST( "sname_list_english", (yyvsp[-2].sname_list) );
      DUMP_AST( "alignas_or_width_decl_english_ast", (yyvsp[0].ast) );

      (yyvsp[0].ast)->loc = (yylsp[-2]);

      DUMP_AST( "$$_ast", (yyvsp[0].ast) );
      DUMP_END();

      // To check the declaration, it needs a name: just dup the first one.
      c_sname_t temp_sname = c_sname_dup( slist_front( &(yyvsp[-2].sname_list) ) );
      c_sname_set( &(yyvsp[0].ast)->sname, &temp_sname );

      bool ok = c_ast_check( (yyvsp[0].ast) );

      if ( ok ) {
        //
        // Ensure that none of the names aren't of a previously declared type:
        //
        //      cdecl> struct S
        //      cdecl> declare S as int // error: "S": previously declared
        //
        // This check is done now in the parser rather than later in the AST
        // since similar checks are also done here in the parser.
        //
        FOREACH_SLIST_NODE( sname_node, &(yyvsp[-2].sname_list) ) {
          c_sname_t const *const sname = sname_node->data;
          c_typedef_t const *const tdef = c_typedef_find_sname( sname );
          if ( tdef != NULL ) {
            print_error( &(yyvsp[0].ast)->loc,
              "\"%s\": previously declared as type \"",
              c_sname_full_name( sname )
            );
            print_type_ast( tdef, stderr );
            EPUTS( "\"\n" );
            ok = false;
            break;
          }
        } // for
      }

      if ( ok )
        c_sname_list_ast_gibberish( &(yyvsp[-2].sname_list), (yyvsp[0].ast), stdout );

      c_sname_list_cleanup( &(yyvsp[-2].sname_list) );
      PARSE_ASSERT( ok );
      PUTC( '\n' );
    }
#line 5999 "parser.c"
    break;

  case 28: /* $@1: %empty  */
#line 2059 "parser.y"
    { //
      // This check is done now in the parser right here mid-rule rather than
      // later in the end-rule action or in the AST since it yields a better
      // error message since otherwise it would warn that "operator" is a
      // keyword in C++98 which skims right past the bigger error that operator
      // overloading isn't supported in C.
      //
      if ( !IS_SUPPORTED( operator ) ) {
        print_error( &(yylsp[0]),
          "operator overloading not supported%s\n",
          C_LANG_WHICH( operator )
        );
        PARSE_ABORT();
      }
    }
#line 6019 "parser.c"
    break;

  case 29: /* declare_command: Y_declare c_operator $@1 of_scope_list_english_opt as_exp type_qualifier_list_english_type_opt ref_qualifier_english_stid_opt member_or_non_member_opt operator_exp paren_param_decl_list_english_opt returning_english_ast_opt  */
#line 2080 "parser.y"
    {
      c_operator_t const *const operator = c_op_get( (yyvsp[-9].op_id) );

      DUMP_START();
      DUMP_PROD( "declare_command",
                 "DECLARE c_operator of_scope_list_english_opt AS "
                 "type_qualifier_list_english_type_opt "
                 "ref_qualifier_english_stid_opt "
                 "member_or_non_member_opt "
                 "OPERATOR paren_param_decl_list_english_opt "
                 "returning_english_ast_opt" );
      DUMP_STR( "c_operator", operator->literal );
      DUMP_SNAME( "of_scope_list_english_opt", (yyvsp[-7].sname) );
      DUMP_TYPE( "type_qualifier_list_english_type_opt", (yyvsp[-5].type) );
      DUMP_TID( "ref_qualifier_english_stid_opt", (yyvsp[-4].tid) );
      DUMP_INT( "member_or_non_member_opt", (yyvsp[-3].member) );
      DUMP_AST_LIST( "paren_param_decl_list_english_opt", (yyvsp[-1].ast_list) );
      DUMP_AST( "returning_english_ast_opt", (yyvsp[0].ast) );
      DUMP_END();

      c_ast_t *const oper_ast = c_ast_new_gc( K_OPERATOR, &(yylsp[-9]) );
      c_sname_set( &oper_ast->sname, &(yyvsp[-7].sname) );
      PARSE_ASSERT( c_type_add( &oper_ast->type, &(yyvsp[-5].type), &(yylsp[-5]) ) );
      PARSE_ASSERT(
        c_type_add_tid( &oper_ast->type, (yyvsp[-4].tid), &(yylsp[-4]) )
      );
      oper_ast->oper.operator = operator;
      c_ast_list_set_param_of( &(yyvsp[-1].ast_list), oper_ast );
      oper_ast->oper.param_ast_list = slist_move( &(yyvsp[-1].ast_list) );
      oper_ast->oper.member = (yyvsp[-3].member);
      c_ast_set_parent( (yyvsp[0].ast), oper_ast );

      PARSE_ASSERT( c_ast_check( oper_ast ) );
      unsigned decl_flags = C_GIB_PRINT_DECL;
      if ( opt_semicolon )
        decl_flags |= C_GIB_OPT_SEMICOLON;
      c_ast_gibberish( oper_ast, decl_flags, stdout );
      PUTC( '\n' );
    }
#line 6063 "parser.c"
    break;

  case 30: /* declare_command: Y_declare storage_class_subset_english_type_opt Y_lambda capturing_paren_capture_decl_list_english_opt paren_param_decl_list_english_opt returning_english_ast_opt  */
#line 2127 "parser.y"
    {
      DUMP_START();
      DUMP_PROD( "declare_command",
                 "DECLARE storage_class_subset_english_type_opt "
                 "LAMBDA capturing_paren_capture_decl_list_english_opt "
                 "paren_param_decl_list_english_opt"
                 "returning_english_ast_opt" );
      DUMP_TYPE( "storage_class_subset_english_type_opt", (yyvsp[-4].type) );
      DUMP_AST_LIST( "capturing_paren_capture_decl_list_english_opt",
                     (yyvsp[-2].ast_list) );
      DUMP_AST_LIST( "paren_param_decl_list_english_opt", (yyvsp[-1].ast_list) );
      DUMP_AST( "returning_english_ast_opt", (yyvsp[0].ast) );

      c_ast_t *const lambda_ast = c_ast_new_gc( K_LAMBDA, &(yyloc) );
      lambda_ast->type = (yyvsp[-4].type);
      c_ast_list_set_param_of( &(yyvsp[-2].ast_list), lambda_ast );
      lambda_ast->lambda.capture_ast_list = slist_move( &(yyvsp[-2].ast_list) );
      c_ast_list_set_param_of( &(yyvsp[-1].ast_list), lambda_ast );
      lambda_ast->lambda.param_ast_list = slist_move( &(yyvsp[-1].ast_list) );
      c_ast_set_parent( (yyvsp[0].ast), lambda_ast );

      DUMP_AST( "$$_ast", lambda_ast );
      DUMP_END();

      PARSE_ASSERT( c_ast_check( lambda_ast ) );
      c_ast_gibberish( lambda_ast, C_GIB_PRINT_DECL, stdout );
      PUTC( '\n' );
    }
#line 6096 "parser.c"
    break;

  case 31: /* declare_command: Y_declare storage_class_subset_english_type_opt cv_qualifier_list_stid_opt user_defined conversion_exp operator_opt of_scope_list_english_opt returning_exp decl_english_ast  */
#line 2163 "parser.y"
    {
      DUMP_START();
      DUMP_PROD( "declare_command",
                 "DECLARE storage_class_subset_english_type_opt "
                 "cv_qualifier_list_stid_opt "
                 "USER-DEFINED CONVERSION [OPERATOR] "
                 "of_scope_list_english_opt "
                 "RETURNING decl_english_ast" );
      DUMP_TYPE( "storage_class_subset_english_type_opt", (yyvsp[-7].type) );
      DUMP_TID( "cv_qualifier_list_stid_opt", (yyvsp[-6].tid) );
      DUMP_SNAME( "of_scope_list_english_opt", (yyvsp[-2].sname) );
      DUMP_AST( "decl_english_ast", (yyvsp[0].ast) );

      c_ast_t *const udc_ast = c_ast_new_gc( K_UDEF_CONV, &(yyloc) );
      c_sname_set( &udc_ast->sname, &(yyvsp[-2].sname) );
      udc_ast->type = c_type_or( &(yyvsp[-7].type), &C_TYPE_LIT_S( (yyvsp[-6].tid) ) );
      c_ast_set_parent( (yyvsp[0].ast), udc_ast );

      DUMP_AST( "$$_ast", udc_ast );
      DUMP_END();

      PARSE_ASSERT( c_ast_check( udc_ast ) );
      unsigned decl_flags = C_GIB_PRINT_DECL;
      if ( opt_semicolon )
        decl_flags |= C_GIB_OPT_SEMICOLON;
      c_ast_gibberish( udc_ast, decl_flags, stdout );
      PUTC( '\n' );
    }
#line 6129 "parser.c"
    break;

  case 32: /* declare_command: Y_declare error  */
#line 2193 "parser.y"
    {
      if ( OPT_LANG_IS( operator ) )
        elaborate_error( "name or operator expected" );
      else
        elaborate_error( "name expected" );
    }
#line 6140 "parser.c"
    break;

  case 34: /* alignas_or_width_decl_english_ast: decl_english_ast alignas_specifier_english  */
#line 2205 "parser.y"
    {
      DUMP_START();
      DUMP_PROD( "alignas_or_width_decl_english_ast",
                 "decl_english_ast alignas_specifier_english" );
      DUMP_AST( "decl_english_ast", (yyvsp[-1].ast) );
      DUMP_ALIGN( "alignas_specifier_english", (yyvsp[0].align) );

      (yyval.ast) = (yyvsp[-1].ast);
      (yyval.ast)->align = (yyvsp[0].align);
      (yyval.ast)->loc = (yyloc);

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 6159 "parser.c"
    break;

  case 35: /* alignas_or_width_decl_english_ast: decl_english_ast width_specifier_english_uint  */
#line 2221 "parser.y"
    {
      DUMP_START();
      DUMP_PROD( "alignas_or_width_decl_english_ast",
                 "decl_english_ast width_specifier_english_uint" );
      DUMP_AST( "decl_english_ast", (yyvsp[-1].ast) );
      DUMP_INT( "width_specifier_english_uint", (yyvsp[0].uint_val) );

      //
      // This check has to be done now in the parser rather than later in the
      // AST since we need to use the builtin union member now.
      //
      if ( !c_ast_is_integral( (yyvsp[-1].ast) ) ) {
        print_error( &(yylsp[0]), "invalid bit-field type " );
        print_ast_type_aka( (yyvsp[-1].ast), stderr );
        EPRINTF( "; must be an integral %stype\n",
          OPT_LANG_IS( enum_BITFIELDS ) ? "or enumeration " : ""
        );
        PARSE_ABORT();
      }

      (yyval.ast) = (yyvsp[-1].ast);
      (yyval.ast)->loc = (yyloc);
      (yyval.ast)->bit_field.bit_width = (yyvsp[0].uint_val);

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 6191 "parser.c"
    break;

  case 36: /* alignas_specifier_english: aligned_english uint_lit bytes_opt  */
#line 2252 "parser.y"
    {
      (yyval.align).kind = C_ALIGNAS_BYTES;
      (yyval.align).loc = (yylsp[-2]);
      (yyval.align).bytes = (yyvsp[-1].uint_val);
    }
#line 6201 "parser.c"
    break;

  case 37: /* alignas_specifier_english: aligned_english decl_english_ast  */
#line 2258 "parser.y"
    {
      (yyval.align).kind = C_ALIGNAS_TYPE;
      (yyval.align).loc = (yylsp[-1]);
      (yyval.align).type_ast = (yyvsp[0].ast);
    }
#line 6211 "parser.c"
    break;

  case 38: /* alignas_specifier_english: aligned_english error  */
#line 2264 "parser.y"
    {
      (yyval.align) = (c_alignas_t){ 0 };
      (yyval.align).loc = (yylsp[-1]);
      elaborate_error( "integer or type expected" );
    }
#line 6221 "parser.c"
    break;

  case 42: /* capturing_paren_capture_decl_list_english_opt: %empty  */
#line 2278 "parser.y"
                                  { slist_init( &(yyval.ast_list) ); }
#line 6227 "parser.c"
    break;

  case 43: /* capturing_paren_capture_decl_list_english_opt: Y_capturing paren_capture_decl_list_english  */
#line 2280 "parser.y"
    {
      (yyval.ast_list) = (yyvsp[0].ast_list);
    }
#line 6235 "parser.c"
    break;

  case 44: /* capturing_paren_capture_decl_list_english_opt: '[' capture_decl_list_english_opt ']'  */
#line 2284 "parser.y"
    {
      (yyval.ast_list) = (yyvsp[-1].ast_list);
    }
#line 6243 "parser.c"
    break;

  case 45: /* paren_capture_decl_list_english: '[' capture_decl_list_english_opt ']'  */
#line 2291 "parser.y"
    {
      (yyval.ast_list) = (yyvsp[-1].ast_list);
    }
#line 6251 "parser.c"
    break;

  case 46: /* paren_capture_decl_list_english: '(' capture_decl_list_english_opt ')'  */
#line 2295 "parser.y"
    {
      (yyval.ast_list) = (yyvsp[-1].ast_list);
    }
#line 6259 "parser.c"
    break;

  case 47: /* paren_capture_decl_list_english: error  */
#line 2299 "parser.y"
    {
      slist_init( &(yyval.ast_list) );
      elaborate_error( "'[' or '(' expected\n" );
    }
#line 6268 "parser.c"
    break;

  case 48: /* capture_decl_list_english_opt: %empty  */
#line 2306 "parser.y"
                                  { slist_init( &(yyval.ast_list) ); }
#line 6274 "parser.c"
    break;

  case 50: /* capture_decl_list_english: capture_decl_list_english comma_exp capture_decl_english_ast  */
#line 2313 "parser.y"
    {
      DUMP_START();
      DUMP_PROD( "capture_decl_list_english",
                 "capture_decl_list_english ',' capture_decl_english_ast" );
      DUMP_AST_LIST( "capture_decl_list_english", (yyvsp[-2].ast_list) );
      DUMP_AST( "capture_decl_english_ast", (yyvsp[0].ast) );

      (yyval.ast_list) = (yyvsp[-2].ast_list);
      slist_push_back( &(yyval.ast_list), (yyvsp[0].ast) );

      DUMP_AST_LIST( "$$_ast_list", (yyval.ast_list) );
      DUMP_END();
    }
#line 6292 "parser.c"
    break;

  case 51: /* capture_decl_list_english: capture_decl_english_ast  */
#line 2328 "parser.y"
    {
      DUMP_START();
      DUMP_PROD( "capture_decl_list_english",
                 "capture_decl_english_ast" );
      DUMP_AST( "capture_decl_english_ast", (yyvsp[0].ast) );

      slist_init( &(yyval.ast_list) );
      slist_push_back( &(yyval.ast_list), (yyvsp[0].ast) );

      DUMP_AST_LIST( "$$_ast_list", (yyval.ast_list) );
      DUMP_END();
    }
#line 6309 "parser.c"
    break;

  case 52: /* capture_decl_english_ast: Y_copy capture_default_opt  */
#line 2344 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_CAPTURE, &(yyloc) );
      (yyval.ast)->capture.kind = C_CAPTURE_COPY;
    }
#line 6318 "parser.c"
    break;

  case 53: /* capture_decl_english_ast: Y_reference capture_default_opt  */
#line 2349 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_CAPTURE, &(yyloc) );
      (yyval.ast)->capture.kind = C_CAPTURE_REFERENCE;
    }
#line 6327 "parser.c"
    break;

  case 54: /* capture_decl_english_ast: Y_reference Y_to name_exp  */
#line 2354 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_CAPTURE, &(yyloc) );
      c_sname_append_name( &(yyval.ast)->sname, (yyvsp[0].name) );
      (yyval.ast)->capture.kind = C_CAPTURE_REFERENCE;
    }
#line 6337 "parser.c"
    break;

  case 59: /* width_specifier_english_uint: Y_width uint_lit_exp bits_opt  */
#line 2370 "parser.y"
    { //
      // This check has to be done now in the parser rather than later in the
      // AST since we use 0 to mean "no bit-field."
      //
      if ( (yyvsp[-1].uint_val) == 0 ) {
        print_error( &(yylsp[-1]), "bit-field width must be > 0\n" );
        PARSE_ABORT();
      }
      (yyval.uint_val) = (yyvsp[-1].uint_val);
    }
#line 6352 "parser.c"
    break;

  case 60: /* storage_class_subset_english_type_opt: %empty  */
#line 2383 "parser.y"
                                  { (yyval.type) = T_NONE; }
#line 6358 "parser.c"
    break;

  case 61: /* storage_class_subset_english_type_opt: storage_class_subset_english_type_opt storage_class_subset_english_type  */
#line 2386 "parser.y"
    {
      DUMP_START();
      DUMP_PROD( "storage_class_subset_english_type_opt",
                 "storage_class_subset_english_type_opt "
                 "storage_class_subset_english_type" );
      DUMP_TYPE( "storage_class_subset_english_type_opt", (yyvsp[-1].type) );
      DUMP_TYPE( "storage_class_subset_english_type", (yyvsp[0].type) );

      (yyval.type) = (yyvsp[-1].type);
      PARSE_ASSERT( c_type_add( &(yyval.type), &(yyvsp[0].type), &(yylsp[0]) ) );

      DUMP_TYPE( "$$_type", (yyval.type) );
      DUMP_END();
    }
#line 6377 "parser.c"
    break;

  case 62: /* storage_class_subset_english_type: attribute_english_atid  */
#line 2403 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_A( (yyvsp[0].tid) ); }
#line 6383 "parser.c"
    break;

  case 63: /* storage_class_subset_english_type: storage_class_subset_english_stid  */
#line 2405 "parser.y"
    {
      (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) );
    }
#line 6391 "parser.c"
    break;

  case 64: /* storage_class_subset_english_stid: Y_const_ENG eval_expr_init_stid  */
#line 2426 "parser.y"
    {
      (yyval.tid) = (yyvsp[0].tid);
    }
#line 6399 "parser.c"
    break;

  case 74: /* storage_class_subset_english_stid: Y_no Y_except  */
#line 2438 "parser.y"
                                  { (yyval.tid) = TS_noexcept; }
#line 6405 "parser.c"
    break;

  case 80: /* storage_class_subset_english_stid: Y_pure virtual_stid_exp  */
#line 2444 "parser.y"
                                  { (yyval.tid) = TS_PURE_virtual | (yyvsp[0].tid); }
#line 6411 "parser.c"
    break;

  case 81: /* define_command: Y_define sname_english_exp as_exp decl_english_ast  */
#line 2451 "parser.y"
    {
      DUMP_START();
      DUMP_PROD( "define_command",
                 "DEFINE sname_english AS decl_english_ast" );
      DUMP_SNAME( "sname_english_exp", (yyvsp[-2].sname) );
      DUMP_AST( "decl_english_ast", (yyvsp[0].ast) );

      c_sname_set( &(yyvsp[0].ast)->sname, &(yyvsp[-2].sname) );

      if ( (yyvsp[0].ast)->kind == K_NAME ) { // see the comment in "declare_command"
        assert( !c_sname_empty( &(yyvsp[0].ast)->sname ) );
        print_error_unknown_name( &(yylsp[0]), &(yyvsp[0].ast)->sname );
        PARSE_ABORT();
      }

      if ( !c_tid_is_any( (yyvsp[0].ast)->type.stids, TS_typedef ) ) {
        //
        // Explicitly add TS_typedef (if it doesn't have it already) to
        // prohibit cases like:
        //
        //      define eint as extern int
        //      define rint as register int
        //      define sint as static int
        //      ...
        //
        // i.e., a defined type with a storage class.  Once the semantic checks
        // pass, remove the TS_typedef.
        //
        PARSE_ASSERT(
          c_type_add( &(yyvsp[0].ast)->type, &T_TS_typedef, &(yylsp[0]) )
        );
      }
      PARSE_ASSERT( c_ast_check( (yyvsp[0].ast) ) );
      PJL_IGNORE_RV( c_ast_take_type_any( (yyvsp[0].ast), &T_TS_typedef ) );

      if ( c_tid_is_any( (yyvsp[0].ast)->type.btids, TB_ANY_SCOPE ) )
        c_sname_set_local_type( &(yyvsp[0].ast)->sname, &(yyvsp[0].ast)->type );
      c_sname_fill_in_namespaces( &(yyvsp[0].ast)->sname );

      DUMP_AST( "$$_ast", (yyvsp[0].ast) );
      DUMP_END();

      PARSE_ASSERT( c_sname_check( &(yyvsp[0].ast)->sname, &(yylsp[-2]) ) );
      PARSE_ASSERT( define_type( (yyvsp[0].ast), C_ENG_DECL ) );
    }
#line 6461 "parser.c"
    break;

  case 82: /* expand_command: Y_expand Y_NAME expand_command2  */
#line 2502 "parser.y"
    {
      p_arg_list_t   *const arg_list   = (yyvsp[0].ptrs)[0];
      p_token_list_t *const extra_list = (yyvsp[0].ptrs)[1];

      DUMP_START();
      DUMP_PROD( "expand_command", "EXPAND NAME arg_list_opt extra_list_opt" );
      DUMP_STR( "name", (yyvsp[-1].name) );
      DUMP_MACRO_ARG_LIST( "arg_list", arg_list );
      DUMP_MACRO_TOKEN_LIST( "extra_list", extra_list );
      DUMP_END();

      bool const ok =
        p_macro_expand( (yyvsp[-1].name), &(yylsp[-1]), arg_list, extra_list, stdout );
      p_arg_list_cleanup( arg_list );
      free( arg_list );
      p_token_list_cleanup( extra_list );
      free( extra_list );
      free( (yyvsp[-1].name) );
      PARSE_ASSERT( ok );
    }
#line 6486 "parser.c"
    break;

  case 83: /* expand_command: Y_expand error  */
#line 2524 "parser.y"
    {
      elaborate_error( "macro name expected" );
    }
#line 6494 "parser.c"
    break;

  case 84: /* expand_command2: %empty  */
#line 2530 "parser.y"
                                  { (yyval.ptrs)[0] = (yyval.ptrs)[1] = NULL; }
#line 6500 "parser.c"
    break;

  case 85: /* expand_command2: p_extra_token_except_lparen p_extra_tokens_opt  */
#line 2546 "parser.y"
    {
      if ( (yyvsp[0].p_token_list) == NULL ) {
        (yyvsp[0].p_token_list) = MALLOC( p_token_list_t, 1 );
        slist_init( (yyvsp[0].p_token_list) );
      }
      slist_push_front( (yyvsp[0].p_token_list), (yyvsp[-1].p_token) );

      (yyval.ptrs)[0] = NULL;
      (yyval.ptrs)[1] = (yyvsp[0].p_token_list);
    }
#line 6515 "parser.c"
    break;

  case 86: /* expand_command2: '(' p_arg_list_opt ')' p_extra_tokens_opt  */
#line 2558 "parser.y"
    {
      (yyval.ptrs)[0] = (yyvsp[-2].p_arg_list);
      (yyval.ptrs)[1] = (yyvsp[0].p_token_list);
    }
#line 6524 "parser.c"
    break;

  case 88: /* p_extra_token_except_lparen: ')'  */
#line 2567 "parser.y"
    {
      (yyval.p_token) = p_token_new_loc( P_PUNCTUATOR, &(yylsp[0]), ")" );
    }
#line 6532 "parser.c"
    break;

  case 89: /* p_extra_tokens_opt: %empty  */
#line 2573 "parser.y"
                                  { (yyval.p_token_list) = NULL; }
#line 6538 "parser.c"
    break;

  case 91: /* p_extra_tokens: p_extra_tokens p_extra_token  */
#line 2579 "parser.y"
    {
      (yyval.p_token_list) = (yyvsp[-1].p_token_list);
      slist_push_back( (yyval.p_token_list), (yyvsp[0].p_token) );
    }
#line 6547 "parser.c"
    break;

  case 92: /* p_extra_tokens: p_extra_token  */
#line 2584 "parser.y"
    {
      (yyval.p_token_list) = MALLOC( p_token_list_t, 1 );
      slist_init( (yyval.p_token_list) );
      slist_push_back( (yyval.p_token_list), (yyvsp[0].p_token) );
    }
#line 6557 "parser.c"
    break;

  case 94: /* p_extra_token: '('  */
#line 2594 "parser.y"
    {
      (yyval.p_token) = p_token_new_loc( P_PUNCTUATOR, &(yylsp[0]), "(" );
    }
#line 6565 "parser.c"
    break;

  case 95: /* p_arg_list_opt: %empty  */
#line 2601 "parser.y"
    {
      (yyval.p_arg_list) = MALLOC( p_arg_list_t, 1 );
      slist_init( (yyval.p_arg_list) );
    }
#line 6574 "parser.c"
    break;

  case 97: /* p_arg_list_opt: p_comma_arg_list  */
#line 2619 "parser.y"
    {
      slist_push_back( (yyvsp[0].p_arg_list), p_token_list_new_placemarker() );
      slist_push_back( (yyvsp[0].p_arg_list), p_token_list_new_placemarker() );

      (yyval.p_arg_list) = MALLOC( p_arg_list_t, 1 );
      slist_init( (yyval.p_arg_list) );
      slist_push_list_back( (yyval.p_arg_list), (yyvsp[0].p_arg_list) );
    }
#line 6587 "parser.c"
    break;

  case 98: /* p_arg_list_opt: p_comma_arg_list p_arg_list  */
#line 2639 "parser.y"
    {
      slist_push_back( (yyvsp[-1].p_arg_list), p_token_list_new_placemarker() );

      (yyval.p_arg_list) = (yyvsp[0].p_arg_list);
      slist_push_list_front( (yyval.p_arg_list), (yyvsp[-1].p_arg_list) );
    }
#line 6598 "parser.c"
    break;

  case 99: /* p_arg_list_opt: p_comma_arg_list p_arg_list p_comma_arg_list  */
#line 2661 "parser.y"
    {
      slist_push_back( (yyvsp[-2].p_arg_list), p_token_list_new_placemarker() );
      slist_push_back( (yyvsp[0].p_arg_list), p_token_list_new_placemarker() );

      (yyval.p_arg_list) = (yyvsp[-1].p_arg_list);
      slist_push_list_front( (yyval.p_arg_list), (yyvsp[-2].p_arg_list) );
      slist_push_list_back ( (yyval.p_arg_list), (yyvsp[0].p_arg_list) );
    }
#line 6611 "parser.c"
    break;

  case 100: /* p_arg_list_opt: p_arg_list p_comma_arg_list  */
#line 2681 "parser.y"
    {
      (yyval.p_arg_list) = (yyvsp[-1].p_arg_list);
      slist_push_back( (yyvsp[0].p_arg_list), p_token_list_new_placemarker() );
      slist_push_list_back( (yyval.p_arg_list), (yyvsp[0].p_arg_list) );
    }
#line 6621 "parser.c"
    break;

  case 101: /* p_arg_list_opt: error  */
#line 2688 "parser.y"
    {
      (yyval.p_arg_list) = NULL;
      elaborate_error( "macro argument expected" );
    }
#line 6630 "parser.c"
    break;

  case 102: /* p_comma_arg_list: p_comma_arg_list ','  */
#line 2696 "parser.y"
    {
      (yyval.p_arg_list) = (yyvsp[-1].p_arg_list);
      slist_push_back( (yyval.p_arg_list), p_token_list_new_placemarker() );
    }
#line 6639 "parser.c"
    break;

  case 103: /* p_comma_arg_list: ','  */
#line 2701 "parser.y"
    {
      (yyval.p_arg_list) = MALLOC( p_arg_list_t, 1 );
      slist_init( (yyval.p_arg_list) );
    }
#line 6648 "parser.c"
    break;

  case 104: /* p_arg_list: p_arg_list p_comma_arg_list p_arg_tokens  */
#line 2722 "parser.y"
    {
      (yyval.p_arg_list) = (yyvsp[-2].p_arg_list);

      if ( !slist_empty( (yyvsp[-1].p_arg_list) ) )
        slist_push_list_back( (yyval.p_arg_list), (yyvsp[-1].p_arg_list) );

      slist_push_back( (yyval.p_arg_list), (yyvsp[0].p_token_list) );
    }
#line 6661 "parser.c"
    break;

  case 105: /* p_arg_list: p_arg_tokens  */
#line 2732 "parser.y"
    {
      (yyval.p_arg_list) = MALLOC( p_arg_list_t, 1 );
      slist_init( (yyval.p_arg_list) );
      slist_push_back( (yyval.p_arg_list), (yyvsp[0].p_token_list) );
    }
#line 6671 "parser.c"
    break;

  case 106: /* p_arg_tokens: p_arg_tokens p_arg_token_as_list  */
#line 2741 "parser.y"
    {
      (yyval.p_token_list) = (yyvsp[-1].p_token_list);
      slist_push_list_back( (yyval.p_token_list), (yyvsp[0].p_token_list) );
    }
#line 6680 "parser.c"
    break;

  case 108: /* p_arg_token_as_list: p_arg_token  */
#line 2750 "parser.y"
    {
      (yyval.p_token_list) = MALLOC( p_token_list_t, 1 );
      slist_init( (yyval.p_token_list) );
      slist_push_back( (yyval.p_token_list), (yyvsp[0].p_token) );
    }
#line 6690 "parser.c"
    break;

  case 109: /* p_arg_token_as_list: '(' p_arg_tokens_with_comma_opt ')'  */
#line 2756 "parser.y"
    {
      (yyval.p_token_list) = (yyvsp[-1].p_token_list);
      slist_push_front( (yyval.p_token_list), p_token_new_loc( P_PUNCTUATOR, &(yylsp[-2]), "(" ) );
      slist_push_back ( (yyval.p_token_list), p_token_new_loc( P_PUNCTUATOR, &(yylsp[0]), ")" ) );
    }
#line 6700 "parser.c"
    break;

  case 110: /* p_arg_token: Y_CHAR_LIT  */
#line 2765 "parser.y"
    {
      (yyval.p_token) = p_token_new_loc( P_CHAR_LIT, &(yylsp[0]), (yyvsp[0].str_val) );
    }
#line 6708 "parser.c"
    break;

  case 111: /* p_arg_token: Y_NAME  */
#line 2769 "parser.y"
    {
      (yyval.p_token) = p_token_new_loc( P_IDENTIFIER, &(yylsp[0]), (yyvsp[0].name) );
    }
#line 6716 "parser.c"
    break;

  case 112: /* p_arg_token: p_num_lit  */
#line 2773 "parser.y"
    {
      (yyval.p_token) = p_token_new_loc( P_NUM_LIT, &(yylsp[0]), check_strdup( lexer_token ) );
    }
#line 6724 "parser.c"
    break;

  case 113: /* p_arg_token: Y_P_SPACE  */
#line 2777 "parser.y"
    {
      (yyval.p_token) = p_token_new_loc( P_SPACE, &(yylsp[0]), /*literal=*/NULL );
    }
#line 6732 "parser.c"
    break;

  case 114: /* p_arg_token: Y_STR_LIT  */
#line 2781 "parser.y"
    {
      (yyval.p_token) = p_token_new_loc( P_STR_LIT, &(yylsp[0]), (yyvsp[0].str_val) );
    }
#line 6740 "parser.c"
    break;

  case 115: /* p_arg_token: p_other  */
#line 2785 "parser.y"
    {
      (yyval.p_token) = p_token_new_loc( P_OTHER, &(yylsp[0]), lexer_token );
    }
#line 6748 "parser.c"
    break;

  case 116: /* p_arg_token: p_punctuator  */
#line 2789 "parser.y"
    {
      (yyval.p_token) = p_token_new_loc( P_PUNCTUATOR, &(yylsp[0]), lexer_token );
    }
#line 6756 "parser.c"
    break;

  case 170: /* p_arg_tokens_with_comma_opt: %empty  */
#line 2861 "parser.y"
    {
      (yyval.p_token_list) = MALLOC( p_token_list_t, 1 );
      slist_init( (yyval.p_token_list) );
    }
#line 6765 "parser.c"
    break;

  case 172: /* p_arg_tokens_with_comma: p_arg_tokens_with_comma p_arg_token_with_comma_as_list  */
#line 2881 "parser.y"
    {
      (yyval.p_token_list) = (yyvsp[-1].p_token_list);
      slist_push_list_back( (yyval.p_token_list), (yyvsp[0].p_token_list) );
    }
#line 6774 "parser.c"
    break;

  case 174: /* p_arg_token_with_comma_as_list: p_arg_token_with_comma  */
#line 2890 "parser.y"
    {
      (yyval.p_token_list) = MALLOC( p_token_list_t, 1 );
      slist_init( (yyval.p_token_list) );
      slist_push_back( (yyval.p_token_list), (yyvsp[0].p_token) );
    }
#line 6784 "parser.c"
    break;

  case 175: /* p_arg_token_with_comma_as_list: '(' p_arg_tokens_with_comma_opt ')'  */
#line 2896 "parser.y"
    {
      (yyval.p_token_list) = (yyvsp[-1].p_token_list);
      slist_push_front( (yyval.p_token_list), p_token_new_loc( P_PUNCTUATOR, &(yylsp[-2]), "(" ) );
      slist_push_back ( (yyval.p_token_list), p_token_new_loc( P_PUNCTUATOR, &(yylsp[0]), ")" ) );
    }
#line 6794 "parser.c"
    break;

  case 177: /* p_arg_token_with_comma: ','  */
#line 2906 "parser.y"
    {
      (yyval.p_token) = p_token_new_loc( P_PUNCTUATOR, &(yylsp[0]), "," );
    }
#line 6802 "parser.c"
    break;

  case 188: /* explain_command: explain pc99_pointer_decl_list_c  */
#line 2973 "parser.y"
    {
      PARSE_ASSERT( c_ast_list_check( &(yyvsp[0].ast_list) ) );
      c_ast_list_english( &(yyvsp[0].ast_list), stdout );
    }
#line 6811 "parser.c"
    break;

  case 190: /* $@2: %empty  */
#line 2991 "parser.y"
                       { in_attr.is_typename = true; }
#line 6817 "parser.c"
    break;

  case 193: /* explain_command: explain extern_linkage_c_stid_opt using_decl_c_ast  */
#line 3012 "parser.y"
    {
      DUMP_START();
      DUMP_PROD( "explain_command",
                 "EXPLAIN extern_linkage_c_stid_opt using_decl_c_ast" );
      DUMP_TID( "extern_linkage_c_stid_opt", (yyvsp[-1].tid) );
      DUMP_AST( "using_decl_c_ast", (yyvsp[0].ast) );

      PARSE_ASSERT(
        c_type_add_tid( &(yyvsp[0].ast)->type, (yyvsp[-1].tid), &(yylsp[-1]) )
      );

      DUMP_AST( "$$_ast", (yyvsp[0].ast) );
      DUMP_END();

      PARSE_ASSERT( c_ast_check( (yyvsp[0].ast) ) );
      c_ast_english( (yyvsp[0].ast), C_ENG_DECL, stdout );
      PUTC( '\n' );
    }
#line 6840 "parser.c"
    break;

  case 194: /* explain_command: explain sname_c  */
#line 3036 "parser.y"
    {
      print_error_unknown_name( &(yylsp[0]), &(yyvsp[0].sname) );
      c_sname_cleanup( &(yyvsp[0].sname) );
      PARSE_ABORT();
    }
#line 6850 "parser.c"
    break;

  case 195: /* explain_command: explain error  */
#line 3043 "parser.y"
    {
      elaborate_error( "cast or declaration expected" );
    }
#line 6858 "parser.c"
    break;

  case 196: /* explain: Y_explain  */
#line 3050 "parser.y"
    { //
      // Set our mode to deciphering gibberish into English and specifically
      // tell the lexer to return cdecl keywords (e.g., "func") as ordinary
      // names, otherwise gibberish like:
      //
      //      int func(void);
      //
      // would result in a parser error.
      //
      gibberish_to_english();
    }
#line 6874 "parser.c"
    break;

  case 197: /* $@3: %empty  */
#line 3067 "parser.y"
    { //
      // We want cdecl commands (like "declare", etc.), other cdecl keywords
      // (like "cast", "commands", "english", "options", etc.), and C/C++
      // keywords (like "const", "static", "typedef", etc.) all to be returned
      // as just strings so we don't have to enumerate all the possible tokens
      // in the grammar.
      //
      lexer_find &= ~(LEXER_FIND_C_KEYWORDS | LEXER_FIND_CDECL_KEYWORDS);
    }
#line 6888 "parser.c"
    break;

  case 198: /* help_command: '?' $@3 help_what_opt  */
#line 3077 "parser.y"
    {
      bool const ok = print_help( (yyvsp[0].name), &(yylsp[0]) );
      free( (yyvsp[0].name) );
      PARSE_ASSERT( ok );
    }
#line 6898 "parser.c"
    break;

  case 199: /* help_what_opt: %empty  */
#line 3085 "parser.y"
                                  { (yyval.name) = NULL; }
#line 6904 "parser.c"
    break;

  case 201: /* help_what_opt: '#' Y_NAME  */
#line 3087 "parser.y"
                                  { (yyval.name) = str_realloc_pcat( "#", "", (yyvsp[0].name) ); }
#line 6910 "parser.c"
    break;

  case 202: /* help_what_opt: '#' error  */
#line 3089 "parser.y"
    {
      (yyval.name) = NULL;
      elaborate_error( "\"#define\", \"#include\", or \"#undef\" expected" );
    }
#line 6919 "parser.c"
    break;

  case 203: /* help_what_opt: error  */
#line 3094 "parser.y"
    {
      (yyval.name) = NULL;
      elaborate_error(
        "<command>, \"commands\", \"english\", or \"options\" expected"
      );
    }
#line 6930 "parser.c"
    break;

  case 207: /* preprocessor_command: '#' Y_P_elif  */
#line 3111 "parser.y"
    {
      UNSUPPORTED( &(yylsp[0]), "\"#elif\"" );
      PARSE_ABORT();
    }
#line 6939 "parser.c"
    break;

  case 208: /* preprocessor_command: '#' Y_P_elifdef  */
#line 3116 "parser.y"
    {
      UNSUPPORTED( &(yylsp[0]), "\"#elifdef\"" );
      PARSE_ABORT();
    }
#line 6948 "parser.c"
    break;

  case 209: /* preprocessor_command: '#' Y_P_elifndef  */
#line 3121 "parser.y"
    {
      UNSUPPORTED( &(yylsp[0]), "\"#elifdef\"" );
      PARSE_ABORT();
    }
#line 6957 "parser.c"
    break;

  case 210: /* preprocessor_command: '#' Y_P_else  */
#line 3126 "parser.y"
    {
      UNSUPPORTED( &(yylsp[0]), "\"#else\"" );
      PARSE_ABORT();
    }
#line 6966 "parser.c"
    break;

  case 211: /* preprocessor_command: '#' Y_P_embed  */
#line 3131 "parser.y"
    {
      UNSUPPORTED( &(yylsp[0]), "\"#embed\"" );
      PARSE_ABORT();
    }
#line 6975 "parser.c"
    break;

  case 212: /* preprocessor_command: '#' Y_P_error  */
#line 3136 "parser.y"
    {
      UNSUPPORTED( &(yylsp[0]), "\"#error\"" );
      PARSE_ABORT();
    }
#line 6984 "parser.c"
    break;

  case 213: /* preprocessor_command: '#' Y_P_if  */
#line 3141 "parser.y"
    {
      UNSUPPORTED( &(yylsp[0]), "\"#if\"" );
      PARSE_ABORT();
    }
#line 6993 "parser.c"
    break;

  case 214: /* preprocessor_command: '#' Y_P_ifdef  */
#line 3146 "parser.y"
    {
      UNSUPPORTED( &(yylsp[0]), "\"#ifdef\"" );
      PARSE_ABORT();
    }
#line 7002 "parser.c"
    break;

  case 215: /* preprocessor_command: '#' Y_P_ifndef  */
#line 3151 "parser.y"
    {
      UNSUPPORTED( &(yylsp[0]), "\"#ifndef\"" );
      PARSE_ABORT();
    }
#line 7011 "parser.c"
    break;

  case 216: /* preprocessor_command: '#' Y_P_line  */
#line 3156 "parser.y"
    {
      UNSUPPORTED( &(yylsp[0]), "\"#line\"" );
      PARSE_ABORT();
    }
#line 7020 "parser.c"
    break;

  case 217: /* preprocessor_command: '#' Y_P_pragma  */
#line 3161 "parser.y"
    {
      UNSUPPORTED( &(yylsp[0]), "\"#pragma\"" );
      PARSE_ABORT();
    }
#line 7029 "parser.c"
    break;

  case 218: /* preprocessor_command: '#' Y_P_warning  */
#line 3166 "parser.y"
    {
      UNSUPPORTED( &(yylsp[0]), "\"#warning\"" );
      PARSE_ABORT();
    }
#line 7038 "parser.c"
    break;

  case 219: /* preprocessor_command: '#' error  */
#line 3171 "parser.y"
    {
      elaborate_error( "\"#define\", \"#include\", or \"#undef\" expected" );
    }
#line 7046 "parser.c"
    break;

  case 220: /* p_define: Y_P_define name_exp p_paren_param_list_opt p_replace_list_opt  */
#line 3179 "parser.y"
    {
      DUMP_START();
      DUMP_PROD( "p_define",
                 "#define NAME p_paren_param_list_opt p_replace_list_opt" );
      DUMP_STR( "name", (yyvsp[-2].name) );
      DUMP_MACRO_PARAM_LIST( "p_paren_param_list_opt", (yyvsp[-1].p_param_list) );
      DUMP_MACRO_TOKEN_LIST( "p_replace_list_opt", (yyvsp[0].p_token_list) );

      c_typedef_t const *const tdef = c_typedef_find_name( (yyvsp[-2].name) );
      if ( tdef != NULL ) {
        if ( tdef->is_predefined ) {
          print_warning( &(yylsp[-2]),
            "\"%s\" is a predefined type since %s\n",
            (yyvsp[-2].name),
            c_lang_name( c_lang_oldest( tdef->lang_ids ) )
          );
        }
        else {
          print_warning( &(yylsp[-2]),
            "\"%s\" previously defined as type (\"",
            (yyvsp[-2].name)
          );
          print_type_decl( tdef, tdef->decl_flags, stderr );
          EPUTS( "\")\n" );
        }
      }

      p_macro_t *const macro =
        p_macro_define( (yyvsp[-2].name), &(yylsp[-2]), (yyvsp[-1].p_param_list), (yyvsp[0].p_token_list) );
      p_param_list_cleanup( (yyvsp[-1].p_param_list) );
      free( (yyvsp[-1].p_param_list) );
      p_token_list_cleanup( (yyvsp[0].p_token_list) );
      free( (yyvsp[0].p_token_list) );
      PARSE_ASSERT( macro != NULL );

      DUMP_MACRO( "macro", macro );
      DUMP_END();
    }
#line 7089 "parser.c"
    break;

  case 221: /* p_paren_param_list_opt: %empty  */
#line 3219 "parser.y"
                                  { (yyval.p_param_list) = NULL; }
#line 7095 "parser.c"
    break;

  case 222: /* p_paren_param_list_opt: '(' p_param_list_opt ')'  */
#line 3220 "parser.y"
                                  { (yyval.p_param_list) = (yyvsp[-1].p_param_list); }
#line 7101 "parser.c"
    break;

  case 223: /* p_param_list_opt: %empty  */
#line 3224 "parser.y"
    { //
      // Use an empty list to distinguish a macro with an empty parameter list
      // from one with no parameter list.
      //
      //      #define M   X       // no parameter list: use NULL
      //      #define F() #X      // empty parameter list: use empty list
      //
      (yyval.p_param_list) = MALLOC( p_param_list_t, 1 );
      slist_init( (yyval.p_param_list) );
    }
#line 7116 "parser.c"
    break;

  case 225: /* p_param_list: p_param_list comma_exp p_param  */
#line 3239 "parser.y"
    {
      DUMP_START();
      DUMP_PROD( "p_param_list", "p_param" );
      DUMP_MACRO_PARAM_LIST( "p_param_list", (yyvsp[-2].p_param_list) );
      DUMP_STR( "p_param", (yyvsp[0].p_param)->name );

      (yyval.p_param_list) = (yyvsp[-2].p_param_list);
      slist_push_back( (yyval.p_param_list), (yyvsp[0].p_param) );

      DUMP_MACRO_PARAM_LIST( "$$_list", (yyval.p_param_list) );
      DUMP_END();
    }
#line 7133 "parser.c"
    break;

  case 226: /* p_param_list: p_param  */
#line 3253 "parser.y"
    {
      DUMP_START();
      DUMP_PROD( "p_param_list", "p_param" );
      DUMP_STR( "p_param", (yyvsp[0].p_param)->name );

      (yyval.p_param_list) = MALLOC( p_param_list_t, 1 );
      slist_init( (yyval.p_param_list) );
      slist_push_back( (yyval.p_param_list), (yyvsp[0].p_param) );

      DUMP_MACRO_PARAM_LIST( "$$_list", (yyval.p_param_list) );
      DUMP_END();
    }
#line 7150 "parser.c"
    break;

  case 227: /* p_param: Y_NAME  */
#line 3269 "parser.y"
    {
      (yyval.p_param) = MALLOC( p_param_t, 1 );
      *(yyval.p_param) = (p_param_t){ .name = (yyvsp[0].name), .loc = (yylsp[0]) };
    }
#line 7159 "parser.c"
    break;

  case 228: /* p_param: "..."  */
#line 3274 "parser.y"
    {
      (yyval.p_param) = MALLOC( p_param_t, 1 );
      *(yyval.p_param) = (p_param_t){ .name = check_strdup( L_ellipsis ), .loc = (yylsp[0]) };
    }
#line 7168 "parser.c"
    break;

  case 229: /* p_param: error  */
#line 3279 "parser.y"
    {
      (yyval.p_param) = NULL;
      if ( OPT_LANG_IS( VARIADIC_MACROS ) )
        elaborate_error( "parameter name or \"...\" expected" );
      else
        elaborate_error( "parameter name expected" );
    }
#line 7180 "parser.c"
    break;

  case 230: /* p_replace_list_opt: %empty  */
#line 3289 "parser.y"
                                  { (yyval.p_token_list) = NULL; }
#line 7186 "parser.c"
    break;

  case 232: /* p_replace_list: p_replace_list p_replace_token  */
#line 3295 "parser.y"
    {
      (yyval.p_token_list) = (yyvsp[-1].p_token_list);
      slist_push_back( (yyval.p_token_list), (yyvsp[0].p_token) );
    }
#line 7195 "parser.c"
    break;

  case 233: /* p_replace_list: p_replace_token  */
#line 3301 "parser.y"
    {
      (yyval.p_token_list) = MALLOC( p_token_list_t, 1 );
      slist_init( (yyval.p_token_list) );
      slist_push_back( (yyval.p_token_list), (yyvsp[0].p_token) );
    }
#line 7205 "parser.c"
    break;

  case 234: /* p_replace_token: p_arg_token  */
#line 3310 "parser.y"
    {
      if ( p_token_is_punct( (yyvsp[0].p_token), '#' ) ) {
        //
        // A '#' macro argument token is an ordinary '#', but as a replacement
        // token, retroactively make it P_STRINGIFY.
        //
        (yyvsp[0].p_token)->kind = P_STRINGIFY;
      }
      (yyval.p_token) = (yyvsp[0].p_token);
    }
#line 7220 "parser.c"
    break;

  case 235: /* p_replace_token: '('  */
#line 3321 "parser.y"
    {
      (yyval.p_token) = p_token_new_loc( P_PUNCTUATOR, &(yylsp[0]), "(" );
    }
#line 7228 "parser.c"
    break;

  case 236: /* p_replace_token: ')'  */
#line 3325 "parser.y"
    {
      (yyval.p_token) = p_token_new_loc( P_PUNCTUATOR, &(yylsp[0]), ")" );
    }
#line 7236 "parser.c"
    break;

  case 237: /* p_replace_token: ','  */
#line 3329 "parser.y"
    {
      (yyval.p_token) = p_token_new_loc( P_PUNCTUATOR, &(yylsp[0]), "," );
    }
#line 7244 "parser.c"
    break;

  case 238: /* p_replace_token: "##"  */
#line 3333 "parser.y"
    {
      (yyval.p_token) = p_token_new_loc( P_CONCAT, &(yylsp[0]), /*literal=*/NULL );
    }
#line 7252 "parser.c"
    break;

  case 239: /* p_replace_token: Y_P___VA_ARGS__  */
#line 3337 "parser.y"
    {
      (yyval.p_token) = p_token_new_loc( P___VA_ARGS__, &(yylsp[0]), /*literal=*/NULL );
    }
#line 7260 "parser.c"
    break;

  case 240: /* p_replace_token: Y_P___VA_OPT__  */
#line 3341 "parser.y"
    {
      (yyval.p_token) = p_token_new_loc( P___VA_OPT__, &(yylsp[0]), /*literal=*/NULL );
    }
#line 7268 "parser.c"
    break;

  case 241: /* p_undef: Y_P_undef name_exp  */
#line 3348 "parser.y"
    {
      PARSE_ASSERT( p_macro_undef( (yyvsp[0].name), &(yylsp[0]) ) );
    }
#line 7276 "parser.c"
    break;

  case 242: /* quit_command: Y_quit  */
#line 3356 "parser.y"
                                  { cdecl_quit(); }
#line 7282 "parser.c"
    break;

  case 244: /* set_command: Y_set  */
#line 3369 "parser.y"
    {
      PARSE_ASSERT( set_option( NULL, NULL, NULL, NULL ) );
    }
#line 7290 "parser.c"
    break;

  case 248: /* set_option: Y_SET_OPTION set_option_value_opt  */
#line 3382 "parser.y"
    {
      bool const ok = set_option( (yyvsp[-1].name), &(yylsp[-1]), (yyvsp[0].str_val), &(yylsp[0]) );
      free( (yyvsp[-1].name) );
      free( (yyvsp[0].str_val) );
      PARSE_ASSERT( ok );
    }
#line 7301 "parser.c"
    break;

  case 249: /* set_option_value_opt: %empty  */
#line 3391 "parser.y"
                                  { (yyval.str_val) = NULL; }
#line 7307 "parser.c"
    break;

  case 250: /* set_option_value_opt: '=' Y_SET_OPTION  */
#line 3392 "parser.y"
                                  { (yyval.str_val) = (yyvsp[0].name); (yyloc) = (yylsp[0]); }
#line 7313 "parser.c"
    break;

  case 251: /* set_option_value_opt: '=' error  */
#line 3394 "parser.y"
    {
      (yyval.str_val) = NULL;
      elaborate_error( "option value expected" );
    }
#line 7322 "parser.c"
    break;

  case 252: /* show_command: Y_show any_typedef show_format_opt  */
#line 3404 "parser.y"
    {
      DUMP_START();
      DUMP_PROD( "show_command", "SHOW any_typedef show_format_opt" );
      DUMP_AST( "any_typedef__ast", (yyvsp[-1].tdef)->ast );
      DUMP_INT( "show_format_opt", (yyvsp[0].flags) );
      DUMP_END();

      show_type( (yyvsp[-1].tdef), (yyvsp[0].flags), stdout );
    }
#line 7336 "parser.c"
    break;

  case 253: /* show_command: Y_show any_typedef Y_as show_format_exp  */
#line 3415 "parser.y"
    {
      DUMP_START();
      DUMP_PROD( "show_command", "SHOW any_typedef AS show_format_exp" );
      DUMP_AST( "any_typedef__ast", (yyvsp[-2].tdef)->ast );
      DUMP_INT( "show_format_exp", (yyvsp[0].flags) );
      DUMP_END();

      show_type( (yyvsp[-2].tdef), (yyvsp[0].flags), stdout );
    }
#line 7350 "parser.c"
    break;

  case 254: /* show_command: Y_show show_types_opt glob_opt show_format_opt  */
#line 3426 "parser.y"
    {
      show_types( (yyvsp[-2].show), (yyvsp[-1].name), (yyvsp[0].flags), stdout );
      free( (yyvsp[-1].name) );
    }
#line 7359 "parser.c"
    break;

  case 255: /* show_command: Y_show show_types_opt glob_opt Y_as show_format_exp  */
#line 3432 "parser.y"
    {
      show_types( (yyvsp[-3].show), (yyvsp[-2].name), (yyvsp[0].flags), stdout );
      free( (yyvsp[-2].name) );
    }
#line 7368 "parser.c"
    break;

  case 256: /* show_command: Y_show Y_P_MACRO_NAME  */
#line 3438 "parser.y"
    {
      if ( !show_macro( (yyvsp[0].macro), stdout ) ) {
        c_lang_id_t const lang_ids = (*(yyvsp[0].macro)->dyn_fn)( /*ptoken=*/NULL );
        print_error( &(yylsp[0]),
          "\"%s\" not supported%s\n",
          (yyvsp[0].macro)->name, c_lang_which( lang_ids )
        );
        PARSE_ABORT();
      }
    }
#line 7383 "parser.c"
    break;

  case 257: /* show_command: Y_show show_types_opt Y_macros  */
#line 3450 "parser.y"
    {
      show_macros( (yyvsp[-1].show), stdout );
    }
#line 7391 "parser.c"
    break;

  case 258: /* show_command: Y_show Y_NAME  */
#line 3455 "parser.y"
    {
      print_error( &(yylsp[0]), "\"%s\": no such type or macro defined", (yyvsp[0].name) );
      print_suggestions( DYM_C_MACROS | DYM_C_TYPES, (yyvsp[0].name) );
      EPUTC( '\n' );
      free( (yyvsp[0].name) );
      PARSE_ABORT();
    }
#line 7403 "parser.c"
    break;

  case 259: /* show_command: Y_show error  */
#line 3464 "parser.y"
    {
      elaborate_error(
        "type name or \"all\", \"predefined\", or \"user\" expected"
      );
    }
#line 7413 "parser.c"
    break;

  case 260: /* show_format: Y_english  */
#line 3472 "parser.y"
                                  { (yyval.flags) = C_ENG_DECL; }
#line 7419 "parser.c"
    break;

  case 261: /* show_format: Y_typedef  */
#line 3473 "parser.y"
                                  { (yyval.flags) = C_GIB_TYPEDEF; }
#line 7425 "parser.c"
    break;

  case 262: /* show_format: Y_using  */
#line 3475 "parser.y"
    {
      if ( !IS_SUPPORTED( using_DECLS ) ) {
        print_error( &(yylsp[0]),
          "\"using\" not supported%s\n",
          C_LANG_WHICH( using_DECLS )
        );
        PARSE_ABORT();
      }
      (yyval.flags) = C_GIB_USING;
    }
#line 7440 "parser.c"
    break;

  case 264: /* show_format_exp: error  */
#line 3490 "parser.y"
    {
      if ( OPT_LANG_IS( using_DECLS ) )
        elaborate_error( "\"english\", \"typedef\", or \"using\" expected" );
      else
        elaborate_error( "\"english\" or \"typedef\" expected" );
    }
#line 7451 "parser.c"
    break;

  case 265: /* show_format_opt: %empty  */
#line 3499 "parser.y"
                                  { (yyval.flags) = 0/*as declared*/; }
#line 7457 "parser.c"
    break;

  case 267: /* show_types_opt: %empty  */
#line 3504 "parser.y"
                                  { (yyval.show) = CDECL_SHOW_USER_DEFINED; }
#line 7463 "parser.c"
    break;

  case 268: /* show_types_opt: Y_all predefined_or_user_types_opt  */
#line 3506 "parser.y"
    {
      (yyval.show) = (yyvsp[0].show) | CDECL_SHOW_OPT_IGNORE_LANG;
    }
#line 7471 "parser.c"
    break;

  case 269: /* show_types_opt: Y_predefined  */
#line 3509 "parser.y"
                                  { (yyval.show) = CDECL_SHOW_PREDEFINED; }
#line 7477 "parser.c"
    break;

  case 270: /* show_types_opt: Y_user  */
#line 3510 "parser.y"
                                  { (yyval.show) = CDECL_SHOW_USER_DEFINED; }
#line 7483 "parser.c"
    break;

  case 271: /* predefined_or_user_types_opt: %empty  */
#line 3515 "parser.y"
    {
      (yyval.show) = CDECL_SHOW_PREDEFINED | CDECL_SHOW_USER_DEFINED;
    }
#line 7491 "parser.c"
    break;

  case 272: /* predefined_or_user_types_opt: Y_predefined  */
#line 3518 "parser.y"
                                  { (yyval.show) = CDECL_SHOW_PREDEFINED; }
#line 7497 "parser.c"
    break;

  case 273: /* predefined_or_user_types_opt: Y_user  */
#line 3519 "parser.y"
                                  { (yyval.show) = CDECL_SHOW_USER_DEFINED; }
#line 7503 "parser.c"
    break;

  case 277: /* $@4: %empty  */
#line 3548 "parser.y"
    {
      ia_type_ast_push( (yyvsp[0].ast) );
    }
#line 7511 "parser.c"
    break;

  case 278: /* c_style_cast_expr_c: '(' type_c_ast $@4 cast_c_astp_opt rparen_exp sname_c_opt  */
#line 3552 "parser.y"
    {
      ia_type_ast_pop();

      DUMP_START();
      DUMP_PROD( "explain_command",
                 "EXPLAIN '(' type_c_ast cast_c_astp_opt ')' sname_c_opt" );
      DUMP_AST( "type_c_ast", (yyvsp[-4].ast) );
      DUMP_AST_PAIR( "cast_c_astp_opt", (yyvsp[-2].ast_pair) );
      DUMP_SNAME( "sname_c_opt", (yyvsp[0].sname) );

      c_ast_t *const cast_ast = c_ast_new_gc( K_CAST, &(yyloc) );
      cast_ast->sname = c_sname_move( &(yyvsp[0].sname) );
      cast_ast->cast.kind = C_CAST_C;
      cast_ast->cast.to_ast =
        c_ast_patch_placeholder( (yyvsp[-4].ast), (yyvsp[-2].ast_pair).ast );

      DUMP_AST( "$$_ast", cast_ast );
      DUMP_END();

      PARSE_ASSERT( c_ast_check( cast_ast ) );
      c_ast_english( cast_ast, C_ENG_DECL, stdout );
      PUTC( '\n' );
    }
#line 7539 "parser.c"
    break;

  case 279: /* c_style_cast_expr_c: '(' pc99_pointer_decl_list_c rparen_exp  */
#line 3586 "parser.y"
    {
      PARSE_ASSERT( c_ast_list_check( &(yyvsp[-1].ast_list) ) );
      c_ast_list_english( &(yyvsp[-1].ast_list), stdout );
    }
#line 7548 "parser.c"
    break;

  case 280: /* $@5: %empty  */
#line 3596 "parser.y"
    {
      ia_type_ast_push( (yyvsp[0].ast) );
    }
#line 7556 "parser.c"
    break;

  case 281: /* new_style_cast_expr_c: new_style_cast_c lt_exp type_c_ast $@5 cast_c_astp_opt gt_exp lparen_exp sname_c_exp rparen_exp  */
#line 3600 "parser.y"
    {
      ia_type_ast_pop();

      DUMP_START();
      DUMP_PROD( "explain_command",
                 "EXPLAIN new_style_cast_c"
                 "'<' type_c_ast cast_c_astp_opt '>' '(' sname ')'" );
      DUMP_STR( "new_style_cast_c", c_cast_english( (yyvsp[-8].cast_kind) ) );
      DUMP_AST( "type_c_ast", (yyvsp[-6].ast) );
      DUMP_AST_PAIR( "cast_c_astp_opt", (yyvsp[-4].ast_pair) );
      DUMP_SNAME( "sname_c_exp", (yyvsp[-1].sname) );

      c_ast_t *const cast_ast = c_ast_new_gc( K_CAST, &(yyloc) );
      cast_ast->sname = c_sname_move( &(yyvsp[-1].sname) );
      cast_ast->cast.kind = (yyvsp[-8].cast_kind);
      cast_ast->cast.to_ast =
        c_ast_patch_placeholder( (yyvsp[-6].ast), (yyvsp[-4].ast_pair).ast );

      DUMP_AST( "$$_ast", cast_ast );
      DUMP_END();

      PARSE_ASSERT( c_ast_check( cast_ast ) );
      c_ast_english( cast_ast, C_ENG_DECL, stdout );
      PUTC( '\n' );
    }
#line 7586 "parser.c"
    break;

  case 282: /* new_style_cast_c: Y_const_cast  */
#line 3628 "parser.y"
                                  { (yyval.cast_kind) = C_CAST_CONST;        }
#line 7592 "parser.c"
    break;

  case 283: /* new_style_cast_c: Y_dynamic_cast  */
#line 3629 "parser.y"
                                  { (yyval.cast_kind) = C_CAST_DYNAMIC;      }
#line 7598 "parser.c"
    break;

  case 284: /* new_style_cast_c: Y_reinterpret_cast  */
#line 3630 "parser.y"
                                  { (yyval.cast_kind) = C_CAST_REINTERPRET;  }
#line 7604 "parser.c"
    break;

  case 285: /* new_style_cast_c: Y_static_cast  */
#line 3631 "parser.y"
                                  { (yyval.cast_kind) = C_CAST_STATIC;       }
#line 7610 "parser.c"
    break;

  case 286: /* $@6: %empty  */
#line 3641 "parser.y"
                                  { in_attr.align = (yyvsp[0].align); }
#line 7616 "parser.c"
    break;

  case 287: /* $@7: %empty  */
#line 3642 "parser.y"
                                  { in_attr.is_typename = (yyvsp[0].flag); }
#line 7622 "parser.c"
    break;

  case 289: /* alignas_specifier_c: alignas lparen_exp uint_lit rparen_exp  */
#line 3648 "parser.y"
    {
      DUMP_START();
      DUMP_PROD( "alignas_specifier_c", "ALIGNAS '(' uint_lit ')'" );
      DUMP_INT( "uint_lit", (yyvsp[-1].uint_val) );

      (yyval.align).kind = C_ALIGNAS_BYTES;
      (yyval.align).loc = (yylsp[-3]);
      (yyval.align).bytes = (yyvsp[-1].uint_val);

      DUMP_ALIGN( "$$_align", (yyval.align) );
      DUMP_END();
    }
#line 7639 "parser.c"
    break;

  case 290: /* $@8: %empty  */
#line 3661 "parser.y"
                                            { ia_type_ast_push( (yyvsp[0].ast) ); }
#line 7645 "parser.c"
    break;

  case 291: /* alignas_specifier_c: alignas lparen_exp type_c_ast $@8 cast_c_astp_opt rparen_exp  */
#line 3663 "parser.y"
    {
      ia_type_ast_pop();

      DUMP_START();
      DUMP_PROD( "alignas_specifier_c",
                 "ALIGNAS '(' type_c_ast cast_c_astp_opt ')'" );
      DUMP_AST( "type_c_ast", (yyvsp[-3].ast) );
      DUMP_AST_PAIR( "cast_c_astp_opt", (yyvsp[-1].ast_pair) );

      (yyval.align).kind = C_ALIGNAS_TYPE;
      (yyval.align).loc = (yylsp[-5]);
      (yyval.align).type_ast = c_ast_patch_placeholder( (yyvsp[-3].ast), (yyvsp[-1].ast_pair).ast );

      DUMP_ALIGN( "$$_align", (yyval.align) );
      DUMP_END();
    }
#line 7666 "parser.c"
    break;

  case 292: /* alignas_specifier_c: alignas lparen_exp error ')'  */
#line 3681 "parser.y"
    {
      elaborate_error( "integer or type expected" );
    }
#line 7674 "parser.c"
    break;

  case 295: /* asm_declaration_c: Y_asm lparen_exp str_lit_exp rparen_exp  */
#line 3695 "parser.y"
    {
      free( (yyvsp[-1].str_val) );
      UNSUPPORTED( &(yylsp[-3]), "asm declarations" );
      PARSE_ABORT();
    }
#line 7684 "parser.c"
    break;

  case 299: /* $@9: %empty  */
#line 3715 "parser.y"
    {
      PARSE_ASSERT( is_nested_type_ok( &(yylsp[0]) ) );
      gibberish_to_english();           // see the comment in "explain"
    }
#line 7693 "parser.c"
    break;

  case 300: /* $@10: %empty  */
#line 3720 "parser.y"
    {
      c_type_t const *const cur_type =
        c_sname_local_type( &in_attr.scope_sname );
      if ( c_tid_is_any( cur_type->btids, TB_ANY_CLASS ) ) {
        char const *const cur_name = c_sname_local_name( &in_attr.scope_sname );
        char const *const mbr_name = c_sname_local_name( &(yyvsp[0].sname) );
        if ( strcmp( mbr_name, cur_name ) == 0 ) {
          print_error( &(yylsp[0]),
            "\"%s\": member has the same name as its enclosing %s\n",
            mbr_name, c_type_name_c( cur_type )
          );
          c_sname_cleanup( &(yyvsp[0].sname) );
          PARSE_ABORT();
        }
      }

      DUMP_START();
      DUMP_PROD( "class_struct_union_declaration_c",
                 "class_struct_union_btid any_sname_c_exp" );
      DUMP_SNAME( "in_attr__scope_sname", in_attr.scope_sname );
      DUMP_TID( "class_struct_union_btid", (yyvsp[-2].tid) );
      DUMP_SNAME( "any_sname_c_exp", (yyvsp[0].sname) );

      c_sname_append_sname( &in_attr.scope_sname, &(yyvsp[0].sname) );
      c_sname_set_local_type(
        &in_attr.scope_sname, &C_TYPE_LIT_B( (yyvsp[-2].tid) )
      );
      PARSE_ASSERT( c_sname_check( &in_attr.scope_sname, &(yylsp[0]) ) );

      c_ast_t *const csu_ast = c_ast_new_gc( K_CLASS_STRUCT_UNION, &(yylsp[0]) );
      csu_ast->sname = c_sname_dup( &in_attr.scope_sname );
      c_sname_append_name(
        &csu_ast->csu.csu_sname,
        check_strdup( c_sname_local_name( &in_attr.scope_sname ) )
      );
      csu_ast->type.btids = c_tid_check( (yyvsp[-2].tid), C_TPID_BASE );

      DUMP_AST( "$$_ast", csu_ast );
      DUMP_END();

      PARSE_ASSERT( define_type( csu_ast, C_GIB_TYPEDEF ) );
    }
#line 7740 "parser.c"
    break;

  case 302: /* $@11: %empty  */
#line 3770 "parser.y"
    {
      PARSE_ASSERT( is_nested_type_ok( &(yylsp[0]) ) );
      gibberish_to_english();           // see the comment in "explain"
    }
#line 7749 "parser.c"
    break;

  case 303: /* enum_declaration_c: enum_btids $@11 any_sname_c_exp enum_fixed_type_c_ast_opt  */
#line 3775 "parser.y"
    {
      DUMP_START();
      DUMP_PROD( "enum_declaration_c",
                 "enum_btids any_sname_c_exp enum_fixed_type_c_ast_opt" );
      DUMP_TID( "enum_btids", (yyvsp[-3].tid) );
      DUMP_SNAME( "any_sname_c_exp", (yyvsp[-1].sname) );
      DUMP_AST( "enum_fixed_type_c_ast_opt", (yyvsp[0].ast) );

      c_sname_t enum_sname = c_sname_dup( &in_attr.scope_sname );
      c_sname_append_sname( &enum_sname, &(yyvsp[-1].sname) );
      c_sname_set_local_type( &enum_sname, &C_TYPE_LIT_B( (yyvsp[-3].tid) ) );
      if ( !c_sname_check( &enum_sname, &(yylsp[-1]) ) ) {
        c_sname_cleanup( &enum_sname );
        PARSE_ABORT();
      }

      c_ast_t *const enum_ast = c_ast_new_gc( K_ENUM, &(yylsp[-1]) );
      enum_ast->sname = enum_sname;
      enum_ast->type.btids = c_tid_check( (yyvsp[-3].tid), C_TPID_BASE );
      c_ast_set_parent( (yyvsp[0].ast), enum_ast );
      c_sname_append_name(
        &enum_ast->enum_.enum_sname,
        check_strdup( c_sname_local_name( &enum_sname ) )
      );

      DUMP_AST( "$$_ast", enum_ast );
      DUMP_END();

      PARSE_ASSERT( define_type( enum_ast, C_GIB_TYPEDEF ) );
    }
#line 7784 "parser.c"
    break;

  case 304: /* $@12: %empty  */
#line 3812 "parser.y"
    {
      gibberish_to_english();           // see the comment in "explain"
    }
#line 7792 "parser.c"
    break;

  case 305: /* $@13: %empty  */
#line 3816 "parser.y"
    {
      DUMP_START();
      DUMP_PROD( "namespace_declaration_c",
                 "namespace_type namespace_sname_c_exp" );
      DUMP_SNAME( "in_attr__scope_sname", in_attr.scope_sname );
      DUMP_TYPE( "namespace_type", (yyvsp[-2].type) );
      DUMP_SNAME( "namespace_sname_c_exp", (yyvsp[0].sname) );

      //
      // Nested namespace declarations are supported only in C++17 and later.
      // (However, we always allow them in configuration files.)
      //
      // This check has to be done now in the parser rather than later in the
      // AST because the AST has no "memory" of how a namespace was
      // constructed.
      //
      if ( c_sname_count( &(yyvsp[0].sname) ) > 1 && !IS_SUPPORTED( NESTED_namespace ) ) {
        print_error( &(yylsp[0]),
          "nested namespace declarations not supported%s\n",
          C_LANG_WHICH( NESTED_namespace )
        );
        c_sname_cleanup( &(yyvsp[0].sname) );
        PARSE_ABORT();
      }

      //
      // The namespace type (plain namespace or inline namespace) has to be
      // split across the namespace sname: only the storage classes (for
      // TS_inline) has to be or'd with the first scope-type of the sname ...
      //
      c_type_t const *const sname_first_type = c_sname_first_type( &(yyvsp[0].sname) );
      c_sname_set_first_type(
        &(yyvsp[0].sname),
        &C_TYPE_LIT(
          sname_first_type->btids,
          sname_first_type->stids | (yyvsp[-2].type).stids,
          sname_first_type->atids
        )
      );
      //
      // ... and only the base types (for TB_namespace) has to be or'd with the
      // local scope type of the sname.
      //
      c_type_t const *const sname_local_type = c_sname_local_type( &(yyvsp[0].sname) );
      c_sname_set_local_type(
        &(yyvsp[0].sname),
        &C_TYPE_LIT(
          sname_local_type->btids | (yyvsp[-2].type).btids,
          sname_local_type->stids,
          sname_local_type->atids
        )
      );

      c_sname_append_sname( &in_attr.scope_sname, &(yyvsp[0].sname) );

      DUMP_SNAME( "$$_sname", (yyvsp[0].sname) );
      DUMP_END();

      PARSE_ASSERT( c_sname_check( &in_attr.scope_sname, &(yylsp[0]) ) );
    }
#line 7857 "parser.c"
    break;

  case 309: /* namespace_sname_c_exp: error  */
#line 3883 "parser.y"
    {
      c_sname_init( &(yyval.sname) );
      elaborate_error( "name expected" );
    }
#line 7866 "parser.c"
    break;

  case 310: /* namespace_sname_c: namespace_sname_c Y_COLON_COLON Y_NAME  */
#line 3896 "parser.y"
    {
      DUMP_START();
      DUMP_PROD( "namespace_sname_c", "sname_c '::' NAME" );
      DUMP_SNAME( "namespace_sname_c", (yyvsp[-2].sname) );
      DUMP_STR( "name", (yyvsp[0].name) );

      (yyval.sname) = (yyvsp[-2].sname);
      c_sname_append_name( &(yyval.sname), (yyvsp[0].name) );
      c_sname_set_local_type( &(yyval.sname), &C_TYPE_LIT_B( TB_namespace ) );

      DUMP_SNAME( "$$_sname", (yyval.sname) );
      DUMP_END();
    }
#line 7884 "parser.c"
    break;

  case 311: /* namespace_sname_c: namespace_sname_c Y_COLON_COLON any_typedef  */
#line 3911 "parser.y"
    {
      DUMP_START();
      DUMP_PROD( "namespace_sname_c", "namespace_sname_c '::' any_typedef" );
      DUMP_SNAME( "namespace_sname_c", (yyvsp[-2].sname) );
      DUMP_AST( "any_typedef__ast", (yyvsp[0].tdef)->ast );

      (yyval.sname) = (yyvsp[-2].sname);
      c_sname_set_local_type( &(yyval.sname), &C_TYPE_LIT_B( TB_namespace ) );
      c_sname_t temp_sname = c_sname_dup( &(yyvsp[0].tdef)->ast->sname );
      c_sname_append_sname( &(yyval.sname), &temp_sname );

      DUMP_SNAME( "$$_sname", (yyval.sname) );
      DUMP_END();
    }
#line 7903 "parser.c"
    break;

  case 312: /* namespace_sname_c: namespace_sname_c Y_COLON_COLON Y_inline name_exp  */
#line 3927 "parser.y"
    {
      DUMP_START();
      DUMP_PROD( "namespace_sname_c", "sname_c '::' NAME INLINE NAME" );
      DUMP_SNAME( "namespace_sname_c", (yyvsp[-3].sname) );
      DUMP_STR( "name", (yyvsp[0].name) );

      (yyval.sname) = (yyvsp[-3].sname);
      c_sname_append_name( &(yyval.sname), (yyvsp[0].name) );
      c_sname_set_local_type( &(yyval.sname),
        &C_TYPE_LIT( TB_namespace, (yyvsp[-1].tid), TA_NONE )
      );

      DUMP_SNAME( "$$_sname", (yyval.sname) );
      DUMP_END();
    }
#line 7923 "parser.c"
    break;

  case 313: /* namespace_sname_c: Y_NAME  */
#line 3944 "parser.y"
    {
      DUMP_START();
      DUMP_PROD( "namespace_sname_c", "NAME" );
      DUMP_STR( "NAME", (yyvsp[0].name) );

      c_sname_init_name( &(yyval.sname), (yyvsp[0].name) );
      c_sname_set_local_type( &(yyval.sname), &C_TYPE_LIT_B( TB_namespace ) );

      DUMP_SNAME( "$$_sname", (yyval.sname) );
      DUMP_END();
    }
#line 7939 "parser.c"
    break;

  case 314: /* namespace_typedef_sname_c: namespace_typedef_sname_c Y_COLON_COLON sname_c  */
#line 3964 "parser.y"
    {
      DUMP_START();
      DUMP_PROD( "namespace_typedef_sname_c",
                 "namespace_typedef_sname_c '::' sname_c" );
      DUMP_SNAME( "namespace_typedef_sname_c", (yyvsp[-2].sname) );
      DUMP_SNAME( "sname_c", (yyvsp[0].sname) );

      (yyval.sname) = (yyvsp[-2].sname);
      c_sname_append_sname( &(yyval.sname), &(yyvsp[0].sname) );

      DUMP_SNAME( "$$_sname", (yyval.sname) );
      DUMP_END();
    }
#line 7957 "parser.c"
    break;

  case 315: /* namespace_typedef_sname_c: namespace_typedef_sname_c Y_COLON_COLON any_typedef  */
#line 3979 "parser.y"
    {
      DUMP_START();
      DUMP_PROD( "namespace_typedef_sname_c",
                 "namespace_typedef_sname_c '::' any_typedef" );
      DUMP_SNAME( "namespace_typedef_sname_c", (yyvsp[-2].sname) );
      DUMP_AST( "any_typedef__ast", (yyvsp[0].tdef)->ast );

      (yyval.sname) = (yyvsp[-2].sname);
      c_sname_set_local_type( &(yyval.sname), c_sname_local_type( &(yyvsp[0].tdef)->ast->sname ) );
      c_sname_t temp_sname = c_sname_dup( &(yyvsp[0].tdef)->ast->sname );
      c_sname_append_sname( &(yyval.sname), &temp_sname );

      DUMP_SNAME( "$$_sname", (yyval.sname) );
      DUMP_END();
    }
#line 7977 "parser.c"
    break;

  case 316: /* namespace_typedef_sname_c: namespace_typedef_sname_c Y_COLON_COLON Y_inline name_exp  */
#line 3997 "parser.y"
    {
      DUMP_START();
      DUMP_PROD( "namespace_typedef_sname_c",
                 "namespace_typedef_sname_c '::' INLINE NAME" );
      DUMP_SNAME( "namespace_typedef_sname_c", (yyvsp[-3].sname) );
      DUMP_STR( "name", (yyvsp[0].name) );

      (yyval.sname) = (yyvsp[-3].sname);
      c_sname_append_name( &(yyval.sname), (yyvsp[0].name) );
      c_sname_set_local_type( &(yyval.sname),
        &C_TYPE_LIT( TB_namespace, (yyvsp[-1].tid), TA_NONE )
      );

      DUMP_SNAME( "$$_sname", (yyval.sname) );
      DUMP_END();
    }
#line 7998 "parser.c"
    break;

  case 317: /* namespace_typedef_sname_c: any_typedef  */
#line 4014 "parser.y"
                                  { (yyval.sname) = c_sname_dup( &(yyvsp[0].tdef)->ast->sname ); }
#line 8004 "parser.c"
    break;

  case 319: /* brace_in_scope_declaration_c_exp: error  */
#line 4020 "parser.y"
    {
      punct_expected( '{' );
    }
#line 8012 "parser.c"
    break;

  case 327: /* in_scope_declaration_c_exp: error  */
#line 4040 "parser.y"
    {
      elaborate_error( "declaration expected" );
    }
#line 8020 "parser.c"
    break;

  case 328: /* lambda_declaration_c: '[' capture_decl_list_c_opt ']' lambda_param_c_ast_list_opt storage_class_subset_english_type_opt lambda_return_type_c_ast_opt  */
#line 4052 "parser.y"
    {
      DUMP_START();
      DUMP_PROD( "lambda_declaration_c",
                 "'[' capture_decl_list_c_opt ']' "
                 "lambda_param_c_ast_list_opt "
                 "lambda_return_type_c_ast_opt" );
      DUMP_AST_LIST( "capture_decl_list_c_opt", (yyvsp[-4].ast_list) );
      DUMP_AST_LIST( "lambda_param_c_ast_list_opt", (yyvsp[-2].ast_list) );
      DUMP_TYPE( "storage_class_subset_english_type_opt", (yyvsp[-1].type) );
      DUMP_AST( "lambda_return_type_c_ast_opt", (yyvsp[0].ast) );

      c_ast_t *const lambda_ast = c_ast_new_gc( K_LAMBDA, &(yyloc) );
      lambda_ast->type = (yyvsp[-1].type);
      c_ast_list_set_param_of( &(yyvsp[-4].ast_list), lambda_ast );
      lambda_ast->lambda.capture_ast_list = slist_move( &(yyvsp[-4].ast_list) );
      c_ast_list_set_param_of( &(yyvsp[-2].ast_list), lambda_ast );
      lambda_ast->lambda.param_ast_list = slist_move( &(yyvsp[-2].ast_list) );
      c_ast_set_parent( (yyvsp[0].ast), lambda_ast );

      DUMP_AST( "$$_ast", lambda_ast );
      DUMP_END();

      PARSE_ASSERT( c_ast_check( lambda_ast ) );
      c_ast_english( lambda_ast, C_ENG_DECL, stdout );
      PUTC( '\n' );
    }
#line 8051 "parser.c"
    break;

  case 329: /* capture_decl_list_c_opt: %empty  */
#line 4081 "parser.y"
                                  { slist_init( &(yyval.ast_list) ); }
#line 8057 "parser.c"
    break;

  case 331: /* capture_decl_list_c: capture_decl_list_c comma_exp capture_decl_c_ast  */
#line 4088 "parser.y"
    {
      DUMP_START();
      DUMP_PROD( "capture_decl_list_c",
                 "capture_decl_list_c ',' "
                 "capture_decl_c_ast" );
      DUMP_AST_LIST( "capture_decl_list_c", (yyvsp[-2].ast_list) );
      DUMP_AST( "capture_decl_c_ast", (yyvsp[0].ast) );

      (yyval.ast_list) = (yyvsp[-2].ast_list);
      slist_push_back( &(yyval.ast_list), (yyvsp[0].ast) );

      DUMP_AST_LIST( "$$_ast_list", (yyval.ast_list) );
      DUMP_END();
    }
#line 8076 "parser.c"
    break;

  case 332: /* capture_decl_list_c: capture_decl_c_ast  */
#line 4104 "parser.y"
    {
      DUMP_START();
      DUMP_PROD( "capture_decl_list_c",
                 "capture_decl_c_ast" );
      DUMP_AST( "capture_decl_c_ast", (yyvsp[0].ast) );

      slist_init( &(yyval.ast_list) );
      slist_push_back( &(yyval.ast_list), (yyvsp[0].ast) );

      DUMP_AST_LIST( "$$_ast_list", (yyval.ast_list) );
      DUMP_END();
    }
#line 8093 "parser.c"
    break;

  case 333: /* capture_decl_c_ast: '&'  */
#line 4120 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_CAPTURE, &(yyloc) );
      (yyval.ast)->capture.kind = C_CAPTURE_REFERENCE;
    }
#line 8102 "parser.c"
    break;

  case 334: /* capture_decl_c_ast: '&' Y_NAME  */
#line 4125 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_CAPTURE, &(yyloc) );
      c_sname_append_name( &(yyval.ast)->sname, (yyvsp[0].name) );
      (yyval.ast)->capture.kind = C_CAPTURE_REFERENCE;
    }
#line 8112 "parser.c"
    break;

  case 335: /* capture_decl_c_ast: '='  */
#line 4131 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_CAPTURE, &(yyloc) );
      (yyval.ast)->capture.kind = C_CAPTURE_COPY;
    }
#line 8121 "parser.c"
    break;

  case 336: /* capture_decl_c_ast: Y_NAME  */
#line 4136 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_CAPTURE, &(yyloc) );
      c_sname_append_name( &(yyval.ast)->sname, (yyvsp[0].name) );
    }
#line 8130 "parser.c"
    break;

  case 337: /* capture_decl_c_ast: Y_this  */
#line 4141 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_CAPTURE, &(yyloc) );
      (yyval.ast)->capture.kind = C_CAPTURE_THIS;
    }
#line 8139 "parser.c"
    break;

  case 338: /* capture_decl_c_ast: '*' this_exp  */
#line 4146 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_CAPTURE, &(yyloc) );
      (yyval.ast)->capture.kind = C_CAPTURE_STAR_THIS;
    }
#line 8148 "parser.c"
    break;

  case 339: /* lambda_param_c_ast_list_opt: %empty  */
#line 4153 "parser.y"
                                  { slist_init( &(yyval.ast_list) ); }
#line 8154 "parser.c"
    break;

  case 340: /* lambda_param_c_ast_list_opt: '(' param_c_ast_list_opt ')'  */
#line 4154 "parser.y"
                                  { (yyval.ast_list) = (yyvsp[-1].ast_list); }
#line 8160 "parser.c"
    break;

  case 341: /* lambda_return_type_c_ast_opt: %empty  */
#line 4158 "parser.y"
                                  { (yyval.ast) = NULL; }
#line 8166 "parser.c"
    break;

  case 342: /* $@14: %empty  */
#line 4159 "parser.y"
                                         { ia_type_ast_push( (yyvsp[0].ast) ); }
#line 8172 "parser.c"
    break;

  case 343: /* lambda_return_type_c_ast_opt: Y_MINUS_GREATER type_c_ast $@14 cast_c_astp_opt  */
#line 4161 "parser.y"
    {
      ia_type_ast_pop();

      DUMP_START();
      DUMP_PROD( "lambda_return_type_c_ast_opt",
                 "'->' type_c_ast cast_c_astp_opt" );
      DUMP_AST( "type_c_ast", (yyvsp[-2].ast) );
      DUMP_AST_PAIR( "cast_c_astp_opt", (yyvsp[0].ast_pair) );

      (yyval.ast) = IF_ELSE( (yyvsp[0].ast_pair).ast, (yyvsp[-2].ast) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 8191 "parser.c"
    break;

  case 344: /* template_declaration_c: Y_template  */
#line 4181 "parser.y"
    {
      UNSUPPORTED( &(yylsp[0]), "template declarations" );
      PARSE_ABORT();
    }
#line 8200 "parser.c"
    break;

  case 345: /* $@15: %empty  */
#line 4190 "parser.y"
                         { ia_type_ast_push( (yyvsp[0].ast) ); }
#line 8206 "parser.c"
    break;

  case 346: /* typed_declaration_c: type_c_ast $@15 decl_list_c_opt  */
#line 4191 "parser.y"
    {
      ia_type_ast_pop();
    }
#line 8214 "parser.c"
    break;

  case 347: /* $@16: %empty  */
#line 4200 "parser.y"
    {
      PARSE_ASSERT( is_nested_type_ok( &(yylsp[-1]) ) );
      in_attr.is_typename = (yyvsp[0].flag);
      gibberish_to_english();           // see the comment in "explain"
    }
#line 8224 "parser.c"
    break;

  case 348: /* $@17: %empty  */
#line 4206 "parser.y"
    {
      PARSE_ASSERT( !in_attr.is_typename || c_ast_is_typename_ok( (yyvsp[0].ast) ) );
      // see the comment in "define_command" about TS_typedef
      PARSE_ASSERT(
        c_type_add_tid( &(yyvsp[0].ast)->type, TS_typedef, &(yylsp[0]) )
      );
      ia_type_ast_push( (yyvsp[0].ast) );
    }
#line 8237 "parser.c"
    break;

  case 349: /* typedef_declaration_c: Y_typedef typename_flag_opt $@16 type_c_ast $@17 typedef_decl_list_c  */
#line 4215 "parser.y"
    {
      ia_type_ast_pop();
    }
#line 8245 "parser.c"
    break;

  case 352: /* typedef_decl_c: decl_c_astp  */
#line 4228 "parser.y"
    {
      c_ast_t *const type_ast = ia_type_ast_peek();

      DUMP_START();
      DUMP_PROD( "typedef_decl_c", "decl_c_astp" );
      DUMP_SNAME( "in_attr__scope_sname", in_attr.scope_sname );
      DUMP_AST( "in_attr__type_c_ast", type_ast );
      DUMP_AST_PAIR( "decl_c_astp", (yyvsp[0].ast_pair) );

      c_ast_t *const decl_ast = (yyvsp[0].ast_pair).ast;
      c_ast_t *typedef_ast;
      c_sname_t temp_sname;

      if ( decl_ast->kind == K_TYPEDEF ) {
        //
        // This is for either of the following cases:
        //
        //      typedef int int32_t;
        //      typedef int32_t int_least32_t;
        //
        // that is: any type name followed by an existing typedef name.
        //
        typedef_ast = type_ast;
        if ( c_sname_empty( &typedef_ast->sname ) )
          typedef_ast->sname = c_sname_dup( &decl_ast->tdef.for_ast->sname );
      }
      else {
        //
        // This is for either of the following cases:
        //
        //      typedef int foo;
        //      typedef int32_t foo;
        //
        // that is: any type name followed by a new name.
        //
        typedef_ast = c_ast_patch_placeholder( type_ast, decl_ast );
        temp_sname = c_ast_move_sname( decl_ast );
        c_sname_set( &typedef_ast->sname, &temp_sname );
      }

      PARSE_ASSERT( c_ast_check( typedef_ast ) );
      // see the comment in "define_command" about TS_typedef
      PJL_IGNORE_RV( c_ast_take_type_any( typedef_ast, &T_TS_typedef ) );

      if ( c_sname_count( &typedef_ast->sname ) > 1 ) {
        print_error( &(yylsp[0]),
          "typedef names can not be scoped; "
          "use: namespace %s { typedef ... }\n",
          c_sname_scope_name( &typedef_ast->sname )
        );
        PARSE_ABORT();
      }

      temp_sname = c_sname_dup( &in_attr.scope_sname );
      c_sname_prepend_sname( &typedef_ast->sname, &temp_sname );

      DUMP_AST( "$$_ast", typedef_ast );
      DUMP_END();

      PARSE_ASSERT( define_type( typedef_ast, C_GIB_TYPEDEF  ) );
    }
#line 8311 "parser.c"
    break;

  case 354: /* typedef_decl_c_exp: error  */
#line 4294 "parser.y"
    {
      elaborate_error( "type expected" );
    }
#line 8319 "parser.c"
    break;

  case 355: /* user_defined_conversion_declaration_c: user_defined_conversion_decl_c_astp  */
#line 4303 "parser.y"
    {
      DUMP_START();
      DUMP_PROD( "user_defined_conversion_declaration_c",
                 "user_defined_conversion_decl_c_astp" );
      DUMP_AST_PAIR( "user_defined_conversion_declaration_c", (yyvsp[0].ast_pair) );
      DUMP_END();

      PARSE_ASSERT( c_ast_check( (yyvsp[0].ast_pair).ast ) );
      c_ast_english( (yyvsp[0].ast_pair).ast, C_ENG_DECL, stdout );
      PUTC( '\n' );
    }
#line 8335 "parser.c"
    break;

  case 356: /* using_declaration_c: using_decl_c_ast  */
#line 4320 "parser.y"
    {
      // see the comment in "define_command" about TS_typedef
      PJL_IGNORE_RV( c_ast_take_type_any( (yyvsp[0].ast), &T_TS_typedef ) );

      PARSE_ASSERT( define_type( (yyvsp[0].ast), C_GIB_USING ) );
    }
#line 8346 "parser.c"
    break;

  case 357: /* $@18: %empty  */
#line 4330 "parser.y"
    { //
      // Using declarations are supported only in C++11 and later.  (However,
      // we always allow them in configuration files.)
      //
      // This check has to be done now in the parser rather than later in the
      // AST because using declarations are treated like typedef declarations
      // and the AST has no "memory" that such a declaration was a using
      // declaration.
      //
      if ( !IS_SUPPORTED( using_DECLS ) ) {
        print_error( &(yylsp[0]),
          "\"using\" not supported%s\n",
          C_LANG_WHICH( using_DECLS )
        );
        PARSE_ABORT();
      }

      gibberish_to_english();           // see the comment in "explain"
    }
#line 8370 "parser.c"
    break;

  case 358: /* $@19: %empty  */
#line 4351 "parser.y"
    {
      // see the comment in "define_command" about TS_typedef
      if ( !c_type_add_tid( &(yyvsp[0].ast)->type, TS_typedef, &(yylsp[0]) ) ) {
        free( (yyvsp[-3].name) );
        PARSE_ABORT();
      }
      ia_type_ast_push( (yyvsp[0].ast) );
    }
#line 8383 "parser.c"
    break;

  case 359: /* using_decl_c_ast: Y_using $@18 any_name_exp attribute_specifier_list_c_atid_opt equals_exp type_c_ast $@19 cast_c_astp_opt  */
#line 4360 "parser.y"
    {
      ia_type_ast_pop();

      DUMP_START();
      DUMP_PROD( "using_decl_c_ast",
                 "USING any_name_exp attribute_specifier_list_c_atid_opt '=' "
                 "type_c_ast cast_c_astp_opt" );
      DUMP_SNAME( "in_attr__scope_sname", in_attr.scope_sname );
      DUMP_STR( "any_name_exp", (yyvsp[-5].name) );
      DUMP_TID( "attribute_specifier_list_c_atid_opt", (yyvsp[-4].tid) );
      DUMP_AST( "type_c_ast", (yyvsp[-2].ast) );
      DUMP_AST_PAIR( "cast_c_astp_opt", (yyvsp[0].ast_pair) );

      c_ast_t *const cast_ast = (yyvsp[0].ast_pair).ast;

      //
      // Ensure the type on the right-hand side doesn't have a name, e.g.:
      //
      //      using U = void (*F)();    // error
      //
      // This check has to be done now in the parser rather than later in the
      // AST because the patched AST loses the name.
      //
      c_sname_t const *const sname = c_ast_find_name( cast_ast, C_VISIT_DOWN );
      if ( sname != NULL ) {
        print_error( &cast_ast->loc, "\"using\" type can not have a name\n" );
        FREE( (yyvsp[-5].name) );
        PARSE_ABORT();
      }

      c_sname_t temp_sname = c_sname_dup( &in_attr.scope_sname );
      c_sname_append_name( &temp_sname, (yyvsp[-5].name) );

      (yyval.ast) = c_ast_patch_placeholder( (yyvsp[-2].ast), cast_ast );
      c_sname_set( &(yyval.ast)->sname, &temp_sname );
      (yyval.ast)->type.atids = c_tid_check( (yyvsp[-4].tid), C_TPID_ATTR );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();

      PARSE_ASSERT( c_ast_check( (yyval.ast) ) );
    }
#line 8430 "parser.c"
    break;

  case 360: /* decl_list_c_opt: %empty  */
#line 4416 "parser.y"
    {
      c_ast_t *const type_ast = ia_type_ast_peek();

      DUMP_START();
      DUMP_PROD( "decl_list_c_opt", "<empty>" );
      DUMP_AST( "in_attr__type_c_ast", type_ast );

      if ( (type_ast->kind & K_ANY_ECSU) == 0 ) {
        //
        // The declaration is a non-ECSU type, e.g.:
        //
        //      int
        //
        c_loc_t const loc = lexer_loc();
        print_error( &loc, "declaration expected" );
        print_error_token_is_a( lexer_printable_token() );
        EPUTC( '\n' );
        PARSE_ABORT();
      }

      if ( in_attr.align.kind != C_ALIGNAS_NONE ) {
        print_error( &in_attr.align.loc,
          "\"%s\" invalid here\n",
          alignas_name()
        );
        PARSE_ABORT();
      }

      c_sname_t const *const ecsu_sname = &type_ast->csu.csu_sname;
      assert( !c_sname_empty( ecsu_sname ) );

      if ( c_sname_count( ecsu_sname ) > 1 ) {
        print_error( &type_ast->loc,
          "forward declaration can not have a scoped name\n"
        );
        PARSE_ABORT();
      }

      c_sname_t temp_sname = c_sname_dup( ecsu_sname );
      c_sname_set( &type_ast->sname, &temp_sname );

      DUMP_AST( "$$_ast", type_ast );
      DUMP_END();

      PARSE_ASSERT( c_ast_check( type_ast ) );
      c_typedef_english( &C_TYPEDEF_LIT( type_ast, C_ENG_DECL ), stdout );
      PUTC( '\n' );
    }
#line 8483 "parser.c"
    break;

  case 361: /* decl_list_c_opt: decl_list_c  */
#line 4466 "parser.y"
    {
      PARSE_ASSERT( c_ast_list_check( &(yyvsp[0].ast_list) ) );
      c_ast_list_english( &(yyvsp[0].ast_list), stdout );
    }
#line 8492 "parser.c"
    break;

  case 362: /* decl_list_c: decl_list_c ',' decl_c_exp  */
#line 4474 "parser.y"
    {
      (yyval.ast_list) = (yyvsp[-2].ast_list);
      slist_push_back( &(yyval.ast_list), (yyvsp[0].ast) );
    }
#line 8501 "parser.c"
    break;

  case 363: /* decl_list_c: decl_c  */
#line 4479 "parser.y"
    {
      slist_init( &(yyval.ast_list) );
      slist_push_back( &(yyval.ast_list), (yyvsp[0].ast) );
    }
#line 8510 "parser.c"
    break;

  case 364: /* decl_c: decl_c_astp  */
#line 4488 "parser.y"
    {
      c_ast_t *const type_ast = ia_type_ast_peek();

      DUMP_START();
      DUMP_PROD( "decl_c", "decl_c_astp" );
      switch ( in_attr.align.kind ) {
        case C_ALIGNAS_NONE:
          break;
        case C_ALIGNAS_BYTES:
          DUMP_INT( "in_attr__alignas_bytes", in_attr.align.bytes );
          break;
        case C_ALIGNAS_TYPE:
          DUMP_AST( "in_attr__alignas_type_ast", in_attr.align.type_ast );
          break;
      } // switch
      DUMP_BOOL( "in_attr__typename_flag_opt", in_attr.is_typename );
      DUMP_AST( "in_attr__type_c_ast", type_ast );
      DUMP_AST_PAIR( "decl_c_astp", (yyvsp[0].ast_pair) );

      (yyval.ast) = join_type_decl( ia_type_spec_ast( type_ast ), (yyvsp[0].ast_pair).ast );
      PARSE_ASSERT( (yyval.ast) != NULL );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 8540 "parser.c"
    break;

  case 366: /* decl_c_exp: error  */
#line 4518 "parser.y"
    {
      elaborate_error( "declaration expected" );
    }
#line 8548 "parser.c"
    break;

  case 371: /* decl_c_astp: msc_calling_convention_atid msc_calling_convention_c_astp  */
#line 4529 "parser.y"
    {
      (yyval.ast_pair) = (yyvsp[0].ast_pair);
      (yyval.ast_pair).ast->loc = (yyloc);
      (yyval.ast_pair).ast->type.atids |= (yyvsp[-1].tid);
    }
#line 8558 "parser.c"
    break;

  case 379: /* decl2_c_astp: sname_c_ast gnu_attribute_specifier_list_c_opt  */
#line 4548 "parser.y"
    {
      (yyval.ast_pair) = (c_ast_pair_t){ (yyvsp[-1].ast), .target_ast = NULL };
    }
#line 8566 "parser.c"
    break;

  case 380: /* decl2_c_astp: typedef_type_decl_c_ast  */
#line 4552 "parser.y"
    {
      (yyval.ast_pair) = (c_ast_pair_t){ (yyvsp[0].ast), .target_ast = NULL };
    }
#line 8574 "parser.c"
    break;

  case 383: /* array_decl_c_astp: decl2_c_astp array_size_c_ast gnu_attribute_specifier_list_c_opt  */
#line 4565 "parser.y"
    {
      c_ast_t *const type_ast = ia_type_ast_peek();

      DUMP_START();
      DUMP_PROD( "array_decl_c_astp", "decl2_c_astp array_size_c_ast" );
      DUMP_AST( "in_attr__type_c_ast", type_ast );
      DUMP_AST_PAIR( "decl2_c_astp", (yyvsp[-2].ast_pair) );
      DUMP_AST( "array_size_c_ast", (yyvsp[-1].ast) );

      c_ast_set_parent(
        c_ast_new_gc( K_PLACEHOLDER, &(yylsp[-2]) ), (yyvsp[-1].ast)
      );

      c_ast_t *const of_ast = ia_type_spec_ast( type_ast );
      if ( (yyvsp[-2].ast_pair).target_ast != NULL ) {
        // array-of or function-like-ret type
        (yyval.ast_pair) = (c_ast_pair_t){
          (yyvsp[-2].ast_pair).ast,
          c_ast_add_array( (yyvsp[-2].ast_pair).target_ast, (yyvsp[-1].ast), of_ast )
        };
      }
      else {
        (yyval.ast_pair) = (c_ast_pair_t){
          c_ast_add_array( (yyvsp[-2].ast_pair).ast, (yyvsp[-1].ast), of_ast ),
          .target_ast = NULL
        };
      }

      DUMP_AST_PAIR( "$$_astp", (yyval.ast_pair) );
      DUMP_END();
    }
#line 8610 "parser.c"
    break;

  case 384: /* array_size_c_ast: '[' rbracket_exp  */
#line 4600 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_ARRAY, &(yyloc) );
      (yyval.ast)->array.kind = C_ARRAY_EMPTY_SIZE;
    }
#line 8619 "parser.c"
    break;

  case 385: /* array_size_c_ast: '[' uint_lit rbracket_exp  */
#line 4605 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_ARRAY, &(yyloc) );
      (yyval.ast)->array.kind = C_ARRAY_INT_SIZE;
      (yyval.ast)->array.size_int = (yyvsp[-1].uint_val);
    }
#line 8629 "parser.c"
    break;

  case 386: /* array_size_c_ast: '[' Y_NAME rbracket_exp  */
#line 4611 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_ARRAY, &(yyloc) );
      (yyval.ast)->array.kind = C_ARRAY_NAMED_SIZE;
      (yyval.ast)->array.size_name = (yyvsp[-1].name);
    }
#line 8639 "parser.c"
    break;

  case 387: /* array_size_c_ast: '[' type_qualifier_list_c_stid rbracket_exp  */
#line 4617 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_ARRAY, &(yyloc) );
      (yyval.ast)->type.stids = c_tid_check( (yyvsp[-1].tid), C_TPID_STORE );
      (yyval.ast)->array.kind = C_ARRAY_EMPTY_SIZE;
    }
#line 8649 "parser.c"
    break;

  case 388: /* array_size_c_ast: '[' type_qualifier_list_c_stid static_stid_opt uint_lit rbracket_exp  */
#line 4624 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_ARRAY, &(yyloc) );
      (yyval.ast)->type.stids = c_tid_check( (yyvsp[-3].tid) | (yyvsp[-2].tid), C_TPID_STORE );
      (yyval.ast)->array.kind = C_ARRAY_INT_SIZE;
      (yyval.ast)->array.size_int = (yyvsp[-1].uint_val);
    }
#line 8660 "parser.c"
    break;

  case 389: /* array_size_c_ast: '[' type_qualifier_list_c_stid static_stid_opt Y_NAME rbracket_exp  */
#line 4632 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_ARRAY, &(yyloc) );
      (yyval.ast)->type.stids = c_tid_check( (yyvsp[-3].tid) | (yyvsp[-2].tid), C_TPID_STORE );
      (yyval.ast)->array.kind = C_ARRAY_NAMED_SIZE;
      (yyval.ast)->array.size_name = (yyvsp[-1].name);
    }
#line 8671 "parser.c"
    break;

  case 390: /* array_size_c_ast: '[' type_qualifier_list_c_stid_opt '*' rbracket_exp  */
#line 4639 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_ARRAY, &(yyloc) );
      (yyval.ast)->type.stids = c_tid_check( (yyvsp[-2].tid), C_TPID_STORE );
      (yyval.ast)->array.kind = C_ARRAY_VLA_STAR;
    }
#line 8681 "parser.c"
    break;

  case 391: /* array_size_c_ast: '[' Y_static type_qualifier_list_c_stid_opt uint_lit rbracket_exp  */
#line 4646 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_ARRAY, &(yyloc) );
      (yyval.ast)->type.stids =
        c_tid_check( TS_NON_EMPTY_ARRAY | (yyvsp[-2].tid), C_TPID_STORE );
      (yyval.ast)->array.kind = C_ARRAY_INT_SIZE;
      (yyval.ast)->array.size_int = (yyvsp[-1].uint_val);
    }
#line 8693 "parser.c"
    break;

  case 392: /* array_size_c_ast: '[' Y_static type_qualifier_list_c_stid_opt Y_NAME rbracket_exp  */
#line 4655 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_ARRAY, &(yyloc) );
      (yyval.ast)->type.stids =
        c_tid_check( TS_NON_EMPTY_ARRAY | (yyvsp[-2].tid), C_TPID_STORE );
      (yyval.ast)->array.kind = C_ARRAY_NAMED_SIZE;
      (yyval.ast)->array.size_name = (yyvsp[-1].name);
    }
#line 8705 "parser.c"
    break;

  case 393: /* array_size_c_ast: '[' error ']'  */
#line 4663 "parser.y"
    {
      elaborate_error( "array size expected" );
    }
#line 8713 "parser.c"
    break;

  case 394: /* $@20: %empty  */
#line 4673 "parser.y"
    { //
      // A block AST has to be the type inherited attribute for decl_c_astp so
      // we have to create it here.
      //
      ia_type_ast_push( c_ast_new_gc( K_APPLE_BLOCK, &(yyloc) ) );
    }
#line 8724 "parser.c"
    break;

  case 395: /* block_decl_c_astp: '(' '^' $@20 type_qualifier_list_c_stid_opt decl_c_astp rparen_exp lparen_exp param_c_ast_list_opt ')' gnu_attribute_specifier_list_c_opt  */
#line 4682 "parser.y"
    {
      c_ast_t *const block_ast = ia_type_ast_pop();
      c_ast_t *const type_ast = ia_type_ast_peek();

      DUMP_START();
      DUMP_PROD( "block_decl_c_astp",
                 "'(' '^' type_qualifier_list_c_stid_opt decl_c_astp ')' "
                 "'(' param_c_ast_list_opt ')'" );
      DUMP_AST( "in_attr__type_c_ast", type_ast );
      DUMP_TID( "type_qualifier_list_c_stid_opt", (yyvsp[-6].tid) );
      DUMP_AST_PAIR( "decl_c_astp", (yyvsp[-5].ast_pair) );
      DUMP_AST_LIST( "param_c_ast_list_opt", (yyvsp[-2].ast_list) );

      PARSE_ASSERT(
        c_type_add_tid( &block_ast->type, (yyvsp[-6].tid), &(yylsp[-6]) )
      );
      c_ast_list_set_param_of( &(yyvsp[-2].ast_list), block_ast );
      block_ast->block.param_ast_list = slist_move( &(yyvsp[-2].ast_list) );

      c_ast_t *const ret_ast = ia_type_spec_ast( type_ast );
      if ( (yyvsp[-5].ast_pair).target_ast != NULL ) {
        (yyval.ast_pair) = (c_ast_pair_t){
          (yyvsp[-5].ast_pair).ast,
          c_ast_add_func( (yyvsp[-5].ast_pair).target_ast, block_ast, ret_ast )
        };
      }
      else {
        (yyval.ast_pair) = (c_ast_pair_t){
          c_ast_add_func( (yyvsp[-5].ast_pair).ast, block_ast, ret_ast ),
          block_ast->block.ret_ast
        };
      }

      DUMP_AST_PAIR( "$$_astp", (yyval.ast_pair) );
      DUMP_END();
    }
#line 8765 "parser.c"
    break;

  case 396: /* destructor_declaration_c: virtual_stid_opt '~' any_name_exp lparen_exp rparen_func_qualifier_list_c_stid_opt noexcept_c_stid_opt gnu_attribute_specifier_list_c_opt func_equals_c_stid_opt  */
#line 4730 "parser.y"
    {
      DUMP_START();
      DUMP_PROD( "destructor_declaration_c",
                 "virtual_stid_opt '~' any_name_exp '(' ')' "
                 "func_qualifier_list_c_stid_opt noexcept_c_stid_opt "
                 "gnu_attribute_specifier_list_c_opt func_equals_c_stid_opt" );
      DUMP_TID( "virtual_stid_opt", (yyvsp[-7].tid) );
      DUMP_STR( "any_name_exp", (yyvsp[-5].name) );
      DUMP_TID( "func_qualifier_list_c_stid_opt", (yyvsp[-3].tid) );
      DUMP_TID( "noexcept_c_stid_opt", (yyvsp[-2].tid) );
      DUMP_TID( "func_equals_c_stid_opt", (yyvsp[0].tid) );

      c_ast_t *const dtor_ast = c_ast_new_gc( K_DESTRUCTOR, &(yyloc) );
      c_sname_append_name( &dtor_ast->sname, (yyvsp[-5].name) );
      dtor_ast->type.stids = c_tid_check(
        (yyvsp[-7].tid) | (yyvsp[-3].tid) | (yyvsp[-2].tid) | (yyvsp[0].tid),
        C_TPID_STORE
      );

      DUMP_AST( "$$_ast", dtor_ast );
      DUMP_END();

      PARSE_ASSERT( c_ast_check( dtor_ast ) );
      c_ast_english( dtor_ast, C_ENG_DECL, stdout );
      PUTC( '\n' );
    }
#line 8796 "parser.c"
    break;

  case 397: /* file_scope_constructor_declaration_c: inline_stid_opt Y_CONSTRUCTOR_SNAME lparen_exp param_c_ast_list_opt rparen_func_qualifier_list_c_stid_opt noexcept_c_stid_opt gnu_attribute_specifier_list_c_opt  */
#line 4765 "parser.y"
    {
      DUMP_START();
      DUMP_PROD( "file_scope_constructor_declaration_c",
                 "inline_opt CONSTRUCTOR_SNAME '(' param_c_ast_list_opt ')' "
                 "func_qualifier_list_c_stid_opt noexcept_c_stid_opt" );
      DUMP_TID( "inline_stid_opt", (yyvsp[-6].tid) );
      DUMP_SNAME( "CONSTRUCTOR_SNAME", (yyvsp[-5].sname) );
      DUMP_AST_LIST( "param_c_ast_list_opt", (yyvsp[-3].ast_list) );
      DUMP_TID( "func_qualifier_list_c_stid_opt", (yyvsp[-2].tid) );
      DUMP_TID( "noexcept_c_stid_opt", (yyvsp[-1].tid) );

      c_sname_set_scope_type( &(yyvsp[-5].sname), &C_TYPE_LIT_B( TB_class ) );

      c_ast_t *const ctor_ast = c_ast_new_gc( K_CONSTRUCTOR, &(yyloc) );
      ctor_ast->sname = c_sname_move( &(yyvsp[-5].sname) );
      ctor_ast->type.stids = c_tid_check(
        (yyvsp[-6].tid) | (yyvsp[-2].tid) | (yyvsp[-1].tid),
        C_TPID_STORE
      );
      c_ast_list_set_param_of( &(yyvsp[-3].ast_list), ctor_ast );
      ctor_ast->ctor.param_ast_list = slist_move( &(yyvsp[-3].ast_list) );

      DUMP_AST( "$$_ast", ctor_ast );
      DUMP_END();

      PARSE_ASSERT( c_ast_check( ctor_ast ) );
      c_ast_english( ctor_ast, C_ENG_DECL, stdout );
      PUTC( '\n' );
    }
#line 8830 "parser.c"
    break;

  case 398: /* file_scope_destructor_declaration_c: inline_stid_opt destructor_sname lparen_exp rparen_func_qualifier_list_c_stid_opt noexcept_c_stid_opt gnu_attribute_specifier_list_c_opt  */
#line 4802 "parser.y"
    {
      DUMP_START();
      DUMP_PROD( "file_scope_destructor_declaration_c",
                 "inline_opt destructor_sname '(' ')' "
                 "func_qualifier_list_c_stid_opt noexcept_c_stid_opt" );
      DUMP_TID( "inline_stid_opt", (yyvsp[-5].tid) );
      DUMP_SNAME( "destructor_sname", (yyvsp[-4].sname) );
      DUMP_TID( "func_qualifier_list_c_stid_opt", (yyvsp[-2].tid) );
      DUMP_TID( "noexcept_c_stid_opt", (yyvsp[-1].tid) );

      c_sname_set_scope_type( &(yyvsp[-4].sname), &C_TYPE_LIT_B( TB_class ) );

      c_ast_t *const dtor_ast = c_ast_new_gc( K_DESTRUCTOR, &(yyloc) );
      dtor_ast->sname = c_sname_move( &(yyvsp[-4].sname) );
      dtor_ast->type.stids = c_tid_check(
        (yyvsp[-5].tid) | (yyvsp[-2].tid) | (yyvsp[-1].tid),
        C_TPID_STORE
      );

      DUMP_AST( "$$_ast", dtor_ast );
      DUMP_END();

      PARSE_ASSERT( c_ast_check( dtor_ast ) );
      c_ast_english( dtor_ast, C_ENG_DECL, stdout );
      PUTC( '\n' );
    }
#line 8861 "parser.c"
    break;

  case 399: /* func_decl_c_astp: decl2_c_astp '(' param_c_ast_list_opt rparen_func_qualifier_list_c_stid_opt func_ref_qualifier_c_stid_opt noexcept_c_stid_opt trailing_return_type_c_ast_opt func_equals_c_stid_opt  */
#line 4847 "parser.y"
    {
      c_ast_t *const type_ast = ia_type_ast_peek();

      DUMP_START();
      DUMP_PROD( "func_decl_c_astp",
                 "decl2_c_astp '(' param_c_ast_list_opt ')' "
                 "func_qualifier_list_c_stid_opt "
                 "func_ref_qualifier_c_stid_opt noexcept_c_stid_opt "
                 "trailing_return_type_c_ast_opt "
                 "func_equals_c_stid_opt" );
      DUMP_AST( "in_attr__type_c_ast", type_ast );
      DUMP_AST_PAIR( "decl2_c_astp", (yyvsp[-7].ast_pair) );
      DUMP_AST_LIST( "param_c_ast_list_opt", (yyvsp[-5].ast_list) );
      DUMP_TID( "func_qualifier_list_c_stid_opt", (yyvsp[-4].tid) );
      DUMP_TID( "func_ref_qualifier_c_stid_opt", (yyvsp[-3].tid) );
      DUMP_TID( "noexcept_c_stid_opt", (yyvsp[-2].tid) );
      DUMP_AST( "trailing_return_type_c_ast_opt", (yyvsp[-1].ast) );
      DUMP_TID( "func_equals_c_stid_opt", (yyvsp[0].tid) );

      c_tid_t const func_stids = c_tid_check(
        (yyvsp[-4].tid) | (yyvsp[-3].tid) | (yyvsp[-2].tid) | (yyvsp[0].tid),
        C_TPID_STORE
      );

      bool const assume_constructor =
        // + The type is likely for a constructor; and:
        c_ast_is_likely_ctor( type_ast ) &&

        // + The new type does _not_ have any non-constructor storage classes.
        !c_tid_is_any( func_stids, TS_FUNC_LIKE_NOT_CTOR );

      c_ast_t *const func_ast =
        c_ast_new_gc( assume_constructor ? K_CONSTRUCTOR : K_FUNCTION, &(yyloc) );
      func_ast->type.stids = func_stids;
      c_ast_list_set_param_of( &(yyvsp[-5].ast_list), func_ast );
      func_ast->func.param_ast_list = slist_move( &(yyvsp[-5].ast_list) );

      c_ast_t *const decl_ast = (yyvsp[-7].ast_pair).ast;

      if ( assume_constructor ) {
        assert( (yyvsp[-1].ast) == NULL );
        (yyval.ast_pair) = (c_ast_pair_t){
          c_ast_add_func( decl_ast, func_ast, /*ret_ast=*/NULL ),
          .target_ast = NULL
        };
      }
      else {
        c_ast_t *ret_ast;
        c_ast_t *target_ast = (yyvsp[-7].ast_pair).target_ast;

        if ( target_ast != NULL && target_ast->kind != K_POINTER ) {
          //
          // This is for a case like:
          //
          //      int f() ()
          //       |    |  |
          //       |    |  func
          //       |    |
          //       |    decl_ast (func)
          //       |
          //       ret_ast
          //
          // We replace ret_ast with decl_ast:
          //
          //      int f() ()
          //       |    |  |
          //       |    |  func
          //       X    |
          //       |    decl_ast (func)
          //       |
          //       ret_ast <- decl_ast (func)
          //
          // that is, a "function returning function" -- which is illegal
          // (since functions can't return functions) and will be caught by
          // c_ast_check_ret_type().
          //
          ret_ast = decl_ast;
          target_ast = NULL;
        }
        else {
          ret_ast = IF_ELSE( (yyvsp[-1].ast), ia_type_spec_ast( type_ast ) );
        }

        if ( target_ast != NULL ) {
          (yyval.ast_pair) = (c_ast_pair_t){
            decl_ast,
            c_ast_add_func( target_ast, func_ast, ret_ast )
          };
        }
        else {
          (yyval.ast_pair) = (c_ast_pair_t){
            c_ast_add_func( decl_ast, func_ast, ret_ast ),
            func_ast->func.ret_ast
          };
        }
      }

      c_tid_t const msc_call_atids = (yyval.ast_pair).ast->type.atids & TA_ANY_MSC_CALL;
      if ( msc_call_atids != TA_NONE ) {
        //
        // Microsoft calling conventions need to be moved from the pointer to
        // the function, e.g., change:
        //
        //      declare f as cdecl pointer to function returning void
        //
        // to:
        //
        //      declare f as pointer to cdecl function returning void
        //
        for ( c_ast_t const *ast = (yyval.ast_pair).ast;
              (ast = c_ast_unpointer( ast )) != NULL; ) {
          if ( ast->kind == K_FUNCTION ) {
            (yyval.ast_pair).ast->type.atids &= c_tid_compl( TA_ANY_MSC_CALL );
            CONST_CAST( c_ast_t*, ast )->type.atids |= msc_call_atids;
          }
        } // for
      }

      DUMP_AST_PAIR( "$$_astp", (yyval.ast_pair) );
      DUMP_END();
    }
#line 8987 "parser.c"
    break;

  case 400: /* $@21: %empty  */
#line 4979 "parser.y"
    {
      if ( OPT_LANG_IS( CONSTRUCTORS ) ) {
        //
        // In C++, encountering a name followed by '(' declares an in-class
        // constructor.  That means NAME is the name of a class, so we have to
        // create a temporary class type for it so if it's used as the type of
        // a parameter, e.g.:
        //
        //      C(C const&)
        //
        // it'll be recognized as such.
        //
        c_ast_t *const csu_ast = c_ast_new_gc( K_CLASS_STRUCT_UNION, &(yylsp[-1]) );
        csu_ast->type.btids = TB_class;
        c_sname_init_name( &csu_ast->csu.csu_sname, check_strdup( (yyvsp[-1].name) ) );
        csu_ast->sname = c_sname_dup( &csu_ast->csu.csu_sname );

        in_attr.typedef_rb = c_typedef_add( csu_ast, C_GIB_TYPEDEF );
        MAYBE_UNUSED c_typedef_t const *const csu_tdef =
          in_attr.typedef_rb->data;
        assert( csu_tdef->ast == csu_ast );
      }
    }
#line 9015 "parser.c"
    break;

  case 401: /* pc99_func_or_constructor_declaration_c: Y_NAME '(' $@21 param_c_ast_list_opt ')' noexcept_c_stid_opt func_equals_c_stid_opt  */
#line 5004 "parser.y"
    {
      DUMP_START();
      DUMP_PROD( "pc99_func_or_constructor_declaration_c",
                 "NAME '(' param_c_ast_list_opt ')' noexcept_c_stid_opt "
                 "func_equals_c_stid_opt" );
      DUMP_STR( "NAME", (yyvsp[-6].name) );
      DUMP_AST_LIST( "param_c_ast_list_opt", (yyvsp[-3].ast_list) );
      DUMP_TID( "noexcept_c_stid_opt", (yyvsp[-1].tid) );
      DUMP_TID( "func_equals_c_stid_opt", (yyvsp[0].tid) );

      c_ast_t *ast;

      if ( OPT_LANG_IS( CONSTRUCTORS ) ) {
        //
        // Free the temporary typedef for the class.
        //
        // Note that we free only the typedef and not its AST; its AST will be
        // garbage collected.
        //
        free( c_typedef_remove( in_attr.typedef_rb ) );

        //
        // In C++, encountering a name followed by '(' declares an in-class
        // constructor.
        //
        ast = c_ast_new_gc( K_CONSTRUCTOR, &(yyloc) );
      }
      else {
        if ( !IS_SUPPORTED( IMPLICIT_int ) ) {
          //
          // In C99 and later, implicit int is an error.  This check has to be
          // done now in the parser rather than later in the AST since the AST
          // would have no "memory" that the return type was implicitly int.
          //
          print_error( &(yylsp[-6]),
            "implicit \"%s\" functions are illegal%s",
            c_tid_name_error( TB_int ),
            C_LANG_WHICH( IMPLICIT_int )
          );
          print_error_token_is_a( (yyvsp[-6].name) );
          if ( strcmp( (yyvsp[-6].name), L_typeof ) == 0 ||
               strcmp( (yyvsp[-6].name), L_typeof_unqual ) == 0 ) {
            EPRINTF( "; use \"%s\" instead", L_GNU___typeof__ );
          }
          else {
            print_suggestions(
              DYM_C_KEYWORDS | DYM_C_MACROS | DYM_C_TYPES,
              (yyvsp[-6].name)
            );
          }
          EPUTC( '\n' );
          FREE( (yyvsp[-6].name) );
          PARSE_ABORT();
        }

        //
        // In C prior to C99, encountering a name followed by '(' declares a
        // function that implicitly returns int:
        //
        //      power(x, n)             /* raise x to n-th power; n > 0 */
        //
        c_ast_t *const ret_ast = c_ast_new_gc( K_BUILTIN, &(yylsp[-6]) );
        ret_ast->type.btids = TB_int;

        ast = c_ast_new_gc( K_FUNCTION, &(yyloc) );
        c_ast_set_parent( ret_ast, ast );
      }

      c_sname_init_name( &ast->sname, (yyvsp[-6].name) );
      ast->type.stids =
        c_tid_check( (yyvsp[-1].tid) | (yyvsp[0].tid), C_TPID_STORE );
      c_ast_list_set_param_of( &(yyvsp[-3].ast_list), ast );
      ast->func.param_ast_list = slist_move( &(yyvsp[-3].ast_list) );

      DUMP_AST( "$$_ast", ast );
      DUMP_END();

      PARSE_ASSERT( c_ast_check( ast ) );
      c_ast_english( ast, C_ENG_DECL, stdout );
      PUTC( '\n' );
    }
#line 9101 "parser.c"
    break;

  case 402: /* $@22: %empty  */
#line 5089 "parser.y"
    {
      if ( OPT_LANG_IS( MEMBER_FUNCTIONS ) ) {
        //
        // Both "final" and "override" are matched only within member function
        // declarations.  Now that ')' has been parsed, we're within one, so
        // set the keyword context to C_KW_CTX_MBR_FUNC.
        //
        lexer_keyword_ctx = C_KW_CTX_MBR_FUNC;
      }
    }
#line 9116 "parser.c"
    break;

  case 403: /* rparen_func_qualifier_list_c_stid_opt: ')' $@22 func_qualifier_list_c_stid_opt  */
#line 5100 "parser.y"
    {
      lexer_keyword_ctx = C_KW_CTX_DEFAULT;
      (yyval.tid) = (yyvsp[0].tid);
    }
#line 9125 "parser.c"
    break;

  case 404: /* func_qualifier_list_c_stid_opt: %empty  */
#line 5107 "parser.y"
                                  { (yyval.tid) = TS_NONE; }
#line 9131 "parser.c"
    break;

  case 405: /* func_qualifier_list_c_stid_opt: func_qualifier_list_c_stid_opt func_qualifier_c_stid  */
#line 5109 "parser.y"
    {
      DUMP_START();
      DUMP_PROD( "func_qualifier_list_c_stid_opt",
                 "func_qualifier_list_c_stid_opt func_qualifier_c_stid" );
      DUMP_TID( "func_qualifier_list_c_stid_opt", (yyvsp[-1].tid) );
      DUMP_TID( "func_qualifier_c_stid", (yyvsp[0].tid) );

      (yyval.tid) = (yyvsp[-1].tid);
      PARSE_ASSERT( c_tid_add( &(yyval.tid), (yyvsp[0].tid), &(yylsp[0]) ) );

      DUMP_TID( "$$_stids", (yyval.tid) );
      DUMP_END();
    }
#line 9149 "parser.c"
    break;

  case 410: /* func_ref_qualifier_c_stid_opt: %empty  */
#line 5139 "parser.y"
                                  { (yyval.tid) = TS_NONE; }
#line 9155 "parser.c"
    break;

  case 411: /* func_ref_qualifier_c_stid_opt: '&'  */
#line 5140 "parser.y"
                                  { (yyval.tid) = TS_REFERENCE; }
#line 9161 "parser.c"
    break;

  case 412: /* func_ref_qualifier_c_stid_opt: Y_AMPER_AMPER  */
#line 5141 "parser.y"
                                  { (yyval.tid) = TS_RVALUE_REFERENCE; }
#line 9167 "parser.c"
    break;

  case 413: /* noexcept_c_stid_opt: %empty  */
#line 5145 "parser.y"
                                  { (yyval.tid) = TS_NONE; }
#line 9173 "parser.c"
    break;

  case 415: /* noexcept_c_stid_opt: Y_noexcept '(' noexcept_bool_stid_exp rparen_exp  */
#line 5148 "parser.y"
    {
      (yyval.tid) = (yyvsp[-1].tid);
    }
#line 9181 "parser.c"
    break;

  case 416: /* noexcept_c_stid_opt: Y_throw lparen_exp rparen_exp  */
#line 5152 "parser.y"
    {
      (yyval.tid) = (yyvsp[-2].tid);
    }
#line 9189 "parser.c"
    break;

  case 417: /* noexcept_c_stid_opt: Y_throw lparen_exp param_c_ast_list ')'  */
#line 5156 "parser.y"
    {
      c_ast_list_cleanup( &(yyvsp[-1].ast_list) );

      if ( OPT_LANG_IS( throw ) ) {
        UNSUPPORTED( &(yylsp[-1]), "dynamic exception specifications" );
      } else {
        print_error( &(yylsp[-1]),
          "dynamic exception specifications not supported%s\n",
          C_LANG_WHICH( throw )
        );
      }
      PARSE_ABORT();
    }
#line 9207 "parser.c"
    break;

  case 420: /* noexcept_bool_stid_exp: error  */
#line 5175 "parser.y"
    {
      elaborate_error( "\"true\" or \"false\" expected" );
    }
#line 9215 "parser.c"
    break;

  case 421: /* trailing_return_type_c_ast_opt: %empty  */
#line 5181 "parser.y"
                                  { (yyval.ast) = NULL; }
#line 9221 "parser.c"
    break;

  case 422: /* $@23: %empty  */
#line 5183 "parser.y"
                                         { ia_type_ast_push( (yyvsp[0].ast) ); }
#line 9227 "parser.c"
    break;

  case 423: /* trailing_return_type_c_ast_opt: Y_MINUS_GREATER type_c_ast $@23 cast_c_astp_opt  */
#line 5185 "parser.y"
    { //
      // The function trailing return-type syntax is supported only in C++11
      // and later.  This check has to be done now in the parser rather than
      // later in the AST because the AST has no "memory" of where the return-
      // type came from.
      //
      if ( !IS_SUPPORTED( TRAILING_RETURN_TYPES ) ) {
        print_error( &(yylsp[-3]),
          "trailing return type not supported%s\n",
          C_LANG_WHICH( TRAILING_RETURN_TYPES )
        );
        PARSE_ABORT();
      }

      ia_type_ast_pop();
      c_ast_t const *const ret_ast = ia_type_ast_peek();

      DUMP_START();
      DUMP_PROD( "trailing_return_type_c_ast_opt",
                 "'->' type_c_ast cast_c_astp_opt" );
      DUMP_AST( "in_attr__type_c_ast", ret_ast );
      DUMP_AST( "type_c_ast", (yyvsp[-2].ast) );
      DUMP_AST_PAIR( "cast_c_astp_opt", (yyvsp[0].ast_pair) );

      (yyval.ast) = IF_ELSE( (yyvsp[0].ast_pair).ast, (yyvsp[-2].ast) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();

      //
      // Ensure that a function using the C++11 trailing return type syntax
      // starts with "auto":
      //
      //      void f() -> int
      //      ^
      //      error: must be "auto"
      //
      // This check has to be done now in the parser rather than later in the
      // AST because the "auto" is just a syntactic return-type placeholder in
      // C++11 and the AST node for the placeholder is discarded and never made
      // part of the AST.
      //
      if ( ret_ast->type.btids != TB_auto ) {
        print_error( &ret_ast->loc,
          "function with trailing return type must only specify \"%s\"\n",
          c_tid_name_error( TB_auto )
        );
        PARSE_ABORT();
      }
    }
#line 9282 "parser.c"
    break;

  case 424: /* trailing_return_type_c_ast_opt: gnu_attribute_specifier_list_c  */
#line 5237 "parser.y"
    {
      (yyval.ast) = NULL;
    }
#line 9290 "parser.c"
    break;

  case 425: /* func_equals_c_stid_opt: %empty  */
#line 5243 "parser.y"
                                  { (yyval.tid) = TS_NONE; }
#line 9296 "parser.c"
    break;

  case 426: /* func_equals_c_stid_opt: '=' Y_default  */
#line 5244 "parser.y"
                                  { (yyval.tid) = (yyvsp[0].tid); }
#line 9302 "parser.c"
    break;

  case 427: /* func_equals_c_stid_opt: '=' Y_delete  */
#line 5245 "parser.y"
                                  { (yyval.tid) = (yyvsp[0].tid); }
#line 9308 "parser.c"
    break;

  case 428: /* func_equals_c_stid_opt: '=' uint_lit  */
#line 5247 "parser.y"
    {
      if ( (yyvsp[0].uint_val) != 0 ) {
        print_error( &(yylsp[0]), "'0' expected\n" );
        PARSE_ABORT();
      }
      (yyval.tid) = TS_PURE_virtual;
    }
#line 9320 "parser.c"
    break;

  case 429: /* func_equals_c_stid_opt: '=' error  */
#line 5255 "parser.y"
    {
      if ( OPT_LANG_IS( default_delete_FUNCS ) )
        elaborate_error( "'0', \"default\", or \"delete\" expected" );
      else
        elaborate_error( "'0' expected" );
    }
#line 9331 "parser.c"
    break;

  case 431: /* param_c_ast_list_exp: error  */
#line 5268 "parser.y"
    {
      slist_init( &(yyval.ast_list) );
      elaborate_error( "parameter list expected" );
    }
#line 9340 "parser.c"
    break;

  case 432: /* param_c_ast_list_opt: %empty  */
#line 5275 "parser.y"
                                  { slist_init( &(yyval.ast_list) ); }
#line 9346 "parser.c"
    break;

  case 434: /* param_c_ast_list: param_c_ast_list comma_exp param_c_ast_exp  */
#line 5281 "parser.y"
    {
      DUMP_START();
      DUMP_PROD( "param_c_ast_list", "param_c_ast_list ',' param_c_ast" );
      DUMP_AST_LIST( "param_c_ast_list", (yyvsp[-2].ast_list) );
      DUMP_AST( "param_c_ast", (yyvsp[0].ast) );

      (yyval.ast_list) = (yyvsp[-2].ast_list);
      slist_push_back( &(yyval.ast_list), (yyvsp[0].ast) );

      DUMP_AST_LIST( "$$_ast_list", (yyval.ast_list) );
      DUMP_END();
    }
#line 9363 "parser.c"
    break;

  case 435: /* param_c_ast_list: param_c_ast  */
#line 5295 "parser.y"
    {
      DUMP_START();
      DUMP_PROD( "param_c_ast_list", "param_c_ast" );
      DUMP_AST( "param_c_ast", (yyvsp[0].ast) );

      slist_init( &(yyval.ast_list) );
      slist_push_back( &(yyval.ast_list), (yyvsp[0].ast) );

      DUMP_AST_LIST( "$$_ast_list", (yyval.ast_list) );
      DUMP_END();
    }
#line 9379 "parser.c"
    break;

  case 436: /* $@24: %empty  */
#line 5313 "parser.y"
    {
      ia_type_ast_push( (yyvsp[0].ast) );
    }
#line 9387 "parser.c"
    break;

  case 437: /* param_c_ast: this_stid_opt type_c_ast $@24 cast_c_astp_opt  */
#line 5317 "parser.y"
    {
      ia_type_ast_pop();

      DUMP_START();
      DUMP_PROD( "param_c_ast", "this_stid_opt type_c_ast cast_c_astp_opt" );
      DUMP_TID( "this_stid_opt", (yyvsp[-3].tid) );
      DUMP_AST( "type_c_ast", (yyvsp[-2].ast) );
      DUMP_AST_PAIR( "cast_c_astp_opt", (yyvsp[0].ast_pair) );

      (yyval.ast) = c_ast_patch_placeholder( (yyvsp[-2].ast), (yyvsp[0].ast_pair).ast );

      if ( (yyval.ast)->kind == K_FUNCTION ) {
        //
        // From the C11 standard, section 6.3.2.1(4):
        //
        //    [A] function designator with type "function returning type" is
        //    converted to an expression that has type "pointer to function
        //    returning type."
        //
        (yyval.ast) = c_ast_pointer( (yyval.ast), &gc_ast_list );
      }

      PARSE_ASSERT( c_type_add_tid( &(yyval.ast)->type, (yyvsp[-3].tid), &(yylsp[-3]) ) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 9419 "parser.c"
    break;

  case 439: /* param_c_ast: "..."  */
#line 5354 "parser.y"
    {
      DUMP_START();
      DUMP_PROD( "param_c_ast", "..." );

      (yyval.ast) = c_ast_new_gc( K_VARIADIC, &(yyloc) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 9433 "parser.c"
    break;

  case 441: /* param_c_ast_exp: error  */
#line 5368 "parser.y"
    {
      elaborate_error( "parameter declaration expected" );
    }
#line 9441 "parser.c"
    break;

  case 442: /* $@25: %empty  */
#line 5377 "parser.y"
    {
      ia_type_ast_push( c_ast_new_gc( K_PLACEHOLDER, &(yyloc) ) );
      ++in_attr.ast_depth;
    }
#line 9450 "parser.c"
    break;

  case 443: /* nested_decl_c_astp: '(' $@25 decl_c_astp rparen_exp  */
#line 5382 "parser.y"
    {
      ia_type_ast_pop();
      --in_attr.ast_depth;

      DUMP_START();
      DUMP_PROD( "nested_decl_c_astp", "'(' decl_c_astp ')'" );
      DUMP_AST_PAIR( "decl_c_astp", (yyvsp[-1].ast_pair) );

      (yyval.ast_pair) = (yyvsp[-1].ast_pair);
      (yyval.ast_pair).ast->loc = (yyloc);

      DUMP_AST_PAIR( "$$_astp", (yyval.ast_pair) );
      DUMP_END();
    }
#line 9469 "parser.c"
    break;

  case 444: /* oper_decl_c_astp: oper_sname_c_opt Y_operator c_operator lparen_exp param_c_ast_list_opt rparen_func_qualifier_list_c_stid_opt func_ref_qualifier_c_stid_opt noexcept_c_stid_opt trailing_return_type_c_ast_opt func_equals_c_stid_opt  */
#line 5409 "parser.y"
    {
      c_operator_t const *const operator = c_op_get( (yyvsp[-7].op_id) );
      c_ast_t *const type_ast = ia_type_ast_peek();

      DUMP_START();
      DUMP_PROD( "oper_decl_c_astp",
                 "oper_sname_c_opt OPERATOR c_operator "
                 "'(' param_c_ast_list_opt ')' "
                 "func_qualifier_list_c_stid_opt "
                 "func_ref_qualifier_c_stid_opt noexcept_c_stid_opt "
                 "trailing_return_type_c_ast_opt "
                 "func_equals_c_stid_opt" );
      DUMP_AST( "in_attr__type_c_ast", type_ast );
      DUMP_SNAME( "oper_sname_c_opt", (yyvsp[-9].sname) );
      DUMP_STR( "c_operator", operator->literal );
      DUMP_AST_LIST( "param_c_ast_list_opt", (yyvsp[-5].ast_list) );
      DUMP_TID( "func_qualifier_list_c_stid_opt", (yyvsp[-4].tid) );
      DUMP_TID( "func_ref_qualifier_c_stid_opt", (yyvsp[-3].tid) );
      DUMP_TID( "noexcept_c_stid_opt", (yyvsp[-2].tid) );
      DUMP_AST( "trailing_return_type_c_ast_opt", (yyvsp[-1].ast) );
      DUMP_TID( "func_equals_c_stid_opt", (yyvsp[0].tid) );

      c_tid_t const oper_stids = c_tid_check(
        (yyvsp[-4].tid) | (yyvsp[-3].tid) | (yyvsp[-2].tid) | (yyvsp[0].tid),
        C_TPID_STORE
      );

      c_ast_t *const oper_ast = c_ast_new_gc( K_OPERATOR, &(yyloc) );
      oper_ast->sname = c_sname_move( &(yyvsp[-9].sname) );
      oper_ast->type.stids = oper_stids;
      c_ast_list_set_param_of( &(yyvsp[-5].ast_list), oper_ast );
      oper_ast->oper.param_ast_list = slist_move( &(yyvsp[-5].ast_list) );
      oper_ast->oper.operator = operator;

      c_ast_t *const ret_ast =
        IF_ELSE( (yyvsp[-1].ast), ia_type_spec_ast( type_ast ) );

      (yyval.ast_pair) = (c_ast_pair_t){
        c_ast_add_func( type_ast, oper_ast, ret_ast ),
        oper_ast->oper.ret_ast
      };

      DUMP_AST_PAIR( "$$_astp", (yyval.ast_pair) );
      DUMP_END();
    }
#line 9519 "parser.c"
    break;

  case 445: /* $@26: %empty  */
#line 5459 "parser.y"
                                 { ia_type_ast_push( (yyvsp[0].ast) ); }
#line 9525 "parser.c"
    break;

  case 446: /* pointer_decl_c_astp: pointer_type_c_ast $@26 decl_c_astp  */
#line 5461 "parser.y"
    {
      ia_type_ast_pop();

      DUMP_START();
      DUMP_PROD( "pointer_decl_c_astp", "pointer_type_c_ast decl_c_astp" );
      DUMP_AST( "pointer_type_c_ast", (yyvsp[-2].ast) );
      DUMP_AST_PAIR( "decl_c_astp", (yyvsp[0].ast_pair) );

      PJL_IGNORE_RV( c_ast_patch_placeholder( (yyvsp[-2].ast), (yyvsp[0].ast_pair).ast ) );
      (yyval.ast_pair) = (yyvsp[0].ast_pair);
      (yyval.ast_pair).ast->loc = (yyloc);

      DUMP_AST_PAIR( "$$_astp", (yyval.ast_pair) );
      DUMP_END();
    }
#line 9545 "parser.c"
    break;

  case 447: /* pointer_type_c_ast: '*' type_qualifier_list_c_stid_opt  */
#line 5481 "parser.y"
    {
      c_ast_t *const type_ast = ia_type_ast_peek();

      DUMP_START();
      DUMP_PROD( "pointer_type_c_ast", "'*' type_qualifier_list_c_stid_opt" );
      DUMP_AST( "in_attr__type_c_ast", type_ast );
      DUMP_TID( "type_qualifier_list_c_stid_opt", (yyvsp[0].tid) );

      (yyval.ast) = c_ast_new_gc( K_POINTER, &(yyloc) );
      (yyval.ast)->type.stids = c_tid_check( (yyvsp[0].tid), C_TPID_STORE );
      c_ast_set_parent( ia_type_spec_ast( type_ast ), (yyval.ast) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 9565 "parser.c"
    break;

  case 448: /* pc99_pointer_decl_list_c: pc99_pointer_decl_c ',' decl_list_c  */
#line 5502 "parser.y"
    {
      (yyval.ast_list) = (yyvsp[0].ast_list);
      slist_push_front( &(yyval.ast_list), (yyvsp[-2].ast) );
    }
#line 9574 "parser.c"
    break;

  case 449: /* pc99_pointer_decl_list_c: pc99_pointer_decl_c  */
#line 5507 "parser.y"
    {
      slist_init( &(yyval.ast_list) );
      slist_push_back( &(yyval.ast_list), (yyvsp[0].ast) );
    }
#line 9583 "parser.c"
    break;

  case 450: /* $@27: %empty  */
#line 5514 "parser.y"
                                      { ia_type_ast_push( (yyvsp[0].ast) ); }
#line 9589 "parser.c"
    break;

  case 451: /* pc99_pointer_decl_c: pc99_pointer_type_c_ast $@27 decl_c_astp  */
#line 5516 "parser.y"
    {
      ia_type_ast_pop();

      DUMP_START();
      DUMP_PROD( "pc99_pointer_decl_c",
                 "pc99_pointer_type_c_ast decl_c_astp" );
      DUMP_AST( "pc99_pointer_type_c_ast", (yyvsp[-2].ast) );
      DUMP_AST_PAIR( "decl_c_astp", (yyvsp[0].ast_pair) );

      (yyval.ast) = c_ast_patch_placeholder( (yyvsp[-2].ast), (yyvsp[0].ast_pair).ast );
      (yyval.ast)->loc = (yyloc);

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 9609 "parser.c"
    break;

  case 452: /* pc99_pointer_type_c_ast: '*' type_qualifier_list_c_stid_opt  */
#line 5536 "parser.y"
    {
      if ( !IS_SUPPORTED( IMPLICIT_int ) ) {
        //
        // In C99 and later, implicit int is an error.  This check has to be
        // done now in the parser rather than later in the AST since the AST
        // would have no "memory" that the return type was implicitly int.
        //
        print_error( &(yylsp[-1]),
          "implicit \"%s\" is illegal%s\n",
          c_tid_name_error( TB_int ),
          C_LANG_WHICH( IMPLICIT_int )
        );
        PARSE_ABORT();
      }

      c_ast_t *type_ast = ia_type_ast_peek();

      DUMP_START();
      DUMP_PROD( "pc99_pointer_type_c_ast",
                 "'*' type_qualifier_list_c_stid_opt" );
      DUMP_AST( "in_attr__type_c_ast", type_ast );
      DUMP_TID( "type_qualifier_list_c_stid_opt", (yyvsp[0].tid) );

      if ( type_ast == NULL ) {
        type_ast = c_ast_new_gc( K_BUILTIN, &(yylsp[-1]) );
        type_ast->type.btids = TB_int;
        ia_type_ast_push( type_ast );
      }

      (yyval.ast) = c_ast_pointer( ia_type_spec_ast( type_ast ), &gc_ast_list );
      (yyval.ast)->type.stids = c_tid_check( (yyvsp[0].tid), C_TPID_STORE );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 9649 "parser.c"
    break;

  case 453: /* $@28: %empty  */
#line 5576 "parser.y"
                                           { ia_type_ast_push( (yyvsp[0].ast) ); }
#line 9655 "parser.c"
    break;

  case 454: /* pointer_to_member_decl_c_astp: pointer_to_member_type_c_ast $@28 decl_c_astp  */
#line 5578 "parser.y"
    {
      ia_type_ast_pop();

      DUMP_START();
      DUMP_PROD( "pointer_to_member_decl_c_astp",
                 "pointer_to_member_type_c_ast decl_c_astp" );
      DUMP_AST( "pointer_to_member_type_c_ast", (yyvsp[-2].ast) );
      DUMP_AST_PAIR( "decl_c_astp", (yyvsp[0].ast_pair) );

      (yyval.ast_pair) = (yyvsp[0].ast_pair);
      (yyval.ast_pair).ast->loc = (yyloc);

      DUMP_AST_PAIR( "$$_astp", (yyval.ast_pair) );
      DUMP_END();
    }
#line 9675 "parser.c"
    break;

  case 455: /* pointer_to_member_type_c_ast: any_sname_c Y_COLON_COLON_STAR '*' cv_qualifier_list_stid_opt  */
#line 5599 "parser.y"
    {
      c_ast_t *const type_ast = ia_type_ast_peek();

      DUMP_START();
      DUMP_PROD( "pointer_to_member_type_c_ast",
                 "any_sname_c '::*' cv_qualifier_list_stid_opt" );
      DUMP_AST( "in_attr__type_c_ast", type_ast );
      DUMP_SNAME( "any_sname_c", (yyvsp[-3].sname) );
      DUMP_TID( "cv_qualifier_list_stid_opt", (yyvsp[0].tid) );

      (yyval.ast) = c_ast_new_gc( K_POINTER_TO_MEMBER, &(yyloc) );

      c_type_t scope_type = *c_sname_local_type( &(yyvsp[-3].sname) );
      if ( !c_tid_is_any( scope_type.btids, TB_ANY_SCOPE ) ) {
        //
        // The sname has no scope-type, but we now know there's a pointer-to-
        // member of it, so it must be a class.  (It could alternatively be a
        // struct, but we have no context to know, so just pick class because
        // it's more C++-like.)
        //
        scope_type.btids = TB_class;
        c_sname_set_local_type( &(yyvsp[-3].sname), &scope_type );
      }

      // adopt sname's scope-type for the AST
      (yyval.ast)->type = c_type_or( &C_TYPE_LIT_S( (yyvsp[0].tid) ), &scope_type );

      (yyval.ast)->ptr_mbr.class_sname = c_sname_move( &(yyvsp[-3].sname) );
      c_ast_set_parent( c_ast_dup_gc( type_ast ), (yyval.ast) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 9713 "parser.c"
    break;

  case 456: /* $@29: %empty  */
#line 5637 "parser.y"
                                   { ia_type_ast_push( (yyvsp[0].ast) ); }
#line 9719 "parser.c"
    break;

  case 457: /* reference_decl_c_astp: reference_type_c_ast $@29 decl_c_astp  */
#line 5639 "parser.y"
    {
      ia_type_ast_pop();

      DUMP_START();
      DUMP_PROD( "reference_decl_c_astp", "reference_type_c_ast decl_c_astp" );
      DUMP_AST( "reference_type_c_ast", (yyvsp[-2].ast) );
      DUMP_AST_PAIR( "decl_c_astp", (yyvsp[0].ast_pair) );

      (yyval.ast_pair) = (yyvsp[0].ast_pair);
      (yyval.ast_pair).ast->loc = (yyloc);

      DUMP_AST_PAIR( "$$_astp", (yyval.ast_pair) );
      DUMP_END();
    }
#line 9738 "parser.c"
    break;

  case 458: /* reference_type_c_ast: '&' type_qualifier_list_c_stid_opt  */
#line 5658 "parser.y"
    {
      c_ast_t *const type_ast = ia_type_ast_peek();

      DUMP_START();
      DUMP_PROD( "reference_type_c_ast", "'&' type_qualifier_list_c_stid_opt" );
      DUMP_AST( "in_attr__type_c_ast", type_ast );
      DUMP_TID( "type_qualifier_list_c_stid_opt", (yyvsp[0].tid) );

      (yyval.ast) = c_ast_new_gc( K_REFERENCE, &(yyloc) );
      (yyval.ast)->type.stids = c_tid_check( (yyvsp[0].tid), C_TPID_STORE );
      c_ast_set_parent( ia_type_spec_ast( type_ast ), (yyval.ast) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 9758 "parser.c"
    break;

  case 459: /* reference_type_c_ast: Y_AMPER_AMPER type_qualifier_list_c_stid_opt  */
#line 5676 "parser.y"
    {
      c_ast_t *const type_ast = ia_type_ast_peek();

      DUMP_START();
      DUMP_PROD( "reference_type_c_ast",
                 "'&&' type_qualifier_list_c_stid_opt" );
      DUMP_AST( "in_attr__type_c_ast", type_ast );
      DUMP_TID( "type_qualifier_list_c_stid_opt", (yyvsp[0].tid) );

      (yyval.ast) = c_ast_new_gc( K_RVALUE_REFERENCE, &(yyloc) );
      (yyval.ast)->type.stids = c_tid_check( (yyvsp[0].tid), C_TPID_STORE );
      c_ast_set_parent( ia_type_spec_ast( type_ast ), (yyval.ast) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 9779 "parser.c"
    break;

  case 460: /* typedef_type_decl_c_ast: typedef_type_c_ast bit_field_c_uint_opt  */
#line 5699 "parser.y"
    {
      c_ast_t *const type_ast = ia_type_ast_peek();

      DUMP_START();
      DUMP_PROD( "typedef_type_decl_c_ast",
                 "typedef_type_c_ast bit_field_c_uint_opt" );
      DUMP_AST( "in_attr__type_c_ast", type_ast );
      DUMP_AST( "typedef_type_c_ast", (yyvsp[-1].ast) );
      DUMP_INT( "bit_field_c_uint_opt", (yyvsp[0].uint_val) );

      if ( c_tid_is_any( type_ast->type.stids, TS_typedef ) ) {
        //
        // If we're defining a type, return the type as-is.
        //
        (yyval.ast) = (yyvsp[-1].ast);
      }
      else {
        //
        // Otherwise, return the type that it's typedef'd as.
        //
        c_ast_t const *const raw_tdef_ast = c_ast_untypedef( (yyvsp[-1].ast) );

        //
        // But first ensure the name isn't of a previously declared type:
        //
        //      cdecl> struct S
        //      cdecl> explain int S    // error: "S": previously declared
        //
        // Note that typedef_type_c_ast is like:
        //
        //      typedef_type_c_ast: {
        //        sname: { string: "" },
        //        kind: { value: 0x20, string: "typedef" },
        //        ...
        //        type: { btid: 0x10000001, ..., string: "none" },
        //        tdef: {
        //          for_ast: {
        //            sname: { string: "S", scopes: "struct" },
        //            kind: { value: 0x8, string: "struct or union" },
        //            ...
        //            type: { btid: 0x800001, ..., string: "struct" },
        //            csu: {
        //              csu_sname: { string: "S", scopes: "none" }
        //            }
        //          }
        //        },
        //        ...
        //      }
        //
        // That is, typedef_type_c_ast has no name itself (at this point), but
        // the raw type, of course, does, so it's that name we have to check.
        //
        // This check has to be done now in the parser rather than later in the
        // AST since if this declaration were joined with a type (like `int`
        // above), the type information would be lost and we'd get this from
        // above:
        //
        //      declare S as structure S          // wrong
        //
        // Additionally, we also get here when the typedef name is used as part
        // of longer name, e.g., `S::x`:
        //
        //      c++decl> explain int S::x
        //      declare x of structure S as int   // correct
        //
        // but that name isn't of a previously declared type, so it's OK.
        //
        c_typedef_t const *const tdef =
          c_typedef_find_sname( &raw_tdef_ast->sname );
        if ( tdef != NULL ) {
          print_error( &(yyvsp[-1].ast)->loc,
            "\"%s\": previously declared as type \"",
            c_sname_full_name( &raw_tdef_ast->sname )
          );
          print_type_ast( tdef, stderr );
          EPUTS( "\"\n" );
          PARSE_ABORT();
        }

        //
        // We have to duplicate the type to set the current location.
        //
        (yyval.ast) = c_ast_dup_gc( raw_tdef_ast );
        (yyval.ast)->loc = (yyvsp[-1].ast)->loc;
      }

      PARSE_ASSERT( c_ast_set_bit_field_width( (yyval.ast), (yyvsp[0].uint_val) ) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 9875 "parser.c"
    break;

  case 461: /* $@30: %empty  */
#line 5797 "parser.y"
    {
      ia_type_ast_push( (yyvsp[0].ast) );
    }
#line 9883 "parser.c"
    break;

  case 462: /* user_defined_conversion_decl_c_astp: oper_sname_c_opt Y_operator type_c_ast $@30 udc_decl_c_ast_opt lparen_exp rparen_func_qualifier_list_c_stid_opt noexcept_c_stid_opt func_equals_c_stid_opt  */
#line 5803 "parser.y"
    {
      ia_type_ast_pop();

      c_ast_t *const type_ast = ia_type_ast_peek();

      DUMP_START();
      DUMP_PROD( "user_defined_conversion_decl_c_astp",
                 "oper_sname_c_opt OPERATOR "
                 "type_c_ast udc_decl_c_ast_opt '(' ')' "
                 "func_qualifier_list_c_stid_opt noexcept_c_stid_opt "
                 "func_equals_c_stid_opt" );
      DUMP_AST( "in_attr__type_c_ast", type_ast );
      DUMP_SNAME( "oper_sname_c_opt", (yyvsp[-8].sname) );
      DUMP_AST( "type_c_ast", (yyvsp[-6].ast) );
      DUMP_AST( "udc_decl_c_ast_opt", (yyvsp[-4].ast) );
      DUMP_TID( "func_qualifier_list_c_stid_opt", (yyvsp[-2].tid) );
      DUMP_TID( "noexcept_c_stid_opt", (yyvsp[-1].tid) );
      DUMP_TID( "func_equals_c_stid_opt", (yyvsp[0].tid) );

      c_ast_t *const udc_ast = c_ast_new_gc( K_UDEF_CONV, &(yyloc) );
      udc_ast->sname = c_sname_move( &(yyvsp[-8].sname) );
      udc_ast->type.stids = c_tid_check(
        (yyvsp[-2].tid) | (yyvsp[-1].tid) | (yyvsp[0].tid),
        C_TPID_STORE
      );
      if ( type_ast != NULL )
        c_type_or_eq( &udc_ast->type, &type_ast->type );
      udc_ast->udef_conv.to_ast = IF_ELSE( (yyvsp[-4].ast), (yyvsp[-6].ast) );

      (yyval.ast_pair) = (c_ast_pair_t){ udc_ast, udc_ast->udef_conv.to_ast };

      DUMP_AST_PAIR( "$$_astp", (yyval.ast_pair) );
      DUMP_END();
    }
#line 9922 "parser.c"
    break;

  case 463: /* user_defined_literal_decl_c_astp: oper_sname_c_opt Y_operator empty_str_lit_exp name_exp lparen_exp param_c_ast_list_exp ')' noexcept_c_stid_opt trailing_return_type_c_ast_opt  */
#line 5847 "parser.y"
    {
      c_ast_t *const type_ast = ia_type_ast_peek();

      DUMP_START();
      DUMP_PROD( "user_defined_literal_decl_c_astp",
                 "oper_sname_c_opt OPERATOR '\"\"' "
                 "'(' param_c_ast_list_exp ')' noexcept_c_stid_opt "
                 "trailing_return_type_c_ast_opt" );
      DUMP_AST( "in_attr__type_c_ast", type_ast );
      DUMP_SNAME( "oper_sname_c_opt", (yyvsp[-8].sname) );
      DUMP_STR( "name", (yyvsp[-5].name) );
      DUMP_AST_LIST( "param_c_ast_list_exp", (yyvsp[-3].ast_list) );
      DUMP_TID( "noexcept_c_stid_opt", (yyvsp[-1].tid) );
      DUMP_AST( "trailing_return_type_c_ast_opt", (yyvsp[0].ast) );

      c_sname_set( &type_ast->sname, &(yyvsp[-8].sname) );
      c_sname_append_name( &type_ast->sname, (yyvsp[-5].name) );

      c_ast_t *const udl_ast = c_ast_new_gc( K_UDEF_LIT, &(yyloc) );
      udl_ast->type.stids = c_tid_check( (yyvsp[-1].tid), C_TPID_STORE );
      c_ast_list_set_param_of( &(yyvsp[-3].ast_list), udl_ast );
      udl_ast->udef_lit.param_ast_list = slist_move( &(yyvsp[-3].ast_list) );

      (yyval.ast_pair) = (c_ast_pair_t){
        c_ast_add_func(
          type_ast,
          udl_ast,
          IF_ELSE( (yyvsp[0].ast), type_ast )
        ),
        udl_ast->udef_lit.ret_ast
      };

      DUMP_AST_PAIR( "$$_astp", (yyval.ast_pair) );
      DUMP_END();
    }
#line 9962 "parser.c"
    break;

  case 464: /* cast_c_astp_opt: %empty  */
#line 5889 "parser.y"
                                  { (yyval.ast_pair) = (c_ast_pair_t){ NULL, NULL }; }
#line 9968 "parser.c"
    break;

  case 474: /* cast2_c_astp: sname_c_ast  */
#line 5906 "parser.y"
                                  { (yyval.ast_pair) = (c_ast_pair_t){ (yyvsp[0].ast), NULL }; }
#line 9974 "parser.c"
    break;

  case 475: /* array_cast_c_astp: cast_c_astp_opt array_size_c_ast  */
#line 5917 "parser.y"
    {
      c_ast_t *const type_ast = ia_type_ast_peek();

      DUMP_START();
      DUMP_PROD( "array_cast_c_astp", "cast_c_astp_opt array_size_c_ast" );
      DUMP_AST( "in_attr__type_c_ast", type_ast );
      DUMP_AST_PAIR( "cast_c_astp_opt", (yyvsp[-1].ast_pair) );
      DUMP_AST( "array_size_c_ast", (yyvsp[0].ast) );

      c_ast_set_parent(
        c_ast_new_gc( K_PLACEHOLDER, &(yylsp[-1]) ), (yyvsp[0].ast)
      );

      c_ast_t *const of_ast = ia_type_spec_ast( type_ast );
      if ( (yyvsp[-1].ast_pair).target_ast != NULL ) {
        // array-of or function-like-ret type
        (yyval.ast_pair) = (c_ast_pair_t){
          (yyvsp[-1].ast_pair).ast,
          c_ast_add_array( (yyvsp[-1].ast_pair).target_ast, (yyvsp[0].ast), of_ast )
        };
      } else {
        c_ast_t *const ast = IF_ELSE( (yyvsp[-1].ast_pair).ast, of_ast );
        (yyval.ast_pair) = (c_ast_pair_t){
          c_ast_add_array( ast, (yyvsp[0].ast), of_ast ),
          .target_ast = NULL
        };
      }

      DUMP_AST_PAIR( "$$_astp", (yyval.ast_pair) );
      DUMP_END();
    }
#line 10010 "parser.c"
    break;

  case 476: /* $@31: %empty  */
#line 5955 "parser.y"
    { //
      // A block AST has to be the type inherited attribute for cast_c_astp_opt
      // so we have to create it here.
      //
      ia_type_ast_push( c_ast_new_gc( K_APPLE_BLOCK, &(yyloc) ) );
    }
#line 10021 "parser.c"
    break;

  case 477: /* block_cast_c_astp: '(' '^' $@31 type_qualifier_list_c_stid_opt cast_c_astp_opt rparen_exp lparen_exp param_c_ast_list_opt ')'  */
#line 5963 "parser.y"
    {
      c_ast_t *const block_ast = ia_type_ast_pop();
      c_ast_t *const type_ast = ia_type_ast_peek();

      DUMP_START();
      DUMP_PROD( "block_cast_c_astp",
                 "'(' '^' type_qualifier_list_c_stid_opt cast_c_astp_opt ')' "
                 "'(' param_c_ast_list_opt ')'" );
      DUMP_AST( "in_attr__type_c_ast", type_ast );
      DUMP_TID( "type_qualifier_list_c_stid_opt", (yyvsp[-5].tid) );
      DUMP_AST_PAIR( "cast_c_astp_opt", (yyvsp[-4].ast_pair) );
      DUMP_AST_LIST( "param_c_ast_list_opt", (yyvsp[-1].ast_list) );

      PARSE_ASSERT(
        c_type_add_tid( &block_ast->type, (yyvsp[-5].tid), &(yylsp[-5]) )
      );
      c_ast_list_set_param_of( &(yyvsp[-1].ast_list), block_ast );
      block_ast->block.param_ast_list = slist_move( &(yyvsp[-1].ast_list) );

      c_ast_t *const ret_ast = ia_type_spec_ast( type_ast );
      if ( (yyvsp[-4].ast_pair).target_ast != NULL ) {
        (yyval.ast_pair) = (c_ast_pair_t){
          (yyvsp[-4].ast_pair).ast,
          c_ast_add_func( (yyvsp[-4].ast_pair).target_ast, block_ast, ret_ast )
        };
      }
      else {
        (yyval.ast_pair) = (c_ast_pair_t){
          c_ast_add_func( (yyvsp[-4].ast_pair).ast, block_ast, ret_ast ),
          block_ast->block.ret_ast
        };
      }

      DUMP_AST_PAIR( "$$_astp", (yyval.ast_pair) );
      DUMP_END();
    }
#line 10062 "parser.c"
    break;

  case 478: /* func_cast_c_astp: cast2_c_astp '(' param_c_ast_list_opt rparen_func_qualifier_list_c_stid_opt noexcept_c_stid_opt trailing_return_type_c_ast_opt  */
#line 6009 "parser.y"
    {
      c_ast_t *const type_ast = ia_type_ast_peek();

      DUMP_START();
      DUMP_PROD( "func_cast_c_astp",
                 "cast2_c_astp '(' param_c_ast_list_opt ')' "
                 "func_qualifier_list_c_stid_opt noexcept_c_stid_opt "
                 "trailing_return_type_c_ast_opt" );
      DUMP_AST( "in_attr__type_c_ast", type_ast );
      DUMP_AST_PAIR( "cast2_c_astp", (yyvsp[-5].ast_pair) );
      DUMP_AST_LIST( "param_c_ast_list_opt", (yyvsp[-3].ast_list) );
      DUMP_TID( "func_qualifier_list_c_stid_opt", (yyvsp[-2].tid) );
      DUMP_AST( "trailing_return_type_c_ast_opt", (yyvsp[0].ast) );
      DUMP_TID( "noexcept_c_stid_opt", (yyvsp[-1].tid) );

      c_ast_t *const func_ast = c_ast_new_gc( K_FUNCTION, &(yyloc) );
      func_ast->type.stids =
        c_tid_check( (yyvsp[-2].tid) | (yyvsp[-1].tid), C_TPID_STORE );
      c_ast_list_set_param_of( &(yyvsp[-3].ast_list), func_ast );
      func_ast->func.param_ast_list = slist_move( &(yyvsp[-3].ast_list) );

      c_ast_t *const cast_ast = (yyvsp[-5].ast_pair).ast;
      //
      // This is for a case similar to the one in func_decl_c_astp like:
      //
      //     void f( int () () )
      //              |   |  |
      //              |   |  func
      //              |   |
      //              |   cast_ast (func)
      //              |
      //              ret_ast
      //
      // We replace ret_ast with cast_ast:
      //
      //      void f( int() () )
      //              |  |  |
      //              |  |  func
      //              X  |
      //              |  cast_ast (func)
      //              |
      //              ret_ast <- cast_ast (func)
      //
      // that is, a "function returning function returning int" -- which is
      // illegal (since functions can't return functions) and will be caught by
      // c_ast_check_ret_type().
      //
      c_ast_t *const ret_ast = cast_ast->kind == K_FUNCTION ?
        cast_ast : IF_ELSE( (yyvsp[0].ast), ia_type_spec_ast( type_ast ) );

      if ( (yyvsp[-5].ast_pair).target_ast != NULL ) {
        (yyval.ast_pair) = (c_ast_pair_t){
          cast_ast,
          c_ast_add_func( (yyvsp[-5].ast_pair).target_ast, func_ast, ret_ast )
        };
      }
      else {
        (yyval.ast_pair) = (c_ast_pair_t){
          c_ast_add_func( cast_ast, func_ast, ret_ast ),
          func_ast->func.ret_ast
        };
      }

      DUMP_AST_PAIR( "$$_astp", (yyval.ast_pair) );
      DUMP_END();
    }
#line 10133 "parser.c"
    break;

  case 479: /* $@32: %empty  */
#line 6081 "parser.y"
    {
      ia_type_ast_push( c_ast_new_gc( K_PLACEHOLDER, &(yyloc) ) );
      ++in_attr.ast_depth;
    }
#line 10142 "parser.c"
    break;

  case 480: /* nested_cast_c_astp: '(' $@32 cast_c_astp_opt rparen_exp  */
#line 6086 "parser.y"
    {
      ia_type_ast_pop();
      --in_attr.ast_depth;

      c_ast_t *const type_ast = ia_type_ast_peek();

      DUMP_START();
      DUMP_PROD( "nested_cast_c_astp", "'(' cast_c_astp_opt ')'" );
      DUMP_AST( "in_attr__type_c_ast", type_ast );
      DUMP_AST_PAIR( "cast_c_astp_opt", (yyvsp[-1].ast_pair) );

      (yyval.ast_pair) = (yyvsp[-1].ast_pair);

      if ( (yyval.ast_pair).ast == NULL ) {
        //
        // This is for a case like:
        //
        //      void f( int() )
        //                 ^^
        //
        // where the unnamed parameter is a "function returning int".  (In
        // param_c_ast, this will be converted into a "pointer to function
        // returning int".)
        //
        (yyval.ast_pair).ast = c_ast_new_gc( K_FUNCTION, &(yyloc) );
        c_ast_set_parent( type_ast, (yyval.ast_pair).ast );
      } else {
        (yyval.ast_pair).ast->loc = (yyloc);
      }

      DUMP_AST_PAIR( "$$_astp", (yyval.ast_pair) );
      DUMP_END();
    }
#line 10180 "parser.c"
    break;

  case 481: /* $@33: %empty  */
#line 6124 "parser.y"
                                 { ia_type_ast_push( (yyvsp[0].ast) ); }
#line 10186 "parser.c"
    break;

  case 482: /* pointer_cast_c_astp: pointer_type_c_ast $@33 cast_c_astp_opt  */
#line 6126 "parser.y"
    {
      ia_type_ast_pop();

      DUMP_START();
      DUMP_PROD( "pointer_cast_c_astp", "pointer_type_c_ast cast_c_astp_opt" );
      DUMP_AST( "pointer_type_c_ast", (yyvsp[-2].ast) );
      DUMP_AST_PAIR( "cast_c_astp_opt", (yyvsp[0].ast_pair) );

      (yyval.ast_pair) = (c_ast_pair_t){
        c_ast_patch_placeholder( (yyvsp[-2].ast), (yyvsp[0].ast_pair).ast ),
        (yyvsp[0].ast_pair).target_ast
      };

      DUMP_AST_PAIR( "$$_astp", (yyval.ast_pair) );
      DUMP_END();
    }
#line 10207 "parser.c"
    break;

  case 483: /* $@34: %empty  */
#line 6147 "parser.y"
                                           { ia_type_ast_push( (yyvsp[0].ast) ); }
#line 10213 "parser.c"
    break;

  case 484: /* pointer_to_member_cast_c_astp: pointer_to_member_type_c_ast $@34 cast_c_astp_opt  */
#line 6149 "parser.y"
    {
      ia_type_ast_pop();

      DUMP_START();
      DUMP_PROD( "pointer_to_member_cast_c_astp",
                 "pointer_to_member_type_c_ast cast_c_astp_opt" );
      DUMP_AST( "pointer_to_member_type_c_ast", (yyvsp[-2].ast) );
      DUMP_AST_PAIR( "cast_c_astp_opt", (yyvsp[0].ast_pair) );

      (yyval.ast_pair) = (c_ast_pair_t){
        c_ast_patch_placeholder( (yyvsp[-2].ast), (yyvsp[0].ast_pair).ast ),
        (yyvsp[0].ast_pair).target_ast
      };

      DUMP_AST_PAIR( "$$_astp", (yyval.ast_pair) );
      DUMP_END();
    }
#line 10235 "parser.c"
    break;

  case 485: /* $@35: %empty  */
#line 6171 "parser.y"
                                   { ia_type_ast_push( (yyvsp[0].ast) ); }
#line 10241 "parser.c"
    break;

  case 486: /* reference_cast_c_astp: reference_type_c_ast $@35 cast_c_astp_opt  */
#line 6173 "parser.y"
    {
      ia_type_ast_pop();

      DUMP_START();
      DUMP_PROD( "reference_cast_c_astp",
                 "reference_type_c_ast cast_c_astp_opt" );
      DUMP_AST( "reference_type_c_ast", (yyvsp[-2].ast) );
      DUMP_AST_PAIR( "cast_c_astp_opt", (yyvsp[0].ast_pair) );

      (yyval.ast_pair) = (c_ast_pair_t){
        c_ast_patch_placeholder( (yyvsp[-2].ast), (yyvsp[0].ast_pair).ast ),
        (yyvsp[0].ast_pair).target_ast
      };

      DUMP_AST_PAIR( "$$_astp", (yyval.ast_pair) );
      DUMP_END();
    }
#line 10263 "parser.c"
    break;

  case 487: /* udc_decl_c_ast_opt: %empty  */
#line 6201 "parser.y"
                                  { (yyval.ast) = NULL; }
#line 10269 "parser.c"
    break;

  case 493: /* $@36: %empty  */
#line 6213 "parser.y"
                                 { ia_type_ast_push( (yyvsp[0].ast) ); }
#line 10275 "parser.c"
    break;

  case 494: /* pointer_udc_decl_c_ast: pointer_type_c_ast $@36 udc_decl_c_ast_opt  */
#line 6215 "parser.y"
    {
      ia_type_ast_pop();

      DUMP_START();
      DUMP_PROD( "pointer_udc_decl_c_ast",
                 "pointer_type_c_ast udc_decl_c_ast_opt" );
      DUMP_AST( "pointer_type_c_ast", (yyvsp[-2].ast) );
      DUMP_AST( "udc_decl_c_ast_opt", (yyvsp[0].ast) );

      (yyval.ast) = c_ast_patch_placeholder( (yyvsp[-2].ast), (yyvsp[0].ast) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 10294 "parser.c"
    break;

  case 495: /* $@37: %empty  */
#line 6232 "parser.y"
                                           { ia_type_ast_push( (yyvsp[0].ast) ); }
#line 10300 "parser.c"
    break;

  case 496: /* pointer_to_member_udc_decl_c_ast: pointer_to_member_type_c_ast $@37 udc_decl_c_ast_opt  */
#line 6234 "parser.y"
    {
      ia_type_ast_pop();

      DUMP_START();
      DUMP_PROD( "pointer_to_member_udc_decl_c_ast",
                 "pointer_to_member_type_c_ast udc_decl_c_ast_opt" );
      DUMP_AST( "pointer_to_member_type_c_ast", (yyvsp[-2].ast) );
      DUMP_AST( "udc_decl_c_ast_opt", (yyvsp[0].ast) );

      (yyval.ast) = c_ast_patch_placeholder( (yyvsp[-2].ast), (yyvsp[0].ast) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 10319 "parser.c"
    break;

  case 497: /* $@38: %empty  */
#line 6251 "parser.y"
                                   { ia_type_ast_push( (yyvsp[0].ast) ); }
#line 10325 "parser.c"
    break;

  case 498: /* reference_udc_decl_c_ast: reference_type_c_ast $@38 udc_decl_c_ast_opt  */
#line 6253 "parser.y"
    {
      ia_type_ast_pop();

      DUMP_START();
      DUMP_PROD( "reference_udc_decl_c_ast",
                 "reference_type_c_ast udc_decl_c_ast_opt" );
      DUMP_AST( "reference_type_c_ast", (yyvsp[-2].ast) );
      DUMP_AST( "udc_decl_c_ast_opt", (yyvsp[0].ast) );

      (yyval.ast) = c_ast_patch_placeholder( (yyvsp[-2].ast), (yyvsp[0].ast) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 10344 "parser.c"
    break;

  case 499: /* type_c_ast: type_modifier_list_c_type  */
#line 6280 "parser.y"
    {
      DUMP_START();
      DUMP_PROD( "type_c_ast", "type_modifier_list_c_type" );
      DUMP_TYPE( "type_modifier_list_c_type", (yyvsp[0].type) );

      //
      // Prior to C99, typeless declarations are implicitly int, so we set it
      // here.  In C99 and later, however, implicit int is an error, so we
      // don't set it here and c_ast_check() will catch the error later.
      //
      // Note that type modifiers, e.g., unsigned, count as a type since that
      // means unsigned int; however, neither qualifiers, e.g., const, nor
      // storage classes, e.g., register, by themselves count as a type:
      //
      //      unsigned i;   // legal in C99
      //      const    j;   // illegal in C99
      //      register k;   // illegal in C99
      //
      c_type_t type = OPT_LANG_IS( IMPLICIT_int ) ?
        C_TYPE_LIT_B( TB_int ) : T_NONE;

      PARSE_ASSERT( c_type_add( &type, &(yyvsp[0].type), &(yylsp[0]) ) );

      (yyval.ast) = c_ast_new_gc( K_BUILTIN, &(yyloc) );
      (yyval.ast)->type = type;

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 10378 "parser.c"
    break;

  case 500: /* type_c_ast: type_modifier_list_c_type east_modified_type_c_ast  */
#line 6316 "parser.y"
    {
      DUMP_START();
      DUMP_PROD( "type_c_ast",
                 "type_modifier_list_c_type east_modified_type_c_ast " );
      DUMP_TYPE( "type_modifier_list_c_type", (yyvsp[-1].type) );
      DUMP_AST( "east_modified_type_c_ast", (yyvsp[0].ast) );

      (yyval.ast) = (yyvsp[0].ast);
      (yyval.ast)->loc = (yyloc);
      PARSE_ASSERT( c_type_add( &(yyval.ast)->type, &(yyvsp[-1].type), &(yylsp[-1]) ) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 10397 "parser.c"
    break;

  case 502: /* type_modifier_list_c_type_opt: %empty  */
#line 6335 "parser.y"
                                  { (yyval.type) = T_NONE; }
#line 10403 "parser.c"
    break;

  case 504: /* type_modifier_list_c_type: type_modifier_list_c_type type_modifier_c_type  */
#line 6341 "parser.y"
    {
      DUMP_START();
      DUMP_PROD( "type_modifier_list_c_type",
                 "type_modifier_list_c_type type_modifier_c_type" );
      DUMP_TYPE( "type_modifier_list_c_type", (yyvsp[-1].type) );
      DUMP_TYPE( "type_modifier_c_type", (yyvsp[0].type) );

      (yyval.type) = (yyvsp[-1].type);
      PARSE_ASSERT( c_type_add( &(yyval.type), &(yyvsp[0].type), &(yylsp[0]) ) );

      DUMP_TYPE( "$$_type", (yyval.type) );
      DUMP_END();
    }
#line 10421 "parser.c"
    break;

  case 506: /* type_modifier_c_type: type_modifier_base_type  */
#line 6360 "parser.y"
    {
      (yyval.type) = (yyvsp[0].type);
      //
      // This is for a case like:
      //
      //      explain typedef unsigned long size_t
      //
      // that is: explain a redefinition of a typedef'd type with the same type
      // that contains only one or more type_modifier_base_type.  The problem
      // is that, without an east_modified_type_c_ast (like int), the parser
      // would ordinarily take the typedef'd type (here, the size_t) as part of
      // the type_c_ast and then be out of tokens for the decl_c_astp -- at
      // which time it'll complain.
      //
      // Since type modifiers can't apply to a typedef'd type (e.g., "long
      // size_t" is illegal), we tell the lexer not to return either
      // Y_TYPEDEF_NAME or Y_TYPEDEF_SNAME if we encounter at least one type
      // modifier (except "register" since it's is really a storage class --
      // see the comment in type_modifier_base_type about "register").
      //
      if ( (yyval.type).stids != TS_register )
        lexer_find &= ~LEXER_FIND_TYPES;
    }
#line 10449 "parser.c"
    break;

  case 507: /* type_modifier_c_type: type_qualifier_c_stid  */
#line 6383 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 10455 "parser.c"
    break;

  case 509: /* type_modifier_c_type: attribute_specifier_list_c_atid  */
#line 6386 "parser.y"
    {
      (yyval.type) = C_TYPE_LIT_A( (yyvsp[0].tid) );
    }
#line 10463 "parser.c"
    break;

  case 510: /* type_modifier_base_type: Y__Complex  */
#line 6392 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_B( (yyvsp[0].tid) ); }
#line 10469 "parser.c"
    break;

  case 511: /* type_modifier_base_type: Y__Imaginary  */
#line 6393 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_B( (yyvsp[0].tid) ); }
#line 10475 "parser.c"
    break;

  case 512: /* type_modifier_base_type: Y_long  */
#line 6394 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_B( (yyvsp[0].tid) ); }
#line 10481 "parser.c"
    break;

  case 513: /* type_modifier_base_type: Y_short  */
#line 6395 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_B( (yyvsp[0].tid) ); }
#line 10487 "parser.c"
    break;

  case 514: /* type_modifier_base_type: Y_signed  */
#line 6396 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_B( (yyvsp[0].tid) ); }
#line 10493 "parser.c"
    break;

  case 515: /* type_modifier_base_type: Y_unsigned  */
#line 6397 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_B( (yyvsp[0].tid) ); }
#line 10499 "parser.c"
    break;

  case 516: /* type_modifier_base_type: Y_EMC__Sat  */
#line 6398 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_B( (yyvsp[0].tid) ); }
#line 10505 "parser.c"
    break;

  case 517: /* type_modifier_base_type: Y_register  */
#line 6404 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 10511 "parser.c"
    break;

  case 518: /* east_modified_type_c_ast: atomic_builtin_typedef_type_c_ast type_modifier_list_c_type_opt  */
#line 6410 "parser.y"
    {
      DUMP_START();
      DUMP_PROD( "east_modified_type_c_ast",
                 "atomic_builtin_typedef_type_c_ast "
                 "type_modifier_list_c_type_opt" );
      DUMP_AST( "atomic_builtin_typedef_type_c_ast", (yyvsp[-1].ast) );
      DUMP_TYPE( "type_modifier_list_c_type_opt", (yyvsp[0].type) );

      (yyval.ast) = (yyvsp[-1].ast);
      (yyval.ast)->loc = (yyloc);
      PARSE_ASSERT( c_type_add( &(yyval.ast)->type, &(yyvsp[0].type), &(yylsp[0]) ) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 10531 "parser.c"
    break;

  case 519: /* east_modified_type_c_ast: enum_class_struct_union_c_ast cv_qualifier_list_stid_opt  */
#line 6428 "parser.y"
    {
      DUMP_START();
      DUMP_PROD( "east_modified_type_c_ast",
                 "enum_class_struct_union_c_ast cv_qualifier_list_stid_opt" );
      DUMP_AST( "enum_class_struct_union_c_ast", (yyvsp[-1].ast) );
      DUMP_TID( "cv_qualifier_list_stid_opt", (yyvsp[0].tid) );

      (yyval.ast) = (yyvsp[-1].ast);
      (yyval.ast)->loc = (yyloc);
      PARSE_ASSERT( c_type_add_tid( &(yyval.ast)->type, (yyvsp[0].tid), &(yylsp[0]) ) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 10550 "parser.c"
    break;

  case 524: /* $@39: %empty  */
#line 6455 "parser.y"
    {
      ia_type_ast_push( (yyvsp[0].ast) );
    }
#line 10558 "parser.c"
    break;

  case 525: /* atomic_specifier_type_c_ast: Y__Atomic_SPEC lparen_exp type_c_ast $@39 cast_c_astp_opt rparen_exp  */
#line 6459 "parser.y"
    {
      ia_type_ast_pop();

      DUMP_START();
      DUMP_PROD( "atomic_specifier_type_c_ast",
                 "ATOMIC '(' type_c_ast cast_c_astp_opt ')'" );
      DUMP_AST( "type_c_ast", (yyvsp[-3].ast) );
      DUMP_AST_PAIR( "cast_c_astp_opt", (yyvsp[-1].ast_pair) );

      (yyval.ast) = IF_ELSE( (yyvsp[-1].ast_pair).ast, (yyvsp[-3].ast) );
      (yyval.ast)->loc = (yyloc);

      //
      // Ensure the _Atomic() specifier type doesn't have either a storage
      // class or attributes:
      //
      //      const _Atomic(int) x;     // OK
      //      _Atomic(const int) y;     // error
      //
      // This check has to be done now in the parser rather than later in the
      // AST since the type would be stored as "atomic const int" either way so
      // the AST has no "memory" of which it was.
      //
      if ( (yyval.ast)->type.stids != TS_NONE || (yyval.ast)->type.atids != TA_NONE ) {
        static c_type_t const TSA_ANY = { TB_NONE, TS_ANY, TA_ANY };
        c_type_t const error_type = c_type_and( &(yyval.ast)->type, &TSA_ANY );
        print_error( &(yylsp[-3]),
          "\"%s\" can not be of \"%s\"\n",
          c_tid_name_error( TS__Atomic ),
          c_type_name_c( &error_type )
        );
        PARSE_ABORT();
      }

      PARSE_ASSERT( c_type_add_tid( &(yyval.ast)->type, TS__Atomic, &(yylsp[-5]) ) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 10602 "parser.c"
    break;

  case 526: /* builtin_type_c_ast: builtin_no_BitInt_c_btid  */
#line 6504 "parser.y"
    {
      DUMP_START();
      DUMP_PROD( "builtin_type_c_ast", "builtin_no_BitInt_c_btid" );
      DUMP_TID( "builtin_no_BitInt_c_btid", (yyvsp[0].tid) );

      (yyval.ast) = c_ast_new_gc( K_BUILTIN, &(yyloc) );
      (yyval.ast)->type.btids = c_tid_check( (yyvsp[0].tid), C_TPID_BASE );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 10618 "parser.c"
    break;

  case 527: /* builtin_type_c_ast: Y__BitInt lparen_exp uint_lit_exp rparen_exp  */
#line 6516 "parser.y"
    {
      DUMP_START();
      DUMP_PROD( "builtin_type_c_ast", "_BitInt '(' uint_lit_exp ')'" );
      DUMP_INT( "uint_lit_exp", (yyvsp[-1].uint_val) );

      (yyval.ast) = c_ast_new_gc( K_BUILTIN, &(yyloc) );
      (yyval.ast)->type.btids = TB__BitInt;
      (yyval.ast)->builtin.BitInt.width = (yyvsp[-1].uint_val);

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 10635 "parser.c"
    break;

  case 542: /* $@40: %empty  */
#line 6549 "parser.y"
    {
      ia_type_ast_push( (yyvsp[0].ast) );
    }
#line 10643 "parser.c"
    break;

  case 543: /* typeof_type_c_ast: typeof lparen_exp type_c_ast $@40 cast_c_astp_opt rparen_exp  */
#line 6553 "parser.y"
    {
      ia_type_ast_pop();

      DUMP_START();
      DUMP_PROD( "typeof_type_c_ast",
                 "TYPEOF '(' type_c_ast cast_c_astp_opt ')'" );
      DUMP_BOOL( "is_unqual", (yyvsp[-5].flag) );
      DUMP_AST( "type_c_ast", (yyvsp[-3].ast) );
      DUMP_AST_PAIR( "cast_c_astp_opt", (yyvsp[-1].ast_pair) );

      if ( (yyvsp[-5].flag) ) {
        c_ast_t const *const raw_ast = c_ast_untypedef( (yyvsp[-3].ast) );
        if ( raw_ast != (yyvsp[-3].ast) &&
             c_tid_is_any( raw_ast->type.stids, TS__Atomic | TS_CVR ) ) {
          //
          // The type is a typedef and the type that it's for is ACVR-qualified
          // so we need to dup _that_ type before un-ACVR-qualifying it because
          // we don't want to modify it.
          //
          (yyvsp[-3].ast) = c_ast_dup_gc( raw_ast );
        }
        (yyvsp[-3].ast)->type.stids &= c_tid_compl( TS__Atomic | TS_CVR );
      }

      (yyval.ast) = c_ast_patch_placeholder( (yyvsp[-3].ast), (yyvsp[-1].ast_pair).ast );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();

      //
      // Overwrite type_spec_ast to be the typeof type since _that_ is the base
      // type for one or more declarators, e.g.:
      //
      //      typeof(int*) p, a[2], f(char)
      //
      in_attr.type_spec_ast = (yyval.ast);
    }
#line 10685 "parser.c"
    break;

  case 544: /* typeof_type_c_ast: typeof lparen_exp error  */
#line 6592 "parser.y"
    {
      elaborate_error(
        "typeof(expression) declarations not supported by " CDECL
      );
    }
#line 10695 "parser.c"
    break;

  case 545: /* typeof: Y_typeof  */
#line 6600 "parser.y"
                                  { (yyval.flag) = /*is_unqual=*/false; }
#line 10701 "parser.c"
    break;

  case 546: /* typeof: Y_typeof_unqual  */
#line 6601 "parser.y"
                                  { (yyval.flag) = /*is_unqual=*/true;  }
#line 10707 "parser.c"
    break;

  case 549: /* class_struct_union_c_ast: class_struct_union_btid attribute_specifier_list_c_atid_opt any_sname_c_exp  */
#line 6614 "parser.y"
    {
      DUMP_START();
      DUMP_PROD( "enum_class_struct_union_c_ast",
                 "class_struct_union_btid "
                 "attribute_specifier_list_c_atid_opt any_sname_c_exp" );
      DUMP_TID( "class_struct_union_btid", (yyvsp[-2].tid) );
      DUMP_TID( "attribute_specifier_list_c_atid_opt", (yyvsp[-1].tid) );
      DUMP_SNAME( "any_sname_c_exp", (yyvsp[0].sname) );

      (yyval.ast) = c_ast_new_gc( K_CLASS_STRUCT_UNION, &(yyloc) );
      (yyval.ast)->type.btids = c_tid_check( (yyvsp[-2].tid), C_TPID_BASE );
      (yyval.ast)->type.atids = c_tid_check( (yyvsp[-1].tid), C_TPID_ATTR );
      (yyval.ast)->csu.csu_sname = c_sname_move( &(yyvsp[0].sname) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 10729 "parser.c"
    break;

  case 550: /* class_struct_union_c_ast: class_struct_union_btid attribute_specifier_list_c_atid_opt any_sname_c_opt '{'  */
#line 6634 "parser.y"
    {
      UNSUPPORTED( &(yylsp[0]),
        "explaining %s declarations", c_tid_name_c( (yyvsp[-3].tid) )
      );
      c_sname_cleanup( &(yyvsp[-1].sname) );
      PARSE_ABORT();
    }
#line 10741 "parser.c"
    break;

  case 551: /* enum_c_ast: enum_btids attribute_specifier_list_c_atid_opt any_sname_c_exp enum_fixed_type_c_ast_opt  */
#line 6646 "parser.y"
    {
      DUMP_START();
      DUMP_PROD( "enum_c_ast",
                 "enum_btids attribute_specifier_list_c_atid_opt "
                 "any_sname_c_exp enum_fixed_type_c_ast_opt" );
      DUMP_TID( "enum_btids", (yyvsp[-3].tid) );
      DUMP_TID( "attribute_specifier_list_c_atid_opt", (yyvsp[-2].tid) );
      DUMP_SNAME( "any_sname_c_exp", (yyvsp[-1].sname) );
      DUMP_AST( "enum_fixed_type_c_ast_opt", (yyvsp[0].ast) );

      (yyval.ast) = c_ast_new_gc( K_ENUM, &(yyloc) );
      (yyval.ast)->type.btids = c_tid_check( (yyvsp[-3].tid), C_TPID_BASE );
      (yyval.ast)->type.atids = c_tid_check( (yyvsp[-2].tid), C_TPID_ATTR );
      c_ast_set_parent( (yyvsp[0].ast), (yyval.ast) );
      (yyval.ast)->enum_.enum_sname = c_sname_move( &(yyvsp[-1].sname) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 10765 "parser.c"
    break;

  case 552: /* enum_c_ast: enum_btids attribute_specifier_list_c_atid_opt any_sname_c_opt '{'  */
#line 6668 "parser.y"
    {
      c_sname_cleanup( &(yyvsp[-1].sname) );
      UNSUPPORTED( &(yylsp[0]),
        "explaining %s declarations", c_tid_name_c( (yyvsp[-3].tid) )
      );
      PARSE_ABORT();
    }
#line 10777 "parser.c"
    break;

  case 553: /* enum_btids: Y_enum class_struct_btid_opt  */
#line 6680 "parser.y"
                                  { (yyval.tid) = (yyvsp[-1].tid) | (yyvsp[0].tid); }
#line 10783 "parser.c"
    break;

  case 554: /* enum_fixed_type_c_ast_opt: %empty  */
#line 6684 "parser.y"
                                  { (yyval.ast) = NULL; }
#line 10789 "parser.c"
    break;

  case 555: /* enum_fixed_type_c_ast_opt: ':' enum_fixed_type_c_ast  */
#line 6685 "parser.y"
                                  { (yyval.ast) = (yyvsp[0].ast); }
#line 10795 "parser.c"
    break;

  case 556: /* enum_fixed_type_c_ast_opt: ':' error  */
#line 6687 "parser.y"
    {
      elaborate_error( "type name expected" );
    }
#line 10803 "parser.c"
    break;

  case 557: /* enum_fixed_type_c_ast: enum_fixed_type_modifier_list_btid  */
#line 6703 "parser.y"
    {
      DUMP_START();
      DUMP_PROD( "enum_fixed_type_c_ast",
                 "enum_fixed_type_modifier_list_btid" );
      DUMP_TID( "enum_fixed_type_modifier_list_btid", (yyvsp[0].tid) );

      (yyval.ast) = c_ast_new_gc( K_BUILTIN, &(yylsp[0]) );
      (yyval.ast)->type.btids = c_tid_check( (yyvsp[0].tid), C_TPID_BASE );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 10820 "parser.c"
    break;

  case 558: /* enum_fixed_type_c_ast: enum_fixed_type_modifier_list_btid enum_unmodified_fixed_type_c_ast enum_fixed_type_modifier_list_btid_opt  */
#line 6724 "parser.y"
    {
      DUMP_START();
      DUMP_PROD( "enum_fixed_type_c_ast",
                 "enum_fixed_type_modifier_list_btid "
                 "enum_unmodified_fixed_type_c_ast "
                 "enum_fixed_type_modifier_list_btid_opt" );
      DUMP_TID( "enum_fixed_type_modifier_list_btid", (yyvsp[-2].tid) );
      DUMP_AST( "enum_unmodified_fixed_type_c_ast", (yyvsp[-1].ast) );
      DUMP_TID( "enum_fixed_type_modifier_list_btid_opt", (yyvsp[0].tid) );

      (yyval.ast) = (yyvsp[-1].ast);
      (yyval.ast)->loc = (yyloc);
      PARSE_ASSERT( c_type_add_tid( &(yyval.ast)->type, (yyvsp[-2].tid), &(yylsp[-2]) ) );
      PARSE_ASSERT( c_type_add_tid( &(yyval.ast)->type, (yyvsp[0].tid), &(yylsp[0]) ) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 10843 "parser.c"
    break;

  case 559: /* enum_fixed_type_c_ast: enum_unmodified_fixed_type_c_ast enum_fixed_type_modifier_list_btid_opt  */
#line 6750 "parser.y"
    {
      DUMP_START();
      DUMP_PROD( "enum_fixed_type_c_ast",
                 "enum_unmodified_fixed_type_c_ast "
                 "enum_fixed_type_modifier_list_btid_opt" );
      DUMP_AST( "enum_unmodified_fixed_type_c_ast", (yyvsp[-1].ast) );
      DUMP_TID( "enum_fixed_type_modifier_list_btid_opt", (yyvsp[0].tid) );

      (yyval.ast) = (yyvsp[-1].ast);
      (yyval.ast)->loc = (yyloc);
      PARSE_ASSERT( c_type_add_tid( &(yyval.ast)->type, (yyvsp[0].tid), &(yylsp[0]) ) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 10863 "parser.c"
    break;

  case 560: /* enum_fixed_type_modifier_list_btid_opt: %empty  */
#line 6768 "parser.y"
                                  { (yyval.tid) = TB_NONE; }
#line 10869 "parser.c"
    break;

  case 562: /* enum_fixed_type_modifier_list_btid: enum_fixed_type_modifier_list_btid enum_fixed_type_modifier_btid  */
#line 6775 "parser.y"
    {
      DUMP_START();
      DUMP_PROD( "enum_fixed_type_modifier_list_btid",
                 "enum_fixed_type_modifier_list_btid "
                 "enum_fixed_type_modifier_btid" );
      DUMP_TID( "enum_fixed_type_modifier_list_btid", (yyvsp[-1].tid) );
      DUMP_TID( "enum_fixed_type_modifier_btid", (yyvsp[0].tid) );

      (yyval.tid) = (yyvsp[-1].tid);
      PARSE_ASSERT( c_tid_add( &(yyval.tid), (yyvsp[0].tid), &(yylsp[0]) ) );

      DUMP_TID( "$$_btids", (yyval.tid) );
      DUMP_END();
    }
#line 10888 "parser.c"
    break;

  case 571: /* class_struct_btid_opt: %empty  */
#line 6809 "parser.y"
                                  { (yyval.tid) = TB_NONE; }
#line 10894 "parser.c"
    break;

  case 577: /* type_qualifier_list_c_stid_opt: %empty  */
#line 6826 "parser.y"
                                  { (yyval.tid) = TS_NONE; }
#line 10900 "parser.c"
    break;

  case 579: /* type_qualifier_list_c_stid: type_qualifier_list_c_stid type_qualifier_c_stid gnu_or_msc_attribute_specifier_list_c_opt  */
#line 6833 "parser.y"
    {
      DUMP_START();
      DUMP_PROD( "type_qualifier_list_c_stid",
                 "type_qualifier_list_c_stid type_qualifier_c_stid" );
      DUMP_TID( "type_qualifier_list_c_stid", (yyvsp[-2].tid) );
      DUMP_TID( "type_qualifier_c_stid", (yyvsp[-1].tid) );

      (yyval.tid) = (yyvsp[-2].tid);
      PARSE_ASSERT( c_tid_add( &(yyval.tid), (yyvsp[-1].tid), &(yylsp[-1]) ) );

      DUMP_TID( "$$_stids", (yyval.tid) );
      DUMP_END();
    }
#line 10918 "parser.c"
    break;

  case 580: /* type_qualifier_list_c_stid: gnu_or_msc_attribute_specifier_list_c type_qualifier_c_stid  */
#line 6848 "parser.y"
    {
      (yyval.tid) = (yyvsp[0].tid);
    }
#line 10926 "parser.c"
    break;

  case 581: /* type_qualifier_list_c_stid: type_qualifier_c_stid gnu_or_msc_attribute_specifier_list_c_opt  */
#line 6853 "parser.y"
    {
      (yyval.tid) = (yyvsp[-1].tid);
    }
#line 10934 "parser.c"
    break;

  case 591: /* cv_qualifier_list_stid_opt: %empty  */
#line 6874 "parser.y"
                                  { (yyval.tid) = TS_NONE; }
#line 10940 "parser.c"
    break;

  case 592: /* cv_qualifier_list_stid_opt: cv_qualifier_list_stid_opt cv_qualifier_stid  */
#line 6876 "parser.y"
    {
      DUMP_START();
      DUMP_PROD( "cv_qualifier_list_stid_opt",
                 "cv_qualifier_list_stid_opt cv_qualifier_stid" );
      DUMP_TID( "cv_qualifier_list_stid_opt", (yyvsp[-1].tid) );
      DUMP_TID( "cv_qualifier_stid", (yyvsp[0].tid) );

      (yyval.tid) = (yyvsp[-1].tid);
      PARSE_ASSERT( c_tid_add( &(yyval.tid), (yyvsp[0].tid), &(yylsp[0]) ) );

      DUMP_TID( "$$_stids", (yyval.tid) );
      DUMP_END();
    }
#line 10958 "parser.c"
    break;

  case 593: /* restrict_qualifier_c_stid: Y_restrict  */
#line 6893 "parser.y"
    { //
      // This check has to be done now in the parser rather than later in the
      // AST since both "restrict" and "__restrict" map to TS_restrict and the
      // AST has no "memory" of which it was.
      //
      if ( OPT_LANG_IS( CPP_ANY ) ) {
        print_error( &(yylsp[0]),
          "\"restrict\" not supported in C++; use \"%s\" instead\n",
          L_GNU___restrict
        );
        PARSE_ABORT();
      }
    }
#line 10976 "parser.c"
    break;

  case 598: /* upc_layout_qualifier_c: '[' error ']'  */
#line 6914 "parser.y"
    {
      elaborate_error( "one of nothing, integer, or '*' expected" );
    }
#line 10984 "parser.c"
    break;

  case 599: /* storage_class_c_type: Y_auto_STORAGE  */
#line 6922 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 10990 "parser.c"
    break;

  case 600: /* storage_class_c_type: Y_Apple___block  */
#line 6923 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 10996 "parser.c"
    break;

  case 601: /* storage_class_c_type: Y_consteval  */
#line 6924 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 11002 "parser.c"
    break;

  case 602: /* storage_class_c_type: Y_constexpr  */
#line 6925 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 11008 "parser.c"
    break;

  case 603: /* storage_class_c_type: Y_constinit  */
#line 6926 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 11014 "parser.c"
    break;

  case 604: /* storage_class_c_type: Y_explicit  */
#line 6927 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 11020 "parser.c"
    break;

  case 605: /* storage_class_c_type: Y_export  */
#line 6928 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 11026 "parser.c"
    break;

  case 606: /* storage_class_c_type: Y_extern  */
#line 6929 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 11032 "parser.c"
    break;

  case 607: /* storage_class_c_type: extern_linkage_c_stid  */
#line 6930 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 11038 "parser.c"
    break;

  case 608: /* storage_class_c_type: Y_final  */
#line 6931 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 11044 "parser.c"
    break;

  case 609: /* storage_class_c_type: Y_friend  */
#line 6932 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 11050 "parser.c"
    break;

  case 610: /* storage_class_c_type: Y_inline  */
#line 6933 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 11056 "parser.c"
    break;

  case 611: /* storage_class_c_type: Y_mutable  */
#line 6934 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 11062 "parser.c"
    break;

  case 612: /* storage_class_c_type: _Noreturn_atid  */
#line 6936 "parser.y"
    {
      //
      // These checks have to be done now in the parser rather than later in
      // the AST because the _Noreturn keyword is mapped to the [[noreturn]]
      // attribute and the AST has no "memory" that it was _Noreturn.
      //
      if ( !IS_SUPPORTED( _Noreturn ) ) {
        print_error( &(yylsp[0]),
          "\"%s\" keyword not supported%s",
          lexer_token, C_LANG_WHICH( _Noreturn )
        );
        print_hint(
          "%snoreturn%s", other_token_c( "[[" ), other_token_c( "]]" )
        );
        PARSE_ABORT();
      }
      if ( !OPT_LANG_IS( _Noreturn_NOT_DEPRECATED ) ) {
        print_warning( &(yylsp[0]),
          "\"%s\" is deprecated%s",
          lexer_token, C_LANG_WHICH( _Noreturn_NOT_DEPRECATED )
        );
        print_hint(
          "%snoreturn%s", other_token_c( "[[" ), other_token_c( "]]" )
        );
      }

      (yyval.type) = C_TYPE_LIT_A( (yyvsp[0].tid) );
    }
#line 11095 "parser.c"
    break;

  case 613: /* storage_class_c_type: Y_override  */
#line 6964 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 11101 "parser.c"
    break;

  case 614: /* storage_class_c_type: Y_static  */
#line 6966 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 11107 "parser.c"
    break;

  case 615: /* storage_class_c_type: Y_typedef  */
#line 6967 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 11113 "parser.c"
    break;

  case 616: /* storage_class_c_type: Y__Thread_local  */
#line 6968 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 11119 "parser.c"
    break;

  case 617: /* storage_class_c_type: Y_thread_local  */
#line 6969 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 11125 "parser.c"
    break;

  case 618: /* storage_class_c_type: Y_virtual  */
#line 6970 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 11131 "parser.c"
    break;

  case 621: /* attribute_specifier_list_c_atid_opt: %empty  */
#line 6981 "parser.y"
                                  { (yyval.tid) = TA_NONE; }
#line 11137 "parser.c"
    break;

  case 623: /* $@41: %empty  */
#line 6987 "parser.y"
    {
      if ( !IS_SUPPORTED( ATTRIBUTES ) ) {
        print_error( &(yylsp[-1]),
          "\"%s\" attribute syntax not supported%s\n",
          other_token_c( "[[" ),
          C_LANG_WHICH( ATTRIBUTES )
        );
        PARSE_ABORT();
      }
      lexer_keyword_ctx = C_KW_CTX_ATTRIBUTE;
    }
#line 11153 "parser.c"
    break;

  case 624: /* attribute_specifier_list_c_atid: Y_ATTR_BEGIN '[' $@41 using_opt attribute_list_c_atid_opt ']' rbracket_exp  */
#line 6999 "parser.y"
    {
      lexer_keyword_ctx = C_KW_CTX_DEFAULT;

      DUMP_START();
      DUMP_PROD( "attribute_specifier_list_c_atid",
                 "'[[' using_opt attribute_list_c_atid_opt ']]'" );
      DUMP_TID( "attribute_list_c_atid_opt", (yyvsp[-2].tid) );

      (yyval.tid) = (yyvsp[-2].tid);

      DUMP_END();
    }
#line 11170 "parser.c"
    break;

  case 625: /* attribute_specifier_list_c_atid: gnu_or_msc_attribute_specifier_list_c  */
#line 7013 "parser.y"
    {
      (yyval.tid) = TA_NONE;
    }
#line 11178 "parser.c"
    break;

  case 627: /* using_opt: Y_using name_exp colon_exp  */
#line 7021 "parser.y"
    {
      IGNORING( &(yylsp[-2]), "\"using\" in attributes" );
      free( (yyvsp[-1].name) );
    }
#line 11187 "parser.c"
    break;

  case 628: /* attribute_list_c_atid_opt: %empty  */
#line 7028 "parser.y"
                                  { (yyval.tid) = TA_NONE; }
#line 11193 "parser.c"
    break;

  case 630: /* attribute_list_c_atid: attribute_list_c_atid comma_exp attribute_c_atid_exp  */
#line 7034 "parser.y"
    {
      DUMP_START();
      DUMP_PROD( "attribute_list_c_atid",
                 "attribute_list_c_atid ',' attribute_c_atid" );
      DUMP_TID( "attribute_list_c_atid", (yyvsp[-2].tid) );
      DUMP_TID( "attribute_c_atid_exp", (yyvsp[0].tid) );

      (yyval.tid) = (yyvsp[-2].tid);
      PARSE_ASSERT( c_tid_add( &(yyval.tid), (yyvsp[0].tid), &(yylsp[0]) ) );

      DUMP_TID( "$$_atids", (yyval.tid) );
      DUMP_END();
    }
#line 11211 "parser.c"
    break;

  case 640: /* attribute_c_atid_exp: sname_c  */
#line 7061 "parser.y"
    {
      if ( c_sname_count( &(yyvsp[0].sname) ) > 1 ) {
        IGNORING( &(yylsp[0]),
          "\"%s\": namespaced attributes", c_sname_full_name( &(yyvsp[0].sname) )
        );
      }
      else {
        char const *adj = "unknown";
        c_lang_id_t lang_ids = LANG_NONE;

        char const *const name = c_sname_local_name( &(yyvsp[0].sname) );
        c_keyword_t const *const ck =
          c_keyword_find( name, c_lang_newer( opt_lang ), C_KW_CTX_ATTRIBUTE );
        if ( ck != NULL && c_tid_tpid( ck->tid ) == C_TPID_ATTR ) {
          adj = "unsupported";
          lang_ids = ck->lang_ids;
        }
        print_warning( &(yylsp[0]),
          "\"%s\": %s attribute%s",
          name, adj, c_lang_which( lang_ids )
        );

        print_suggestions( DYM_C_ATTRIBUTES, name );
        EPUTC( '\n' );
      }

      (yyval.tid) = TA_NONE;
      c_sname_cleanup( &(yyvsp[0].sname) );
    }
#line 11245 "parser.c"
    break;

  case 641: /* attribute_c_atid_exp: error  */
#line 7091 "parser.y"
    {
      elaborate_error_dym( DYM_C_ATTRIBUTES, "attribute name expected" );
    }
#line 11253 "parser.c"
    break;

  case 643: /* attribute_str_arg_c_opt: '(' str_lit_exp rparen_exp  */
#line 7099 "parser.y"
    {
      IGNORING( &(yylsp[-2]), "attribute arguments" );
      free( (yyvsp[-1].str_val) );
    }
#line 11262 "parser.c"
    break;

  case 652: /* $@42: %empty  */
#line 7127 "parser.y"
    {
      attr_syntax_not_supported( L_GNU___attribute__, &(yylsp[0]) );
      //
      // Temporariy disabling finding keywords allows GNU attributes that are C
      // keywords (e.g., const) to be found as ordinary string literals.
      //
      lexer_find &= ~LEXER_FIND_C_KEYWORDS;
    }
#line 11275 "parser.c"
    break;

  case 653: /* gnu_attribute_specifier_c: Y_GNU___attribute__ $@42 lparen_exp lparen_exp gnu_attribute_list_c_opt ')' rparen_exp  */
#line 7136 "parser.y"
    {
      lexer_find |= LEXER_FIND_C_KEYWORDS;
    }
#line 11283 "parser.c"
    break;

  case 658: /* gnu_attribute_c_exp: Y_NAME gnu_attribute_decl_arg_list_c_opt  */
#line 7153 "parser.y"
    {
      free( (yyvsp[-1].name) );
    }
#line 11291 "parser.c"
    break;

  case 659: /* gnu_attribute_c_exp: error  */
#line 7157 "parser.y"
    {
      elaborate_error( "attribute name expected" );
    }
#line 11299 "parser.c"
    break;

  case 666: /* gnu_attribute_arg_c: Y_NAME  */
#line 7178 "parser.y"
                                  { free( (yyvsp[0].name) ); }
#line 11305 "parser.c"
    break;

  case 667: /* gnu_attribute_arg_c: Y_CHAR_LIT  */
#line 7179 "parser.y"
                                  { free( (yyvsp[0].str_val) ); }
#line 11311 "parser.c"
    break;

  case 669: /* gnu_attribute_arg_c: Y_STR_LIT  */
#line 7181 "parser.y"
                                  { free( (yyvsp[0].str_val) ); }
#line 11317 "parser.c"
    break;

  case 671: /* gnu_attribute_arg_c: Y_LEXER_ERROR  */
#line 7184 "parser.y"
    {
      PARSE_ABORT();
    }
#line 11325 "parser.c"
    break;

  case 674: /* $@43: %empty  */
#line 7196 "parser.y"
    {
      attr_syntax_not_supported( L_MSC___declspec, &(yylsp[0]) );
      // See comment in gnu_attribute_specifier_c.
      lexer_find &= ~LEXER_FIND_C_KEYWORDS;
    }
#line 11335 "parser.c"
    break;

  case 675: /* msc_attribute_specifier_c: Y_MSC___declspec $@43 lparen_exp msc_attribute_list_c_opt ')'  */
#line 7202 "parser.y"
    {
      lexer_find |= LEXER_FIND_C_KEYWORDS;
    }
#line 11343 "parser.c"
    break;

  case 683: /* array_decl_english_ast: Y_array array_size_decl_ast of_exp decl_english_ast  */
#line 7238 "parser.y"
    {
      DUMP_START();
      DUMP_PROD( "array_decl_english_ast",
                 "ARRAY array_size_num_opt OF decl_english_ast" );
      DUMP_AST( "array_size_decl_ast", (yyvsp[-2].ast) );
      DUMP_AST( "decl_english_ast", (yyvsp[0].ast) );

      (yyval.ast) = (yyvsp[-2].ast);
      (yyval.ast)->loc = (yylsp[-3]);
      c_ast_set_parent( (yyvsp[0].ast), (yyval.ast) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 11362 "parser.c"
    break;

  case 684: /* array_decl_english_ast: Y_variable length_opt array_exp name_opt of_exp decl_english_ast  */
#line 7255 "parser.y"
    {
      DUMP_START();
      DUMP_PROD( "array_decl_english_ast",
                 "VARIABLE LENGTH ARRAY name_opt OF decl_english_ast" );
      DUMP_STR( "name_opt", (yyvsp[-2].name) );
      DUMP_AST( "decl_english_ast", (yyvsp[0].ast) );

      (yyval.ast) = c_ast_new_gc( K_ARRAY, &(yyloc) );
      if ( (yyvsp[-2].name) == NULL ) {
        (yyval.ast)->array.kind = C_ARRAY_VLA_STAR;
      } else {
        (yyval.ast)->array.kind = C_ARRAY_NAMED_SIZE;
        (yyval.ast)->array.size_name = (yyvsp[-2].name);
      }
      c_ast_set_parent( (yyvsp[0].ast), (yyval.ast) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 11386 "parser.c"
    break;

  case 685: /* array_size_decl_ast: %empty  */
#line 7278 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_ARRAY, &(yyloc) );
      (yyval.ast)->array.kind = C_ARRAY_EMPTY_SIZE;
    }
#line 11395 "parser.c"
    break;

  case 686: /* array_size_decl_ast: uint_lit  */
#line 7283 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_ARRAY, &(yyloc) );
      (yyval.ast)->array.kind = C_ARRAY_INT_SIZE;
      (yyval.ast)->array.size_int = (yyvsp[0].uint_val);
    }
#line 11405 "parser.c"
    break;

  case 687: /* array_size_decl_ast: Y_NAME  */
#line 7289 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_ARRAY, &(yyloc) );
      (yyval.ast)->array.kind = C_ARRAY_NAMED_SIZE;
      (yyval.ast)->array.size_name = (yyvsp[0].name);
    }
#line 11415 "parser.c"
    break;

  case 688: /* array_size_decl_ast: '*'  */
#line 7295 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_ARRAY, &(yyloc) );
      (yyval.ast)->array.kind = C_ARRAY_VLA_STAR;
    }
#line 11424 "parser.c"
    break;

  case 691: /* block_decl_english_ast: Y_Apple_block paren_param_decl_list_english_opt returning_english_ast_opt  */
#line 7312 "parser.y"
    {
      DUMP_START();
      DUMP_PROD( "block_decl_english_ast",
                 "BLOCK paren_param_decl_list_english_opt "
                 "returning_english_ast_opt" );
      DUMP_AST_LIST( "paren_param_decl_list_english_opt", (yyvsp[-1].ast_list) );
      DUMP_AST( "returning_english_ast_opt", (yyvsp[0].ast) );

      (yyval.ast) = c_ast_new_gc( K_APPLE_BLOCK, &(yyloc) );
      c_ast_list_set_param_of( &(yyvsp[-1].ast_list), (yyval.ast) );
      (yyval.ast)->block.param_ast_list = slist_move( &(yyvsp[-1].ast_list) );
      c_ast_set_parent( (yyvsp[0].ast), (yyval.ast) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 11445 "parser.c"
    break;

  case 692: /* constructor_decl_english_ast: Y_constructor paren_param_decl_list_english_opt  */
#line 7334 "parser.y"
    {
      DUMP_START();
      DUMP_PROD( "constructor_decl_english_ast",
                 "CONSTRUCTOR paren_param_decl_list_english_opt" );
      DUMP_AST_LIST( "paren_param_decl_list_english_opt", (yyvsp[0].ast_list) );

      (yyval.ast) = c_ast_new_gc( K_CONSTRUCTOR, &(yyloc) );
      c_ast_list_set_param_of( &(yyvsp[0].ast_list), (yyval.ast) );
      (yyval.ast)->ctor.param_ast_list = slist_move( &(yyvsp[0].ast_list) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 11463 "parser.c"
    break;

  case 693: /* destructor_decl_english_ast: Y_destructor parens_opt  */
#line 7353 "parser.y"
    {
      DUMP_START();
      DUMP_PROD( "destructor_decl_english_ast", "DESTRUCTOR ['(' ')']" );

      (yyval.ast) = c_ast_new_gc( K_DESTRUCTOR, &(yyloc) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 11477 "parser.c"
    break;

  case 696: /* func_decl_english_ast: func_qualifier_english_type_opt member_or_non_member_opt Y_function paren_param_decl_list_english_opt returning_english_ast_opt  */
#line 7376 "parser.y"
    {
      DUMP_START();
      DUMP_PROD( "func_decl_english_ast",
                 "ref_qualifier_english_stid_opt "
                 "member_or_non_member_opt "
                 "FUNCTION paren_param_decl_list_english_opt "
                 "returning_english_ast_opt" );
      DUMP_TYPE( "func_qualifier_english_type_opt", (yyvsp[-4].type) );
      DUMP_INT( "member_or_non_member_opt", (yyvsp[-3].member) );
      DUMP_AST_LIST( "paren_param_decl_list_english_opt", (yyvsp[-1].ast_list) );
      DUMP_AST( "returning_english_ast_opt", (yyvsp[0].ast) );

      (yyval.ast) = c_ast_new_gc( K_FUNCTION, &(yyloc) );
      (yyval.ast)->type = (yyvsp[-4].type);
      c_ast_list_set_param_of( &(yyvsp[-1].ast_list), (yyval.ast) );
      (yyval.ast)->func.param_ast_list = slist_move( &(yyvsp[-1].ast_list) );
      (yyval.ast)->func.member = (yyvsp[-3].member);
      c_ast_set_parent( (yyvsp[0].ast), (yyval.ast) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 11504 "parser.c"
    break;

  case 697: /* func_qualifier_english_type_opt: ref_qualifier_english_stid_opt  */
#line 7402 "parser.y"
    {
      (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) );
    }
#line 11512 "parser.c"
    break;

  case 698: /* func_qualifier_english_type_opt: msc_calling_convention_atid  */
#line 7406 "parser.y"
    {
      (yyval.type) = C_TYPE_LIT_A( (yyvsp[0].tid) );
    }
#line 11520 "parser.c"
    break;

  case 705: /* paren_param_decl_list_english_opt: %empty  */
#line 7423 "parser.y"
                                  { slist_init( &(yyval.ast_list) ); }
#line 11526 "parser.c"
    break;

  case 707: /* paren_param_decl_list_english: '(' param_decl_list_english_opt ')'  */
#line 7429 "parser.y"
    {
      DUMP_START();
      DUMP_PROD( "paren_param_decl_list_english",
                 "'(' param_decl_list_english_opt ')'" );
      DUMP_AST_LIST( "param_decl_list_english_opt", (yyvsp[-1].ast_list) );

      (yyval.ast_list) = (yyvsp[-1].ast_list);

      DUMP_AST_LIST( "$$_ast_list", (yyval.ast_list) );
      DUMP_END();
    }
#line 11542 "parser.c"
    break;

  case 708: /* param_decl_list_english_opt: %empty  */
#line 7443 "parser.y"
                                  { slist_init( &(yyval.ast_list) ); }
#line 11548 "parser.c"
    break;

  case 710: /* param_decl_list_english: param_decl_list_english comma_exp decl_english_ast_exp  */
#line 7450 "parser.y"
    {
      DUMP_START();
      DUMP_PROD( "param_decl_list_english",
                 "param_decl_list_english ',' decl_english_ast" );
      DUMP_AST_LIST( "param_decl_list_english", (yyvsp[-2].ast_list) );
      DUMP_AST( "decl_english_ast", (yyvsp[0].ast) );

      (yyval.ast_list) = (yyvsp[-2].ast_list);
      slist_push_back( &(yyval.ast_list), (yyvsp[0].ast) );

      DUMP_AST_LIST( "$$_ast_list", (yyval.ast_list) );
      DUMP_END();
    }
#line 11566 "parser.c"
    break;

  case 711: /* param_decl_list_english: decl_english_ast  */
#line 7465 "parser.y"
    {
      DUMP_START();
      DUMP_PROD( "param_decl_list_english", "decl_english_ast" );
      DUMP_AST( "decl_english_ast", (yyvsp[0].ast) );

      if ( (yyvsp[0].ast)->kind == K_FUNCTION ) // see the comment in param_c_ast
        (yyvsp[0].ast) = c_ast_pointer( (yyvsp[0].ast), &gc_ast_list );

      slist_init( &(yyval.ast_list) );
      slist_push_back( &(yyval.ast_list), (yyvsp[0].ast) );

      DUMP_AST_LIST( "$$_ast_list", (yyval.ast_list) );
      DUMP_END();
    }
#line 11585 "parser.c"
    break;

  case 713: /* decl_english_ast_exp: error  */
#line 7484 "parser.y"
    {
      elaborate_error( "declaration expected" );
    }
#line 11593 "parser.c"
    break;

  case 714: /* ref_qualifier_english_stid_opt: %empty  */
#line 7492 "parser.y"
                                  { (yyval.tid) = TS_NONE; }
#line 11599 "parser.c"
    break;

  case 715: /* ref_qualifier_english_stid_opt: Y_reference  */
#line 7493 "parser.y"
                                  { (yyval.tid) = TS_REFERENCE; }
#line 11605 "parser.c"
    break;

  case 716: /* ref_qualifier_english_stid_opt: Y_rvalue reference_exp  */
#line 7494 "parser.y"
                                  { (yyval.tid) = TS_RVALUE_REFERENCE; }
#line 11611 "parser.c"
    break;

  case 717: /* returning_english_ast_opt: %empty  */
#line 7501 "parser.y"
    {
      DUMP_START();
      DUMP_PROD( "returning_english_ast_opt", "<empty>" );

      (yyval.ast) = c_ast_new_gc( K_BUILTIN, &(yyloc) );
      // see the comment in "type_c_ast"
      (yyval.ast)->type.btids = OPT_LANG_IS( IMPLICIT_int ) ? TB_int : TB_void;

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 11627 "parser.c"
    break;

  case 719: /* returning_english_ast: returning decl_english_ast  */
#line 7518 "parser.y"
    {
      DUMP_START();
      DUMP_PROD( "returning_english_ast", "RETURNING decl_english_ast" );
      DUMP_AST( "decl_english_ast", (yyvsp[0].ast) );

      (yyval.ast) = (yyvsp[0].ast);

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 11642 "parser.c"
    break;

  case 720: /* returning_english_ast: returning error  */
#line 7530 "parser.y"
    {
      elaborate_error( "English expected after \"returning\"" );
    }
#line 11650 "parser.c"
    break;

  case 721: /* qualified_decl_english_ast: type_qualifier_list_english_type_opt qualifiable_decl_english_ast  */
#line 7540 "parser.y"
    {
      DUMP_START();
      DUMP_PROD( "qualified_decl_english_ast",
                 "type_qualifier_list_english_type_opt "
                 "qualifiable_decl_english_ast" );
      DUMP_TYPE( "type_qualifier_list_english_type_opt", (yyvsp[-1].type) );
      DUMP_AST( "qualifiable_decl_english_ast", (yyvsp[0].ast) );

      (yyval.ast) = (yyvsp[0].ast);
      if ( !c_type_is_none( &(yyvsp[-1].type) ) )
        (yyval.ast)->loc = (yyloc);
      PARSE_ASSERT( c_type_add( &(yyval.ast)->type, &(yyvsp[-1].type), &(yylsp[-1]) ) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 11671 "parser.c"
    break;

  case 722: /* type_qualifier_list_english_type_opt: %empty  */
#line 7559 "parser.y"
                                  { (yyval.type) = T_NONE; }
#line 11677 "parser.c"
    break;

  case 724: /* type_qualifier_list_english_type: type_qualifier_list_english_type type_qualifier_english_type  */
#line 7566 "parser.y"
    {
      DUMP_START();
      DUMP_PROD( "type_qualifier_list_english_type",
                 "type_qualifier_list_english_type "
                 "type_qualifier_english_type" );
      DUMP_TYPE( "type_qualifier_list_english_type", (yyvsp[-1].type) );
      DUMP_TYPE( "type_qualifier_english_type", (yyvsp[0].type) );

      (yyval.type) = (yyvsp[-1].type);
      PARSE_ASSERT( c_type_add( &(yyval.type), &(yyvsp[0].type), &(yylsp[0]) ) );

      DUMP_TYPE( "$$_type", (yyval.type) );
      DUMP_END();
    }
#line 11696 "parser.c"
    break;

  case 726: /* type_qualifier_english_type: attribute_english_atid  */
#line 7585 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_A( (yyvsp[0].tid) ); }
#line 11702 "parser.c"
    break;

  case 727: /* type_qualifier_english_type: storage_class_english_stid  */
#line 7586 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 11708 "parser.c"
    break;

  case 728: /* type_qualifier_english_type: type_qualifier_english_stid  */
#line 7587 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 11714 "parser.c"
    break;

  case 729: /* attribute_english_atid: Y_carries dependency_exp  */
#line 7591 "parser.y"
                                  { (yyval.tid) = TA_carries_dependency; }
#line 11720 "parser.c"
    break;

  case 732: /* attribute_english_atid: Y_maybe unused_exp  */
#line 7594 "parser.y"
                                  { (yyval.tid) = TA_maybe_unused; }
#line 11726 "parser.c"
    break;

  case 734: /* attribute_english_atid: Y_no Y_discard  */
#line 7596 "parser.y"
                                  { (yyval.tid) = TA_nodiscard; }
#line 11732 "parser.c"
    break;

  case 736: /* attribute_english_atid: Y_no Y_return  */
#line 7598 "parser.y"
                                  { (yyval.tid) = TA_noreturn; }
#line 11738 "parser.c"
    break;

  case 739: /* attribute_english_atid: Y_no Y_unique address_exp  */
#line 7601 "parser.y"
                                  { (yyval.tid) = TA_no_unique_address; }
#line 11744 "parser.c"
    break;

  case 745: /* storage_class_english_stid: Y_const_ENG eval_expr_init_stid  */
#line 7611 "parser.y"
    {
      (yyval.tid) = (yyvsp[0].tid);
    }
#line 11752 "parser.c"
    break;

  case 754: /* storage_class_english_stid: Y_extern linkage_stid linkage_opt  */
#line 7623 "parser.y"
    {
      (yyval.tid) = (yyvsp[-1].tid);
    }
#line 11760 "parser.c"
    break;

  case 759: /* storage_class_english_stid: Y_no Y_except  */
#line 7630 "parser.y"
                                  { (yyval.tid) = TS_noexcept; }
#line 11766 "parser.c"
    break;

  case 761: /* storage_class_english_stid: Y_non_empty  */
#line 7632 "parser.y"
                                  { (yyval.tid) = TS_NON_EMPTY_ARRAY; }
#line 11772 "parser.c"
    break;

  case 765: /* storage_class_english_stid: Y_thread local_exp  */
#line 7637 "parser.y"
                                  { (yyval.tid) = TS_thread_local; }
#line 11778 "parser.c"
    break;

  case 771: /* storage_class_english_stid: Y_pure virtual_stid_exp  */
#line 7643 "parser.y"
                                  { (yyval.tid) = TS_PURE_virtual | (yyvsp[0].tid); }
#line 11784 "parser.c"
    break;

  case 772: /* eval_expr_init_stid: Y_evaluation  */
#line 7647 "parser.y"
                                  { (yyval.tid) = TS_consteval; }
#line 11790 "parser.c"
    break;

  case 773: /* eval_expr_init_stid: Y_expression  */
#line 7648 "parser.y"
                                  { (yyval.tid) = TS_constexpr; }
#line 11796 "parser.c"
    break;

  case 774: /* eval_expr_init_stid: Y_initialization  */
#line 7649 "parser.y"
                                  { (yyval.tid) = TS_constinit; }
#line 11802 "parser.c"
    break;

  case 775: /* linkage_stid: str_lit  */
#line 7661 "parser.y"
    {
      bool ok = true;

      if ( strcmp( (yyvsp[0].str_val), "C" ) == 0 )
        (yyval.tid) = TS_extern_C;
      else if ( strcmp( (yyvsp[0].str_val), "C++" ) == 0 )
        (yyval.tid) = TS_NONE;
      else {
        print_error( &(yylsp[0]), "\"%s\": unknown linkage language", (yyvsp[0].str_val) );
        print_hint( "\"C\" or \"C++\"" );
        ok = false;
      }

      free( (yyvsp[0].str_val) );
      PARSE_ASSERT( ok );
    }
#line 11823 "parser.c"
    break;

  case 795: /* pointer_decl_english_ast: Y_pointer to_exp decl_english_ast  */
#line 7718 "parser.y"
    {
      DUMP_START();
      DUMP_PROD( "pointer_decl_english_ast", "POINTER TO decl_english_ast" );
      DUMP_AST( "decl_english_ast", (yyvsp[0].ast) );

      if ( (yyvsp[0].ast)->kind == K_NAME ) { // see the comment in "declare_command"
        assert( !c_sname_empty( &(yyvsp[0].ast)->sname ) );
        print_error_unknown_name( &(yylsp[0]), &(yyvsp[0].ast)->sname );
        PARSE_ABORT();
      }

      (yyval.ast) = c_ast_new_gc( K_POINTER, &(yyloc) );
      c_ast_set_parent( (yyvsp[0].ast), (yyval.ast) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 11845 "parser.c"
    break;

  case 796: /* pointer_decl_english_ast: Y_pointer to_exp Y_member of_exp class_struct_union_btid_exp sname_english_exp decl_english_ast  */
#line 7742 "parser.y"
    {
      DUMP_START();
      DUMP_PROD( "pointer_to_member_decl_english",
                 "POINTER TO MEMBER OF "
                 "class_struct_union_btid_exp "
                 "sname_english decl_english_ast" );
      DUMP_TID( "class_struct_union_btid_exp", (yyvsp[-2].tid) );
      DUMP_SNAME( "sname_english_exp", (yyvsp[-1].sname) );
      DUMP_AST( "decl_english_ast", (yyvsp[0].ast) );

      (yyval.ast) = c_ast_new_gc( K_POINTER_TO_MEMBER, &(yyloc) );
      (yyval.ast)->ptr_mbr.class_sname = c_sname_move( &(yyvsp[-1].sname) );
      c_ast_set_parent( (yyvsp[0].ast), (yyval.ast) );
      PARSE_ASSERT( c_type_add_tid( &(yyval.ast)->type, (yyvsp[-2].tid), &(yylsp[-2]) ) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 11868 "parser.c"
    break;

  case 797: /* pointer_decl_english_ast: Y_pointer to_exp error  */
#line 7762 "parser.y"
    {
      if ( OPT_LANG_IS( POINTERS_TO_MEMBER ) )
        elaborate_error( "type name or \"member\" expected" );
      else
        elaborate_error( "type name expected" );
    }
#line 11879 "parser.c"
    break;

  case 798: /* reference_decl_english_ast: reference_english_ast to_exp decl_english_ast  */
#line 7775 "parser.y"
    {
      DUMP_START();
      DUMP_PROD( "reference_decl_english_ast",
                 "reference_english_ast TO decl_english_ast" );
      DUMP_AST( "reference_english_ast", (yyvsp[-2].ast) );
      DUMP_AST( "decl_english_ast", (yyvsp[0].ast) );

      (yyval.ast) = (yyvsp[-2].ast);
      (yyval.ast)->loc = (yyloc);
      c_ast_set_parent( (yyvsp[0].ast), (yyval.ast) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 11898 "parser.c"
    break;

  case 799: /* reference_english_ast: Y_reference  */
#line 7793 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_REFERENCE, &(yyloc) );
    }
#line 11906 "parser.c"
    break;

  case 800: /* reference_english_ast: Y_rvalue reference_exp  */
#line 7798 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_RVALUE_REFERENCE, &(yyloc) );
    }
#line 11914 "parser.c"
    break;

  case 801: /* user_defined_literal_decl_english_ast: user_defined literal_exp lparen_exp param_decl_list_english_opt ')' returning_english_ast_opt  */
#line 7809 "parser.y"
    { //
      // User-defined literals are supported only in C++11 and later.
      // (However, we always allow them in configuration files.)
      //
      // This check is better to do now in the parser rather than later in the
      // AST because it has to be done in fewer places in the code plus gives a
      // better error location.
      //
      if ( !IS_SUPPORTED( USER_DEF_LITS ) ) {
        print_error( &(yylsp[-5]),
          "user-defined literals not supported%s\n",
          C_LANG_WHICH( USER_DEF_LITS )
        );
        PARSE_ABORT();
      }

      DUMP_START();
      DUMP_PROD( "user_defined_literal_decl_english_ast",
                 "USER-DEFINED LITERAL '(' param_decl_list_english_opt ')' "
                 "returning_english_ast_opt" );
      DUMP_AST_LIST( "param_decl_list_english_opt", (yyvsp[-2].ast_list) );
      DUMP_AST( "returning_english_ast_opt", (yyvsp[0].ast) );

      (yyval.ast) = c_ast_new_gc( K_UDEF_LIT, &(yyloc) );
      c_ast_list_set_param_of( &(yyvsp[-2].ast_list), (yyval.ast) );
      (yyval.ast)->udef_lit.param_ast_list = slist_move( &(yyvsp[-2].ast_list) );
      c_ast_set_parent( (yyvsp[0].ast), (yyval.ast) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 11950 "parser.c"
    break;

  case 802: /* var_decl_english_ast: sname_c Y_as decl_english_ast  */
#line 7849 "parser.y"
    {
      DUMP_START();
      DUMP_PROD( "var_decl_english_ast", "sname_c AS decl_english_ast" );
      DUMP_SNAME( "sname_c", (yyvsp[-2].sname) );
      DUMP_AST( "decl_english_ast", (yyvsp[0].ast) );

      if ( (yyvsp[0].ast)->kind == K_NAME ) { // see the comment in "declare_command"
        assert( !c_sname_empty( &(yyvsp[0].ast)->sname ) );
        print_error_unknown_name( &(yylsp[0]), &(yyvsp[0].ast)->sname );
        c_sname_cleanup( &(yyvsp[-2].sname) );
        PARSE_ABORT();
      }

      (yyval.ast) = (yyvsp[0].ast);
      (yyval.ast)->loc = (yyloc);
      c_sname_set( &(yyval.ast)->sname, &(yyvsp[-2].sname) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 11975 "parser.c"
    break;

  case 804: /* var_decl_english_ast: "..."  */
#line 7879 "parser.y"
    {
      DUMP_START();
      DUMP_PROD( "var_decl_english_ast", "..." );

      (yyval.ast) = c_ast_new_gc( K_VARIADIC, &(yyloc) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 11989 "parser.c"
    break;

  case 805: /* type_english_ast: type_modifier_list_english_type_opt unmodified_type_english_ast  */
#line 7897 "parser.y"
    {
      DUMP_START();
      DUMP_PROD( "type_english_ast",
                 "type_modifier_list_english_type_opt "
                 "unmodified_type_english_ast" );
      DUMP_TYPE( "type_modifier_list_english_type_opt", (yyvsp[-1].type) );
      DUMP_AST( "unmodified_type_english_ast", (yyvsp[0].ast) );

      (yyval.ast) = (yyvsp[0].ast);
      if ( !c_type_is_none( &(yyvsp[-1].type) ) ) {
        // Set the AST's location to the entire rule only if the leading
        // optional rule is actually present, otherwise @$ refers to a column
        // before $ast.
        (yyval.ast)->loc = (yyloc);
        PARSE_ASSERT( c_type_add( &(yyval.ast)->type, &(yyvsp[-1].type), &(yylsp[-1]) ) );
      }

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 12014 "parser.c"
    break;

  case 806: /* type_english_ast: type_modifier_list_english_type  */
#line 7920 "parser.y"
    {
      DUMP_START();
      DUMP_PROD( "type_english_ast", "type_modifier_list_english_type" );
      DUMP_TYPE( "type_modifier_list_english_type", (yyvsp[0].type) );

      // see the comment in "type_c_ast"
      c_type_t new_type =
        C_TYPE_LIT_B( OPT_LANG_IS( IMPLICIT_int ) ? TB_int : TB_NONE );

      PARSE_ASSERT( c_type_add( &new_type, &(yyvsp[0].type), &(yylsp[0]) ) );

      (yyval.ast) = c_ast_new_gc( K_BUILTIN, &(yyloc) );
      (yyval.ast)->type = new_type;

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 12036 "parser.c"
    break;

  case 807: /* type_modifier_list_english_type_opt: %empty  */
#line 7940 "parser.y"
                                  { (yyval.type) = T_NONE; }
#line 12042 "parser.c"
    break;

  case 809: /* type_modifier_list_english_type: type_modifier_list_english_type type_modifier_english_type  */
#line 7947 "parser.y"
    {
      DUMP_START();
      DUMP_PROD( "type_modifier_list_english_type",
                 "type_modifier_list_english_type "
                 "type_modifier_english_type" );
      DUMP_TYPE( "type_modifier_list_english_type", (yyvsp[-1].type) );
      DUMP_TYPE( "type_modifier_english_type", (yyvsp[0].type) );

      (yyval.type) = (yyvsp[-1].type);
      PARSE_ASSERT( c_type_add( &(yyval.type), &(yyvsp[0].type), &(yylsp[0]) ) );

      DUMP_TYPE( "$$_type", (yyval.type) );
      DUMP_END();
    }
#line 12061 "parser.c"
    break;

  case 816: /* builtin_type_english_ast: builtin_no_BitInt_english_btid  */
#line 7978 "parser.y"
    {
      DUMP_START();
      DUMP_PROD( "builtin_type_english_ast",
                 "builtin_no_BitInt_english_btid" );
      DUMP_TID( "builtin_no_BitInt_english_btid", (yyvsp[0].tid) );

      (yyval.ast) = c_ast_new_gc( K_BUILTIN, &(yyloc) );
      (yyval.ast)->type.btids = c_tid_check( (yyvsp[0].tid), C_TPID_BASE );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 12078 "parser.c"
    break;

  case 817: /* builtin_type_english_ast: BitInt_english_int  */
#line 7991 "parser.y"
    {
      DUMP_START();
      DUMP_PROD( "builtin_type_english_ast", "BitInt_english_int" );
      DUMP_INT( "BitInt_english_int", (yyvsp[0].uint_val) );

      (yyval.ast) = c_ast_new_gc( K_BUILTIN, &(yyloc) );
      (yyval.ast)->type.btids = TB__BitInt;
      (yyval.ast)->builtin.BitInt.width = (yyvsp[0].uint_val);

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 12095 "parser.c"
    break;

  case 822: /* builtin_no_BitInt_english_btid: Y_char uint_lit_opt  */
#line 8011 "parser.y"
    {
      switch ( (yyvsp[0].uint_val) ) {
        case  0: (yyval.tid) = TB_char    ; break;
        case  8: (yyval.tid) = TB_char8_t ; break;
        case 16: (yyval.tid) = TB_char16_t; break;
        case 32: (yyval.tid) = TB_char32_t; break;
        default:
          print_error( &(yylsp[0]), "bits must be one of 8, 16, or 32\n" );
          PARSE_ABORT();
      } // switch
    }
#line 12111 "parser.c"
    break;

  case 827: /* builtin_no_BitInt_english_btid: Y_wide char_exp  */
#line 8026 "parser.y"
                                  { (yyval.tid) = TB_wchar_t; }
#line 12117 "parser.c"
    break;

  case 830: /* builtin_no_BitInt_english_btid: Y_floating point_exp  */
#line 8029 "parser.y"
                                  { (yyval.tid) = TB_float; }
#line 12123 "parser.c"
    break;

  case 831: /* builtin_no_BitInt_english_btid: Y_double precision_opt  */
#line 8030 "parser.y"
                                  { (yyval.tid) = TB_double; }
#line 12129 "parser.c"
    break;

  case 834: /* BitInt_english_int: BitInt_english uint_lit bits_opt  */
#line 8037 "parser.y"
    {
      (yyval.uint_val) = (yyvsp[-1].uint_val);
    }
#line 12137 "parser.c"
    break;

  case 835: /* BitInt_english_int: BitInt_english '(' uint_lit_exp rparen_exp  */
#line 8041 "parser.y"
    {
      (yyval.uint_val) = (yyvsp[-1].uint_val);
    }
#line 12145 "parser.c"
    break;

  case 836: /* BitInt_english_int: BitInt_english Y_width uint_lit_exp bits_opt  */
#line 8045 "parser.y"
    {
      (yyval.uint_val) = (yyvsp[-1].uint_val);
    }
#line 12153 "parser.c"
    break;

  case 837: /* BitInt_english_int: BitInt_english error  */
#line 8049 "parser.y"
    {
      elaborate_error( "integer literal, '(', or \"width\" expected" );
    }
#line 12161 "parser.c"
    break;

  case 843: /* class_struct_union_english_ast: class_struct_union_btid any_sname_c_exp  */
#line 8067 "parser.y"
    {
      DUMP_START();
      DUMP_PROD( "class_struct_union_english_ast",
                 "class_struct_union_btid any_sname_c_exp" );
      DUMP_TID( "class_struct_union_btid", (yyvsp[-1].tid) );
      DUMP_SNAME( "any_sname_c_exp", (yyvsp[0].sname) );

      (yyval.ast) = c_ast_new_gc( K_CLASS_STRUCT_UNION, &(yyloc) );
      (yyval.ast)->type.btids = c_tid_check( (yyvsp[-1].tid), C_TPID_BASE );
      (yyval.ast)->csu.csu_sname = c_sname_move( &(yyvsp[0].sname) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 12180 "parser.c"
    break;

  case 844: /* enum_english_ast: enum_btids any_sname_c_exp of_type_enum_fixed_type_english_ast_opt  */
#line 8086 "parser.y"
    {
      DUMP_START();
      DUMP_PROD( "enum_english_ast",
                 "enum_btids any_sname_c_exp "
                 "of_type_enum_fixed_type_english_ast_opt" );
      DUMP_TID( "enum_btids", (yyvsp[-2].tid) );
      DUMP_SNAME( "any_sname_c_exp", (yyvsp[-1].sname) );
      DUMP_AST( "enum_fixed_type_english_ast", (yyvsp[0].ast) );

      (yyval.ast) = c_ast_new_gc( K_ENUM, &(yyloc) );
      (yyval.ast)->type.btids = c_tid_check( (yyvsp[-2].tid), C_TPID_BASE );
      c_ast_set_parent( (yyvsp[0].ast), (yyval.ast) );
      (yyval.ast)->enum_.enum_sname = c_sname_move( &(yyvsp[-1].sname) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 12202 "parser.c"
    break;

  case 845: /* of_type_enum_fixed_type_english_ast_opt: %empty  */
#line 8106 "parser.y"
                                        { (yyval.ast) = NULL; }
#line 12208 "parser.c"
    break;

  case 846: /* of_type_enum_fixed_type_english_ast_opt: Y_of type_opt enum_fixed_type_english_ast  */
#line 8108 "parser.y"
    {
      (yyval.ast) = (yyvsp[0].ast);
    }
#line 12216 "parser.c"
    break;

  case 847: /* enum_fixed_type_english_ast: enum_fixed_type_modifier_list_english_btid_opt enum_unmodified_fixed_type_english_ast  */
#line 8116 "parser.y"
    {
      DUMP_START();
      DUMP_PROD( "enum_fixed_type_english_ast",
                 "enum_fixed_type_modifier_list_stid" );
      DUMP_TID( "enum_fixed_type_modifier_list_stid", (yyvsp[-1].tid) );
      DUMP_AST( "enum_unmodified_fixed_type_english_ast", (yyvsp[0].ast) );

      (yyval.ast) = (yyvsp[0].ast);
      if ( (yyvsp[-1].tid) != TB_NONE ) {        // See comment in type_english_ast.
        (yyval.ast)->loc = (yyloc);
        PARSE_ASSERT( c_type_add_tid( &(yyval.ast)->type, (yyvsp[-1].tid), &(yylsp[-1]) ) );
      }

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 12237 "parser.c"
    break;

  case 848: /* enum_fixed_type_english_ast: enum_fixed_type_modifier_list_english_btid  */
#line 8134 "parser.y"
    {
      DUMP_START();
      DUMP_PROD( "enum_fixed_type_english_ast",
                 "enum_fixed_type_modifier_list_english_btid" );
      DUMP_TID( "enum_fixed_type_modifier_list_english_btid", (yyvsp[0].tid) );

      (yyval.ast) = c_ast_new_gc( K_BUILTIN, &(yyloc) );
      (yyval.ast)->type.btids = c_tid_check( (yyvsp[0].tid), C_TPID_BASE );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 12254 "parser.c"
    break;

  case 849: /* enum_fixed_type_modifier_list_english_btid_opt: %empty  */
#line 8149 "parser.y"
                                  { (yyval.tid) = TB_NONE; }
#line 12260 "parser.c"
    break;

  case 851: /* enum_fixed_type_modifier_list_english_btid: enum_fixed_type_modifier_list_english_btid enum_fixed_type_modifier_btid  */
#line 8156 "parser.y"
    {
      DUMP_START();
      DUMP_PROD( "enum_fixed_type_modifier_list_english_btid",
                 "enum_fixed_type_modifier_list_english_btid "
                 "enum_fixed_type_modifier_btid" );
      DUMP_TID( "enum_fixed_type_modifier_list_english_btid", (yyvsp[-1].tid) );
      DUMP_TID( "enum_fixed_type_modifier_btid", (yyvsp[0].tid) );

      (yyval.tid) = (yyvsp[-1].tid);
      PARSE_ASSERT( c_tid_add( &(yyval.tid), (yyvsp[0].tid), &(yylsp[0]) ) );

      DUMP_TID( "$$_btids", (yyval.tid) );
      DUMP_END();
    }
#line 12279 "parser.c"
    break;

  case 856: /* any_name: Y_TYPEDEF_NAME  */
#line 8186 "parser.y"
    {
      assert( c_sname_count( &(yyvsp[0].tdef)->ast->sname ) == 1 );
      (yyval.name) = check_strdup( c_sname_local_name( &(yyvsp[0].tdef)->ast->sname ) );
    }
#line 12288 "parser.c"
    break;

  case 858: /* any_name_exp: error  */
#line 8195 "parser.y"
    {
      (yyval.name) = NULL;
      elaborate_error( "name expected" );
    }
#line 12297 "parser.c"
    break;

  case 862: /* any_sname_c_exp: error  */
#line 8209 "parser.y"
    {
      c_sname_init( &(yyval.sname) );
      elaborate_error( "name expected" );
    }
#line 12306 "parser.c"
    break;

  case 863: /* any_sname_c_opt: %empty  */
#line 8216 "parser.y"
                                  { c_sname_init( &(yyval.sname) ); }
#line 12312 "parser.c"
    break;

  case 867: /* name_ast: Y_NAME  */
#line 8227 "parser.y"
    {
      DUMP_START();
      DUMP_PROD( "name_ast", "NAME" );
      DUMP_STR( "NAME", (yyvsp[0].name) );

      (yyval.ast) = c_ast_new_gc( K_NAME, &(yyloc) );
      c_sname_append_name( &(yyval.ast)->sname, (yyvsp[0].name) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 12328 "parser.c"
    break;

  case 869: /* name_exp: error  */
#line 8243 "parser.y"
    {
      (yyval.name) = NULL;
      elaborate_error( "name expected" );
    }
#line 12337 "parser.c"
    break;

  case 870: /* name_cat: name_cat Y_NAME  */
#line 8251 "parser.y"
    {
      (yyval.name) = str_realloc_cat( (yyvsp[-1].name), " ", (yyvsp[0].name) );
      free( (yyvsp[0].name) );
    }
#line 12346 "parser.c"
    break;

  case 872: /* name_opt: %empty  */
#line 8259 "parser.y"
                                  { (yyval.name) = NULL; }
#line 12352 "parser.c"
    break;

  case 874: /* oper_sname_c_opt: %empty  */
#line 8264 "parser.y"
                                  { c_sname_init( &(yyval.sname) ); }
#line 12358 "parser.c"
    break;

  case 875: /* oper_sname_c_opt: Y_OPERATOR_SNAME Y_COLON_COLON  */
#line 8267 "parser.y"
    {
      (yyval.sname) = (yyvsp[-1].sname);
      if ( c_type_is_none( c_sname_local_type( &(yyval.sname) ) ) )
        c_sname_set_local_type( &(yyval.sname), &C_TYPE_LIT_B( TB_SCOPE ) );
    }
#line 12368 "parser.c"
    break;

  case 876: /* typedef_type_c_ast: any_typedef sub_scope_sname_c_opt  */
#line 8276 "parser.y"
    {
      c_ast_t *type_ast = ia_type_ast_peek();
      c_ast_t const *type_for_ast = (yyvsp[-1].tdef)->ast;

      DUMP_START();
      DUMP_PROD( "typedef_type_c_ast", "any_typedef sub_scope_sname_c_opt" );
      DUMP_AST( "in_attr__type_c_ast", type_ast );
      DUMP_AST( "any_typedef__ast", type_for_ast );
      DUMP_SNAME( "sub_scope_sname_c_opt", (yyvsp[0].sname) );

      if ( c_sname_empty( &(yyvsp[0].sname) ) ) {
ttntd:  (yyval.ast) = c_ast_new_gc( K_TYPEDEF, &(yyloc) );
        (yyval.ast)->type.btids = TB_typedef;
        (yyval.ast)->tdef.for_ast = type_for_ast;
      }
      else {
        c_sname_t temp_name = c_sname_dup( &(yyvsp[-1].tdef)->ast->sname );
        c_sname_append_sname( &temp_name, &(yyvsp[0].sname) );

        if ( type_ast == NULL ) {
          //
          // This is for a case like:
          //
          //      define S as struct S
          //      explain S::T x
          //
          // that is: a typedef'd type followed by ::T where T is an unknown
          // name used as a type. Just assume the T is some type, say int, and
          // create a name for it.
          //
          type_ast = c_ast_new_gc( K_BUILTIN, &(yylsp[0]) );
          type_ast->type.btids = TB_int;
          c_sname_set( &type_ast->sname, &temp_name );
          type_for_ast = type_ast;
          goto ttntd;
        }

        //
        // Otherwise, this is for cases like:
        //
        //  1. A typedef'd type used for a scope:
        //
        //          define S as struct S
        //          explain int S::x
        //
        //  2. A typedef'd type used for an intermediate scope:
        //
        //          define S as struct S
        //          define T as struct T
        //          explain int S::T::x
        //
        (yyval.ast) = type_ast;
        c_sname_set( &(yyval.ast)->sname, &temp_name );
      }

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 12431 "parser.c"
    break;

  case 877: /* sub_scope_sname_c_opt: %empty  */
#line 8337 "parser.y"
                                  { c_sname_init( &(yyval.sname) ); }
#line 12437 "parser.c"
    break;

  case 878: /* sub_scope_sname_c_opt: Y_COLON_COLON any_sname_c  */
#line 8339 "parser.y"
    {
      (yyval.sname) = (yyvsp[0].sname);
    }
#line 12445 "parser.c"
    break;

  case 879: /* sname_c: sname_c Y_COLON_COLON Y_NAME  */
#line 8346 "parser.y"
    {
      // see the comment in "of_scope_english"
      if ( !IS_SUPPORTED( SCOPED_NAMES ) ) {
        print_error( &(yylsp[-1]),
          "scoped names not supported%s\n",
          C_LANG_WHICH( SCOPED_NAMES )
        );
        c_sname_cleanup( &(yyvsp[-2].sname) );
        free( (yyvsp[0].name) );
        PARSE_ABORT();
      }

      DUMP_START();
      DUMP_PROD( "sname_c", "sname_c '::' NAME" );
      DUMP_SNAME( "sname_c", (yyvsp[-2].sname) );
      DUMP_STR( "name", (yyvsp[0].name) );

      (yyval.sname) = (yyvsp[-2].sname);
      c_sname_set_local_type( &(yyval.sname), &C_TYPE_LIT_B( TB_SCOPE ) );
      c_sname_append_name( &(yyval.sname), (yyvsp[0].name) );

      DUMP_SNAME( "$$_sname", (yyval.sname) );
      DUMP_END();
    }
#line 12474 "parser.c"
    break;

  case 880: /* sname_c: sname_c Y_COLON_COLON any_typedef  */
#line 8372 "parser.y"
    { //
      // This is for a case like:
      //
      //      define S::int8_t as char
      //
      // that is: the type int8_t is an existing type in no scope being defined
      // as a distinct type in a new scope.
      //
      DUMP_START();
      DUMP_PROD( "sname_c", "sname_c '::' any_typedef" );
      DUMP_SNAME( "sname_c", (yyvsp[-2].sname) );
      DUMP_AST( "any_typedef__ast", (yyvsp[0].tdef)->ast );

      (yyval.sname) = (yyvsp[-2].sname);
      c_sname_set_local_type( &(yyval.sname), &C_TYPE_LIT_B( TB_SCOPE ) );
      c_sname_t temp_sname = c_sname_dup( &(yyvsp[0].tdef)->ast->sname );
      c_sname_append_sname( &(yyval.sname), &temp_sname );

      DUMP_SNAME( "$$_sname", (yyval.sname) );
      DUMP_END();
    }
#line 12500 "parser.c"
    break;

  case 881: /* sname_c: Y_NAME  */
#line 8395 "parser.y"
    {
      DUMP_START();
      DUMP_PROD( "sname_c", "NAME" );
      DUMP_STR( "NAME", (yyvsp[0].name) );

      c_sname_init_name( &(yyval.sname), (yyvsp[0].name) );

      DUMP_SNAME( "$$_sname", (yyval.sname) );
      DUMP_END();
    }
#line 12515 "parser.c"
    break;

  case 882: /* sname_c_ast: sname_c bit_field_c_uint_opt  */
#line 8410 "parser.y"
    {
      c_ast_t *type_ast = ia_type_ast_peek();

      DUMP_START();
      DUMP_PROD( "sname_c_ast", "sname_c" );
      DUMP_AST( "in_attr__type_c_ast", type_ast );
      DUMP_SNAME( "sname_c", (yyvsp[-1].sname) );
      DUMP_INT( "bit_field_c_uint_opt", (yyvsp[0].uint_val) );

      type_ast = ia_type_spec_ast( type_ast );
      c_sname_set( &type_ast->sname, &(yyvsp[-1].sname) );
      PARSE_ASSERT( c_ast_set_bit_field_width( type_ast, (yyvsp[0].uint_val) ) );

      (yyval.ast) = type_ast;
      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 12537 "parser.c"
    break;

  case 883: /* bit_field_c_uint_opt: %empty  */
#line 8430 "parser.y"
                                  { (yyval.uint_val) = 0; }
#line 12543 "parser.c"
    break;

  case 884: /* bit_field_c_uint_opt: ':' uint_lit_exp  */
#line 8432 "parser.y"
    { //
      // This check has to be done now in the parser rather than later in the
      // AST since we use 0 to mean "no bit-field."
      //
      if ( (yyvsp[0].uint_val) == 0 ) {
        print_error( &(yylsp[0]), "bit-field width must be > 0\n" );
        PARSE_ABORT();
      }
      (yyval.uint_val) = (yyvsp[0].uint_val);
    }
#line 12558 "parser.c"
    break;

  case 886: /* sname_c_exp: error  */
#line 8447 "parser.y"
    {
      c_sname_init( &(yyval.sname) );
      elaborate_error( "name expected" );
    }
#line 12567 "parser.c"
    break;

  case 887: /* sname_c_opt: %empty  */
#line 8454 "parser.y"
                                  { c_sname_init( &(yyval.sname) ); }
#line 12573 "parser.c"
    break;

  case 889: /* sname_english: any_sname_c of_scope_list_english_opt  */
#line 8460 "parser.y"
    {
      DUMP_START();
      DUMP_PROD( "sname_english", "any_sname_c of_scope_list_english_opt" );
      DUMP_SNAME( "any_sname_c", (yyvsp[-1].sname) );
      DUMP_SNAME( "of_scope_list_english_opt", (yyvsp[0].sname) );

      c_type_t const *local_type = c_sname_local_type( &(yyvsp[0].sname) );
      if ( c_type_is_none( local_type ) )
        local_type = c_sname_local_type( &(yyvsp[-1].sname) );
      (yyval.sname) = (yyvsp[0].sname);
      c_sname_append_sname( &(yyval.sname), &(yyvsp[-1].sname) );
      c_sname_set_local_type( &(yyval.sname), local_type );

      DUMP_SNAME( "$$_sname", (yyval.sname) );
      DUMP_END();
    }
#line 12594 "parser.c"
    break;

  case 890: /* sname_english_ast: Y_NAME of_scope_list_english_opt  */
#line 8480 "parser.y"
    {
      DUMP_START();
      DUMP_PROD( "sname_english_ast", "NAME of_scope_list_english_opt" );
      DUMP_STR( "NAME", (yyvsp[-1].name) );
      DUMP_SNAME( "of_scope_list_english_opt", (yyvsp[0].sname) );

      c_sname_t sname = c_sname_move( &(yyvsp[0].sname) );
      c_sname_append_name( &sname, (yyvsp[-1].name) );

      //
      // See if the full name is the name of a typedef'd type.
      //
      c_typedef_t const *const tdef = c_typedef_find_sname( &sname );
      if ( tdef != NULL ) {
        (yyval.ast) = c_ast_new_gc( K_TYPEDEF, &(yyloc) );
        (yyval.ast)->type.btids = TB_typedef;
        (yyval.ast)->tdef.for_ast = tdef->ast;
        c_sname_cleanup( &sname );
      } else {
        (yyval.ast) = c_ast_new_gc( K_NAME, &(yyloc) );
        c_sname_set( &(yyval.ast)->sname, &sname );
      }

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 12625 "parser.c"
    break;

  case 892: /* sname_english_exp: error  */
#line 8511 "parser.y"
    {
      c_sname_init( &(yyval.sname) );
      elaborate_error( "name expected" );
    }
#line 12634 "parser.c"
    break;

  case 893: /* sname_english_opt: %empty  */
#line 8518 "parser.y"
                                  { c_sname_init( &(yyval.sname) ); }
#line 12640 "parser.c"
    break;

  case 895: /* sname_list_english: sname_list_english ',' sname_english_exp  */
#line 8524 "parser.y"
    {
      DUMP_START();
      DUMP_PROD( "sname_list_english",
                 "sname_list_english ',' sname_english" );
      DUMP_SNAME_LIST( "sname_list_english", (yyvsp[-2].sname_list) );
      DUMP_SNAME( "sname_english_exp", (yyvsp[0].sname) );

      (yyval.sname_list) = (yyvsp[-2].sname_list);
      c_sname_t *const temp_sname = MALLOC( c_sname_t, 1 );
      *temp_sname = c_sname_move( &(yyvsp[0].sname) );
      slist_push_back( &(yyval.sname_list), temp_sname );

      DUMP_SNAME_LIST( "$$_sname_list", (yyval.sname_list) );
      DUMP_END();
    }
#line 12660 "parser.c"
    break;

  case 896: /* sname_list_english: sname_english  */
#line 8541 "parser.y"
    {
      DUMP_START();
      DUMP_PROD( "sname_list_english", "sname_english" );
      DUMP_SNAME( "sname_english", (yyvsp[0].sname) );

      c_sname_t *const temp_sname = MALLOC( c_sname_t, 1 );
      *temp_sname = c_sname_move( &(yyvsp[0].sname) );
      slist_init( &(yyval.sname_list) );
      slist_push_back( &(yyval.sname_list), temp_sname );

      DUMP_SNAME_LIST( "$$_sname_list", (yyval.sname_list) );
      DUMP_END();
    }
#line 12678 "parser.c"
    break;

  case 897: /* typedef_sname_c: typedef_sname_c Y_COLON_COLON sname_c  */
#line 8558 "parser.y"
    {
      DUMP_START();
      DUMP_PROD( "typedef_sname_c", "typedef_sname_c '::' sname_c" );
      DUMP_SNAME( "typedef_sname_c", (yyvsp[-2].sname) );
      DUMP_SNAME( "sname_c", (yyvsp[0].sname) );

      //
      // This is for a case like:
      //
      //      define S as struct S
      //      define S::T as struct T
      //
      (yyval.sname) = c_sname_move( &(yyvsp[-2].sname) );
      c_sname_append_sname( &(yyval.sname), &(yyvsp[0].sname) );

      DUMP_SNAME( "$$_sname", (yyval.sname) );
      DUMP_END();
    }
#line 12701 "parser.c"
    break;

  case 898: /* typedef_sname_c: typedef_sname_c Y_COLON_COLON any_typedef  */
#line 8578 "parser.y"
    {
      DUMP_START();
      DUMP_PROD( "typedef_sname_c", "typedef_sname_c '::' any_typedef" );
      DUMP_SNAME( "typedef_sname_c", (yyvsp[-2].sname) );
      DUMP_AST( "any_typedef__ast", (yyvsp[0].tdef)->ast );

      //
      // This is for a case like:
      //
      //      define S as struct S
      //      define T as struct T
      //      define S::T as struct S_T
      //
      (yyval.sname) = c_sname_move( &(yyvsp[-2].sname) );
      c_sname_set_local_type( &(yyval.sname), c_sname_local_type( &(yyvsp[0].tdef)->ast->sname ) );
      c_sname_t temp_sname = c_sname_dup( &(yyvsp[0].tdef)->ast->sname );
      c_sname_append_sname( &(yyval.sname), &temp_sname );

      DUMP_SNAME( "$$_sname", (yyval.sname) );
      DUMP_END();
    }
#line 12727 "parser.c"
    break;

  case 899: /* typedef_sname_c: any_typedef  */
#line 8600 "parser.y"
                                  { (yyval.sname) = c_sname_dup( &(yyvsp[0].tdef)->ast->sname ); }
#line 12733 "parser.c"
    break;

  case 901: /* address_exp: error  */
#line 8610 "parser.y"
    {
      keyword_expected( L_address );
    }
#line 12741 "parser.c"
    break;

  case 903: /* array_exp: error  */
#line 8618 "parser.y"
    {
      keyword_expected( L_array );
    }
#line 12749 "parser.c"
    break;

  case 904: /* as_exp: Y_as  */
#line 8625 "parser.y"
    {
      if ( OPT_LANG_IS( MEMBER_FUNCTIONS ) ) {
        //
        // For either "declare" or "define", neither "override" nor "final"
        // must be matched initially to allow for cases like:
        //
        //      c++decl> declare final as int
        //      int final;
        //
        // (which is legal).  However, in C++, after parsing "as", the keyword
        // context has to be set to C_KW_CTX_MBR_FUNC to be able to match
        // "override" and "final", e.g.:
        //
        //      c++decl> declare f as final function
        //      void f() final;
        //
        lexer_keyword_ctx = C_KW_CTX_MBR_FUNC;
      }
    }
#line 12773 "parser.c"
    break;

  case 905: /* as_exp: error  */
#line 8645 "parser.y"
    {
      keyword_expected( L_as );
    }
#line 12781 "parser.c"
    break;

  case 909: /* as_into_to_exp: error  */
#line 8655 "parser.y"
    {
      elaborate_error( "\"as\", \"into\", or \"to\" expected" );
    }
#line 12789 "parser.c"
    break;

  case 919: /* cast_exp: error  */
#line 8680 "parser.y"
    {
      keyword_expected( L_cast );
    }
#line 12797 "parser.c"
    break;

  case 921: /* char_exp: error  */
#line 8688 "parser.y"
    {
      keyword_expected( L_char );
    }
#line 12805 "parser.c"
    break;

  case 923: /* class_struct_union_btid_exp: error  */
#line 8696 "parser.y"
    {
      elaborate_error( "\"class\", \"struct\", or \"union\" expected" );
    }
#line 12813 "parser.c"
    break;

  case 925: /* colon_exp: error  */
#line 8704 "parser.y"
    {
      punct_expected( ':' );
    }
#line 12821 "parser.c"
    break;

  case 927: /* comma_exp: error  */
#line 8712 "parser.y"
    {
      punct_expected( ',' );
    }
#line 12829 "parser.c"
    break;

  case 929: /* conversion_exp: error  */
#line 8720 "parser.y"
    {
      keyword_expected( L_conversion );
    }
#line 12837 "parser.c"
    break;

  case 930: /* c_operator: Y_co_await  */
#line 8726 "parser.y"
                                  { (yyval.op_id) = C_OP_CO_AWAIT              ; }
#line 12843 "parser.c"
    break;

  case 931: /* c_operator: Y_new  */
#line 8727 "parser.y"
                                  { (yyval.op_id) = C_OP_NEW                   ; }
#line 12849 "parser.c"
    break;

  case 932: /* c_operator: Y_new '[' rbracket_exp  */
#line 8728 "parser.y"
                                  { (yyval.op_id) = C_OP_NEW_ARRAY             ; }
#line 12855 "parser.c"
    break;

  case 933: /* c_operator: Y_delete  */
#line 8729 "parser.y"
                                  { (yyval.op_id) = C_OP_DELETE                ; }
#line 12861 "parser.c"
    break;

  case 934: /* c_operator: Y_delete '[' rbracket_exp  */
#line 8730 "parser.y"
                                  { (yyval.op_id) = C_OP_DELETE_ARRAY          ; }
#line 12867 "parser.c"
    break;

  case 935: /* c_operator: '!'  */
#line 8731 "parser.y"
                                  { (yyval.op_id) = C_OP_EXCLAM                ; }
#line 12873 "parser.c"
    break;

  case 936: /* c_operator: Y_EXCLAM_EQUAL  */
#line 8732 "parser.y"
                                  { (yyval.op_id) = C_OP_EXCLAM_EQUAL          ; }
#line 12879 "parser.c"
    break;

  case 937: /* c_operator: '%'  */
#line 8733 "parser.y"
                                  { (yyval.op_id) = C_OP_PERCENT               ; }
#line 12885 "parser.c"
    break;

  case 938: /* c_operator: Y_PERCENT_EQUAL  */
#line 8734 "parser.y"
                                  { (yyval.op_id) = C_OP_PERCENT_EQUAL         ; }
#line 12891 "parser.c"
    break;

  case 939: /* c_operator: '&'  */
#line 8735 "parser.y"
                                  { (yyval.op_id) = C_OP_AMPER                 ; }
#line 12897 "parser.c"
    break;

  case 940: /* c_operator: Y_AMPER_AMPER  */
#line 8736 "parser.y"
                                  { (yyval.op_id) = C_OP_AMPER_AMPER           ; }
#line 12903 "parser.c"
    break;

  case 941: /* c_operator: Y_AMPER_EQUAL  */
#line 8737 "parser.y"
                                  { (yyval.op_id) = C_OP_AMPER_EQUAL           ; }
#line 12909 "parser.c"
    break;

  case 942: /* c_operator: '(' rparen_exp  */
#line 8738 "parser.y"
                                  { (yyval.op_id) = C_OP_PARENS                ; }
#line 12915 "parser.c"
    break;

  case 943: /* c_operator: '*'  */
#line 8739 "parser.y"
                                  { (yyval.op_id) = C_OP_STAR                  ; }
#line 12921 "parser.c"
    break;

  case 944: /* c_operator: Y_STAR_EQUAL  */
#line 8740 "parser.y"
                                  { (yyval.op_id) = C_OP_STAR_EQUAL            ; }
#line 12927 "parser.c"
    break;

  case 945: /* c_operator: '+'  */
#line 8741 "parser.y"
                                  { (yyval.op_id) = C_OP_PLUS                  ; }
#line 12933 "parser.c"
    break;

  case 946: /* c_operator: "++"  */
#line 8742 "parser.y"
                                  { (yyval.op_id) = C_OP_PLUS_PLUS             ; }
#line 12939 "parser.c"
    break;

  case 947: /* c_operator: Y_PLUS_EQUAL  */
#line 8743 "parser.y"
                                  { (yyval.op_id) = C_OP_PLUS_EQUAL            ; }
#line 12945 "parser.c"
    break;

  case 948: /* c_operator: ','  */
#line 8744 "parser.y"
                                  { (yyval.op_id) = C_OP_COMMA                 ; }
#line 12951 "parser.c"
    break;

  case 949: /* c_operator: '-'  */
#line 8745 "parser.y"
                                  { (yyval.op_id) = C_OP_MINUS                 ; }
#line 12957 "parser.c"
    break;

  case 950: /* c_operator: "--"  */
#line 8746 "parser.y"
                                  { (yyval.op_id) = C_OP_MINUS_MINUS           ; }
#line 12963 "parser.c"
    break;

  case 951: /* c_operator: Y_MINUS_EQUAL  */
#line 8747 "parser.y"
                                  { (yyval.op_id) = C_OP_MINUS_EQUAL           ; }
#line 12969 "parser.c"
    break;

  case 952: /* c_operator: Y_MINUS_GREATER  */
#line 8748 "parser.y"
                                  { (yyval.op_id) = C_OP_MINUS_GREATER         ; }
#line 12975 "parser.c"
    break;

  case 953: /* c_operator: Y_MINUS_GREATER_STAR  */
#line 8749 "parser.y"
                                  { (yyval.op_id) = C_OP_MINUS_GREATER_STAR    ; }
#line 12981 "parser.c"
    break;

  case 954: /* c_operator: '.'  */
#line 8750 "parser.y"
                                  { (yyval.op_id) = C_OP_DOT                   ; }
#line 12987 "parser.c"
    break;

  case 955: /* c_operator: Y_DOT_STAR  */
#line 8751 "parser.y"
                                  { (yyval.op_id) = C_OP_DOT_STAR              ; }
#line 12993 "parser.c"
    break;

  case 956: /* c_operator: '/'  */
#line 8752 "parser.y"
                                  { (yyval.op_id) = C_OP_SLASH                 ; }
#line 12999 "parser.c"
    break;

  case 957: /* c_operator: Y_SLASH_EQUAL  */
#line 8753 "parser.y"
                                  { (yyval.op_id) = C_OP_SLASH_EQUAL           ; }
#line 13005 "parser.c"
    break;

  case 958: /* c_operator: Y_COLON_COLON  */
#line 8754 "parser.y"
                                  { (yyval.op_id) = C_OP_COLON_COLON           ; }
#line 13011 "parser.c"
    break;

  case 959: /* c_operator: '<'  */
#line 8755 "parser.y"
                                  { (yyval.op_id) = C_OP_LESS                  ; }
#line 13017 "parser.c"
    break;

  case 960: /* c_operator: Y_LESS_LESS  */
#line 8756 "parser.y"
                                  { (yyval.op_id) = C_OP_LESS_LESS             ; }
#line 13023 "parser.c"
    break;

  case 961: /* c_operator: Y_LESS_LESS_EQUAL  */
#line 8757 "parser.y"
                                  { (yyval.op_id) = C_OP_LESS_LESS_EQUAL       ; }
#line 13029 "parser.c"
    break;

  case 962: /* c_operator: Y_LESS_EQUAL  */
#line 8758 "parser.y"
                                  { (yyval.op_id) = C_OP_LESS_EQUAL            ; }
#line 13035 "parser.c"
    break;

  case 963: /* c_operator: Y_LESS_EQUAL_GREATER  */
#line 8759 "parser.y"
                                  { (yyval.op_id) = C_OP_LESS_EQUAL_GREATER    ; }
#line 13041 "parser.c"
    break;

  case 964: /* c_operator: '='  */
#line 8760 "parser.y"
                                  { (yyval.op_id) = C_OP_EQUAL                 ; }
#line 13047 "parser.c"
    break;

  case 965: /* c_operator: Y_EQUAL_EQUAL  */
#line 8761 "parser.y"
                                  { (yyval.op_id) = C_OP_EQUAL_EQUAL           ; }
#line 13053 "parser.c"
    break;

  case 966: /* c_operator: '>'  */
#line 8762 "parser.y"
                                  { (yyval.op_id) = C_OP_GREATER               ; }
#line 13059 "parser.c"
    break;

  case 967: /* c_operator: Y_GREATER_GREATER  */
#line 8763 "parser.y"
                                  { (yyval.op_id) = C_OP_GREATER_GREATER       ; }
#line 13065 "parser.c"
    break;

  case 968: /* c_operator: Y_GREATER_GREATER_EQUAL  */
#line 8764 "parser.y"
                                  { (yyval.op_id) = C_OP_GREATER_GREATER_EQUAL ; }
#line 13071 "parser.c"
    break;

  case 969: /* c_operator: Y_GREATER_EQUAL  */
#line 8765 "parser.y"
                                  { (yyval.op_id) = C_OP_GREATER_EQUAL         ; }
#line 13077 "parser.c"
    break;

  case 970: /* c_operator: Y_QMARK_COLON  */
#line 8766 "parser.y"
                                  { (yyval.op_id) = C_OP_QMARK_COLON           ; }
#line 13083 "parser.c"
    break;

  case 971: /* c_operator: '[' rbracket_exp  */
#line 8767 "parser.y"
                                  { (yyval.op_id) = C_OP_BRACKETS              ; }
#line 13089 "parser.c"
    break;

  case 972: /* c_operator: '^'  */
#line 8768 "parser.y"
                                  { (yyval.op_id) = C_OP_CARET                 ; }
#line 13095 "parser.c"
    break;

  case 973: /* c_operator: Y_CARET_EQUAL  */
#line 8769 "parser.y"
                                  { (yyval.op_id) = C_OP_CARET_EQUAL           ; }
#line 13101 "parser.c"
    break;

  case 974: /* c_operator: '|'  */
#line 8770 "parser.y"
                                  { (yyval.op_id) = C_OP_PIPE                  ; }
#line 13107 "parser.c"
    break;

  case 975: /* c_operator: Y_PIPE_PIPE  */
#line 8771 "parser.y"
                                  { (yyval.op_id) = C_OP_PIPE_PIPE             ; }
#line 13113 "parser.c"
    break;

  case 976: /* c_operator: Y_PIPE_EQUAL  */
#line 8772 "parser.y"
                                  { (yyval.op_id) = C_OP_PIPE_EQUAL            ; }
#line 13119 "parser.c"
    break;

  case 977: /* c_operator: '~'  */
#line 8773 "parser.y"
                                  { (yyval.op_id) = C_OP_TILDE                 ; }
#line 13125 "parser.c"
    break;

  case 979: /* default_exp: error  */
#line 8779 "parser.y"
    {
      keyword_expected( L_default );
    }
#line 13133 "parser.c"
    break;

  case 981: /* defined_exp: error  */
#line 8787 "parser.y"
    {
      keyword_expected( L_defined );
    }
#line 13141 "parser.c"
    break;

  case 983: /* dependency_exp: error  */
#line 8795 "parser.y"
    {
      keyword_expected( L_dependency );
    }
#line 13149 "parser.c"
    break;

  case 985: /* destructor_sname: Y_LEXER_ERROR  */
#line 8803 "parser.y"
    {
      c_sname_init( &(yyval.sname) );
      PARSE_ABORT();
    }
#line 13158 "parser.c"
    break;

  case 986: /* empty_str_lit_exp: str_lit_exp  */
#line 8811 "parser.y"
    { //
      // This check is done now in the parser rather than later in the AST so
      // we don't have to keep the string literal around.
      //
      bool const is_empty = (yyvsp[0].str_val) == NULL || (yyvsp[0].str_val)[0] == '\0';
      free( (yyvsp[0].str_val) );
      if ( !is_empty ) {
        print_error( &(yylsp[0]), "empty string literal expected\n" );
        PARSE_ABORT();
      }
    }
#line 13174 "parser.c"
    break;

  case 988: /* equals_exp: error  */
#line 8827 "parser.y"
    {
      punct_expected( '=' );
    }
#line 13182 "parser.c"
    break;

  case 989: /* extern_linkage_c_stid: Y_extern linkage_stid  */
#line 8833 "parser.y"
                                  { (yyval.tid) = (yyvsp[0].tid); }
#line 13188 "parser.c"
    break;

  case 990: /* extern_linkage_c_stid: Y_extern linkage_stid '{'  */
#line 8835 "parser.y"
    {
      UNSUPPORTED( &(yylsp[0]), "scoped linkage declarations" );
      PARSE_ABORT();
    }
#line 13197 "parser.c"
    break;

  case 991: /* extern_linkage_c_stid_opt: %empty  */
#line 8842 "parser.y"
                                  { (yyval.tid) = TS_NONE; }
#line 13203 "parser.c"
    break;

  case 993: /* glob: Y_GLOB  */
#line 8848 "parser.y"
    {
      if ( !OPT_LANG_IS( SCOPED_NAMES ) && strchr( (yyvsp[0].name), ':' ) != NULL ) {
        print_error( &(yylsp[0]),
          "scoped names not supported%s\n",
          C_LANG_WHICH( SCOPED_NAMES )
        );
        free( (yyvsp[0].name) );
        PARSE_ABORT();
      }
      (yyval.name) = (yyvsp[0].name);
    }
#line 13219 "parser.c"
    break;

  case 994: /* glob_opt: %empty  */
#line 8862 "parser.y"
                                  { (yyval.name) = NULL; }
#line 13225 "parser.c"
    break;

  case 997: /* gt_exp: error  */
#line 8869 "parser.y"
    {
      punct_expected( '>' );
    }
#line 13233 "parser.c"
    break;

  case 998: /* inline_stid_opt: %empty  */
#line 8875 "parser.y"
                                  { (yyval.tid) = TS_NONE; }
#line 13239 "parser.c"
    break;

  case 1001: /* int_exp: error  */
#line 8882 "parser.y"
    {
      elaborate_error( "int[eger] expected" );
    }
#line 13247 "parser.c"
    break;

  case 1003: /* literal_exp: error  */
#line 8890 "parser.y"
    {
      keyword_expected( L_literal );
    }
#line 13255 "parser.c"
    break;

  case 1005: /* local_exp: error  */
#line 8898 "parser.y"
    {
      keyword_expected( L_local );
    }
#line 13263 "parser.c"
    break;

  case 1007: /* lparen_exp: error  */
#line 8906 "parser.y"
    {
      punct_expected( '(' );
    }
#line 13271 "parser.c"
    break;

  case 1009: /* lt_exp: error  */
#line 8914 "parser.y"
    {
      punct_expected( '<' );
    }
#line 13279 "parser.c"
    break;

  case 1010: /* member_or_non_member_opt: %empty  */
#line 8920 "parser.y"
                                  { (yyval.member) = C_FUNC_UNSPECIFIED; }
#line 13285 "parser.c"
    break;

  case 1011: /* member_or_non_member_opt: Y_member  */
#line 8921 "parser.y"
                                  { (yyval.member) = C_FUNC_MEMBER     ; }
#line 13291 "parser.c"
    break;

  case 1012: /* member_or_non_member_opt: Y_non_member  */
#line 8922 "parser.y"
                                  { (yyval.member) = C_FUNC_NON_MEMBER ; }
#line 13297 "parser.c"
    break;

  case 1014: /* namespace_btid_exp: error  */
#line 8928 "parser.y"
    {
      keyword_expected( L_namespace );
    }
#line 13305 "parser.c"
    break;

  case 1015: /* namespace_type: Y_namespace  */
#line 8934 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_B( (yyvsp[0].tid) ); }
#line 13311 "parser.c"
    break;

  case 1016: /* namespace_type: Y_inline namespace_btid_exp  */
#line 8935 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT( (yyvsp[0].tid), (yyvsp[-1].tid), TA_NONE ); }
#line 13317 "parser.c"
    break;

  case 1018: /* of_exp: error  */
#line 8941 "parser.y"
    {
      keyword_expected( L_of );
    }
#line 13325 "parser.c"
    break;

  case 1019: /* of_scope_english: Y_of scope_english_type_exp any_sname_c_exp  */
#line 8948 "parser.y"
    { //
      // Scoped names are supported only in C++.  (However, we always allow
      // them in configuration files.)
      //
      // This check is better to do now in the parser rather than later in the
      // AST because it has to be done in fewer places in the code plus gives a
      // better error location.
      //
      if ( !IS_SUPPORTED( SCOPED_NAMES ) ) {
        print_error( &(yylsp[-1]),
          "scoped names not supported%s\n",
          C_LANG_WHICH( SCOPED_NAMES )
        );
        c_sname_cleanup( &(yyvsp[0].sname) );
        PARSE_ABORT();
      }
      (yyval.sname) = c_sname_move( &(yyvsp[0].sname) );
      c_sname_set_local_type( &(yyval.sname), &(yyvsp[-1].type) );
    }
#line 13349 "parser.c"
    break;

  case 1020: /* of_scope_list_english: of_scope_list_english of_scope_english  */
#line 8971 "parser.y"
    {
      // "of scope X of scope Y" means Y::X
      (yyval.sname) = c_sname_move( &(yyvsp[0].sname) );
      c_sname_append_sname( &(yyval.sname), &(yyvsp[-1].sname) );
      c_sname_fill_in_namespaces( &(yyval.sname) );
      if ( !c_sname_check( &(yyval.sname), &(yylsp[-1]) ) ) {
        c_sname_cleanup( &(yyval.sname) );
        PARSE_ABORT();
      }
    }
#line 13364 "parser.c"
    break;

  case 1022: /* of_scope_list_english_opt: %empty  */
#line 8985 "parser.y"
                                  { c_sname_init( &(yyval.sname) ); }
#line 13370 "parser.c"
    break;

  case 1025: /* operator_exp: error  */
#line 8992 "parser.y"
    {
      keyword_expected( L_operator );
    }
#line 13378 "parser.c"
    break;

  case 1029: /* point_exp: error  */
#line 9005 "parser.y"
    {
      keyword_expected( L_point );
    }
#line 13386 "parser.c"
    break;

  case 1033: /* rbrace_exp: error  */
#line 9017 "parser.y"
    {
      punct_expected( '}' );
    }
#line 13394 "parser.c"
    break;

  case 1035: /* rbracket_exp: error  */
#line 9025 "parser.y"
    {
      punct_expected( ']' );
    }
#line 13402 "parser.c"
    break;

  case 1037: /* reference_exp: error  */
#line 9033 "parser.y"
    {
      keyword_expected( L_reference );
    }
#line 13410 "parser.c"
    break;

  case 1041: /* returning_exp: error  */
#line 9046 "parser.y"
    {
      keyword_expected( L_returning );
    }
#line 13418 "parser.c"
    break;

  case 1043: /* rparen_exp: error  */
#line 9054 "parser.y"
    {
      punct_expected( ')' );
    }
#line 13426 "parser.c"
    break;

  case 1044: /* scope_english_type: class_struct_union_btid  */
#line 9060 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_B( (yyvsp[0].tid) ); }
#line 13432 "parser.c"
    break;

  case 1046: /* scope_english_type: Y_scope  */
#line 9062 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_B( TB_SCOPE ); }
#line 13438 "parser.c"
    break;

  case 1048: /* scope_english_type_exp: error  */
#line 9068 "parser.y"
    {
      elaborate_error(
        "\"class\", \"namespace\", \"scope\", \"struct\", or \"union\" expected"
      );
    }
#line 13448 "parser.c"
    break;

  case 1050: /* semi_exp: error  */
#line 9078 "parser.y"
    {
      punct_expected( ';' );
    }
#line 13456 "parser.c"
    break;

  case 1055: /* static_stid_opt: %empty  */
#line 9094 "parser.y"
                                  { (yyval.tid) = TS_NONE; }
#line 13462 "parser.c"
    break;

  case 1056: /* static_stid_opt: Y_static  */
#line 9095 "parser.y"
                                  { (yyval.tid) = TS_NON_EMPTY_ARRAY; }
#line 13468 "parser.c"
    break;

  case 1058: /* str_lit: Y_LEXER_ERROR  */
#line 9101 "parser.y"
    {
      (yyval.str_val) = NULL;
      PARSE_ABORT();
    }
#line 13477 "parser.c"
    break;

  case 1060: /* str_lit_exp: error  */
#line 9110 "parser.y"
    {
      (yyval.str_val) = NULL;
      elaborate_error( "string literal expected" );
    }
#line 13486 "parser.c"
    break;

  case 1062: /* this_exp: error  */
#line 9119 "parser.y"
    {
      keyword_expected( L_this );
    }
#line 13494 "parser.c"
    break;

  case 1063: /* this_stid_opt: %empty  */
#line 9125 "parser.y"
                                  { (yyval.tid) = TS_NONE; }
#line 13500 "parser.c"
    break;

  case 1066: /* to_exp: error  */
#line 9132 "parser.y"
    {
      keyword_expected( L_to );
    }
#line 13508 "parser.c"
    break;

  case 1069: /* typename_flag_opt: %empty  */
#line 9143 "parser.y"
                                  { (yyval.flag) = false; }
#line 13514 "parser.c"
    break;

  case 1070: /* typename_flag_opt: Y_typename  */
#line 9144 "parser.y"
                                  { (yyval.flag) = true; }
#line 13520 "parser.c"
    break;

  case 1071: /* uint_lit: Y_INT_LIT  */
#line 9149 "parser.y"
    {
      if ( (yyvsp[0].int_val) < 0 ) {
        //
        // This check is better to do now in the parser rather than later in
        // the AST because we can store the value as unsigned plus gives a
        // better error location.
        //
        print_error( &(yylsp[0]), "non-negative integer expected\n" );
        PARSE_ABORT();
      }
      (yyval.uint_val) = STATIC_CAST( unsigned, (yyvsp[0].int_val) );
    }
#line 13537 "parser.c"
    break;

  case 1073: /* uint_lit_exp: error  */
#line 9166 "parser.y"
    {
      elaborate_error( "integer literal expected" );
    }
#line 13545 "parser.c"
    break;

  case 1074: /* uint_lit_opt: %empty  */
#line 9172 "parser.y"
                                  { (yyval.uint_val) = 0; }
#line 13551 "parser.c"
    break;

  case 1077: /* unused_exp: error  */
#line 9179 "parser.y"
    {
      keyword_expected( L_unused );
    }
#line 13559 "parser.c"
    break;

  case 1081: /* virtual_stid_exp: error  */
#line 9192 "parser.y"
    {
      keyword_expected( L_virtual );
    }
#line 13567 "parser.c"
    break;

  case 1082: /* virtual_stid_opt: %empty  */
#line 9198 "parser.y"
                                  { (yyval.tid) = TS_NONE; }
#line 13573 "parser.c"
    break;


#line 13577 "parser.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (YY_("syntax error"));
    }

  yyerror_range[1] = yylloc;
  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, &yylloc);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp, yylsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  yyerror_range[2] = yylloc;
  ++yylsp;
  YYLLOC_DEFAULT (*yylsp, yyerror_range, 2);

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp, yylsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

#line 9202 "parser.y"


/// @endcond

// Re-enable warnings.
#ifdef __GNUC__
# pragma GCC diagnostic pop
#endif /* __GNUC__ */

/**
 * @addtogroup parser-group
 * @{
 */

////////// local functions ////////////////////////////////////////////////////

/**
 * Prints an additional parsing error message including a newline to standard
 * error that continues from where yyerror() left off.  Additionally:
 *
 * + If the lexer_printable_token() isn't NULL:
 *     + Checks to see if it's a keyword: if it is, mentions that it's a
 *       keyword in the error message.
 *     + May print "did you mean ...?" \a dym_kinds suggestions.
 *
 * + In debug mode, also prints the file & line where the function was called
 *   from as well as the ID of the lookahead token, if any.
 *
 * @note A newline _is_ printed.
 * @note This function isn't normally called directly; use the
 * #elaborate_error() or #elaborate_error_dym() macros instead.
 *
 * @param file The name of the file where this function was called from.
 * @param line The line number within \a file where this function was called
 * from.
 * @param dym_kinds The bitwise-or of the kind(s) of things possibly meant.
 * @param format A `printf()` style format string.  It _must not_ end in a
 * newline since this function prints its own newline.
 * @param ... Arguments to print.
 *
 * @sa #elaborate_error()
 * @sa #elaborate_error_dym()
 * @sa fl_keyword_expected()
 * @sa fl_punct_expected()
 * @sa yyerror()
 */
PJL_PRINTF_LIKE_FUNC(4)
static void fl_elaborate_error( char const *file, int line,
                                dym_kind_t dym_kinds, char const *format,
                                ... ) {
  assert( format != NULL );

  EPUTS( ": " );
  print_debug_file_line( file, line );

  char const *const error_token = lexer_printable_token();
  if ( error_token != NULL ) {
    EPRINTF( "\"%s\"", error_token );
    if ( opt_cdecl_debug != CDECL_DEBUG_NO ) {
      switch ( yychar ) {
        case YYEMPTY:
          EPUTS( " [<empty>]" );
          break;
        case YYEOF:
          EPUTS( " [<EOF>]" );
          break;
        default:
          EPRINTF( " [%d]", yychar );
      } // switch
    }
    EPUTS( ": " );
  }

  va_list args;
  va_start( args, format );
  vfprintf( stderr, format, args );
  va_end( args );

  if ( error_token != NULL ) {
    print_error_token_is_a( error_token );
    print_suggestions( dym_kinds, error_token );
  }

  EPUTC( '\n' );
}

////////// extern functions ///////////////////////////////////////////////////

void parser_cleanup( void ) {
  c_ast_list_cleanup_gc( &typedef_ast_list );
}

///////////////////////////////////////////////////////////////////////////////

/** @} */

/* vim:set et sw=2 ts=2: */
